(* ::Package:: *)

(* ::Input:: *)
(*                   Algorithm: ARoots              *)
(*                       Authors: Ana C. Concei\[CCedilla]\[ATilde]o (aconcei@ualg.pt) & J\[EAcute]ssica Pires (jessicaccpires@gmail.com)          *)
(*                              Year: 2021*)
(*              Institution: Center for Functional Analysis, Linear Structures and Applications (CEAFEL), Universidade do Algarve          *)
(*   Article/Journal: Symbolic computation applied to Cauchy type singular integrals.  Math. Comput. Appl. *)
(*                  *)
(*         *)


(* ::Input::Initialization:: *)
Clear["Global`*"]

DialogInput[{Row[{Button["Insert p(t) directly.",DialogReturn[opt=1]],Button["Insert roots with multiplicities.",DialogReturn[opt=2]]}]}];


rootsFunc=Function[{},nroots=Length[roots];rootsM=Tally[roots[[All,1,2]]];listroots=List[];rootsdisk=List[];rootscircle=List[];rootsout=List[];For[i=0,i<nroots ,i++;Which[Abs[roots[[i,1,2]]]>1,AppendTo[listroots,"Outside-\!\(\*SubscriptBox[\(\[DoubleStruckCapitalT]\), \(-\)]\)"] ,Abs[roots[[i,1,2]]]==1,AppendTo[listroots,"Unit Circle-\[DoubleStruckCapitalT]"],Abs[roots[[i,1,2]]]<1,AppendTo[listroots,"Unit disk-\!\(\*SubscriptBox[\(\[DoubleStruckCapitalT]\), \(+\)]\)"]]];
For[i=0,i<nroots ,i++;Which[Abs[roots[[i,1,2]]]>1,AppendTo[rootsout,roots[[i,1,2]]],Abs[roots[[i,1,2]]]==1,AppendTo[rootscircle,roots[[i,1,2]]],Abs[roots[[i,1,2]]]<1,AppendTo[rootsdisk,roots[[i,1,2]]]]];
circler=Count[listroots,"Unit Circle-\[DoubleStruckCapitalT]"];
diskr=Count[listroots,"Unit disk-\!\(\*SubscriptBox[\(\[DoubleStruckCapitalT]\), \(+\)]\)"];
outr=Count[listroots,"Outside-\!\(\*SubscriptBox[\(\[DoubleStruckCapitalT]\), \(-\)]\)"];
Print[listroots];
Print["This polynomial has ",circler," roots in the unit circle, ",diskr," roots inside the unit circle and ",outr," roots outside the unit circle."];
For[i=0,i<Length[rootsM],i++;Print[i,"\[LongRightArrow]",rootsM[[i,1]]]]];

approxRoot=Function[{},DialogInput[{TextCell["Do you want approximate roots value?"],Row[{Button["YES",DialogReturn[opt=1]],Button["NO",DialogReturn[opt=2]]}]}];
If[opt==1,nApprox=Input["How many digits?"];
rootApprox=Input["Insert the number of the root to approximate."];
rootA=N[rootsM[[rootApprox,1]],nApprox];
Print["Root ",rootApprox,": Approximate value=",rootA]]];



If[opt==1,p[t]=Input["Input p(t):"];Print["p(t)=",p[t]];If[Switch[Denominator[p[t]],1,"True",_,"False"]=="True",roots=Solve[p[t]==0];rootsFunc[];approxRoot[],
Print["p(t) is not a polynomial"]]
,
If[opt==2,roots={};
nrootsM=Input["How many different roots?"];For[i=0,i<nrootsM,i++; root=Input["Input the root:"];rootM=Input["Input the multiplicity of this root:"];Do[AppendTo[roots,{t\[RightArrow]root}],rootM]];rootsFunc[];approxRoot[]]];

