(* ::Package:: *)

(* ::Input:: *)
(*                   Algorithm: APoles              *)
(*                       Authors: Ana C. Concei\[CCedilla]\[ATilde]o (aconcei@ualg.pt) & J\[EAcute]ssica Pires(jessicaccpires@gmail.com)          *)
(*                              Year: 2021*)
(*              Institution: Center for Functional Analysis, Linear Structures and Applications (CEAFEL), Universidade do Algarve          *)
(*   Article/Journal: Symbolic computation applied to Cauchy type singular integrals.  Math. Comput. Appl. *)
(*                  *)
(*         *)


(* ::Input::Initialization:: *)
(*The output gives the Poles in \[DoubleStruckCapitalT], Subscript[\[DoubleStruckCapitalT], +],Subscript[\[DoubleStruckCapitalT], - ]*)

npoles=Length[poles];
polesM=Tally[poles[[All,1,2]]];
listpoles=List[];
polesdisk=List[];
polescircle=List[];
polesout=List[];
For[i=0,i<npoles ,i++;Which[Abs[poles[[i,1,2]]]>1,AppendTo[listpoles,"Outside-\!\(\*SubscriptBox[\(\[DoubleStruckCapitalT]\), \(-\)]\)"],Abs[poles[[i,1,2]]]==1,AppendTo[listpoles,"Unit Circle-\[DoubleStruckCapitalT]"],Abs[poles[[i,1,2]]]<1,AppendTo[listpoles,"Unit disk-\!\(\*SubscriptBox[\(\[DoubleStruckCapitalT]\), \(+\)]\)"]]];
For[i=0,i<npoles ,i++;Which[Abs[poles[[i,1,2]]]>1,AppendTo[polesout,poles[[i,1,2]]],Abs[poles[[i,1,2]]]==1,AppendTo[polescircle,poles[[i,1,2]]],Abs[poles[[i,1,2]]]<1,AppendTo[polesdisk,poles[[i,1,2]]]]];
circlep=Count[listpoles,"Unit Circle-\[DoubleStruckCapitalT]"];
diskp=Count[listpoles,"Unit disk-\!\(\*SubscriptBox[\(\[DoubleStruckCapitalT]\), \(+\)]\)"];
outp=Count[listpoles,"Outside-\!\(\*SubscriptBox[\(\[DoubleStruckCapitalT]\), \(-\)]\)"];
