(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    213572,       4202]
NotebookOptionsPosition[    210792,       4116]
NotebookOutlinePosition[    211151,       4132]
CellTagsIndexPosition[    211108,       4129]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[Cell[TextData[{
  StyleBox["            ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["Algorithm:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox["APoles",
   FontFamily->"Optima",
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox["             \n               ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["Authors:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox[
  "Ana C. Concei\[CCedilla]\[ATilde]o (aconcei@ualg.pt) & J\[EAcute]ssica \
Pires (jessicaccpires@gmail.com) ",
   FontFamily->"Optima",
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontWeight->"Plain",
   Background->None],
  StyleBox["        \n                    ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["Year:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["2021",
   FontFamily->"Optima",
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox["\n           ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["Institution:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox[
  "Center for Functional Analysis, Linear Structures and Applications \
(CEAFEL), Universidade do Algarve",
   FontFamily->"Optima",
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox["          ",
   FontFamily->"Optima",
   FontWeight->"Plain",
   Background->None],
  "\n   ",
  StyleBox["Article/Journal:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  " ",
  StyleBox["Symb",
   FontColor->GrayLevel[0.5]],
  StyleBox["olic comput",
   FontColor->GrayLevel[0.5],
   Background->GrayLevel[0.85]],
  StyleBox[
  "ation applied to Cauchy type singular integrals. \n                  Math. \
Comput. Appl. ",
   FontColor->GrayLevel[0.5]],
  "\n                  \n        ",
  StyleBox["  ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["License",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[":",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.3799496452277409, 0.6257724879835203, 0.7690852216372931],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  Cell[BoxData[
   GraphicsBox[
    TagBox[RasterBox[CompressedData["
1:eJzs3QmUHMd54Pnqaq2GjzNaWbIlPy5FUGvrjQ9aegQlr+WZXR+AZnzKh6jD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      "], {{0, 270}, {1400, 0}}, {0, 255},
      ColorFunction->RGBColor],
     BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
     Selectable->False],
    DefaultBaseStyle->"ImageGraphics",
    ImageSize->{251.96484375, Automatic},
    ImageSizeRaw->{1400, 270},
    PlotRange->{{0, 1400}, {0, 270}}]]],
  "\n  "
 }], "Section",
  CellChangeTimes->{{3.560518296834669*^9, 3.5605183114080544`*^9}, {
   3.560518646082142*^9, 3.560518662165022*^9}, {3.560518702205791*^9, 
   3.560518800592577*^9}, {3.560518864590123*^9, 3.5605188705762587`*^9}},
  FontFamily->"Courier",
  FontSize->14,
  Background->GrayLevel[0.85],
  ExpressionUUID -> "8c5f323e-a33d-4a8f-a576-4cb80b2c81be"]], "Input",
 CellChangeTimes->{{3.8499020777175817`*^9, 3.849902078798779*^9}, {
  3.849903937087978*^9, 3.8499039376929407`*^9}, {3.849903978703733*^9, 
  3.849903981446308*^9}}],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzs3QeYFHW+/3u493/v2Xv/5z5nn92z6tldl9Xd1VXAiCIgjAgoQcAVRaLk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    "], {{0, 724}, {1008, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->{519.58984375, Automatic},
  ImageSizeRaw->{1008, 724},
  PlotRange->{{0, 1008}, {0, 724}}]], "Input",
 CellChangeTimes->{{3.8499040323125668`*^9, 3.84990404748669*^9}}],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{3.8499021590298357`*^9}],

Cell[BoxData[
 RowBox[{"Instructions", ":", "\[IndentingNewLine]", "    ", 
  RowBox[{
   RowBox[{
    GraphicsBox[
     TagBox[RasterBox[CompressedData["
1:eJztvf9bVEe+78u99/xwf7rP/Rfu2V+SqNEfz957Jn775cxMVHzOee6eQUme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       "], {{0, 270}, {590, 0}}, {0, 255},
       ColorFunction->RGBColor],
      BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
      Selectable->False],
     DefaultBaseStyle->"ImageGraphics",
     ImageSize->{258.2421875, Automatic},
     ImageSizeRaw->{590, 270},
     PlotRange->{{0, 590}, {0, 270}}], "                 ", "Shift"}], "+", 
   "Enter", "            "}]}]], "Input",
 CellChangeTimes->{{3.8499023464082947`*^9, 3.8499023467180357`*^9}, {
  3.849902541591395*^9, 3.849902550003584*^9}, {3.84990412012418*^9, 
  3.849904132977738*^9}, {3.849934569457074*^9, 3.849934571717111*^9}}],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{3.849904158818735*^9}],

Cell[TextData[StyleBox["Example A",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 
  3.842293134812916*^9}},ExpressionUUID->"f919a43f-e25f-4f86-ab01-\
0409a03ef861"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   FractionBox[
    RowBox[{"t", "-", 
     FractionBox["1", "2"]}], 
    RowBox[{"t", "+", 
     RowBox[{"2", "\[ImaginaryI]"}]}]]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"poles", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"Denominator", "[", 
     RowBox[{"r", "[", "t", "]"}], "]"}], "\[Equal]", "0"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<APoles.m\>\""}], "\[IndentingNewLine]", "listpoles"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
  3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
  3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
  3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.8422932731737304`*^9, 
  3.842293278005754*^9}, {3.8499041610751047`*^9, 3.849904194184265*^9}},
 ExpressionUUID -> "8aea5332-1cad-4b9a-9c0a-9546643421cb"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"t", "\[Rule]", 
    RowBox[{
     RowBox[{"-", "2"}], " ", "\[ImaginaryI]"}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.842291889733539*^9, 3.842291915071255*^9}, {
   3.8422920596256094`*^9, 3.842292075027014*^9}, 3.8422921995066347`*^9, {
   3.8422923904141936`*^9, 3.8422924107581663`*^9}, {3.842292529528334*^9, 
   3.8422925498418074`*^9}, 3.8422929688845806`*^9, 3.8422930542716303`*^9, 
   3.842293205200923*^9, 3.842293279255352*^9, 3.8499048028620567`*^9, 
   3.849904861936949*^9, 3.849904926219096*^9},
 ExpressionUUID -> "f1a9e612-e7aa-498b-b190-c79496d1aaab"],

Cell[BoxData[
 RowBox[{"{", \
"\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \\(-\\)]\\)\
\"\>", "}"}]], "Output",
 CellChangeTimes->{{3.842291889733539*^9, 3.842291915071255*^9}, {
   3.8422920596256094`*^9, 3.842292075027014*^9}, 3.8422921995066347`*^9, {
   3.8422923904141936`*^9, 3.8422924107581663`*^9}, {3.842292529528334*^9, 
   3.8422925498418074`*^9}, 3.8422929688845806`*^9, 3.8422930542716303`*^9, 
   3.842293205200923*^9, 3.842293279255352*^9, 3.8499048028620567`*^9, 
   3.849904861936949*^9, 3.849904926236383*^9},
 ExpressionUUID -> "f1a9e612-e7aa-498b-b190-c79496d1aaab"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.849904192563422*^9, 3.849904197305235*^9}}],

Cell[TextData[StyleBox["Example B",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 3.842293134812916*^9}, {
  3.8422931687293143`*^9, 
  3.8422931693503757`*^9}},ExpressionUUID->"57083f35-f0e6-4f24-b8ae-\
5d7f5c93e623"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   FormBox[
    FormBox[
     FormBox[
      RowBox[{
       RowBox[{"3", "t"}], "-", "\[ImaginaryI]"}],
      TraditionalForm],
     TraditionalForm],
    TraditionalForm]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"poles", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"Denominator", "[", 
     RowBox[{"r", "[", "t", "]"}], "]"}], "\[Equal]", "0"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<APoles.m\>\""}], "\[IndentingNewLine]", "listpoles"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
   3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
   3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
   3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.842293182622344*^9, 
   3.8422931839706736`*^9}, {3.8422932673200707`*^9, 3.8422932830463624`*^9}, 
   3.842294010307627*^9, {3.8499041912367268`*^9, 3.84990421293962*^9}},
 ExpressionUUID -> "853fca7f-ac8e-46cd-b703-4e336c567b6c"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.8422931866157265`*^9, 3.84229328399513*^9, 
  3.8422940134767647`*^9, 3.849904208376566*^9},
 ExpressionUUID -> "db5bf696-51fa-454a-81f2-a06eafc013d0"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.8422931866157265`*^9, 3.84229328399513*^9, 
  3.8422940134767647`*^9, 3.849904208393874*^9},
 ExpressionUUID -> "db5bf696-51fa-454a-81f2-a06eafc013d0"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.849904243024029*^9, 3.849904244928773*^9}}],

Cell[TextData[StyleBox["Example C",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 3.842293134812916*^9}, {
  3.8422931687293143`*^9, 
  3.8422931973930235`*^9}},ExpressionUUID->"856433c3-2f9b-46d0-b5c2-\
fb98928abd4c"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   RowBox[{
    FractionBox["\[ImaginaryI]", "t"], "-", 
    FractionBox[
     RowBox[{"8", "\[ImaginaryI]"}], 
     SuperscriptBox["t", "4"]]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"r", "[", "t", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"poles", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"Denominator", "[", 
     RowBox[{"r", "[", "t", "]"}], "]"}], "\[Equal]", "0"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<APoles.m\>\""}], "\[IndentingNewLine]", "listpoles", "\
\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
   3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
   3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
   3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.842293182622344*^9, 
   3.8422931839706736`*^9}, {3.8422932188473063`*^9, 3.8422932240991*^9}, 
   3.8422932899103546`*^9, {3.8422933226096425`*^9, 3.8422933941372023`*^9}, {
   3.84990425431835*^9, 3.84990426379663*^9}},
 ExpressionUUID -> "30034868-f6c4-4659-a201-82a23e77866e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.8422932251870394`*^9, 3.8422932922649355`*^9, {3.842293328823125*^9, 
   3.8422933977893114`*^9}, 3.849904266086533*^9},
 ExpressionUUID -> "74153c79-3eaa-4ffa-9713-16726d819bff"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>"}], "}"}]], "Output",
 CellChangeTimes->{
  3.8422932251870394`*^9, 3.8422932922649355`*^9, {3.842293328823125*^9, 
   3.8422933977893114`*^9}, 3.8499042661020517`*^9},
 ExpressionUUID -> "74153c79-3eaa-4ffa-9713-16726d819bff"]
}, Open  ]],

Cell[TextData[StyleBox["Example D",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 3.842293134812916*^9}, {
  3.8422931687293143`*^9, 3.8422931973930235`*^9}, {3.842293425545861*^9, 
  3.84229342697521*^9}},ExpressionUUID->"05a085f5-a2cd-44ff-a1b4-\
72efcb4bb016"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   FormBox[
    FormBox[
     FractionBox[
      RowBox[{"2", "\[ImaginaryI]"}], 
      RowBox[{"t", "-", "3"}]],
     TraditionalForm],
    TraditionalForm]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"poles", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"Denominator", "[", 
     RowBox[{"r", "[", "t", "]"}], "]"}], "\[Equal]", "0"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<APoles.m\>\""}], "\[IndentingNewLine]", "listpoles"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
   3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
   3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
   3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.842293182622344*^9, 
   3.8422931839706736`*^9}, {3.8422932188473063`*^9, 3.8422932240991*^9}, 
   3.8422932899103546`*^9, {3.8422933226096425`*^9, 3.8422933941372023`*^9}, {
   3.842293439816018*^9, 3.842293463705413*^9}, {3.849904285608148*^9, 
   3.849904293306901*^9}},
 ExpressionUUID -> "84be60bf-af28-436d-bcaf-09e55f84a0dc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"t", "\[Rule]", "3"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.8422934506454973`*^9, 3.8422934648044357`*^9}, 
   3.84990430863339*^9},
 ExpressionUUID -> "69c11072-522b-45aa-a55e-48acf41697bc"],

Cell[BoxData[
 RowBox[{"{", \
"\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \\(-\\)]\\)\
\"\>", "}"}]], "Output",
 CellChangeTimes->{{3.8422934506454973`*^9, 3.8422934648044357`*^9}, 
   3.849904308650195*^9},
 ExpressionUUID -> "69c11072-522b-45aa-a55e-48acf41697bc"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.8499042875800467`*^9, 3.8499042967357187`*^9}}],

Cell[TextData[StyleBox["Example E",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 3.842293134812916*^9}, {
  3.8422931687293143`*^9, 3.8422931973930235`*^9}, {3.842293425545861*^9, 
  3.84229342697521*^9}, {3.84229347456431*^9, 
  3.842293475341224*^9}},ExpressionUUID->"bb4ec4f5-be6f-4dff-8aa2-\
2fd4a8912067"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   FormBox[
    FormBox[
     FormBox[
      FormBox[
       FormBox[
        FormBox[
         FractionBox[
          RowBox[{"2", "t"}], 
          RowBox[{"t", "-", 
           RowBox[{"2", "\[ImaginaryI]"}], "+", "3"}]],
         TraditionalForm],
        TraditionalForm],
       TraditionalForm],
      TraditionalForm],
     TraditionalForm],
    TraditionalForm]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"poles", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"Denominator", "[", 
     RowBox[{"r", "[", "t", "]"}], "]"}], "\[Equal]", "0"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<APoles.m\>\""}], "\[IndentingNewLine]", "listpoles"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
   3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
   3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
   3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.842293182622344*^9, 
   3.8422931839706736`*^9}, {3.8422932188473063`*^9, 3.8422932240991*^9}, 
   3.8422932899103546`*^9, {3.8422933226096425`*^9, 3.8422933941372023`*^9}, {
   3.842293439816018*^9, 3.842293488858713*^9}, {3.8499043042813053`*^9, 
   3.849904322311482*^9}},
 ExpressionUUID -> "272e5734-21c8-431e-bd7a-174eb31d9e0c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"t", "\[Rule]", 
    RowBox[{
     RowBox[{"-", "3"}], "+", 
     RowBox[{"2", " ", "\[ImaginaryI]"}]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.842293489981035*^9, 3.849904316192523*^9, 
  3.849934576621187*^9},
 ExpressionUUID -> "3ba68b02-bc89-4b44-9e7d-ec313ebff59c"],

Cell[BoxData[
 RowBox[{"{", \
"\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \\(-\\)]\\)\
\"\>", "}"}]], "Output",
 CellChangeTimes->{3.842293489981035*^9, 3.849904316192523*^9, 
  3.849934576636544*^9},
 ExpressionUUID -> "3ba68b02-bc89-4b44-9e7d-ec313ebff59c"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.849904324945208*^9, 3.8499043268893003`*^9}}],

Cell[TextData[StyleBox["Example F",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 3.842293134812916*^9}, {
  3.8422931687293143`*^9, 3.8422931973930235`*^9}, {3.842293425545861*^9, 
  3.84229342697521*^9}, {3.84229347456431*^9, 
  3.8422935036720257`*^9}},ExpressionUUID->"f9d28022-fe54-491c-b3b6-\
9ac6a0f625ed"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   FormBox[
    FormBox[
     FormBox[
      FormBox[
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"2", 
           SuperscriptBox["t", "4"]}], "-", 
          RowBox[{"2", "\[ImaginaryI]", " ", 
           SuperscriptBox["t", "3"]}], "-", 
          RowBox[{"5", 
           SuperscriptBox["t", "2"]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"5", "\[ImaginaryI]"}], " ", "+", "1"}], ")"}], " ", 
           "t"}], "-", "\[ImaginaryI]"}], 
         RowBox[{
          SuperscriptBox["t", "6"], "+", "1"}]], " "}],
       TraditionalForm],
      TraditionalForm],
     TraditionalForm],
    TraditionalForm]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"poles", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"Denominator", "[", 
     RowBox[{"r", "[", "t", "]"}], "]"}], "\[Equal]", "0"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<APoles.m\>\""}], "\[IndentingNewLine]", "listpoles"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
   3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
   3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
   3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.842293182622344*^9, 
   3.8422931839706736`*^9}, {3.8422932188473063`*^9, 3.8422932240991*^9}, 
   3.8422932899103546`*^9, {3.8422933226096425`*^9, 3.8422933941372023`*^9}, {
   3.842293439816018*^9, 3.842293518178523*^9}, {3.8499043416011457`*^9, 
   3.849904354096637*^9}, {3.8499044200974617`*^9, 3.849904425855928*^9}},
 ExpressionUUID -> "662c1966-744a-43d2-9d05-c218f2ff6af4"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"-", "\[ImaginaryI]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", "\[ImaginaryI]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"-", "1"}], ")"}], 
       RowBox[{"1", "/", "6"}]]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"-", "1"}], ")"}], 
      RowBox[{"1", "/", "6"}]]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"-", "1"}], ")"}], 
       RowBox[{"5", "/", "6"}]]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"-", "1"}], ")"}], 
      RowBox[{"5", "/", "6"}]]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.842293519423861*^9, 3.849904357030753*^9, 
  3.8499044231194344`*^9},
 ExpressionUUID -> "90ddd47a-cdd1-48ac-825c-bde0a8fd8d21"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Unit Circle-\[DoubleStruckCapitalT]\"\>", 
   ",", "\<\"Unit Circle-\[DoubleStruckCapitalT]\"\>", 
   ",", "\<\"Unit Circle-\[DoubleStruckCapitalT]\"\>", 
   ",", "\<\"Unit Circle-\[DoubleStruckCapitalT]\"\>", 
   ",", "\<\"Unit Circle-\[DoubleStruckCapitalT]\"\>", 
   ",", "\<\"Unit Circle-\[DoubleStruckCapitalT]\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.842293519423861*^9, 3.849904357030753*^9, 
  3.849904423135378*^9},
 ExpressionUUID -> "90ddd47a-cdd1-48ac-825c-bde0a8fd8d21"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.8499044511536703`*^9, 3.849904452666706*^9}}],

Cell[TextData[StyleBox["Example G",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 3.842293134812916*^9}, {
  3.8422931687293143`*^9, 3.8422931973930235`*^9}, {3.842293425545861*^9, 
  3.84229342697521*^9}, {3.84229347456431*^9, 
  3.842293529817839*^9}},ExpressionUUID->"1df9ea5e-ad62-4888-a7b1-\
4763cfc68b35"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   FormBox[
    FormBox[
     FormBox[
      FormBox[
       RowBox[{
        SuperscriptBox["t", "10"], "+", 
        RowBox[{"3", " ", "t"}], "-", "1", " "}],
       TraditionalForm],
      TraditionalForm],
     TraditionalForm],
    TraditionalForm]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"poles", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"Denominator", "[", 
     RowBox[{"r", "[", "t", "]"}], "]"}], "\[Equal]", "0"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<APoles.m\>\""}], "\[IndentingNewLine]", "listpoles"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
   3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
   3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
   3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.842293182622344*^9, 
   3.8422931839706736`*^9}, {3.8422932188473063`*^9, 3.8422932240991*^9}, 
   3.8422932899103546`*^9, {3.8422933226096425`*^9, 3.8422933941372023`*^9}, {
   3.842293439816018*^9, 3.842293538972356*^9}, {3.849904449573483*^9, 
   3.8499044657920847`*^9}},
 ExpressionUUID -> "528f52dc-66a7-46b1-ad6c-9795e8e7a559"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.842293540212613*^9, 3.849904468166771*^9},
 ExpressionUUID -> "ffa54be4-43b6-42aa-912a-de2908274b01"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.842293540212613*^9, 3.849904468182374*^9},
 ExpressionUUID -> "ffa54be4-43b6-42aa-912a-de2908274b01"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.849904454460837*^9, 3.849904457234582*^9}}],

Cell[TextData[StyleBox["Example H",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 3.842293134812916*^9}, {
  3.8422931687293143`*^9, 3.8422931973930235`*^9}, {3.842293425545861*^9, 
  3.84229342697521*^9}, {3.84229347456431*^9, 3.842293529817839*^9}, {
  3.842293587372309*^9, 
  3.842293588049423*^9}},ExpressionUUID->"43badb7f-3f84-4506-8e13-\
1fe100e8b9e3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   FormBox[
    FormBox[
     FormBox[
      FormBox[
       FormBox[
        RowBox[{"2", "+", 
         FractionBox["1", 
          SuperscriptBox["t", "2"]]}],
        TraditionalForm],
       TraditionalForm],
      TraditionalForm],
     TraditionalForm],
    TraditionalForm]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"poles", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"r", "[", "t", "]"}]}], "\[Equal]", "0"}], ",", "t"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<APoles.m\>\""}], "\[IndentingNewLine]", "listpoles"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
   3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
   3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
   3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.842293182622344*^9, 
   3.8422931839706736`*^9}, {3.8422932188473063`*^9, 3.8422932240991*^9}, 
   3.8422932899103546`*^9, {3.8422933226096425`*^9, 3.8422933941372023`*^9}, {
   3.842293439816018*^9, 3.842293538972356*^9}, {3.8422936038794794`*^9, 
   3.8422938174414673`*^9}, {3.849904629151422*^9, 3.849904638096116*^9}},
 ExpressionUUID -> "8d5d613c-2dc3-4b0f-8aaf-c966cfba76eb"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.8422936178650923`*^9, 3.8422936483407016`*^9}, {
   3.8422937046294975`*^9, 3.842293724102346*^9}, {3.8422937919897795`*^9, 
   3.8422938184674635`*^9}, 3.849904631618379*^9},
 ExpressionUUID -> "c30d711a-a632-45e6-80e7-2ac30557034c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>"}], "}"}]], "Output",
 CellChangeTimes->{{3.8422936178650923`*^9, 3.8422936483407016`*^9}, {
   3.8422937046294975`*^9, 3.842293724102346*^9}, {3.8422937919897795`*^9, 
   3.8422938184674635`*^9}, 3.849904631632905*^9},
 ExpressionUUID -> "c30d711a-a632-45e6-80e7-2ac30557034c"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.8499046468883543`*^9, 3.849904661419032*^9}}],

Cell[TextData[StyleBox["Example I",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 3.842293134812916*^9}, {
  3.8422931687293143`*^9, 3.8422931973930235`*^9}, {3.842293425545861*^9, 
  3.84229342697521*^9}, {3.84229347456431*^9, 3.842293529817839*^9}, {
  3.842293587372309*^9, 3.842293588049423*^9}, {3.8499034578038597`*^9, 
  3.849903458684903*^9}},
 ExpressionUUID -> "b21b562d-65c1-4707-a085-9a7e22af40ad"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   FormBox[
    FormBox[
     FormBox[
      FormBox[
       FormBox[
        FractionBox["1", 
         RowBox[{
          SuperscriptBox["t", "6"], "+", 
          RowBox[{"5", 
           SuperscriptBox["t", "4"]}], "-", 
          RowBox[{"6", " ", "t"}], "+", "1"}]],
        TraditionalForm],
       TraditionalForm],
      TraditionalForm],
     TraditionalForm],
    TraditionalForm]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"poles", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"r", "[", "t", "]"}]}], "\[Equal]", "0"}], ",", "t"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<APoles.m\>\""}], "\[IndentingNewLine]", "listpoles"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
   3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
   3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
   3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.842293182622344*^9, 
   3.8422931839706736`*^9}, {3.8422932188473063`*^9, 3.8422932240991*^9}, 
   3.8422932899103546`*^9, {3.8422933226096425`*^9, 3.8422933941372023`*^9}, {
   3.842293439816018*^9, 3.842293538972356*^9}, {3.8422936038794794`*^9, 
   3.8422938174414673`*^9}, {3.849904629151422*^9, 3.849904638096116*^9}, {
   3.849904675038231*^9, 3.8499046783029747`*^9}},
 ExpressionUUID -> "8d5d613c-2dc3-4b0f-8aaf-c966cfba76eb"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"6", " ", "#1"}], "+", 
         RowBox[{"5", " ", 
          SuperscriptBox["#1", "4"]}], "+", 
         SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"6", " ", "#1"}], "+", 
         RowBox[{"5", " ", 
          SuperscriptBox["#1", "4"]}], "+", 
         SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"6", " ", "#1"}], "+", 
         RowBox[{"5", " ", 
          SuperscriptBox["#1", "4"]}], "+", 
         SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"6", " ", "#1"}], "+", 
         RowBox[{"5", " ", 
          SuperscriptBox["#1", "4"]}], "+", 
         SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"6", " ", "#1"}], "+", 
         RowBox[{"5", " ", 
          SuperscriptBox["#1", "4"]}], "+", 
         SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"6", " ", "#1"}], "+", 
         RowBox[{"5", " ", 
          SuperscriptBox["#1", "4"]}], "+", 
         SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.849904681622141*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.84990468163422*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.849904709099133*^9, 3.849904710660181*^9}}],

Cell[TextData[StyleBox["Example J",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 3.842293134812916*^9}, {
  3.8422931687293143`*^9, 3.8422931973930235`*^9}, {3.842293425545861*^9, 
  3.84229342697521*^9}, {3.84229347456431*^9, 3.842293529817839*^9}, {
  3.842293587372309*^9, 3.842293588049423*^9}, {3.8499034578038597`*^9, 
  3.849903458684903*^9}, {3.849904713036612*^9, 3.849904713772131*^9}},
 ExpressionUUID -> "b21b562d-65c1-4707-a085-9a7e22af40ad"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   FormBox[
    FormBox[
     FormBox[
      FormBox[
       FormBox[
        FractionBox["1", 
         RowBox[{
          SuperscriptBox["t", "21"], "-", 
          RowBox[{"6", 
           SuperscriptBox["t", "5"]}], "+", 
          RowBox[{"4", "\[ImaginaryI]", " ", "t"}]}]],
        TraditionalForm],
       TraditionalForm],
      TraditionalForm],
     TraditionalForm],
    TraditionalForm]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"poles", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"r", "[", "t", "]"}]}], "\[Equal]", "0"}], ",", "t"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<APoles.m\>\""}], "\[IndentingNewLine]", "listpoles"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
   3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
   3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
   3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.842293182622344*^9, 
   3.8422931839706736`*^9}, {3.8422932188473063`*^9, 3.8422932240991*^9}, 
   3.8422932899103546`*^9, {3.8422933226096425`*^9, 3.8422933941372023`*^9}, {
   3.842293439816018*^9, 3.842293538972356*^9}, {3.8422936038794794`*^9, 
   3.8422938174414673`*^9}, {3.849904629151422*^9, 3.849904638096116*^9}, {
   3.849904675038231*^9, 3.8499046783029747`*^9}, 3.8499047279917727`*^9},
 ExpressionUUID -> "8d5d613c-2dc3-4b0f-8aaf-c966cfba76eb"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "1"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "2"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "3"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "4"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "5"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "6"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "7"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "8"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "9"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "10"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "11"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "12"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "13"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "14"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "15"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "16"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "17"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "18"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "19"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "20"}], "}"}]}], "]"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.84990475370277*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.849904753710534*^9}]
}, Open  ]]
},
WindowSize->{1128, 628},
WindowMargins->{{Automatic, -7}, {Automatic, 0}},
FrontEndVersion->"11.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (September \
21, 2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 65206, 1162, 242, "Input"],
Cell[65767, 1184, 71935, 1183, 388, "Input"],
Cell[137705, 2369, 89, 1, 54, "Input"],
Cell[137797, 2372, 28932, 479, 169, "Input"],
Cell[166732, 2853, 87, 1, 54, "Input"],
Cell[166822, 2856, 257, 6, 30, "Text"],
Cell[CellGroupData[{
Cell[167104, 2866, 1259, 32, 167, "Input"],
Cell[168366, 2900, 636, 12, 32, "Output"],
Cell[169005, 2914, 608, 10, 32, "Output"]
}, Open  ]],
Cell[169628, 2927, 92, 1, 32, "Input"],
Cell[169723, 2930, 310, 7, 30, "Text"],
Cell[CellGroupData[{
Cell[170058, 2941, 1379, 36, 138, "Input"],
Cell[171440, 2979, 218, 4, 32, "Output"],
Cell[171661, 2985, 218, 4, 32, "Output"]
}, Open  ]],
Cell[171894, 2992, 92, 1, 32, "Input"],
Cell[171989, 2995, 310, 7, 30, "Text"],
Cell[CellGroupData[{
Cell[172324, 3006, 1588, 40, 201, "Input"],
Cell[173915, 3048, 517, 14, 32, "Output"],
Cell[174435, 3064, 643, 13, 32, "Output"]
}, Open  ]],
Cell[175093, 3080, 355, 7, 30, "Text"],
Cell[CellGroupData[{
Cell[175473, 3091, 1465, 37, 157, "Input"],
Cell[176941, 3130, 257, 6, 32, "Output"],
Cell[177201, 3138, 288, 6, 32, "Output"]
}, Open  ]],
Cell[177504, 3147, 96, 1, 32, "Input"],
Cell[177603, 3150, 403, 8, 30, "Text"],
Cell[CellGroupData[{
Cell[178031, 3162, 1680, 46, 157, "Input"],
Cell[179714, 3210, 335, 9, 32, "Output"],
Cell[180052, 3221, 281, 6, 32, "Output"]
}, Open  ]],
Cell[180348, 3230, 94, 1, 32, "Input"],
Cell[180445, 3233, 405, 8, 30, "Text"],
Cell[CellGroupData[{
Cell[180875, 3245, 2045, 54, 163, "Input"],
Cell[182923, 3301, 1104, 36, 35, "Output"],
Cell[184030, 3339, 533, 10, 32, "Output"]
}, Open  ]],
Cell[184578, 3352, 94, 1, 32, "Input"],
Cell[184675, 3355, 403, 8, 30, "Text"],
Cell[CellGroupData[{
Cell[185103, 3367, 1563, 41, 138, "Input"],
Cell[186669, 3410, 168, 3, 32, "Output"],
Cell[186840, 3415, 168, 3, 32, "Output"]
}, Open  ]],
Cell[187023, 3421, 92, 1, 32, "Input"],
Cell[187118, 3424, 452, 9, 30, "Text"],
Cell[CellGroupData[{
Cell[187595, 3437, 1651, 44, 159, "Input"],
Cell[189249, 3483, 440, 10, 32, "Output"],
Cell[189692, 3495, 500, 9, 32, "Output"]
}, Open  ]],
Cell[190207, 3507, 94, 1, 32, "Input"],
Cell[190304, 3510, 502, 9, 30, "Text"],
Cell[CellGroupData[{
Cell[190831, 3523, 1813, 48, 159, "Input"],
Cell[192647, 3573, 2042, 64, 58, "Output"],
Cell[194692, 3639, 664, 14, 32, "Output"]
}, Open  ]],
Cell[195371, 3656, 92, 1, 32, "Input"],
Cell[195466, 3659, 548, 9, 30, "Text"],
Cell[CellGroupData[{
Cell[196039, 3672, 1845, 48, 159, "Input"],
Cell[197887, 3722, 10790, 345, 242, "Output"],
Cell[208680, 4069, 2096, 44, 75, "Output"]
}, Open  ]]
}
]
*)

