(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    381445,       6955]
NotebookOptionsPosition[    378154,       6859]
NotebookOutlinePosition[    378513,       6875]
CellTagsIndexPosition[    378470,       6872]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{Cell[TextData[{
  StyleBox["            ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["Algorithm:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox["ARoots",
   FontFamily->"Optima",
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox["             \n               ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["Authors:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox[
  "Ana C. Concei\[CCedilla]\[ATilde]o (aconcei@ualg.pt) & J\[EAcute]ssica \
Pires (jessicaccpires@gmail.com) ",
   FontFamily->"Optima",
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontWeight->"Plain",
   Background->None],
  StyleBox["        \n                    ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["Year:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["2021",
   FontFamily->"Optima",
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox["\n           ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["Institution:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox[
  "Center for Functional Analysis, Linear Structures and Applications \
(CEAFEL), Universidade do Algarve",
   FontFamily->"Optima",
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox["          ",
   FontFamily->"Optima",
   FontWeight->"Plain",
   Background->None],
  "\n   ",
  StyleBox["Article/Journal:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  " ",
  StyleBox["Symb",
   FontColor->GrayLevel[0.5]],
  StyleBox["olic comput",
   FontColor->GrayLevel[0.5],
   Background->GrayLevel[0.85]],
  StyleBox[
  "ation applied to Cauchy type singular integrals. \n                  Math. \
Comput. Appl. ",
   FontColor->GrayLevel[0.5]],
  "\n                  \n        ",
  StyleBox["  ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["License",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[":",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.3799496452277409, 0.6257724879835203, 0.7690852216372931],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  Cell[BoxData[
   GraphicsBox[
    TagBox[RasterBox[CompressedData["
1:eJzs3QmUHMd54Pnqaq2GjzNaWbIlPy5FUGvrjQ9aegQlr+WZXR+AZnzKh6jD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      "], {{0, 270}, {1400, 0}}, {0, 255},
      ColorFunction->RGBColor],
     BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
     Selectable->False],
    DefaultBaseStyle->"ImageGraphics",
    ImageSize->{251.96484375, Automatic},
    ImageSizeRaw->{1400, 270},
    PlotRange->{{0, 1400}, {0, 270}}]]],
  "\n  "
 }], "Section",
  CellChangeTimes->{{3.560518296834669*^9, 3.5605183114080544`*^9}, {
   3.560518646082142*^9, 3.560518662165022*^9}, {3.560518702205791*^9, 
   3.560518800592577*^9}, {3.560518864590123*^9, 3.5605188705762587`*^9}},
  FontFamily->"Courier",
  FontSize->14,
  Background->GrayLevel[0.85],
  ExpressionUUID -> 
  "8c5f323e-a33d-4a8f-a576-4cb80b2c81be"], "\[IndentingNewLine]", 
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzs3QdcFHf+/3G83nLxn2aaGhtGxU5TLAh2xS72XrCiIopix44FsXcMiqLY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    "], {{0, 936}, {892, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->{755.83984375, Automatic},
  ImageSizeRaw->{892, 936},
  PlotRange->{{0, 892}, {0, 936}}]}], "Input",
 CellChangeTimes->{{3.8495310784374523`*^9, 3.84953114420625*^9}, {
  3.8499015669572363`*^9, 3.849901567649131*^9}, {3.84990395323738*^9, 
  3.849903953722123*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Instructions", ":", "\[IndentingNewLine]", " ", 
    RowBox[{
     RowBox[{
      GraphicsBox[
       TagBox[RasterBox[CompressedData["
1:eJztne9XVFe651kz82Jezr8wc29POiaRl9P3Tscob+7tTgysO2tut5FkTW4E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         "], {{0, 138}, {588, 0}}, {0, 255},
         ColorFunction->RGBColor],
        BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
        Selectable->False],
       DefaultBaseStyle->"ImageGraphics",
       ImageSize->{271.96875, Automatic},
       ImageSizeRaw->{588, 138},
       PlotRange->{{0, 588}, {0, 138}}], "                    ", "Shift"}], 
     "+", "Enter"}]}], "              ", "\[IndentingNewLine]", "     ", 
   GraphicsBox[
    TagBox[RasterBox[CompressedData["
1:eJztnf13FFea33WS/SE/5l9INsns+I1fvZk1YM4mZ2fGvBzvJrPGHmc9vDnZ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      "], {{0, 120}, {720, 0}}, {0, 255},
      ColorFunction->RGBColor],
     BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
     Selectable->False],
    DefaultBaseStyle->"ImageGraphics",
    ImageSize->{321.96875, Automatic},
    ImageSizeRaw->{720, 120},
    PlotRange->{{0, 720}, {0, 120}}], "\[IndentingNewLine]", "    ", 
   GraphicsBox[
    TagBox[RasterBox[CompressedData["
1:eJzt3Ql0XPV58GE3/ZKvJ6f9miZt2rRJswJlb3ag7FkITlgKBUJCIATCkg1D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      "], {{0, 418}, {800, 0}}, {0, 255},
      ColorFunction->RGBColor],
     BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
     Selectable->False],
    DefaultBaseStyle->"ImageGraphics",
    ImageSize->{347.16796875, Automatic},
    ImageSizeRaw->{800, 418},
    PlotRange->{{0, 800}, {0, 418}}], "\[IndentingNewLine]", "    ", 
   GraphicsBox[
    TagBox[RasterBox[CompressedData["
1:eJztnfmXFFWWx2uWH+bH+QfmzHSP7QKKv0zPUbHshu5WYdrWQVFbUUBl0W6h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      "], {{0, 174}, {394, 0}}, {0, 255},
      ColorFunction->RGBColor],
     BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
     Selectable->False],
    DefaultBaseStyle->"ImageGraphics",
    ImageSize->{193.78125, Automatic},
    ImageSizeRaw->{394, 174},
    PlotRange->{{0, 394}, {0, 174}}], "\[IndentingNewLine]", "    ", 
   RowBox[{
    GraphicsBox[
     TagBox[RasterBox[CompressedData["
1:eJzt3QmUXHWd6PG8mTe+OZ6ZN874nvPmjY4rIKtvHEVAUMEFg7IMCIgii7IE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       "], {{0, 406}, {798, 0}}, {0, 255},
       ColorFunction->RGBColor],
      BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
      Selectable->False],
     DefaultBaseStyle->"ImageGraphics",
     ImageSize->{312.28515625, Automatic},
     ImageSizeRaw->{798, 406},
     PlotRange->{{0, 798}, {0, 406}}], "    ", 
    GraphicsBox[
     TagBox[RasterBox[CompressedData["
1:eJzt3Qt4XHWB8P++u//1v4/P7rvu+r7u7ru6XgERwXddRUBQQQVa5bIg4IWr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       "], {{0, 412}, {792, 0}}, {0, 255},
       ColorFunction->RGBColor],
      BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
      Selectable->False],
     DefaultBaseStyle->"ImageGraphics",
     ImageSize->{308.55859375, Automatic},
     ImageSizeRaw->{792, 412},
     PlotRange->{{0, 792}, {0, 412}}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "or", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "     ", 
   RowBox[{
    GraphicsBox[
     TagBox[RasterBox[CompressedData["
1:eJztnf13FFea33WS/SE/5l9INsns+I1fvZk1YM4mZ2fGvBzvJrPGHmc9vDnZ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       "], {{0, 120}, {720, 0}}, {0, 255},
       ColorFunction->RGBColor],
      BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
      Selectable->False],
     DefaultBaseStyle->"ImageGraphics",
     ImageSize->{323.24609375, Automatic},
     ImageSizeRaw->{720, 120},
     PlotRange->{{0, 720}, {0, 120}}], "  ", 
    GraphicsBox[
     TagBox[RasterBox[CompressedData["
1:eJzt3QmYXGWd6OHcmTveeXxm7jjjvc6dOzqugIDgHUcREFRwgURZhlUFWRRJ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       "], {{0, 414}, {798, 0}}, {0, 255},
       ColorFunction->RGBColor],
      BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
      Selectable->False],
     DefaultBaseStyle->"ImageGraphics",
     ImageSize->{298.91015625, Automatic},
     ImageSizeRaw->{798, 414},
     PlotRange->{{0, 798}, {0, 414}}]}], " ", "\[IndentingNewLine]", "     ", 
   RowBox[{
    GraphicsBox[
     TagBox[RasterBox[CompressedData["
1:eJzt3QmcnHV9+PH823/99+Wr/dfW1v7baq0HUORqrSJQbhUkylEQEEUOuT0g
oOVSkSBUyhUISAjInVAkQC4UUBJIAiSQCCEEksCGLLCBJcitAtkk3//8Znd2
n5md2czuPtmdZN+f1+vtbOZ45tl5Hl4+353rI984Yd+j/2jYsGHf/dPC/+x7
+Cm7nHTS4aft977CP/Y//rvHHXP8UUfucfz3jjrmqJO2+cYfF8782f8aNuzv
Cz/878LPL7/8cgAAAOTljTfeiBUrVgAAAAAAAAAAAAwpL730EgAAQK5aW1sB
AAAa1ouzZ8cLP700Wr51TDz35b3i2c/vVJR+Tuely9J1Bmv9li5dGvPmzYvp
06fHL37xi5g8eXJR+jmdly5L17F+AADQPy+++GK/vfDQnGg55Xvx7M7bxh/2
/FzEgXtHHPzliEMPbJd+LpyXLkvXSddNt8njvuuRjs1nzpwZEydOjPvuuy8e
euiheOSRR+Kxxx4rSj+n89Jl6Trpuuk21g8AAPrmhRde6JflN14fz35h12jb
d3jEN74SceTXIo6oIV1WuE66brpNum1/739tHn300Zg6dWrcf//9sWDBgli4
cGHR448/XqZ0frpOum66TbrtUF8/AADoi+XLl/dZy6Wj4809don42r7l88U3
vlpddt4o3CbdNi2jP+vQk/QcwD333FN8vVHlsXs6Xs+qPKZPt0m3TcsYqusH
AAADreXG69tnjPS6qKrzxVcqVJk3CrctzhqFZeW9fvPnzy8eh6e/+WeP4bPH
7qXXJVU7nk+3SbdNy0jLGmrrBwAA/dHS0tJrz8+eXXx/d/F5jG4zRmGmOPyg
6rLzRul2hWWkZaVl9mVdqnnqqaeK75/OPk9QeexeS/Z4vvS8QVpWWuZQWT8A
ABgMz5/83Vi5z/Cu10rVM2PUmjUKy0jLSsvMa/1mzJhRfA9Db4/hax3Lp2Wl
ZQ6V9QMAgP56/vnne+eB++O5Hbdpnxd6mjEOq9DTrFH4d1pmWnav16fCkiVL
YtKkSWWvMerNMXz2WD57+7TMtOwNff0AACAPzz33XK88P/ri9s+uLXsuYy0z
Rk+zRsdzGmmZadm9XZ9Kpc9/zT5XUO04Pb2nIaunY/m0rNLnzW7o6wcAAHl4
9tlne+W5Y49o/36M7HMZ9cwYVWeNzHMahWWmZfd2fSqVPoOpp+P4ymP4Wsfy
2eP40mdDbejrBwAAg2K/Pdu/d6/acxnZeaL0HX0l1WaN7HMahWWmZfd3/e64
447i99rVet9DrWP4asfy2fdBpGWmZW/o6wcAAHlobm7uleLnTJU+yzbPOaNw
nbTs3q5PpfTZS+kYvJ7nCtLnwib1PGeQfk7L3tDXDwAA8rBs2bJeaf7cjuts
zkjL7u36VErvh15Xx/Fp2Rv6+gEAwGBY16+b6u/6revXJW3o6wcAAHl45pln
emVdvw+8t+tTaV2/z3pDXz8AAMjD0qVLe6V51IXr7HNt07J7uz6VHnzwwXX2
ubFp2Rv6+gEAwGB45r5719n39KVl93f90jH3uvoevLTsDX39AAAgD01NTb3W
/N0RsXKf4RXPaVSZNaqpnDEKy0jLSsvsy7pUM3369Lj//vvLnjPozbF89n0P
aRlpWWmZQ2X9AACgv55++ulea7rvvvbPnfravu2zQr2zRuWMkRSWkZaVltmX
dakmHX+nv+/Pmzev18fylcfwaRlpWenfQ2X9AABgsDxz9VXx5h67dH3Gbdms
0TFvlPlq9xmjcNu0jLSsvNfv4YcfLr4vOn0ubOlYPns8nz2mz55Xul66Tbpt
WkZa1lBbPwAA6I+nnnqqz5658IL2WSM9r1F6DVW3eaPKfHFk+/MYxRmjsIz+
rENPZs2aVTwOzz5vUO14Pnv8nn2eIN02LWOorh8AAPTVkiVL+mXpVWOjebdd
om3f4e3PW2TnjUpHtr/nO1033Sbdtr/3vzazZ8+OKVOmFN/DkI7X0zF65TF9
6dg9SddJ1023Sbcd6usHAACD5enp02LZSSdE807btH/mbfp+jfRdfqXv6Es/
F84rfnZt4Trpuuk2A7V+6dh82rRpcfvttxc//zV910T6XrvS65LSz+m8dFm6
Trpuuo31AwCAvlm8eHFunvrVr+KZC8+P5mOOiOZ9v1R8f3dR+rlwXrosXSfP
++yN9D0U6bmAXxXWYerUqcX3Tyfp53Reuixdx/oBAED/LFq0CAAAIFdPPvkk
AAAAAABAQ3viiScAAAAAAAAAAACGlNL3vwEAAAAAADSqBx98sMwDDzwAAABQ
l8p5omTy5MkAAAC5+u1vfwsAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA0D+tj8Zl
p54QI0YcGxfc/tjgrw8AADSMZXHlodvEsM2GxXaHXBXNg74+65Hme2L4sGEx
rGCbc+4b/PUBAICGsSwu2qP9WHnYtqOiadDXJx8vPXFbHLbHHrHHvx8QV899
tg/LaI1J/3Vw7FFYxpdPuClaql1n+T1xQMecsZs5I//HFwCA9diyuCwzZ2wo
z2c8e+9Z7b9TwdnTn+nT43LR9muZv8wZ/VDH4wsAwHpsw5wzls86r3POOH9m
X57PaOl6XHav8biYM/qhjscXAID1WO05o6VpYcyfPz/mL2xuP69lUcy8Y2KM
u/bauLbgljvujcUttZbbEgvTbQuaWtvPa21+PO6eeEtMvOOOuKVw+4nT59V8
vUzz4o77Xtxcc93brzM3Fi5e3nlea2Ed5y9cGLOu+07nnHH8tYX1XNixLjXX
t6Q1mgrXXbhwWpz4iY7HZZOTYsbC0mPR1HXdKnNGa9Ojxd+x/TEaF3f08Dtm
tT82NxYf12TcLXfE/KaWPm7Trse+ubX9d5o/8664Zdy44rKnzl5S9f6nF9a7
dP/XjpsYM+cvrfP+WmPh7GmF5V/befuJd8/s3O59fnwBAFiP1ZozMq9r2X1U
zPzVJbFZxzF1uc3igju6f9bSs2XPJzwR9155ZJXbFvzz4TF1/vJu6zSqdAy6
8bk1XlOTuc5GXes96yf/Vv1+OvzwrrW8hqowO+zQw+3L1iczZ+w7+pfxi0uP
qvE7fjPuWvhSjftsqX27gq9fMKnX713IPvYnj5sQp21fvsyPn/Hrivs/vub9
//OXz40Hm1+peV8tC6fEcdvXerw2ix/eMqfvj+9v09z2cHEmvfaWe722CgBg
vVJ7zug8vw5jZpfPCtlj3bXbLG4omzWW1fGamurXmXXRrj3e11rfq7H8vs7P
kOrNnLF234wHWyuP15fFdcd+dO237eXngK3tse/6bKyn48rD6ln34XF7lTnp
2VmX1/W773bGL6O1L4/vbx+P0z6RXe9f1/0YAAAw2OqfM3Y/5fqO1/K0xuK5
U8v/jv3168v+7l7tWDf9bX5xc2vx9gtn3lB+jL5d9viynveM1LhOa0s0t7TE
Y5N+0PU3/YkLorWlOZqbm+t6bqAlXa/l0Tiz9PttNzIeLSwz3b65uP4d1+02
Z2wW54y7N5paWovrMe+O88v+dn/wNb8pu58nJny7/La3zInm1tZobW2OORPO
Lnv+6OTbn6p7m3Z/7DeLM679RcxfvLj4eqrSa8ceG39E2fVOuOJX7evesX0O
yy6jct575aE4rmz7nR53zV9anCfSa7Am/NfBZcs+f9pzvX98n72z/LmPDej9
QwAAG7765oxtT/llt9u+snRK13FgxTFg5bHu0RXH2EXN95Qdy17S+X7tfswZ
HbLvAz87c4zbp8eljveBl69/l6W/+H6Nv8cvijMzf6uvfD6o+Bjem3kMC3PY
ojrXvfyx3yF+Pr/aa7bKnys4e2qVOWb5fWWzRPb3WzLpe5kZpPq6zcm+Vm6/
yudk6nnO6umyfXDfKx5qgP9eAACoTz1zxg4xtanaa/Sz1zkwprV0XafsWHfj
kTWPkedd99Uqr+fp/5yRvf++fq7tWtchO2fs/tOa1+l8nVDm81tfeuxnPc5w
7Vrjyv27Xrt0Vw/vk6j1u29zRvXXGmXvv+a6/7b8OY+u7dMS4zOv96r5eV6v
PJqZUyrXv87POWt9OubOnVuwsOu1VwAArAfqmTOGx7Sqx7jl18keR2aPdXv6
zNfscyK7XXD/WtapnvXufv8DMWfsdkGN37FwrN35vEHm7/Zlz1X88zdj7LVj
Y+zYCoXzjvvE2rZBd/U89tn773rcq3j2zs45qet3zHy3Y8V8Wenen3y263p9
mTMAAFhP5TdnTKsxZ1R9zVRJ9jmBzvd4rIdzRs1Zqvpyevc++d79HnXNGfW+
rqzqczb1vOap3ayL9qnxvIc5AwBgw7bu54x9R/fw9/Ll93Uex257yuS1rFM9
6939/ht+zth0eBx66KE92v8Lx8Xt3T7/t7rezhk/rPbejCrbZ+Njbuo+B25X
+zVxSdecsVlcPbfGZ4qZMwAANkDrfs7Y5oxa7z8of5/AbtXen1HP59qubc4Y
gPeB93rOuPeszvX7/Oh8399c3+umzspsn9qfF/vKEzd3fu5V1+umnu76bpUe
3zfSGpNGbF1jH6r/OREAANZH637OGDbs8CrfHdHuVz/6XJX3CWRf///NeLja
90o3Z17Ps5Y5o8e/19fzuNT6m30/5oxXltzW9VldPX2WVGvH5722tNa97vXM
GWX3v8np8XiNZXW9v6L8fRy/OPXTnecf//Mnq69Lc+Y98N3ex1H/cyIAAKyP
BmLOGBYbnXBTt1lg6b0XZ74jYrO4fXHp9i2Zz1kaFid3O45tiQmnfr5r+dXm
jMz7nLfp4X3oPT0uF2V+t7uqvde5H3NG5ecGf310lds3ZT/3t8a8VUV978Ev
v//9zvllt89zSt/D17V9dshsn3TZxZnte2BM7fY9fk+XfQfhxztfE9eLx7dg
yfQbYsShh8YhI34SM5pqfac6AACNZ2DmjKIvnBi33D09Zs6cHuMvPLr8sqNv
LTvOrfwOuWPOGR8z586NmXffGCcOr1hulTmj7HNbCzPMCZdOiLvvvjsW1vmZ
TcXPbj206zh50y+cHrfccUfcPfOJruv0a86o+Mypgu2OGRV3z54b8+fOjklj
zyn7jrqan2dVRb2f9VW5jf75y2fGxOkzq26fjU7oaU5of4zPuHZS4bYzY3ph
G5V9h2PhspsXV84IdTy+rQ+Xf1dgYR8Z/P9eAACoT+Z4MfP9Dt3+3lxjzqh1
nV59ntJ2p8fDlX/PLhxjnljv7cvWu6T8e/A6X0N1V/3vCV+S+Y69Thtnvrc8
87qgnuaM6o9vu1nZ77KrZZPT49E6n8soPvb31jdnFO//uu+s/f6/PKr666qa
74sTqzzGlS6Y+kTV+17r45v97pGkh+/5AACg0SyLy0qvUTrkqo7PE0qyr006
PGZUfV1LS1x36MeqXqf886bui/n3jokDqhyT7nfGTbVfm9/ycFx07DbdbrPp
vx8Xt8+dH+NHfKb9vP2qH3+2Ns2IMw/dtuy2vfvsqdaYNe6HZc8rlD0n8dID
nd9Dt2/N76DIPL7dvhO73ZKZN8Rh23d/bNLsdsbYX1SZoXq2/LHrO9f54Dq+
Q3vp7JvjuD02qXL/O8QZ196b2SeqeTomXXhU1fliu0POjGkLe/qMrLU8vul9
5Gd2vX/n7Kk13gcCAMCQUeu1O81Ni2PhwoUxf/7CaKrzvc0thdvMnz+/eLvF
TS29X5/W1mhpaSnq6+/T2tp++5ZePK/QW82L2x+X4u+5uHnAv/+6ualw/wsX
R9Pi9tOe54vKx7g5Fha20eKmpvbT5t491gPx+AIAsP6r9z0CAAAA9TJnAAAA
ect+D9zHe/geOAAAgLo1PxzXXnppXFpw++ylg78+AAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA0
vPsWvx7Xz3krxtz/OwAAYAM3UHPGZTPfAgAAhghzBgAAkLeBnDNOGf8kAAAw
BAz0nCFJkiRpw8+cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmSJCnvzBmSJEmS8s6cIUmS
JCnvBnrOAAAANnwDOWcAAABDgzkDAADI20DNGfctfj2un/NWjLn/dwAAwAZu
oOYMAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAANgwrVqyIF198MV544YWqli9fTgOrtd3SNk3bdrD3L/vj0LKh
7Y8AQO+lY4KnnnoqFixYEPPmzYuHHnoo5syZ083s2bNpYNW2WdqWaZumbZu2
cdrWg72/rc3jS1+Iq+57MU6c+EocMO538aUb3mUDkrZp2rZpG6dtPdj7GwCQ
v5dffjmeeeaZmD9/fixevDhaW1vj3XffDW1YpW2atm3axmlbp22etv1g73/V
9sc75i2PvW9cGV/9+co48vaVcdyUlfHtqWxIjpvcvm3TNt7rxneL27wR90cA
oO/S8Wb6O3d6HYOGRmlbp22etv1g73+V0vHmPuNWxmG3vRvfLMwX35raVjwt
+VbxvI7T0s+F6zht1NPy7ZfdhqV/H16YN/YZ1z5rDPb+BwDkI71+Jv1t24wx
9ErbPG37RnoNVXr9zF7Xr4xDb21/DuPYye1/9y6a0lY87ek8p415WtOUDpPb
t/mXCtvea6gAYMOQXqv/5JNPDvYhrwaptO3TPjDY+2HJ2Okvxv43rYxjJrfF
MZNWtks/F63MnLeyyuU0pEkry02u8u/J7dvxgMK2T/vAYO+HAED/pM968Xqp
oV3p9VON8Lk/aR2+M+HVOPiWlXHUxComtRVO27p+ntRW/Xo0tsJ2O7pj2x1d
sR3Ttk/7QCPsjwBA36VjzPQ5RO+8885gH+5qkErbPu0DaV9ohP1xr2t+F4fd
2v7+4CNva2s/ndhxWvCNjn9/o3T5bV2X0Zi+UaFs+1Vs37Tt0z7QCPsjANB3
6TPs77///kE5vn11eXPx7+jtFkXT8hXRNihr0pi9MPPqGDHitBhx6nWxbB0/
MGkfSPtCI+yPnx27Mg4vHH8mh6XjzpJbM+ffmt4j3tapdN1GPj3khpbYd9RD
sfclTXHA5Y/EnqMWxIHXvzXo6zUQp6XtV7Y9Ky7P/rxrYR9ohP0RAOi79P/l
M2bMWLcHsRW9/JuJceIuw2LYsGp2jZHjZsWrA7pGjdkjo/fofExmv7lu7yvt
A41wXJfWYZcxK+OQWwvH5RNWtiv+XLKy/fTWKiasbMjTr4+ZFZ/abaca+/uw
+L/b/yg+f9mK2su59dXYKd3+w8Pibz47Lg7q4Xq77rln/NU/7hx/V7jusO1u
jIMa4PfvWr8etlXF+WkfaIT9EQDou4GdM96O6aO/UvN4q9yxMWP5qgFar8bs
8bEHdjwW+8S8ITRn7HR5eo1+W3yt08ri6cETus5LP5f+fXDp3w14utf3Tq5z
fx8WGx33QHy12nImvBbbfqbjepuMiQOq3d+tb8fnD9wxs7wtY8fRrw367186
LW2naqfZ7Vmyw0/NGQCwvhu4OaMtpp+1Xfmx1ebHxjV3zooFixbFb2ZOivNG
7Nlt1nhsHR9fN3JDdc7Y4bKVcdDP28p85ebaP3+l4vxGOd3jqIMq9uedY7Nj
J8bu5z4UuxXseuJF8aGKWeN9B/06Dqxc3s9fi+227rjOxmNi3yr3N/zo8vv6
1PmvDfrvX3laTXH7Vbk87QONsD8CAH03UHPGW49cVnYctOfIu6PaofNbTb+O
Y7LHXidMHbLv2Riqc8Z2F6+MAwrHnvv/T1scUKHaeY1o/4tuKNvf37vL1TH8
+irXHb88th1e/pqqfznntfLr3PxabJOZM/6jYhl7nlT+nMkWI18Y9N+/5uNS
2oY3J6syv+OqzPltxX2gEfZHAKDvBmbOeDtuOrjrOGjHU+/ucXZYtfTmzHHT
PjXem9AWy5vmxbTJk2PChAlF0+YsiFdrLPjtV1uiubk5mpe/1XHGS7Fg5rSY
3HHbO2c+Eiverud3KdzvotlxZ8ftJkyYXLjfxTXvt+yWb7bEnGmTOtd38p0z
o/nV2nc6VOeMbUatjP1uaot9b1oV+45vK/683/gO6fzSeVnjG+n07djuc5lZ
eedxsVdP1/+ft2KHvTOzxjbjYu+yy1+LrT/dcdlGY2KvzO33+tFFZTPGxv+5
tAF+/x5Ob8psw8xlaVtnt+W2F7c1xP4IAPTdQMwZlXPD2o+Z2+K2zFwyat7v
yi59Yc6N8fUta73Ofas4d9KSiuW9EVeW3ne+55Wx4KGrY6sat7185rO1f4/l
D8bpNd+/vlVc3O1+S70ds677Ts3X5R855t6oNm0M1Tlj64vaYp9xqwraOu3d
+fOqTnt3nr+qofzH6Oz+vnNsO3btt9n36gfi77PPaVz4u67ljXs9Pp2ZM4aX
fv//Ln/O5MPHPTHov3stpe20d2abFo0vbedVZedtfaHnMwBgfTcQc8ZrD13Y
eSy06al313Wbtjfbv6drxYpXy577eOvxn9X1ntqT78l+7+Abcd3e9b0XN7lx
0bvd1uetxTfXmE3KHXTNwopbvhG3jtho7fd71P90ex3ZUJ0zPnVBW+x546r4
0g3tp6WfS/+u/Dl7XiP44tmZ5xg+Nym+WOft/n2vruc0Pnr6C5nLXotPfqpr
zvhC+p1H3REfyOw/Hzj04UH/vddmz8xp57a7YVXnNu5UOP9T53s+AwDWdwMx
Zzwy9gtdz0385vV+LCnzvETBV8+9LZpWvFmcQ9Jrku665Iiu47vNzo6WzO0q
54w9R97W8ZqltljRNKP8c3aPvK3i+YVlcXp2Jtj5+zGj6eXi/b796rKYMjpz
v8O2iomZz8l64a7vlT/ncefieLOtLdra3ozFd44qm13OvOe3Zfc6VOeMfz1v
dQy/flXRHsl1bWWGd5zXeZ0q5w/m6c6Hd70n+6M/WFH37b7wXz/tvN17v/Jw
5vLX418/2bGfbD0udr/y0bL3j79//1/HFxrg9+7xtGKbVV6nKPNz2gcaYX8E
APpuIOaMruPl/s8Zd11ySow4bUScUJgTun/HRlvcevTGncfmXe/rKJ8zdhhZ
5XsJX7svdi0du+14ZdlzCy9PP6NrVtjp7MLU0b3sLLX9mNJzGi/FeZnXd1V9
niT7/vgdLy3coquhOmds+ZO22O3aVQVtsXvxtN3umdPdryv9u63bZYN9usNh
XXPGx854ve7bfe7srjnjfQfOzVz+emz1b6X9aMt4/4fKZ+ZPjmmM37un087t
1m27tnVuy+x10z7QCPsjANB369ecsfaWXndAlWPz7Jyxa8yo+iWA2escEvM6
n9BoiymZ1z3VXP+3l8WdEybH5IJ5y98pnrXq2Zt7nm06lt/1Hvny97wP1Tlj
i3PaYterV8Wu16xqPy25ZlX38yuv0wC2O7RrzvjID1+u+3a7nHZm5+3+/IC5
ned/9urXY4t/7eE1d58eFzs2wO/dLxXbdotzVjXE/ggA9N36Ome8uWJZ/GbO
zJh2552FY/vxce21V8Qll/x3HLPL5muZM2ods5dfJ/tcyNiq88faK3uuYvOT
YnxhPcePr1A478Qtq6/bUJ0zPvHjttj5Z6tip6tWFU5XF6WfS9JlXVZXOW9w
bXtI15zxTz94uf7bnvXTsjmjdP4uP3s9Nu9pzkjPf3x1/qD/3j3KbKPO7XhV
1/ar3Lab/djzGQCwvhuQ92eM3qNrzqj47Khe9+qTMfroHXs85spjzqh62z2v
rPqdH7V66/HL6ljPctk5bKjOGZuOXBXbj10VO1y5Ora/sv20+HPhvPTvRvdv
X+/6vskPnfJy/bc9s2vOeM/+czOXvR6bfjKzn2wxKj5TOH/bEaeU7TsfPr0X
9zXA2rdh1zbNnl+2jTvO32Sk5zMAYH03MJ83dU4drx+qo1VPl78fO9lyy9h7
773j4KOPjtPOOq3rPRbrYs74xPmZ95avvbI5Y4t94ujCOvbk4L1OjHua3+m8
/VCdMzb+UeEY+oreWN3L669b25zW9XlTf/T5X9Z9u6326/q8qb894fnMZa/H
Jv9S2jdHxBajS+e/E5sP3zzz38PesemFg//717edVmf+3f3njc4wZwDA+m4g
5ox3Fmc/5/+QeKyO1x4tvfPyOO20swrOi9kr2j+/Kfv5uOl1SPc0vdz9djft
n/ucMXat7+2o3luPdK3vF6+p9d0atRuqc8bHfrAqPn35qvjM5auLp1lbj1nd
eX46zf7cKKdb/zi7v+8TG1+49tttM3p+/G1mfv7QD//QtbzLX4+NtyrNulfE
J7O3H7Os7LOnhn304tiqQR6HytOelLZt6bppH2iE/REA6LuB+T7w7LH6sPjS
xQ/3fPVV8+OYzLHTjU3tf+Mv+3zcqq+/eqPsPdX5zBkRD523bef9HnHLM9XX
+bUH47wRpxXmohFxzYyO7+54+VeZz7Aq/yypstrejjfffDPefLv8S8WH6pzx
kdNXxScvXR2f/GnGZas6/Vv6d+Hy0mnndRvl9LLfx8c/kzn2/+yd8a9rud0n
/mOvrusXZokty5b3RnysNGf8U+Gyitt/6seT4r2Z/17+eM+ZjfE4ZE8vW1V+
Wmu7dUj7QCPsjwBA3w3MnFH+2qnkyDEPR1u1K7a1xE0nbpw55uo6Pl983eGd
5x9f5Xh/6ZQfrYP3Z6TnY67KLHfXmNT0TsVt2+Ku0z/eeZ2Dxi2psszC73zN
o1UemLmZmeqkeDrzoAzVOeMfT10VW45e3eWS7M+rup/XgLY69fKy/f1P9pgc
n6h2vUvfiI322avsun914ivdrvPRLbvmjM2qLGeLb51atoz3fev5QX8Mqrqk
4rSGfzzFnAEA67uBmjMi3o5bj6l4b8Ve349JcxbH8uXLo2nRb2LKFWd2+87t
qxd0PW9Rfrw/LE64YkosWLQoFi2YEWNHfKl82TnOGWndu54naTfy2umxqKkp
fjNzUpy+92Zl9zs789qqss+cKtjphCtjzqKmaG5aFNPHX5x5P8mw+OKY8jlk
qM4ZHzp5dWx+yZrY7JJ0urp4Wvo5nb952b9L55Wu3yCno1fGx7+4U/k++f8O
jr87ZnZs9OPW2PTHzfHx74yLv/mH8v3qf+0wJTatXN7oN+KfOueMsbFJrfvb
LftejV3iH85aOfiPQ8dp5bbM2jyj9O+0DzTC/ggA9N3AzRmpV+LW07avmAdq
+8k9z1Xc/o1ux/u11fps2vLvqMguu8frvPNE/HiXtd/vqBm/7bbkx2/69trX
d7OzY1nFEzyPd75OrNY651cjzRl/993Vsemo1bFJh00vXtMuc94mlZePWt14
Lv59fGy/r9W9v7/nS3fGxlWX80Z8aIuO6334itio5v0tK3uPx7D3j4yPXNgY
j80mmdPK7VrtvLQPNML+CAD03cDOGe0tnXZ17NPD8daep46Nxzre+929V2L6
Fd/pfrstvh7jfvNCLJ3ynx3nZb/r4u2466zhHecfW+N96G9nvku81nXeKNz3
Kd2ec0l2Puq8mN38Vs3f+eUFE+OYXavPQ+eOm1Xlu80Lj9Ot36ryu6ybGmnO
+H8nro6NCsfHJRtfFF2nBRt32OiiNUVllzfi6cmT46827mHG+MAx8YHjn699
+1Fvxgc/3XHdrcfHx3q4v03OmBR/lp1dDnpy8H//yu2WtmvmvI2y53dI+0Aj
7I8AQN8NxpzR3tuxvOmxmDltWsxZsCDmzJxZOG2KFW9WfddG99reLL7e6tVX
V8SKFev4j/1V7nvF8uZoLtx/cR3qXedI3y+4PJqb22+X1rv+W67bGmnO+MCI
NfGx81fHRy9YUyZ7XrXLG94PnowPHntP/EOHvz92Znzw+63xkcFerwaR3aZp
H2iE/REA6LvBmzPUSDXSnPH+b6+OD5+3Jv7p/DXF06Liz6s7zlvdLnN56bpO
G/O0axtmrS67rHjdjtO/PsGcAQDrO3OGUo01Z6yJD567Oj7432u6O7fKeWwY
Mts27QONsD8CAH1nzlCqkeaM931zTfzdT+pwbod6rkvjqGOb/cVx3p8BAOs7
c4ZSjTRn/MWxa+Jv/ysriqcfOKfyvPLznTb2aWmbVTs//Zzdvn9+rOczAGB9
Z85QqpHmjD87ek389TnR5eySNeXnVZ7SuMq255ral3VI+0Aj7I8AQN+9+OKL
cf/998cf/vCHwT7U1SCVtn3aB9K+0Aj744e++W785ciI9/044q+Ss9PPa4o/
v4/1Vvv2W9N9u54dmW27Jv7yzIgPfXtlQ+yPAEDfrVixIubOnRstLS2Dfbir
QSpt+7QPpH2hEfbHz/3otfjz0yL+4qzu/jL775HVr0MDGpk5HdmxHSu2X2nb
pm2f9oFG2B8BgP5ZuHBhPProo4N9uKtBKm37tA8M9n5Y8sPrX4j3Hl843hxZ
4cwOIzOnIyv+7bQxT2v9fGaFwnlp26d9YLD3QwCg/5YtWxYPPPBA8VRDq+y2
H+z9sGT2/OfiPUdE/Ol/RvzZGQVnZmT+/d5alzltzNNq261ie/7pyRF/Utj2
aR8Y7P0QAOi/l156KRYsWBCzZs0yawyh0rZO2zxt+7QPDPZ+mN0fr5zyTLzn
6Ij3fK/9+DPr/9T4t9P187QkzZVpm19V2PaNtD8CAP2TXqP/yCOPxLRp04qv
1W9ubo7f//73g30orJxL2zRt27SN07ZO2zxt+8He/6rtj2Nufzr++PCIP/lW
QWHeeM8PCn7YLh2jZn8u/dtp455W857vt2/bP/l2FLd12uaNuD8CAH2X3nP5
/PPPxxNPPFF8Hc3dd98dU6ZMiYkTJ8btt9/ezW233UYDq7bN0rZM2zRt27SN
07ZO27wR329b2h+nPbg4Trr8mdj+lBXx/iPejT/6WsQfHcyG4v1HvFPctmkb
p23dqPsjANA/6f/fly9fXnw9zZIlS+Lxxx+Pxx57LObPn88GIG3LtE3Ttk3b
OG3rRj6mq9wf03vV7Y8bjrQt0zZdX/ZHAKD/0muj03dkpf/fT69hSNLfGbOe
e+45Gljl9iptx7RN07Zdn17/bn9c/21I+yMAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAsH74/wXY2kY=
       "], {{0, 412}, {794, 0}}, {0, 255},
       ColorFunction->RGBColor],
      BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
      Selectable->False],
     DefaultBaseStyle->"ImageGraphics",
     ImageSize->{329.86328125, Automatic},
     ImageSizeRaw->{794, 412},
     PlotRange->{{0, 794}, {0, 412}}], 
    GraphicsBox[
     TagBox[RasterBox[CompressedData["
1:eJzt3QmYXHWZ6P/cmf/4n8dn5o4z3uvM3NFxBQQE7zgugKKCChJlGRBwQRZF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       "], {{0, 404}, {792, 0}}, {0, 255},
       ColorFunction->RGBColor],
      BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
      Selectable->False],
     DefaultBaseStyle->"ImageGraphics",
     ImageSize->{336.15625, Automatic},
     ImageSizeRaw->{792, 404},
     PlotRange->{{0, 792}, {0, 404}}]}]}]}]], "Input",
 CellChangeTimes->{{3.849531711054488*^9, 3.849531725504019*^9}, {
  3.849531840562112*^9, 3.849531853997031*^9}, {3.849531895244656*^9, 
  3.8495319800098543`*^9}, {3.849532031989149*^9, 3.849532103253682*^9}, {
  3.849534677731761*^9, 3.84953467844134*^9}, {3.8499341914740334`*^9, 
  3.8499341980660553`*^9}, {3.8499342345411377`*^9, 3.849934237508543*^9}, {
  3.849934276124346*^9, 3.849934336228923*^9}, {3.8499343903885098`*^9, 
  3.849934444499095*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.849934243538435*^9, 3.849934274417869*^9}}],

Cell[TextData[{
 "\n",
 StyleBox["Example A", "Text",
  FontColor->RGBColor[1, 0.5, 0],
  Background->GrayLevel[0.85]]
}], "Input",
 CellChangeTimes->{{3.8490960592243304`*^9, 3.8490960658361*^9}, {
  3.8491004422116766`*^9, 3.8491004483012094`*^9}, {3.84910062231301*^9, 
  3.849100622656823*^9}, {3.849903055240994*^9, 3.849903055893759*^9}},
 ExpressionUUID -> "70cdafed-04df-4fd8-bff6-b13301cfa087"],

Cell[BoxData[
 RowBox[{
  RowBox[{"p", 
   RowBox[{"(", "t", ")"}]}], "=", 
  RowBox[{
   SuperscriptBox["t", "7"], "+", 
   FractionBox["\[ImaginaryI]", "4"]}]}]], "Input",
 CellChangeTimes->{{3.84952971909087*^9, 3.849529761888335*^9}, {
  3.849531190126484*^9, 3.8495312069767857`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "\"\<ARoots.m\>\""}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.8484105984889536`*^9, 3.848410628764763*^9}, {
   3.848410679074044*^9, 3.848410752639961*^9}, {3.8484107980005493`*^9, 
   3.8484108095210733`*^9}, {3.848410856847094*^9, 3.8484108773186274`*^9}, {
   3.8491004693199797`*^9, 3.8491004798034134`*^9}, {3.8491006394337797`*^9, 
   3.8491006515988455`*^9}, {3.849100753336996*^9, 3.8491007543654523`*^9}, 
   3.849531170261579*^9, 3.8495312445074263`*^9},
 ExpressionUUID -> "6f1e2249-a7c1-4726-8945-4ec814a5dd75"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"p(t)=\"\>", "\[InvisibleSpace]", 
   RowBox[{
    FractionBox["\[ImaginaryI]", "4"], "+", 
    SuperscriptBox["t", "7"]}]}],
  SequenceForm["p(t)=", Complex[0, 
     Rational[1, 4]] + $CellContext`t^7],
  Editable->False]], "Print",
 CellChangeTimes->{3.849531490348078*^9, 3.849531997350418*^9, 
  3.849901696376642*^9, 3.849901974216854*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>"}], "}"}]], "Print",
 CellChangeTimes->{3.849531490348078*^9, 3.849531997350418*^9, 
  3.849901696376642*^9, 3.849901974233979*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"This polynomial has \"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\" roots in the unit circle, \"\>", 
   "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\" roots inside the unit circle and \"\>", 
   "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\" roots outside the unit circle.\"\>"}],
  SequenceForm[
  "This polynomial has ", 0, " roots in the unit circle, ", 7, 
   " roots inside the unit circle and ", 0, " roots outside the unit circle."],
  Editable->False]], "Print",
 CellChangeTimes->{3.849531490348078*^9, 3.849531997350418*^9, 
  3.849901696376642*^9, 3.849901974249968*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   FractionBox["\[ImaginaryI]", 
    SuperscriptBox["2", 
     RowBox[{"2", "/", "7"}]]]}],
  SequenceForm[1, "\[LongRightArrow]", Complex[0, 1] 2^Rational[-2, 7]],
  Editable->False]], "Print",
 CellChangeTimes->{3.849531490348078*^9, 3.849531997350418*^9, 
  3.849901696376642*^9, 3.849901974265189*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "2", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"-", "1"}], ")"}], 
      RowBox[{"1", "/", "14"}]], 
     SuperscriptBox["2", 
      RowBox[{"2", "/", "7"}]]]}]}],
  SequenceForm[
  2, "\[LongRightArrow]", -(-1)^Rational[1, 14] 2^Rational[-2, 7]],
  Editable->False]], "Print",
 CellChangeTimes->{3.849531490348078*^9, 3.849531997350418*^9, 
  3.849901696376642*^9, 3.84990197427993*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "3", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   FractionBox[
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], 
     RowBox[{"3", "/", "14"}]], 
    SuperscriptBox["2", 
     RowBox[{"2", "/", "7"}]]]}],
  SequenceForm[3, "\[LongRightArrow]", (-1)^Rational[3, 14] 2^Rational[-2, 7]],
  Editable->False]], "Print",
 CellChangeTimes->{3.849531490348078*^9, 3.849531997350418*^9, 
  3.849901696376642*^9, 3.8499019742949038`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "4", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"-", "1"}], ")"}], 
      RowBox[{"5", "/", "14"}]], 
     SuperscriptBox["2", 
      RowBox[{"2", "/", "7"}]]]}]}],
  SequenceForm[
  4, "\[LongRightArrow]", -(-1)^Rational[5, 14] 2^Rational[-2, 7]],
  Editable->False]], "Print",
 CellChangeTimes->{3.849531490348078*^9, 3.849531997350418*^9, 
  3.849901696376642*^9, 3.8499019743092957`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "5", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"-", "1"}], ")"}], 
      RowBox[{"9", "/", "14"}]], 
     SuperscriptBox["2", 
      RowBox[{"2", "/", "7"}]]]}]}],
  SequenceForm[
  5, "\[LongRightArrow]", -(-1)^Rational[9, 14] 2^Rational[-2, 7]],
  Editable->False]], "Print",
 CellChangeTimes->{3.849531490348078*^9, 3.849531997350418*^9, 
  3.849901696376642*^9, 3.849901974324033*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "6", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   FractionBox[
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], 
     RowBox[{"11", "/", "14"}]], 
    SuperscriptBox["2", 
     RowBox[{"2", "/", "7"}]]]}],
  SequenceForm[
  6, "\[LongRightArrow]", (-1)^Rational[11, 14] 2^Rational[-2, 7]],
  Editable->False]], "Print",
 CellChangeTimes->{3.849531490348078*^9, 3.849531997350418*^9, 
  3.849901696376642*^9, 3.8499019743386183`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "7", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"-", "1"}], ")"}], 
      RowBox[{"13", "/", "14"}]], 
     SuperscriptBox["2", 
      RowBox[{"2", "/", "7"}]]]}]}],
  SequenceForm[
  7, "\[LongRightArrow]", -(-1)^Rational[13, 14] 2^Rational[-2, 7]],
  Editable->False]], "Print",
 CellChangeTimes->{3.849531490348078*^9, 3.849531997350418*^9, 
  3.849901696376642*^9, 3.849901974353168*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Root \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\": Approximate value=\"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{
    "-", "0.35593017159492717513512052562797305268`9.787888371990134"}], "-", 
    RowBox[{
    "0.73909661700252944568437893940308619012`10.105224782449477", " ", 
     "\[ImaginaryI]"}]}]}],
  SequenceForm["Root ", 4, ": Approximate value=", 
   Complex[-0.35593017159492717513512052562797305268`9.787888371990134, \
-0.73909661700252944568437893940308619012`10.105224782449477]],
  Editable->False]], "Print",
 CellChangeTimes->{3.849531490348078*^9, 3.849531997350418*^9, 
  3.849901696376642*^9, 3.849901980404293*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.849903111921574*^9, 3.849903114144231*^9}}],

Cell[TextData[{
 "\n",
 StyleBox["Example B", "Text",
  FontColor->RGBColor[1, 0.5, 0],
  Background->GrayLevel[0.85]]
}], "Input",
 CellChangeTimes->{{3.8490960592243304`*^9, 3.8490960658361*^9}, {
  3.8491004422116766`*^9, 3.8491004483012094`*^9}, {3.84910062231301*^9, 
  3.849100622656823*^9}, {3.8491009585039067`*^9, 3.8491009591552997`*^9}, {
  3.849903059087081*^9, 3.849903060028494*^9}},
 ExpressionUUID -> "51ce825d-4d62-4fa2-a696-48b14f1cbde4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"p", 
   RowBox[{"(", "t", ")"}]}], "=", 
  RowBox[{
   SuperscriptBox["t", "6"], "+", 
   RowBox[{"5", 
    SuperscriptBox["t", "4"]}], "-", 
   RowBox[{"6", " ", "t"}], "+", "1"}]}]], "Input",
 CellChangeTimes->{{3.84952971909087*^9, 3.849529761888335*^9}, {
  3.849531522730575*^9, 3.849531539777157*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "\"\<ARoots.m\>\""}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.8484105984889536`*^9, 3.848410628764763*^9}, {
  3.848410679074044*^9, 3.848410752639961*^9}, {3.8484107980005493`*^9, 
  3.8484108095210733`*^9}, {3.848410856847094*^9, 3.8484108773186274`*^9}, {
  3.8491004693199797`*^9, 3.8491004798034134`*^9}, {3.8491006394337797`*^9, 
  3.8491006515988455`*^9}, {3.849100753336996*^9, 3.8491007543654523`*^9}, {
  3.849531555378072*^9, 3.8495315561960173`*^9}},
 ExpressionUUID -> "8b01683f-4b00-4ad0-bedf-534fc03f1cbd"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"p(t)=\"\>", "\[InvisibleSpace]", 
   RowBox[{"1", "-", 
    RowBox[{"6", " ", "t"}], "+", 
    RowBox[{"5", " ", 
     SuperscriptBox["t", "4"]}], "+", 
    SuperscriptBox["t", "6"]}]}],
  SequenceForm[
  "p(t)=", 1 - 6 $CellContext`t + 5 $CellContext`t^4 + $CellContext`t^6],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.84910098762825*^9, {3.849531566772294*^9, 3.849531582643984*^9}, 
   3.849901718050455*^9},
 ExpressionUUID -> "720ce199-162e-4153-ac2e-31742fd5f7c9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>"}], "}"}]], "Print",
 CellChangeTimes->{
  3.84910098762825*^9, {3.849531566772294*^9, 3.849531582643984*^9}, 
   3.849901718061357*^9},
 ExpressionUUID -> "720ce199-162e-4153-ac2e-31742fd5f7c9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"This polynomial has \"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\" roots in the unit circle, \"\>", 
   "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\" roots inside the unit circle and \"\>", 
   "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\" roots outside the unit circle.\"\>"}],
  SequenceForm[
  "This polynomial has ", 0, " roots in the unit circle, ", 2, 
   " roots inside the unit circle and ", 4, " roots outside the unit circle."],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.84910098762825*^9, {3.849531566772294*^9, 3.849531582643984*^9}, 
   3.849901718073748*^9},
 ExpressionUUID -> "720ce199-162e-4153-ac2e-31742fd5f7c9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "-", 
       RowBox[{"6", " ", "#1"}], "+", 
       RowBox[{"5", " ", 
        SuperscriptBox["#1", "4"]}], "+", 
       SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}]}],
  SequenceForm[1, "\[LongRightArrow]", 
   Root[1 - 6 # + 5 #^4 + #^6& , 1, 0]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.84910098762825*^9, {3.849531566772294*^9, 3.849531582643984*^9}, 
   3.8499017180783*^9},
 ExpressionUUID -> "720ce199-162e-4153-ac2e-31742fd5f7c9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "2", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "-", 
       RowBox[{"6", " ", "#1"}], "+", 
       RowBox[{"5", " ", 
        SuperscriptBox["#1", "4"]}], "+", 
       SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}]}],
  SequenceForm[2, "\[LongRightArrow]", 
   Root[1 - 6 # + 5 #^4 + #^6& , 2, 0]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.84910098762825*^9, {3.849531566772294*^9, 3.849531582643984*^9}, 
   3.849901718082699*^9},
 ExpressionUUID -> "720ce199-162e-4153-ac2e-31742fd5f7c9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "3", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "-", 
       RowBox[{"6", " ", "#1"}], "+", 
       RowBox[{"5", " ", 
        SuperscriptBox["#1", "4"]}], "+", 
       SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}],
  SequenceForm[3, "\[LongRightArrow]", 
   Root[1 - 6 # + 5 #^4 + #^6& , 3, 0]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.84910098762825*^9, {3.849531566772294*^9, 3.849531582643984*^9}, 
   3.8499017180870447`*^9},
 ExpressionUUID -> "720ce199-162e-4153-ac2e-31742fd5f7c9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "4", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "-", 
       RowBox[{"6", " ", "#1"}], "+", 
       RowBox[{"5", " ", 
        SuperscriptBox["#1", "4"]}], "+", 
       SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}],
  SequenceForm[4, "\[LongRightArrow]", 
   Root[1 - 6 # + 5 #^4 + #^6& , 4, 0]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.84910098762825*^9, {3.849531566772294*^9, 3.849531582643984*^9}, 
   3.8499017180914917`*^9},
 ExpressionUUID -> "720ce199-162e-4153-ac2e-31742fd5f7c9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "5", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "-", 
       RowBox[{"6", " ", "#1"}], "+", 
       RowBox[{"5", " ", 
        SuperscriptBox["#1", "4"]}], "+", 
       SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}],
  SequenceForm[5, "\[LongRightArrow]", 
   Root[1 - 6 # + 5 #^4 + #^6& , 5, 0]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.84910098762825*^9, {3.849531566772294*^9, 3.849531582643984*^9}, 
   3.849901718095783*^9},
 ExpressionUUID -> "720ce199-162e-4153-ac2e-31742fd5f7c9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "6", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "-", 
       RowBox[{"6", " ", "#1"}], "+", 
       RowBox[{"5", " ", 
        SuperscriptBox["#1", "4"]}], "+", 
       SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}],
  SequenceForm[6, "\[LongRightArrow]", 
   Root[1 - 6 # + 5 #^4 + #^6& , 6, 0]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.84910098762825*^9, {3.849531566772294*^9, 3.849531582643984*^9}, 
   3.849901718100119*^9},
 ExpressionUUID -> "720ce199-162e-4153-ac2e-31742fd5f7c9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Root \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\": Approximate value=\"\>", "\[InvisibleSpace]", 
   "0.1673235251238118848`5."}],
  SequenceForm["Root ", 1, ": Approximate value=", 0.1673235251238118848`5.],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.84910098762825*^9, {3.849531566772294*^9, 3.849531582643984*^9}, 
   3.849901724224453*^9},
 ExpressionUUID -> "720ce199-162e-4153-ac2e-31742fd5f7c9"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.849903098695087*^9, 3.8499031075293427`*^9}}],

Cell[BoxData[Cell[TextData[{
  "\n",
  StyleBox["Example C", "Text",
   FontColor->RGBColor[1, 0.5, 0],
   Background->GrayLevel[0.85]]
 }], "Input",
  CellChangeTimes->{{3.8490960592243304`*^9, 3.8490960658361*^9}, {
    3.8491004422116766`*^9, 3.8491004483012094`*^9}, 3.849532134049685*^9},
  ExpressionUUID -> "649647c8-8971-4f18-8746-9fffeb7823c6"]], "Input",
 CellChangeTimes->{{3.8499030638126183`*^9, 3.8499030960011387`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"p", 
   RowBox[{"(", "t", ")"}]}], "=", 
  RowBox[{
   SuperscriptBox["t", "21"], "-", 
   RowBox[{"6", 
    SuperscriptBox["t", "5"]}], "+", 
   RowBox[{"4", "\[ImaginaryI]", " ", "t"}]}]}]], "Input",
 CellChangeTimes->{{3.84952971909087*^9, 3.849529761888335*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "\"\<ARoots.m\>\""}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.8484105984889536`*^9, 3.848410628764763*^9}, {
  3.848410679074044*^9, 3.848410752639961*^9}, {3.8484107980005493`*^9, 
  3.8484108095210733`*^9}, {3.848410856847094*^9, 3.8484108773186274`*^9}, {
  3.8491004693199797`*^9, 3.8491004798034134`*^9}, {3.8491007130869875`*^9, 
  3.8491007231705036`*^9}, {3.849529215644454*^9, 3.849529233684289*^9}},
 ExpressionUUID -> "4e91c716-21a6-42b9-834d-89b72b63244b"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"p(t)=\"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"4", " ", "\[ImaginaryI]", " ", "t"}], "-", 
    RowBox[{"6", " ", 
     SuperscriptBox["t", "5"]}], "+", 
    SuperscriptBox["t", "21"]}]}],
  SequenceForm[
  "p(t)=", Complex[0, 4] $CellContext`t - 
   6 $CellContext`t^5 + $CellContext`t^21],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.8499345119366713`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>"}], "}"}]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.849934511951684*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"This polynomial has \"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\" roots in the unit circle, \"\>", 
   "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\" roots inside the unit circle and \"\>", 
   "\[InvisibleSpace]", "16", 
   "\[InvisibleSpace]", "\<\" roots outside the unit circle.\"\>"}],
  SequenceForm[
  "This polynomial has ", 0, " roots in the unit circle, ", 5, 
   " roots inside the unit circle and ", 16, 
   " roots outside the unit circle."],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.849934511975086*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   "0"}],
  SequenceForm[1, "\[LongRightArrow]", 0],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.849934511989991*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "2", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}]}], "]"}]}],
  SequenceForm[2, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 1}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.8499345120050297`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "3", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2"}], "}"}]}], "]"}]}],
  SequenceForm[3, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 2}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.849934512020232*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "4", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}]}], "]"}]}],
  SequenceForm[4, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 3}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.849934512035391*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "5", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}]}], "]"}]}],
  SequenceForm[5, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 4}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.8499345120505543`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "6", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "5"}], "}"}]}], "]"}]}],
  SequenceForm[6, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 5}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.8499345120657187`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "7", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "6"}], "}"}]}], "]"}]}],
  SequenceForm[7, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 6}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.8499345120808277`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "8", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "7"}], "}"}]}], "]"}]}],
  SequenceForm[8, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 7}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.849934512095853*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "9", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "8"}], "}"}]}], "]"}]}],
  SequenceForm[9, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 8}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.849934512111106*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "10", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "9"}], "}"}]}], "]"}]}],
  SequenceForm[10, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 9}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.849934512126309*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "11", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "10"}], "}"}]}], "]"}]}],
  SequenceForm[11, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 10}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.8499345121414623`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "12", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "11"}], "}"}]}], "]"}]}],
  SequenceForm[12, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 11}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.84993451215917*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "13", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "12"}], "}"}]}], "]"}]}],
  SequenceForm[13, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 12}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.849934512250525*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "14", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "13"}], "}"}]}], "]"}]}],
  SequenceForm[14, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 13}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.849934512266827*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "15", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "14"}], "}"}]}], "]"}]}],
  SequenceForm[15, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 14}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.849934512282411*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "16", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "15"}], "}"}]}], "]"}]}],
  SequenceForm[16, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.84993451229841*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "17", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "16"}], "}"}]}], "]"}]}],
  SequenceForm[17, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 16}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.849934512310503*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "18", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "17"}], "}"}]}], "]"}]}],
  SequenceForm[18, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 17}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.849934512323188*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "19", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "18"}], "}"}]}], "]"}]}],
  SequenceForm[19, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 18}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.849934512335802*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "20", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "19"}], "}"}]}], "]"}]}],
  SequenceForm[20, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 19}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.849934512348029*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "21", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "+", 
         SuperscriptBox["#1", "2"]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", "#1"}], "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["#2", "4"]}], "+", 
         SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "20"}], "}"}]}], "]"}]}],
  SequenceForm[21, "\[LongRightArrow]", 
   Root[{1 + #^2& , 4 # - 6 #2^4 + #2^20& }, {2, 20}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.849531465717772*^9, 3.849531476270172*^9}, {
   3.849531786942943*^9, 3.849531825969304*^9}, 3.849901671679401*^9, {
   3.8499035841909313`*^9, 3.849903612931487*^9}, 3.8499037419553823`*^9, 
   3.8499038202672853`*^9, 3.849934043611994*^9, 3.849934512360758*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.849934061324499*^9, 3.849934063525764*^9}}],

Cell[TextData[{
 "\n",
 StyleBox["Example D", "Text",
  FontColor->RGBColor[1, 0.5, 0],
  Background->GrayLevel[0.85]]
}], "Input",
 CellChangeTimes->{{3.8490960592243304`*^9, 3.8490960658361*^9}, {
  3.8491004422116766`*^9, 3.8491004483012094`*^9}, {3.84910062231301*^9, 
  3.849100622656823*^9}, {3.8491009585039067`*^9, 3.8491009591552997`*^9}, {
  3.849903059087081*^9, 3.849903060028494*^9}, {3.8499340652462797`*^9, 
  3.849934065573617*^9}},
 ExpressionUUID -> "51ce825d-4d62-4fa2-a696-48b14f1cbde4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"p", 
   RowBox[{"(", "t", ")"}]}], "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"t", "-", "2"}], ")"}], 
   RowBox[{"(", 
    RowBox[{"t", "+", 
     RowBox[{"3", "\[ImaginaryI]"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.84952971909087*^9, 3.849529761888335*^9}, {
  3.849531522730575*^9, 3.849531539777157*^9}, {3.849934071935124*^9, 
  3.849934089295857*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "\"\<ARoots.m\>\""}]}], "Input",
 CellChangeTimes->{{3.8484105984889536`*^9, 3.848410628764763*^9}, {
   3.848410679074044*^9, 3.848410752639961*^9}, {3.8484107980005493`*^9, 
   3.8484108095210733`*^9}, {3.848410856847094*^9, 3.8484108773186274`*^9}, {
   3.8491004693199797`*^9, 3.8491004798034134`*^9}, {3.8491007130869875`*^9, 
   3.8491007231705036`*^9}, {3.849529215644454*^9, 3.849529233684289*^9}, 
   3.8499341609888487`*^9},
 ExpressionUUID -> "4e91c716-21a6-42b9-834d-89b72b63244b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>"}], "}"}]], "Print",
 CellChangeTimes->{3.849934156374104*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"This polynomial has \"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\" roots in the unit circle, \"\>", 
   "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\" roots inside the unit circle and \"\>", 
   "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\" roots outside the unit circle.\"\>"}],
  SequenceForm[
  "This polynomial has ", 0, " roots in the unit circle, ", 0, 
   " roots inside the unit circle and ", 2, " roots outside the unit circle."],
  Editable->False]], "Print",
 CellChangeTimes->{3.8499341563815413`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   "2"}],
  SequenceForm[1, "\[LongRightArrow]", 2],
  Editable->False]], "Print",
 CellChangeTimes->{3.8499341563905*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "2", "\[InvisibleSpace]", "\<\"\[LongRightArrow]\"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"-", "3"}], " ", "\[ImaginaryI]"}]}],
  SequenceForm[2, "\[LongRightArrow]", 
   Complex[0, -3]],
  Editable->False]], "Print",
 CellChangeTimes->{3.8499341563962727`*^9}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{897, 753},
WindowMargins->{{190, Automatic}, {Automatic, 0}},
FrontEndVersion->"11.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (September \
21, 2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 170394, 2892, 1068, "Input"],
Cell[170955, 2914, 161635, 2692, 1161, "Input"],
Cell[332593, 5608, 92, 1, 32, "Input"],
Cell[332688, 5611, 403, 9, 51, "Input"],
Cell[333094, 5622, 289, 8, 49, "Input"],
Cell[CellGroupData[{
Cell[333408, 5634, 879, 18, 96, "Input"],
Cell[CellGroupData[{
Cell[334312, 5656, 392, 10, 36, "Print"],
Cell[334707, 5668, 838, 17, 24, "Print"],
Cell[335548, 5687, 667, 13, 44, "Print"],
Cell[336218, 5702, 429, 10, 37, "Print"],
Cell[336650, 5714, 554, 16, 40, "Print"],
Cell[337207, 5732, 527, 14, 40, "Print"],
Cell[337737, 5748, 557, 16, 40, "Print"],
Cell[338297, 5766, 555, 16, 40, "Print"],
Cell[338855, 5784, 532, 15, 40, "Print"],
Cell[339390, 5801, 557, 16, 40, "Print"],
Cell[339950, 5819, 714, 15, 24, "Print"]
}, Open  ]]
}, Open  ]],
Cell[340691, 5838, 92, 1, 32, "Input"],
Cell[340786, 5841, 456, 10, 51, "Input"],
Cell[341245, 5853, 342, 10, 32, "Input"],
Cell[CellGroupData[{
Cell[341612, 5867, 876, 18, 96, "Input"],
Cell[CellGroupData[{
Cell[342513, 5889, 530, 14, 25, "Print"],
Cell[343046, 5905, 797, 17, 24, "Print"],
Cell[343846, 5924, 731, 15, 44, "Print"],
Cell[344580, 5941, 656, 18, 27, "Print"],
Cell[345239, 5961, 658, 18, 27, "Print"],
Cell[345900, 5981, 660, 18, 27, "Print"],
Cell[346563, 6001, 660, 18, 27, "Print"],
Cell[347226, 6021, 658, 18, 27, "Print"],
Cell[347887, 6041, 658, 18, 27, "Print"],
Cell[348548, 6061, 481, 10, 24, "Print"]
}, Open  ]]
}, Open  ]],
Cell[349056, 6075, 94, 1, 32, "Input"],
Cell[349153, 6078, 434, 9, 53, "Input"],
Cell[349590, 6089, 301, 9, 32, "Input"],
Cell[CellGroupData[{
Cell[349916, 6102, 823, 17, 96, "Input"],
Cell[CellGroupData[{
Cell[350764, 6123, 669, 15, 25, "Print"],
Cell[351436, 6140, 2339, 47, 63, "Print"],
Cell[353778, 6189, 848, 16, 44, "Print"],
Cell[354629, 6207, 492, 10, 24, "Print"],
Cell[355124, 6219, 978, 25, 27, "Print"],
Cell[356105, 6246, 976, 25, 27, "Print"],
Cell[357084, 6273, 976, 25, 27, "Print"],
Cell[358063, 6300, 978, 25, 27, "Print"],
Cell[359044, 6327, 978, 25, 27, "Print"],
Cell[360025, 6354, 978, 25, 27, "Print"],
Cell[361006, 6381, 976, 25, 27, "Print"],
Cell[361985, 6408, 976, 25, 27, "Print"],
Cell[362964, 6435, 978, 25, 27, "Print"],
Cell[363945, 6462, 982, 25, 27, "Print"],
Cell[364930, 6489, 979, 25, 27, "Print"],
Cell[365912, 6516, 980, 25, 27, "Print"],
Cell[366895, 6543, 980, 25, 27, "Print"],
Cell[367878, 6570, 980, 25, 27, "Print"],
Cell[368861, 6597, 979, 25, 27, "Print"],
Cell[369843, 6624, 980, 25, 27, "Print"],
Cell[370826, 6651, 980, 25, 27, "Print"],
Cell[371809, 6678, 980, 25, 27, "Print"],
Cell[372792, 6705, 980, 25, 27, "Print"],
Cell[373775, 6732, 980, 25, 27, "Print"]
}, Open  ]]
}, Open  ]],
Cell[374782, 6761, 92, 1, 32, "Input"],
Cell[374877, 6764, 507, 11, 51, "Input"],
Cell[375387, 6777, 403, 12, 32, "Input"],
Cell[CellGroupData[{
Cell[375815, 6793, 832, 18, 75, "Input"],
Cell[CellGroupData[{
Cell[376672, 6815, 280, 6, 24, "Print"],
Cell[376955, 6823, 600, 12, 44, "Print"],
Cell[377558, 6837, 246, 7, 24, "Print"],
Cell[377807, 6846, 319, 9, 24, "Print"]
}, Open  ]]
}, Open  ]]
}
]
*)

