(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    531653,      10108]
NotebookOptionsPosition[    529624,      10043]
NotebookOutlinePosition[    529983,      10059]
CellTagsIndexPosition[    529940,      10056]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[Cell[TextData[{
  StyleBox["            ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["Algorithm:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox["ASPPlusPMinus",
   FontFamily->"Optima",
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox["             \n               ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["Authors:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox[
  "Ana C. Concei\[CCedilla]\[ATilde]o (aconcei@ualg.pt) & J\[EAcute]ssica \
Pires (jessicaccpires@gmail.com) ",
   FontFamily->"Optima",
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontWeight->"Plain",
   Background->None],
  StyleBox["        \n                    ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["Year:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["2021",
   FontFamily->"Optima",
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox["\n           ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["Institution:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox[
  "Center for Functional Analysis, Linear Structures and Applications \
(CEAFEL), Universidade do Algarve",
   FontFamily->"Optima",
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox["          ",
   FontFamily->"Optima",
   FontWeight->"Plain",
   Background->None],
  "\n   ",
  StyleBox["Article/Journal:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  " ",
  StyleBox["Symb",
   FontColor->GrayLevel[0.5]],
  StyleBox["olic comput",
   FontColor->GrayLevel[0.5],
   Background->GrayLevel[0.85]],
  StyleBox[
  "ation applied to Cauchy type singular integrals. \n                  Math. \
Comput. Appl. ",
   FontColor->GrayLevel[0.5]],
  "\n                  \n        ",
  StyleBox["  ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["License",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[":",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.3799496452277409, 0.6257724879835203, 0.7690852216372931],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  Cell[BoxData[
   GraphicsBox[
    TagBox[RasterBox[CompressedData["
1:eJzs3QmUHMd54Pnqaq2GjzNaWbIlPy5FUGvrjQ9aegQlr+WZXR+AZnzKh6jD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      "], {{0, 270}, {1400, 0}}, {0, 255},
      ColorFunction->RGBColor],
     BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
     Selectable->False],
    DefaultBaseStyle->"ImageGraphics",
    ImageSize->{251.96484375, Automatic},
    ImageSizeRaw->{1400, 270},
    PlotRange->{{0, 1400}, {0, 270}}]]],
  "\n  "
 }], "Section",
  CellChangeTimes->{{3.560518296834669*^9, 3.5605183114080544`*^9}, {
   3.560518646082142*^9, 3.560518662165022*^9}, {3.560518702205791*^9, 
   3.560518800592577*^9}, {3.560518864590123*^9, 3.5605188705762587`*^9}},
  FontFamily->"Courier",
  FontSize->14,
  Background->GrayLevel[0.85],
  ExpressionUUID -> "8c5f323e-a33d-4a8f-a576-4cb80b2c81be"]], "Input",
 CellChangeTimes->{{3.849904978814466*^9, 3.8499049822246857`*^9}, {
  3.849907318616084*^9, 3.8499073186162157`*^9}}],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzsnQdcFVfe/iHZki3vu252k2hM1ERjjxVBUQTFiqCIiogNRMGCjSKIgIgg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    "], {{0, 738}, {724, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{724, 738},
  PlotRange->{{0, 724}, {0, 738}}]], "Input"],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{3.849905020260078*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Instructions", ":", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     GraphicsBox[
      TagBox[RasterBox[CompressedData["
1:eJztnf1XVMe651kz88P8OP/CzL1ncmIS+XHOvXPjUX6595zEwLqz5p6TaLIm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        "], {{0, 148}, {604, 0}}, {0, 255},
        ColorFunction->RGBColor],
       BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
       Selectable->False],
      DefaultBaseStyle->"ImageGraphics",
      ImageSize->{264.87109375, Automatic},
      ImageSizeRaw->{604, 148},
      PlotRange->{{0, 604}, {0, 148}}], "             ", "Shift"}], "+", 
    "Enter"}]}], "            "}], "\[IndentingNewLine]", 
 RowBox[{"          ", 
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJztnWt3HdWZoL1m5sN8nL8wMz3dE0Lga3q6ua6eWR06YBad7oRLMp0Adnp1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     "], {{0, 148}, {1124, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   DefaultBaseStyle->"ImageGraphics",
   ImageSize->{507.48046875, Automatic},
   ImageSizeRaw->{1124, 148},
   PlotRange->{{0, 1124}, {0, 148}}]}], "\[IndentingNewLine]", 
 RowBox[{"          ", 
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJzt3QmUXHWd6PG8mTe+OZ6ZN874nvPmjY7jAgwg+MZRBxhQQQVBWQYG3FBQ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     "], {{0, 428}, {806, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   DefaultBaseStyle->"ImageGraphics",
   ImageSize->{341.58984375, Automatic},
   ImageSizeRaw->{806, 428},
   PlotRange->{{0, 806}, {0, 428}}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"or", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"         ", 
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJztnWt3HdWZoL1m5sN8nL8wMz3dE0Lga3q6ua6eWR06YBad7oRLMp0Adnp1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     "], {{0, 148}, {1124, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   DefaultBaseStyle->"ImageGraphics",
   ImageSize->{507.48046875, Automatic},
   ImageSizeRaw->{1124, 148},
   PlotRange->{{0, 1124}, {0, 148}}]}], "\[IndentingNewLine]", 
 RowBox[{"         ", 
  RowBox[{
   GraphicsBox[
    TagBox[RasterBox[CompressedData["
1:eJzt3QmYXHWd6P2+M+/4zuMz844z3uvcuaPjuADD6tVRBxBUUNmUZUBElNWF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      "], {{0, 416}, {796, 0}}, {0, 255},
      ColorFunction->RGBColor],
     BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
     Selectable->False],
    DefaultBaseStyle->"ImageGraphics",
    ImageMargins->0.,
    ImageSize->{327.62890625, Automatic},
    ImageSizeRaw->{796, 416},
    PlotRange->{{0, 796}, {0, 416}}], 
   GraphicsBox[
    TagBox[RasterBox[CompressedData["
1:eJzt3QmYXHWd6O/cmf/4n8dn5o4z3uvcuaPjCkgQvOMoAoIKLhCUZUDAhVVZ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      "], {{0, 412}, {790, 0}}, {0, 255},
      ColorFunction->RGBColor],
     BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
     Selectable->False],
    DefaultBaseStyle->"ImageGraphics",
    ImageSize->{323.8671875, Automatic},
    ImageSizeRaw->{790, 412},
    PlotRange->{{0, 790}, {0, 412}}]}], " "}], "\[IndentingNewLine]", 
 RowBox[{"         ", 
  RowBox[{
   GraphicsBox[
    TagBox[RasterBox[CompressedData["
1:eJzt3QmUXHWZ8OGM8+k3xzPzjaMzzjgj4wqIbOOGwLCrLFGWAQFRFJDdBQI6
bCoSFmXYAgEJAdkTBtmygAJKAiRAgAQIIZAAHdJAJzRBdhVIJ3m/+ld3dd+q
ruquTt90V9LP75zH6q6uW3Wr7vVw39T2se8eufsh7xo2bNiP/qbwP7sfcOy2
Rx99wPF7vK/wy55H/OjwQ484+KCdjvjxwYcefPSm3/3rwplX/NWwYf9S+OH/
FH5+6aWXAgAAoL9ef/31WLJkCQAAAAAAAAAAwBrpxRdfBAAAyEVraysAAEDD
eGHGjFj8q/Oj5fuHxnNf3yWe/crWRenndF76W7rMYK3fggULYtasWTF16tT4
7W9/G5MmTSpKP6fz0t/SZawfAAD0zwsvvLDSFj9wf7Qc++N4dpvN4i87fzli
710j9v16xH57t0s/F85Lf0uXSZdNy/TnNvsiHZNPmzYtJkyYEHfddVc88MAD
8fDDD8ejjz5alH5O56W/pcuky6ZlrB8AAKycxYsXr5RFV18Zz+64XbTtPjzi
u9+IOOhbEQfWkP5WuEy6bFomLbuyt1uvRx55JG6++ea45557Ys6cOTF37tyi
xx57rEzp/HSZdNm0TFp2qK8fAACsjEWLFvVZy/mj442dto341u7lc8V3v1ld
ds4oLJOWTdexMrddj/Rv/nfccUfxdUWVx+zpOD2r8lg+LZOWTdcxVNcPAAAG
SsvVV7bPFun1T1Xnim9UqDJnFJYtzhiF68p7/WbPnl08/k7/xp89ds8es5de
f1TtOD4tk5ZN15Gua6itHwAA9EdLS0vdnp8xo/i+7eLzFt1mi8IsccA+1WXn
jNJyhetI15Wusy/r0JOnnnqq+L7o7PMClcfstWSP40vPE6TrStc5VNYPAAAG
0vPH/CiW7ja86zVR9cwWtWaMwnWk60rXmdf63X333cX3KPT12L3WMXy6rnSd
Q2X9AACgv55//vn63HtPPLfVpu1zQk+zxf4VepoxCr+n60zXXfd61PDkk0/G
xIkTy15L1Jdj9+wxfHb5dJ3putf09QMAgDw899xzdXl+9Lntn0Fb9txFL7NF
TzNGx3MY6TrTdde7HrWUPsc1+9xAtePz9J6FrJ6O4dN1lT43dk1fPwAAyMOz
zz5bl+cOO7D9+y2yz13UM1tUnTEyz2EUrjNdd73rUUvpM5V6On6vPHavdQyf
PX4vfdbTmr5+AAAwoPbYuf378qo9d5GdI0rfrVdSbcbIPodRuM503f1dv1tu
uaX4fXS13tdQ69i92jF89n0O6TrTda/p6wcAAHlobm6uS/Fzo0qfSZvnfFG4
TLruetejlvRZSunYu57nBtLnuyb1PEeQfk7XvaavHwAA5GHhwoV1af7yVqts
vkjXXe961JLe57yqjt/Tda/p6wcAAANpVb8+qr/rt6pff7Smrx8AAOThmWee
qcuqfn93vetRy6p+//Savn4AAJCHBQsW1KV51Nmr7PNp03XXux613Hfffavs
81/Tda/p6wcAAAPpmbvuXGXfr5euu7/rl461V9X316XrXtPXDwAA8tDU1FS3
5h+NiKW7Da94DqPKjFFN5WxRuI50Xek6+7IOPZk6dWrcc889Zc8R9OUYPvu+
hnQd6brSdQ6V9QMAgP56+umn69Z0113tnyP1rd3bZ4R6Z4zK2SIpXEe6rnSd
fVmHnqTj7vTv+bNmzerzMXzlsXu6jnRd6fehsn4AADDQnrn0knhjp227Pqu2
bMbomDPKfLP7bFFYNl1Huq681+/BBx8svt85fb5r6Rg+exyfPZbPnle6XFom
LZuuI13XUFs/AADoj6eeeqrPnjn7rPYZIz2PUXqtVLc5o8pccVD78xbF2aJw
HStz2/WYPn168fg7+zxBteP47HF79nmBtGy6jqG6fgAAsLKefPLJlbLgkrHR
vP220bb78PbnKbJzRqWD2t/LnS6blknLruzt1mvGjBkxefLk4nsU0nF6Ojav
PJYvHbMn6TLpsmmZtOxQXz8AABhoT0+dEguPPjKat960/bNr0/djpO/gK323
Xvq5cF7xM2gLl0mXTcsM1PqlY/IpU6bETTfdVPwc1/RdEen76EqvP0o/p/PS
39Jl0mXTMtYPAABWzvz58/vtqd//Pp45+8xoPvTAaN79a8X3bRelnwvnpb+l
y+RxWysjfY9E+rf/3xfW4eabby6+LzpJP6fz0t/SZawfAAD0z7x58wAAAHLx
xBNPAAAAAAAANJTHH38cAAAAAAAAAABgjVT6/jYAAAAAAIBGcd999xXde++9
AAAAdSnNEZUmTZoEAACQiz/+8Y8AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAQKNo
fSQuOO7IGDHisDjrpkcHf30agccEAGCIWxgX77dpDFt/WGz+nUuiedDXZzXS
fEcMHzYshhVsetpdg78+jcBjAgAwxC2Mc3ZqPx4cttmoaBr09cnHi4/fGPvv
tFPs9J97xaUzn12J62iNib/YN3YqXMfXj7wmWqpdZtEdsVfHsfT2jqU9JgAA
RJovLsjMF2vK8xfP3nly+30qOHXqMyv1uJyzRS9zl2NpjwkAABXWzPli0fQz
OueLM6etzPMXLV2Pyw41HhfH0h4TAAAq1J4vWprmxuzZs2P23Ob281rmxbRb
JsS4yy+Pywuuu+XOmN9S63pbYm5atqCptf281ubH4vYJ18WEW26J6wrLT5g6
q/rrjgqa53fc9vzmmuvefpmZMXf+os7zWgvrOHvu3Jh+xQ8754sjLi+s59yO
dam5viWt0VS47Ny5U+KoT3c8LuseHXfPLT0WTV2XrXIs3dr0SPE+tj9G4+KW
Hu5jVvtjc3XxcU3GXXdLzG5qWclt2r/HvnK9phaWK63X5eMmxLTZC2ovU+d8
ke/9BQCgcdSaLzKvD9phVEz7/XmxfsdxY7n146xbun9O0LNlzx88HndefFCV
ZQs+dUDcPHtRt3UaVTq2X+f0Gu8JyVxm7a71nv7Lz1W/nQ4/u62X10oVjo+3
7GH5svXJHEvvPvp38dvzD65xH78Xt819scZtttReruDbZ02saw7I77HPrtcR
NdfrU18/Pe5rfrnq49fzfLGy97c1Zt7+m7h87OVx2+yVeT4KAICBUXu+6Dy/
DmNmlB+nZo9xe7d+XFV2nLuw99cm1bjM9HO26/G2en0vxqK7Oj//qC/zRe++
F/e1Vh6PL4wrDvt478v28XO9+vfYJ0/HxfvXs+zwuKlybupxvlj5+/vkb3+c
ucyWcVu12QYAgAZQ/3yxw7FXdryGpTXmz7w5Dt8i8/dvX1n2787VjnHTv03P
b24tLj932lXlx+abZ5+nqOc9ITUu09oSzS0t8ejEn3Ze9zET5kRrS3M0NzfX
9VxAS7pcyyNxUun+bT4yHilcZ1q+ubj+HZftNl+sH6eNuzOaWlqL6zHrljPL
ngvZ97KHym7n8et/UL7sdfdHc2trtLY2x/3Xn1r2fNExNz1V9zbt32P/x3h0
/IFlyx550e/b71PHsvtnl62c/3qYL/pzf+/85Zf6NicCADBI6psvNjv2d92W
fXnB5K7j54o5oPIY95CKY+ui5jvKjlXP63wfdj/miw7Z93efOuW5/j0udby/
u3z9uyz47U86/77paX/I/G1enPTprmUrn/8pPoZ3Zh7Dwgwwr851799j/1gc
n1mvU2+uMtcsuisOr3W/a84X/bu/ZX8bdkDc3eL5CwCAxlTPfLFl3NxU7Xgu
e5m9Y0rmmK/sGHedkTWPjWdd8c3M8fddvaxTPevd/fZX9vNpe12H7Hyxw69q
Xqbz9VaZz7l98dFf9zi7tWuNi/fsei1Sva8J6s9jn12vmvfpj+XPcZR9j16N
+SKP+9s098GYOXNmzM0+hwQAQIOpZ74YHlOqHtuWXyZ7PJg9xu3pc4Syz4Fs
f9Y9vaxTPevd/fYHYr7Y/qwa9/HlR7qeD8g8D1L27/Gf+l6MvXxsjB1boXDe
4Z/ubRt015/HPrteXdujimdv7Zybyu57jfliVd5fAAAaSX7zxZQa80XV1+eU
ZJ8D6HwPx2o4X9Q8jq9+PX17D3bf7kd/Hvtn631dWa3nbmrNF6vw/gIA0EhW
/Xyx++ge/h180V2dx6ObHTupl3WqZ727337DzxfrDY/99tuvR3vueHjcVPOz
ZGvf974+9tllf1btvRdVll3n0Gu63jdfz3yR8/0FAKCRrPr5YtMTa73evvx1
+dtXe/9FPZ9P29t8MQDv7+7zfHHnyZ3r95XRD+S6Tfvz2GfXa9MT/1Bz2Zcf
v7bz857qe33Uqru/AAA0klU/X6TP++n+3Q/tfv/zL1d5vf/COKfzer8XD7ZW
We/mzOtzepkvevx3+Hoel81rvEe6H/PFy0/e2PXZWz19NlRrx+fittT/nub+
PPZl67XuCfFYjdvIfl5s2fs0ajwmq/L+AgDQSAZivhgWax95TbcZYMGd52a+
82D9uGl+afmWzOcIDYtjfvNExe22xPXHfaXr+qvNF5n3E2/aw3uce3pczsnc
t9uqfR5qP+aLys///fboKss3ZT9DtsacVUX/Hvvy9drjtN9Fa7frvzCz7JaZ
ZXt6TPp5f1vnxfhfHBn77blfnDZuerd1AgCgUQzMfFG041Fx3e1TY9q0qTH+
7EPK/3bIDWXHjJXf8XboaeNj2syZMe32q+Oo4RXXW2W+KPuc1cLx85HnXx+3
3357zK37M4laYvx+Xd81vd6OJ8R1t9wSt097vOsy/ZovKr/TYVhsfuiouH3G
zJg9c0ZMHHta2Xfz1fx8qir6+9hXLv+pr58UE6ZOq7rs2kdOKr/9Hh6T/tzf
7GfpJr+p/N5wAAAaRObf6TPfz9Dt3+9rzBe1LtOnzwva/IR4sPL5gdYH46h6
ly9b75Ly73PrfK3UbfW/1/vJzHfjdVon813XzV3fbdHTfFH98W03/eKDer9/
654Qj9T53EUuj31aryt+2PuyXx/V/fVTvTwmK3t/p5+zXdllzqzyXYYAADSC
hXFB6bVI37mk63OAyl6DVOv7klviiv0+UfUy5Z9hdFfMvnNM7FXleH+PE6+p
/Vr8lgfjnMM27bbMev95eNw0c3aMH/HF9vP2qP49cK1Nd8dJ+21WtmzfPkuq
NaaP+1nZv6uXPQfx4r2d32O9e83visg8vntcUnU9n5x2Vey/RbVj7eFx4tjf
VpmdepbLY1+wYMa1cfhO61ZZry3jxMvvzOwrGXU8Jitzf198/Nqu7ync4fSa
7wsBAGDNVOs73pqb5sfcuXNj9uy50VTne3hbCsvMnj27uNz8ppa+r09ra7S0
tBSt7P1pbW1fvqUPzyP0VfP89seleD/nN6/0ewzyfOzblyssM3d+NM1vP606
Vwzi/QUAYM1X73dI47EHAIDeOMb12AMAQF6y36f2yR6+pw2PPQAA9Kr5wbj8
/PPj/IKbZiwY/PUZSjz2AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAALDauGv+a3Hl/W/GmHv+BAAA
rOFW9XxxwbQ3AQCAIcJ8AQAA5GUg5otjxz8BAAAMAQM1X0iSJEla8zNfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIk
Scor84UkSZKkvDJfSJIkScor84UkSZKkvDJfSJIkScqrgZovAACANd9AzBcA
AMDQYL4AAADysqrni7vmvxZX3v9mjLnnTwAAwBpuVc8XAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAADA0LFkyZJ4
4YUXYvHixVUtWrSIBlZru6VtmrbtYO9f9sehZU3bHwGA+qVjgaeeeirmzJkT
s2bNigceeCDuv//+bmbMmEEDq7bN0rZM2zRt27SN07Ye7P2tN48tWByX3PVC
HDXh5dhr3J/ia1e9wxokbdO0bdM2Ttt6sPc3ACA/L730UjzzzDMxe/bsmD9/
frS2tsY777wTWrNK2zRt27SN07ZO2zxt+8He/6rtj7fMWhS7Xr00vvmbpXHQ
TUvj8MlL4wc3syY5fFL7tk3beJer3ylu80bcHwGAvkvHmenftdPrFTQ0Sts6
bfO07Qd7/6uUjjN3G7c09r/xnfheYa74/s1txdOS7xfP6zgt/Vy4jNNGPS3f
ftltWPr9gMKcsdu49hljsPc/AKB/0utk0r9lmy2GXmmbp23fSK+VSq+T2eXK
pbHfDe3PWRw2qf3fuYsmtxVPezrPaWOe1jS5w6T2bf61wrb3WikAWL2l1+I/
8cQTg32oq0Eqbfu0Dwz2flgyduoLsec1S+PQSW1x6MSl7dLPRUsz5y2t8nca
0sSl5SZV+X1S+3bcq7Dt0z4w2PshALBy0me3eF3U0K70OqlG+ByftA4/vP6V
2Pe6pXHwhComthVO27p+nthW/XI0tsJ2O6Rj2x1SsR3Ttk/7QCPsjwBA36Vj
y/S5Qm+//fZgH+ZqkErbPu0DaV9ohP1xl8v+FPvf0P6+34NubGs/ndBxWvDd
jt+/W/r7jV1/ozF9t0LZ9qvYvmnbp32gEfZHAKDv0mfQ33PPPYNyXPvKoubi
v5u3mxdNi5ZE26CsSWO2eNqlMWLE8THiuCti4Sp+YNI+kPaFRtgfvzR2aRxQ
OO5M9k/HmyU3ZM6/Ib33u61T6bKNfPqdq1pi91EPxK7nNcVeFz4cO4+aE3tf
+eagr9dAnJa2X9n2rPh79uftCvtAI+yPAEDfpf+G33333av24LWilx6aEEdt
OyyGDatmuxg5bnq8MqBr1Jg9PHqnzsdkxhur9rbSPtAIx3NpHbYdszS+c0Ph
ePz6pe2KP5csbT+9oYrrlzbk6bfHTI/Pb791jf19WPy/LX4eX7lgSe3rueGV
2Dot/5Fh8U9fGhf79HC57XbeOd7/79vEhwqXHbb51bFPA9z/rvXrYVtVnJ/2
gUbYHwGAvhvY+eKtmDr6GzWPs8odFncvWjZA69WYPTZ2747HYreYNYTmi60v
TK/Bb4tvdVpaPN33+q7z0s+l3/ct/d6Ap7v8+Jg69/dhsfbh98Y3q13P9a/G
Zl/suNy6Y2Kvard3w1vxlb23ylzfRrHV6FcH/f6XTkvbqdppdnuWbPkr8wUA
rK4Gbr5oi6knb15+TLXBYXHZrdNjzrx58dC0iXHGiJ27zRiPruLj6kZuqM4X
W16wNPb5TVuZb1xb++dvVJzfKKc7HbxPxf68Tax/2ITY4fQHYvuC7Y46J9aq
mDHet88fYu/K6/vNq7H5Jh2XWWdM7F7l9oYfUn5bnz/z1UG//5Wn1RS3X5W/
p32gEfZHAKDvBmq+ePPhC8qOf3YeeXtUO2R+s+kPcWj2mOvIm4fsezKG6nyx
+blLY6/CMeee/9sWe1Wodl4j2vOcq8r29/due2kMv7LKZccvis2Gl7926j9O
e7X8Mte+Gptm5ov/qriOnY8uf45kw5GLB/3+13xcStvw2mRZ5j4uy5zfVtwH
GmF/BAD6bmDmi7fimn27jn+2Ou72HmeGZQuuzRwv7VbjvQdtsahpVkyZNCmu
v/76oin3z4lXalzxW6+0RHNzczQverPjjBdjzrQpMalj2VunPRxL3qrnvhRu
d96MuLVjueuvn1S43fk1b7dsyTda4v4pEzvXd9Kt06L5ldo3OlTni01HLY09
rmmL3a9ZFruPbyv+vMf4Dun80nlZ4xvp9K3Y/MuZGXmbcbFLT5f/3zdjy10z
M8am42LXsr+/Gpt8oeNva4+JXTLL7/Lzc8pmi3X+e0ED3P8eTq/JbMPM39K2
zm7Lzc5ta4j9EQDou4GYLyrnhd6Pldvixsw8MmrWn8r+uvj+q+PbG9V6HfvG
cfrEJyuu7/W4uPR+8p0vjjkPXBob11j2wmnP1r4fi+6LE2q+L33jOLfb7ZZ6
K6Zf8cOar7s/aMydUW3KGKrzxSbntMVu45YVtHXatfPnZZ127Tx/WUP5r9HZ
/X2b2Gxs78vsfum98a/Z5zDO/lPX9Y17Lb6QmS+Gl+7//5Q/R/KRwx8f9Pte
S2k77ZrZpkXjS9t5Wdl5m5zt+QsAWF0NxHzx6gNndx4DrXfc7XUt0/ZG+/dr
LVnyStlzHW8+9uu63it7zB3Z7wt8Pa7Ytb732CZXz3un2/q8Of/aGjNJuX0u
m1ux5Otxw4i1e7/dg/+32+vFhup88fmz2mLnq5fF165qPy39XPq98ufseY3g
q6dmnlP48sT4ap3L/ecuXc9hfPyExZm/vRqf/XzXfLFjus+jbokPZvafD+73
4KDf797snDnt3HZXLevcxp0K53/+TM9fAMDqaiDmi4fH7tj1XMRDr/XjmjLP
QxR88/Qbo2nJG8X5I7326LbzDuw6rlv/1GjJLFc5X+w88saO1ya1xZKmu8s/
L/egGyueT1gYJ2RngW1+Enc3vVS83bdeWRiTR2dud9jGMSHzuVeLb/tx+XMc
t86PN9raoq3tjZh/66iymeWkO/5YdqtDdb74zBnLY/iVy4p2Sq5oKzO847zO
y1Q5fzBPtzmg673WH//pkrqX2/EXv+pc7r3feDDz99fiM5/t2E82GRc7XPxI
2fvCP7DnH2LHBrjfPZ5WbLPKyxRlfk77QCPsjwBA3w3EfNF1nNz/+eK2846N
EcePiCML80H378hoixsOWafzmLzrfRvl88WWI6t8n+Crd8V2pWO2rS4uey7h
paknds0IW59amDa6l52hthhTeg7jxTgj8zquqs+LZN/3vtX5hSW6GqrzxUa/
bIvtL19W0BY7FE/b7ZA53eGK0u9t3f422Kdb7t81X3zixNfqXu7Lp3bNF+/b
e2bm76/Fxp8r7UcbxQfWKp+VPzumMe53T6ed263bdm3r3JbZy6Z9oBH2RwCg
71av+aL3FlyxV5Vj8ux8sV3cXfXL+7KX+U7M6nwCoy0mZ17fVHP931oYt14/
KSYVzFr0dvGsZc9e2/NM03H9Xe99L38v+1CdLzY8rS22u3RZbHfZsvbTksuW
dT+/8jINYPP9uuaLj/3spbqX2/b4kzqX+7u9Znae/6VLX4sNP9PDa+u+MC62
aoD73S8V23bD05Y1xP4IAPTd6jpfvLFkYTx0/7SYcuuthWP68XH55RfFeef9
Txy67Qa9zBe1jtXLL5N97mNs1bmj98qem9jg6BhfWM/x4ysUzjtqo+rrNlTn
i0+f0hbb/HpZbH3JssLp8qL0c0n6W5flVc4bXJt9p2u++OhPX6p/2ZN/VTZf
lM7f9tevxQY9zRfp+Y5vzh70+92jzDbq3I6XdG2/ym27/imevwCA1dWAvP9i
9E5d80XFZ0H1uVeeiNGHbNXjsVYe80XVZXe+uOp3dtTqzccuqGM9y2Xnr6E6
X6w3cllsMXZZbHnx8tji4vbT4s+F89Lvje5z3+76nsi1jn2p/mVP6pov3rPn
zMzfXov1PpvZTzYcFV8snL/ZiGPL9p2PnNCH2xpg7duwa5tmzy/bxh3nrzvS
8xcAsLoamM+POq2O1wnV0bKny99nnWy0Uey6666x7yGHxPEnH9/1HopVMV98
+szMe8Z7r2y+2HC3OKSwjj3Zd5ej4o7mtzuXH6rzxTo/Lxw7X9QXy/t4+VVr
0+O7Pj/qXV/5Xd3LbbxH1+dH/fORz2f+9lqs+x+lfXNEbDi6dP7bscHwDTL/
f9g11jt78O9/fdtpeeb37j+vfaL5AgBWVwMxX7w9P/s5/d+JR+t4jdGCWy+M
448/ueCMmLGk/fOYsp9zm15vdEfTS92Xu2bP3OeLsb2+d6N6bz7ctb5fvazW
d2PUbqjOF5/46bL4woXL4osXLi+eZm0yZnnn+ek0+3OjnG5ySnZ/3y3WObv3
5TYdPTv+OTM3r/Wzv3Rd34WvxTobl2bci+Kz2eXHLCz7LKlhHz83Nm6Qx6Hy
tCelbVu6bNoHGmF/BAD6bmC+vzt7jD4svnbugz1ffNnsODRzzHR1U/u/6Zd9
zm3V11m9XvZe6Xzmi4gHztis83YPvO6Z6uv86n1xxojjC/PQiLjs7o7v3njp
95nPpCr/bKiy2t6KN954I954q/xLwIfqfPGxE5bFZ89fHp/9VcYFyzp9Lv1e
+HvptPOyjXJ6wZ/jk1/MHPN/6db4TC/Lffq/dum6fGGG2Kjs+l6PT5Tmi48W
/lax/OdPmRjvzfz/5a93ntYYj0P29IJl5ae1tluHtA80wv4IAPTdwMwX5a+R
Sg4a82C0VbtgW0tcc9Q6mWOtruPy+Vcc0Hn+EVWO8xdM/vkqeP9Fev7lksz1
bhcTm96uWLYtbjvhk52X2Wfck1Wus3CfL3ukygMzMzNLHR1PZx6UoTpf/Ptx
y2Kj0cu7nJf9eVn38xrQxsddWLa/v3unSfHpapc7//VYe7ddyi77/qNe7naZ
j2/UNV+sX+V6Nvz+cWXX8b7vPz/oj0FV51Wc1vDvx5ovAGB1NVDzRcRbccOh
Fe+d2OUnMfH++bFo0aJomvdQTL7opG7fkX3pnK7nKcqP84fFkRdNjjnz5sW8
OXfH2BFfK7/uHOeLtO5dz4u0G3n51JjX1BQPTZsYJ+y6ftntzsi8hqrsM6QK
tj7y4rh/XlM0N82LqePPzbxfZFh8dUz5/DFU54u1jlkeG5y3ItY/L50uL56W
fk7nb1D2e+m80uUb5HT00vjkV7cu3yf/Zd/40KEzYu1TWmO9U5rjkz8cF//0
b+X71V9tOTnWq7y+0a/HRzvni7Gxbq3b2z77Xoxt499OXjr4j0PHaeW2zNog
o/R72gcaYX8EAPpu4OaL1Mtxw/FbVMwBtf3yjucqln+923F+bbU+Y7b8Oyay
193jZd5+PE7ZtvfbHXX3H7td82PX/KD39V3/1FhY8YTOY52vB6u1zvnVSPPF
h360PNYbtTzW7bDeuSvaZc5bt/Lvo5Y3nnP/HJ/Y41t17+/v+dqtsU7V63k9
1tqw43IfuSjWrnl7C8vewzHsAyPjY2c3xmOzbua0crtWOy/tA42wPwIAfTew
80V7C6ZcGrv1cJy183Fj49GO93R37+WYetEPuy+34bdj3EOLY8Hk/+44L/td
FW/FbScP7zj/sBrvL38r893ftS7zeuG2j+32HEuyzcFnxIzmN2ve55fmTIhD
t6s+B50+bnqV7yIvPE43fL/KfVk1NdJ88S9HLY+1C8fFJeucE12nBet0WPuc
FUVlf2/E02MmxfvX6WG2+OCh8cEjnq+9/Kg34sNf6LjsJuPjEz3c3ronToy/
zc4s+zwx+Pe/crul7Zo5b+3s+R3SPtAI+yMA0HeDMV+091Ysano0pk2ZEvfP
mRP3T5tWOG2KJW9UfVdG99reKL6u6pVXlsSSJav4H/er3PaSRc3RXLj94jrU
u86RvhdwUTQ3ty+X1rv+JVdtjTRffHDEivjEmcvj42etKJM9r9rfG95Pn4gP
H3ZH/FuHfz1sWnz4J63xscFerwaR3aZpH2iE/REA6LvBmy/USDXSfPGBHyyP
j5yxIj565oriaVHx5+Ud5y1vl/l76bJOG/O0axtmLS/7W/GyHaf/eKT5AgBW
V+YLpRprvlgRHz59eXz4f1Z0d3qV81gzZLZt2gcaYX8EAPrOfKFUI80X7/ve
ivjQL+tweod6LkvjqGOb/f3h3n8BAKsr84VSjTRf/P1hK+Kff5EVxdMPnlZ5
Xvn5Thv7tLTNqp2ffs5u3787zPMXALC6Ml8o1Ujzxd8esiL+8bTocmrJivLz
Kk9pXGXbc0Xtv3VI+0Aj7I8AQN+98MILcc8998Rf/vKXwT7E1SCVtn3aB9K+
0Aj741rfeyf+YWTE+06JeH9yavp5RfHn97Haat9+K7pv11Mjs21XxD+cFLHW
D5Y2xP4IAPTdkiVLYubMmdHS0jLYh7kapNK2T/tA2hcaYX/88s9fjb87PuLv
T+7uH7K/j6x+GRrQyMzpyI7tWLH9Sts2bfu0DzTC/ggArJy5c+fGI488MtiH
uRqk0rZP+8Bg74clP7tycbz3iMJx5sgKJ3UYmTkdWfG708Y8rfXzSRUK56Vt
n/aBwd4PAYCVt3Dhwrj33nuLpxpaZbf9YO+HJTNmPxfvOTDib/474m9PLDgp
I/P7e2v9zWljnlbbbhXb82+OiXh3YdunfWCw90MAYOW9+OKLMWfOnJg+fboZ
YwiVtnXa5mnbp31gsPfD7P548eRn4j2HRLznx+3HnVn/t8bvTlfP05I0T6Zt
fklh2zfS/ggArJz0GvyHH344pkyZUnwtfnNzc/z5z38e7ENg5Vzapmnbpm2c
tnXa5mnbD/b+V21/HHPT0/HXB0S8+/sFhTnjPT8t+Fm7dGya/bn0u9PGPa3m
PT9p37bv/kEUt3Xa5o24PwIAfZfeS/n888/H448/Xny9zO233x6TJ0+OCRMm
xE033dTNjTfeSAOrts3StkzbNG3btI3Ttk7bvBHfR1vaH6fcNz+OvvCZ2OLY
JfGBA9+Jd30r4l37sqb4wIFvF7dt2sZpWzfq/ggArJz03/VFixYVXzfz5JNP
xmOPPRaPPvpozJ49mzVA2pZpm6Ztm7Zx2taNfCxXuT+m96DbH9ccaVumbbq6
7I8AwMpLr31O322V/nufXquQpH9XzHruuedoYJXbq7Qd0zZN23Z1en27/XH1
tybtjwAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AADA0Pb/ARDJuEs=
      "], {{0, 416}, {792, 0}}, {0, 255},
      ColorFunction->RGBColor],
     BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
     Selectable->False],
    DefaultBaseStyle->"ImageGraphics",
    ImageSize->{320.14453125, Automatic},
    ImageSizeRaw->{792, 416},
    PlotRange->{{0, 792}, {0, 416}}], 
   GraphicsBox[
    TagBox[RasterBox[CompressedData["
1:eJzt3QmYnGWd6O2cmW/85vKaOeOMc5wzZ3RcAQHBM44LoKiggkRZBgRcUEAR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      "], {{0, 410}, {788, 0}}, {0, 255},
      ColorFunction->RGBColor],
     BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
     Selectable->False],
    DefaultBaseStyle->"ImageGraphics",
    ImageSize->{325.87109375, Automatic},
    ImageSizeRaw->{788, 410},
    PlotRange->{{0, 788}, {0, 410}}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"or", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"          ", 
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJztnWt3HdWZoL1m5sN8nL8wMz3dE0Lga3q6ua6eWR06YBad7oRLMp0Adnp1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     "], {{0, 148}, {1124, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   DefaultBaseStyle->"ImageGraphics",
   ImageSize->{507.48046875, Automatic},
   ImageSizeRaw->{1124, 148},
   PlotRange->{{0, 1124}, {0, 148}}]}], "\[IndentingNewLine]", 
 RowBox[{"           ", 
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJzt3QmYXGWd6OHcmTveeXxm7jjjvc6dOzqugIDgHUcREFRQgURZBgRUdkUS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     "], {{0, 412}, {798, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   DefaultBaseStyle->"ImageGraphics",
   ImageSize->{319.0390625, Automatic},
   ImageSizeRaw->{798, 412},
   PlotRange->{{0, 798}, {0, 412}}]}], "\[IndentingNewLine]", 
 RowBox[{"           ", 
  RowBox[{
   GraphicsBox[
    TagBox[RasterBox[CompressedData["
1:eJzt3Ql0XPV58GG3/ZqvJ6f9mjZtuiXNCoSwtWkWoOxZACcshQAhYQ0EQxYw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      "], {{0, 404}, {788, 0}}, {0, 255},
      ColorFunction->RGBColor],
     BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
     Selectable->False],
    DefaultBaseStyle->"ImageGraphics",
    ImageSize->{319.45703125, Automatic},
    ImageSizeRaw->{788, 404},
    PlotRange->{{0, 788}, {0, 404}}], 
   GraphicsBox[
    TagBox[RasterBox[CompressedData["
1:eJzt3QmYXHWd6P3cmXd85/GZeccZ73Xu3NFxBQRc7jgugKKCCxBlGRBwYVWE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      "], {{0, 412}, {798, 0}}, {0, 255},
      ColorFunction->RGBColor],
     BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
     Selectable->False],
    DefaultBaseStyle->"ImageGraphics",
    ImageSize->{323.40625, Automatic},
    ImageSizeRaw->{798, 412},
    PlotRange->{{0, 798}, {0, 412}}]}]}], "\[IndentingNewLine]", 
 RowBox[{"           ", 
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJzt3QmYXHWd6O/cmf/4n8dn5o4z3uvcuaPjCkgQvOMoAoIKLhCUZUDAhVVZ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     "], {{0, 412}, {790, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   DefaultBaseStyle->"ImageGraphics",
   ImageSize->{323.8671875, Automatic},
   ImageSizeRaw->{790, 412},
   PlotRange->{{0, 790}, {0, 412}}]}], "\[IndentingNewLine]", 
 RowBox[{"           ", 
  RowBox[{
   GraphicsBox[
    TagBox[RasterBox[CompressedData["
1:eJzt3QmUXHWZ8OGM8+k3xzPzjaMzzjgj4wqIbOOGwLCrLFGWAQFRFJDdBQI6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      "], {{0, 416}, {792, 0}}, {0, 255},
      ColorFunction->RGBColor],
     BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
     Selectable->False],
    DefaultBaseStyle->"ImageGraphics",
    ImageSize->{320.14453125, Automatic},
    ImageSizeRaw->{792, 416},
    PlotRange->{{0, 792}, {0, 416}}], 
   GraphicsBox[
    TagBox[RasterBox[CompressedData["
1:eJzt3QmYnGWd6O2cmW/85vKaOeOMc5wzZ3RcAQHBM44LoKiggkRZBgRcUEAR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      "], {{0, 410}, {788, 0}}, {0, 255},
      ColorFunction->RGBColor],
     BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
     Selectable->False],
    DefaultBaseStyle->"ImageGraphics",
    ImageSize->{325.87109375, Automatic},
    ImageSizeRaw->{788, 410},
    PlotRange->{{0, 788}, {0, 410}}]}]}]}], "Input",
 CellChangeTimes->{{3.8499023464082947`*^9, 3.8499023467180357`*^9}, {
  3.849902541591395*^9, 3.849902550003584*^9}, {3.84990412012418*^9, 
  3.849904132977738*^9}, {3.8499051666535053`*^9, 3.8499051758812437`*^9}, {
  3.8499061572426357`*^9, 3.8499061845964622`*^9}, {3.849906239459491*^9, 
  3.8499062467136793`*^9}, {3.849934594350374*^9, 3.849934711737368*^9}}],

Cell["\<\

\
\>", "Input",
 CellChangeTimes->{{3.8490956743654633`*^9, 3.8490956743684587`*^9}, {
   3.849095798234562*^9, 3.849095829816025*^9}, {3.8490958762490063`*^9, 
   3.8490958800398993`*^9}, {3.849095940110881*^9, 3.8490960433681784`*^9}, {
   3.849100592496808*^9, 3.84910060107707*^9}, {3.849100963941261*^9, 
   3.849100974372068*^9}, {3.8491011664033337`*^9, 3.849101180062392*^9}, {
   3.8491014733460264`*^9, 3.8491014740904746`*^9}, {3.8491015091954823`*^9, 
   3.849101529548568*^9}, {3.8491017272615504`*^9, 3.84910187694384*^9}, {
   3.8491019680490255`*^9, 3.849102005560727*^9}, {3.8491020526516275`*^9, 
   3.8491020806662817`*^9}, {3.8491021602073884`*^9, 
   3.8491021795852985`*^9}, {3.849102558280779*^9, 3.8491025661494827`*^9}, {
   3.849102621872627*^9, 3.8491026718006735`*^9}, {3.849102711623271*^9, 
   3.8491027219616137`*^9}, {3.8491041197771935`*^9, 3.849104125709408*^9}, {
   3.8491041714416294`*^9, 3.849104268298612*^9}, 3.8499050930302258`*^9, {
   3.849905130166212*^9, 3.849905132282411*^9}, {3.849905178889791*^9, 
   3.849905179724959*^9}, {3.849907104007675*^9, 3.8499071065677757`*^9}},
 ExpressionUUID -> "d8b7dbe4-680a-4dce-8ba2-c2addd86d482"],

Cell[TextData[StyleBox["Example A", "Text",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Input",
 CellChangeTimes->{{3.8490956743654633`*^9, 3.8490956743684587`*^9}, {
  3.849095798234562*^9, 3.849095829816025*^9}, {3.8490958762490063`*^9, 
  3.8490958800398993`*^9}, {3.849095940110881*^9, 3.8490960433681784`*^9}, {
  3.849100592496808*^9, 3.84910060107707*^9}, {3.849100963941261*^9, 
  3.849100974372068*^9}, {3.8491011664033337`*^9, 3.849101180062392*^9}, {
  3.8491014733460264`*^9, 3.8491014740904746`*^9}, {3.8491015091954823`*^9, 
  3.849101529548568*^9}, {3.8491017272615504`*^9, 3.84910187694384*^9}, {
  3.8491019680490255`*^9, 3.849102005560727*^9}, {3.8491020526516275`*^9, 
  3.8491020806662817`*^9}, {3.8491021602073884`*^9, 3.8491021795852985`*^9}, {
  3.849102558280779*^9, 3.8491025966364975`*^9}},
 FormatType->
  "TextForm",ExpressionUUID->"59fca1d6-b502-4f9e-a74f-4b4a1edc9a38"],

Cell[BoxData[
 RowBox[{
  StyleBox["  ", "Text"], 
  RowBox[{
   StyleBox[
    RowBox[{"r", 
     RowBox[{"(", "t", ")"}]}], "Text"], 
   StyleBox["=", "Text"], 
   FractionBox["1", 
    RowBox[{
     SuperscriptBox["t", "7"], "+", 
     FractionBox["\[ImaginaryI]", "4"]}]]}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "\"\<ASPPlusPMinus.m\>\""}]}], "Input",
 CellChangeTimes->{
  3.8422960679074907`*^9, {3.8422964033208666`*^9, 3.842296473492343*^9}, 
   3.848413662363168*^9, {3.8499050401329603`*^9, 3.8499050405891037`*^9}},
 ExpressionUUID -> "e540be07-2f5d-4ad4-8799-b72cc37896c9"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*\\nStyleBox[\\\"r\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"(\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"t\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\")\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"=\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \\\"Section\\\"]\\)\"\>", 
   "\[InvisibleSpace]", 
   FractionBox["4", 
    RowBox[{"\[ImaginaryI]", "+", 
     RowBox[{"4", " ", 
      SuperscriptBox["t", "7"]}]}]]}],
  SequenceForm[
  "\!\(\*\nStyleBox[\"r\", \"Section\"]\)\!\(\*\nStyleBox[\"(\", \"Section\"]\
\)\!\(\*\nStyleBox[\"t\", \"Section\"]\)\!\(\*\nStyleBox[\")\", \
\"Section\"]\)\!\(\*\nStyleBox[\" \", \"Section\"]\)\!\(\*\nStyleBox[\"=\", \
\"Section\"]\)\!\(\*\nStyleBox[\" \", \"Section\"]\)", 4/(Complex[0, 1] + 
   4 $CellContext`t^7)],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.849905352133359*^9, {3.849905946696056*^9, 3.8499059764536753`*^9}, 
   3.8499060320579977`*^9, {3.849906123949737*^9, 3.849906149563455*^9}, 
   3.849934740604197*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*\\nStyleBox[SubscriptBox[\\\"S\\\", \\\"\
\[DoubleStruckCapitalT]\\\"], \\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"r\\\
\", \\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"(\\\", \\\"Section\\\"]\\)\\!\
\\(\\*\\nStyleBox[\\\"t\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\")\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"=\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \\\"Section\\\"]\\)\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"64", " ", 
        SuperscriptBox["2", 
         RowBox[{"5", "/", "7"}]], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox["2", 
            RowBox[{"2", "/", "7"}]], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"49179", " ", "\[ImaginaryI]"}], "-", 
             RowBox[{"49178", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"-", "1"}], ")"}], 
               RowBox[{"1", "/", "14"}]]}], "+", 
             RowBox[{"49162", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"-", "1"}], ")"}], 
               RowBox[{"3", "/", "14"}]]}], "-", 
             RowBox[{"49167", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"-", "1"}], ")"}], 
               RowBox[{"5", "/", "14"}]]}], "-", 
             RowBox[{"49170", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"-", "1"}], ")"}], 
               RowBox[{"9", "/", "14"}]]}], "+", 
             RowBox[{"49161", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"-", "1"}], ")"}], 
               RowBox[{"11", "/", "14"}]]}], "-", 
             RowBox[{"49173", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"-", "1"}], ")"}], 
               RowBox[{"13", "/", "14"}]]}]}], ")"}]}], "-", 
          RowBox[{"295020", " ", 
           SuperscriptBox["2", 
            RowBox[{"4", "/", "7"}]], " ", 
           RowBox[{"(", 
            RowBox[{"1", "-", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"1", "/", "7"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"2", "/", "7"}]], "-", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"3", "/", "7"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"4", "/", "7"}]], "-", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"5", "/", "7"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"6", "/", "7"}]]}], ")"}], " ", "t"}], "+", 
          RowBox[{"737550", " ", 
           SuperscriptBox["2", 
            RowBox[{"6", "/", "7"}]], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "\[ImaginaryI]"}], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"1", "/", "14"}]], "-", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"3", "/", "14"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"5", "/", "14"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"9", "/", "14"}]], "-", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"11", "/", "14"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"13", "/", "14"}]]}], ")"}], " ", 
           SuperscriptBox["t", "2"]}], "+", 
          RowBox[{"1966800", " ", 
           SuperscriptBox["2", 
            RowBox[{"1", "/", "7"}]], " ", 
           RowBox[{"(", 
            RowBox[{"1", "-", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"1", "/", "7"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"2", "/", "7"}]], "-", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"3", "/", "7"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"4", "/", "7"}]], "-", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"5", "/", "7"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"6", "/", "7"}]]}], ")"}], " ", 
           SuperscriptBox["t", "3"]}], "-", 
          RowBox[{"1475100", " ", 
           SuperscriptBox["2", 
            RowBox[{"3", "/", "7"}]], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "\[ImaginaryI]"}], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"1", "/", "14"}]], "-", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"3", "/", "14"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"5", "/", "14"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"9", "/", "14"}]], "-", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"11", "/", "14"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"13", "/", "14"}]]}], ")"}], " ", 
           SuperscriptBox["t", "4"]}], "-", 
          RowBox[{"590040", " ", 
           SuperscriptBox["2", 
            RowBox[{"5", "/", "7"}]], " ", 
           RowBox[{"(", 
            RowBox[{"1", "-", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"1", "/", "7"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"2", "/", "7"}]], "-", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"3", "/", "7"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"4", "/", "7"}]], "-", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"5", "/", "7"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"6", "/", "7"}]]}], ")"}], " ", 
           SuperscriptBox["t", "5"]}], "+", 
          RowBox[{"196680", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "\[ImaginaryI]"}], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"1", "/", "14"}]], "-", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"3", "/", "14"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"5", "/", "14"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"9", "/", "14"}]], "-", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"11", "/", "14"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"13", "/", "14"}]]}], ")"}], " ", 
           SuperscriptBox["t", "6"]}]}], ")"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"1", "/", "7"}]]}], ")"}], "3"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"1", "/", "7"}]]}], ")"}], "5"], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"2", "/", "7"}]]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"1", "/", "7"}]], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"2", "/", "7"}]]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"1", "/", "7"}]], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"2", "/", "7"}]]}], ")"}], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"1", "-", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"1", "/", "7"}]], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"4", "/", "7"}]]}], ")"}], "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"1", "/", "7"}]], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"4", "/", "7"}]]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"1", "/", "7"}]], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"2", "/", "7"}]], "-", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"3", "/", "7"}]], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"4", "/", "7"}]]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"3", "/", "7"}]], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"5", "/", "7"}]]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"1", "/", "7"}]], "-", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"2", "/", "7"}]], "-", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"4", "/", "7"}]], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"5", "/", "7"}]]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"2", "-", 
          RowBox[{"2", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"1", "/", "7"}]]}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"2", "/", "7"}]], "-", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"3", "/", "7"}]], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"4", "/", "7"}]]}], "-", 
          RowBox[{"2", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"5", "/", "7"}]]}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"6", "/", "7"}]]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"2", "-", 
          RowBox[{"2", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"1", "/", "7"}]]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"2", "/", "7"}]]}], "-", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"3", "/", "7"}]], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"4", "/", "7"}]]}], "-", 
          RowBox[{"2", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"5", "/", "7"}]]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"6", "/", "7"}]]}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"3", "/", "14"}]], " ", 
           SuperscriptBox["2", 
            RowBox[{"5", "/", "7"}]]}], "-", 
          RowBox[{"2", " ", "t"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"11", "/", "14"}]], " ", 
           SuperscriptBox["2", 
            RowBox[{"5", "/", "7"}]]}], "-", 
          RowBox[{"2", " ", "t"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["2", 
           RowBox[{"5", "/", "7"}]], "+", 
          RowBox[{"2", " ", "\[ImaginaryI]", " ", "t"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"1", "/", "14"}]], " ", 
           SuperscriptBox["2", 
            RowBox[{"5", "/", "7"}]]}], "+", 
          RowBox[{"2", " ", "t"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"5", "/", "14"}]], " ", 
           SuperscriptBox["2", 
            RowBox[{"5", "/", "7"}]]}], "+", 
          RowBox[{"2", " ", "t"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"9", "/", "14"}]], " ", 
           SuperscriptBox["2", 
            RowBox[{"5", "/", "7"}]]}], "+", 
          RowBox[{"2", " ", "t"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"13", "/", "14"}]], " ", 
           SuperscriptBox["2", 
            RowBox[{"5", "/", "7"}]]}], "+", 
          RowBox[{"2", " ", "t"}]}], ")"}]}], ")"}]}], ")"}]}]}],
  SequenceForm[
  "\!\(\*\nStyleBox[SubscriptBox[\"S\", \"\[DoubleStruckCapitalT]\"], \
\"Section\"]\)\!\(\*\nStyleBox[\"r\", \"Section\"]\)\!\(\*\nStyleBox[\"(\", \
\"Section\"]\)\!\(\*\nStyleBox[\"t\", \"Section\"]\)\!\(\*\nStyleBox[\")\", \
\"Section\"]\)\!\(\*\nStyleBox[\" \", \"Section\"]\)\!\(\*\nStyleBox[\"=\", \
\"Section\"]\)\!\(\*\nStyleBox[\" \", \"Section\"]\)", (-64) 
   2^Rational[5, 7] (-1 + (-1)^Rational[1, 7])^(-3) (
     1 + (-1)^Rational[1, 7])^(-5) (1 + (-1)^Rational[2, 7])^(-1) (1 - (-1)^
     Rational[1, 7] + (-1)^Rational[2, 7])^(-1) (
     1 + (-1)^Rational[1, 7] + (-1)^Rational[2, 7])^(-1) (1 - (-1)^
     Rational[1, 7] + (-1)^Rational[4, 7])^(-2) (-1 + (-1)^
      Rational[1, 7] + (-1)^Rational[4, 7])^(-1) (1 - (-1)^
     Rational[1, 7] + (-1)^Rational[2, 7] - (-1)^
     Rational[3, 7] + (-1)^Rational[4, 7])^(-1) (-1 + (-1)^
      Rational[3, 7] + (-1)^Rational[5, 7])^(-1) (-1 + (-1)^
      Rational[1, 7] - (-1)^Rational[2, 7] - (-1)^
     Rational[4, 7] + (-1)^Rational[5, 7])^(-1) (2 - 
     2 (-1)^Rational[1, 7] + (-1)^Rational[2, 7] - (-1)^Rational[3, 7] + 
     2 (-1)^Rational[4, 7] - 
     2 (-1)^Rational[5, 7] + (-1)^Rational[6, 7])^(-1) (2 - 
     2 (-1)^Rational[1, 7] + 2 (-1)^Rational[2, 7] - (-1)^Rational[3, 7] + 
     2 (-1)^Rational[4, 7] - 2 (-1)^Rational[5, 7] + 
     2 (-1)^Rational[6, 7])^(-1) ((-1)^Rational[3, 14] 2^Rational[5, 7] - 
     2 $CellContext`t)^(-1) ((-1)^Rational[11, 14] 2^Rational[5, 7] - 
     2 $CellContext`t)^(-1) (2^Rational[5, 7] + 
     Complex[0, 2] $CellContext`t)^(-1) ((-1)^Rational[1, 14] 
      2^Rational[5, 7] + 
     2 $CellContext`t)^(-1) ((-1)^Rational[5, 14] 2^Rational[5, 7] + 
     2 $CellContext`t)^(-1) ((-1)^Rational[9, 14] 2^Rational[5, 7] + 
     2 $CellContext`t)^(-1) ((-1)^Rational[13, 14] 2^Rational[5, 7] + 
     2 $CellContext`t)^(-1) (
    2^Rational[2, 7] (Complex[0, 49179] - 49178 (-1)^Rational[1, 14] + 
      49162 (-1)^Rational[3, 14] - 49167 (-1)^Rational[5, 14] - 
      49170 (-1)^Rational[9, 14] + 49161 (-1)^Rational[11, 14] - 
      49173 (-1)^Rational[13, 14]) - 295020 
    2^Rational[4, 7] (1 - (-1)^Rational[1, 7] + (-1)^Rational[2, 7] - (-1)^
     Rational[3, 7] + (-1)^Rational[4, 7] - (-1)^
     Rational[5, 7] + (-1)^Rational[6, 7]) $CellContext`t + 
    737550 2^Rational[6, 7] (Complex[0, -1] + (-1)^Rational[1, 14] - (-1)^
      Rational[3, 14] + (-1)^Rational[5, 14] + (-1)^Rational[9, 14] - (-1)^
      Rational[11, 14] + (-1)^Rational[13, 14]) $CellContext`t^2 + 
    1966800 2^Rational[1, 7] (1 - (-1)^
      Rational[1, 7] + (-1)^Rational[2, 7] - (-1)^
      Rational[3, 7] + (-1)^Rational[4, 7] - (-1)^
      Rational[5, 7] + (-1)^Rational[6, 7]) $CellContext`t^3 - 1475100 
    2^Rational[3, 7] (Complex[0, -1] + (-1)^Rational[1, 14] - (-1)^
     Rational[3, 14] + (-1)^Rational[5, 14] + (-1)^Rational[9, 14] - (-1)^
     Rational[11, 14] + (-1)^Rational[13, 14]) $CellContext`t^4 - 590040 
    2^Rational[5, 7] (1 - (-1)^Rational[1, 7] + (-1)^Rational[2, 7] - (-1)^
     Rational[3, 7] + (-1)^Rational[4, 7] - (-1)^
     Rational[5, 7] + (-1)^Rational[6, 7]) $CellContext`t^5 + 
    196680 (Complex[0, -1] + (-1)^Rational[1, 14] - (-1)^
      Rational[3, 14] + (-1)^Rational[5, 14] + (-1)^Rational[9, 14] - (-1)^
      Rational[11, 14] + (-1)^Rational[13, 14]) $CellContext`t^6)],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.849905352133359*^9, {3.849905946696056*^9, 3.8499059764536753`*^9}, 
   3.8499060320579977`*^9, {3.849906123949737*^9, 3.849906149563455*^9}, 
   3.849934740625555*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*\\nStyleBox[SubscriptBox[\\\"P\\\", \\\"+\\\"], \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"r\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"(\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"t\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\")\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"=\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \\\"Section\\\"]\\)\"\>", 
   "\[InvisibleSpace]", "0"}],
  SequenceForm[
  "\!\(\*\nStyleBox[SubscriptBox[\"P\", \"+\"], \"Section\"]\)\!\(\*\n\
StyleBox[\"r\", \"Section\"]\)\!\(\*\nStyleBox[\"(\", \"Section\"]\)\!\(\*\n\
StyleBox[\"t\", \"Section\"]\)\!\(\*\nStyleBox[\")\", \"Section\"]\)\!\(\*\n\
StyleBox[\" \", \"Section\"]\)\!\(\*\nStyleBox[\"=\", \"Section\"]\)\!\(\*\n\
StyleBox[\" \", \"Section\"]\)", 0],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.849905352133359*^9, {3.849905946696056*^9, 3.8499059764536753`*^9}, 
   3.8499060320579977`*^9, {3.849906123949737*^9, 3.849906149563455*^9}, 
   3.849934740659301*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*\\nStyleBox[SubscriptBox[\\\"P\\\", \\\"-\\\"], \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"r\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"(\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"t\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\")\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"=\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \\\"Section\\\"]\\)\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"64", " ", 
       SuperscriptBox["2", 
        RowBox[{"5", "/", "7"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox["2", 
           RowBox[{"2", "/", "7"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"49179", " ", "\[ImaginaryI]"}], "-", 
            RowBox[{"49178", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"1", "/", "14"}]]}], "+", 
            RowBox[{"49162", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"3", "/", "14"}]]}], "-", 
            RowBox[{"49167", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"5", "/", "14"}]]}], "-", 
            RowBox[{"49170", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"9", "/", "14"}]]}], "+", 
            RowBox[{"49161", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"11", "/", "14"}]]}], "-", 
            RowBox[{"49173", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"13", "/", "14"}]]}]}], ")"}]}], "-", 
         RowBox[{"295020", " ", 
          SuperscriptBox["2", 
           RowBox[{"4", "/", "7"}]], " ", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"1", "/", "7"}]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"2", "/", "7"}]], "-", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"3", "/", "7"}]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"4", "/", "7"}]], "-", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"5", "/", "7"}]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"6", "/", "7"}]]}], ")"}], " ", "t"}], "+", 
         RowBox[{"737550", " ", 
          SuperscriptBox["2", 
           RowBox[{"6", "/", "7"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"1", "/", "14"}]], "-", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"3", "/", "14"}]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"5", "/", "14"}]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"9", "/", "14"}]], "-", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"11", "/", "14"}]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"13", "/", "14"}]]}], ")"}], " ", 
          SuperscriptBox["t", "2"]}], "+", 
         RowBox[{"1966800", " ", 
          SuperscriptBox["2", 
           RowBox[{"1", "/", "7"}]], " ", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"1", "/", "7"}]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"2", "/", "7"}]], "-", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"3", "/", "7"}]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"4", "/", "7"}]], "-", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"5", "/", "7"}]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"6", "/", "7"}]]}], ")"}], " ", 
          SuperscriptBox["t", "3"]}], "-", 
         RowBox[{"1475100", " ", 
          SuperscriptBox["2", 
           RowBox[{"3", "/", "7"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"1", "/", "14"}]], "-", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"3", "/", "14"}]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"5", "/", "14"}]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"9", "/", "14"}]], "-", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"11", "/", "14"}]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"13", "/", "14"}]]}], ")"}], " ", 
          SuperscriptBox["t", "4"]}], "-", 
         RowBox[{"590040", " ", 
          SuperscriptBox["2", 
           RowBox[{"5", "/", "7"}]], " ", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"1", "/", "7"}]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"2", "/", "7"}]], "-", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"3", "/", "7"}]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"4", "/", "7"}]], "-", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"5", "/", "7"}]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"6", "/", "7"}]]}], ")"}], " ", 
          SuperscriptBox["t", "5"]}], "+", 
         RowBox[{"196680", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"1", "/", "14"}]], "-", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"3", "/", "14"}]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"5", "/", "14"}]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"9", "/", "14"}]], "-", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"11", "/", "14"}]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"13", "/", "14"}]]}], ")"}], " ", 
          SuperscriptBox["t", "6"]}]}], ")"}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"1", "/", "7"}]]}], ")"}], "3"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"1", "/", "7"}]]}], ")"}], "5"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"2", "/", "7"}]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"1", "/", "7"}]], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"2", "/", "7"}]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"1", "/", "7"}]], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"2", "/", "7"}]]}], ")"}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "-", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"1", "/", "7"}]], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"4", "/", "7"}]]}], ")"}], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"1", "/", "7"}]], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"4", "/", "7"}]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"1", "/", "7"}]], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"2", "/", "7"}]], "-", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"3", "/", "7"}]], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"4", "/", "7"}]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"3", "/", "7"}]], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"5", "/", "7"}]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"1", "/", "7"}]], "-", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"2", "/", "7"}]], "-", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"4", "/", "7"}]], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"5", "/", "7"}]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"2", "-", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"1", "/", "7"}]]}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"2", "/", "7"}]], "-", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"3", "/", "7"}]], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"4", "/", "7"}]]}], "-", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"5", "/", "7"}]]}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"6", "/", "7"}]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"2", "-", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"1", "/", "7"}]]}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"2", "/", "7"}]]}], "-", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"3", "/", "7"}]], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"4", "/", "7"}]]}], "-", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"5", "/", "7"}]]}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"6", "/", "7"}]]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"3", "/", "14"}]], " ", 
          SuperscriptBox["2", 
           RowBox[{"5", "/", "7"}]]}], "-", 
         RowBox[{"2", " ", "t"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"11", "/", "14"}]], " ", 
          SuperscriptBox["2", 
           RowBox[{"5", "/", "7"}]]}], "-", 
         RowBox[{"2", " ", "t"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["2", 
          RowBox[{"5", "/", "7"}]], "+", 
         RowBox[{"2", " ", "\[ImaginaryI]", " ", "t"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"1", "/", "14"}]], " ", 
          SuperscriptBox["2", 
           RowBox[{"5", "/", "7"}]]}], "+", 
         RowBox[{"2", " ", "t"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"5", "/", "14"}]], " ", 
          SuperscriptBox["2", 
           RowBox[{"5", "/", "7"}]]}], "+", 
         RowBox[{"2", " ", "t"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"9", "/", "14"}]], " ", 
          SuperscriptBox["2", 
           RowBox[{"5", "/", "7"}]]}], "+", 
         RowBox[{"2", " ", "t"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"13", "/", "14"}]], " ", 
          SuperscriptBox["2", 
           RowBox[{"5", "/", "7"}]]}], "+", 
         RowBox[{"2", " ", "t"}]}], ")"}]}], ")"}]}], ")"}]}],
  SequenceForm[
  "\!\(\*\nStyleBox[SubscriptBox[\"P\", \"-\"], \"Section\"]\)\!\(\*\n\
StyleBox[\"r\", \"Section\"]\)\!\(\*\nStyleBox[\"(\", \"Section\"]\)\!\(\*\n\
StyleBox[\"t\", \"Section\"]\)\!\(\*\nStyleBox[\")\", \"Section\"]\)\!\(\*\n\
StyleBox[\" \", \"Section\"]\)\!\(\*\nStyleBox[\"=\", \"Section\"]\)\!\(\*\n\
StyleBox[\" \", \"Section\"]\)", 64 
   2^Rational[5, 7] (-1 + (-1)^Rational[1, 7])^(-3) (
     1 + (-1)^Rational[1, 7])^(-5) (1 + (-1)^Rational[2, 7])^(-1) (1 - (-1)^
     Rational[1, 7] + (-1)^Rational[2, 7])^(-1) (
     1 + (-1)^Rational[1, 7] + (-1)^Rational[2, 7])^(-1) (1 - (-1)^
     Rational[1, 7] + (-1)^Rational[4, 7])^(-2) (-1 + (-1)^
      Rational[1, 7] + (-1)^Rational[4, 7])^(-1) (1 - (-1)^
     Rational[1, 7] + (-1)^Rational[2, 7] - (-1)^
     Rational[3, 7] + (-1)^Rational[4, 7])^(-1) (-1 + (-1)^
      Rational[3, 7] + (-1)^Rational[5, 7])^(-1) (-1 + (-1)^
      Rational[1, 7] - (-1)^Rational[2, 7] - (-1)^
     Rational[4, 7] + (-1)^Rational[5, 7])^(-1) (2 - 
     2 (-1)^Rational[1, 7] + (-1)^Rational[2, 7] - (-1)^Rational[3, 7] + 
     2 (-1)^Rational[4, 7] - 
     2 (-1)^Rational[5, 7] + (-1)^Rational[6, 7])^(-1) (2 - 
     2 (-1)^Rational[1, 7] + 2 (-1)^Rational[2, 7] - (-1)^Rational[3, 7] + 
     2 (-1)^Rational[4, 7] - 2 (-1)^Rational[5, 7] + 
     2 (-1)^Rational[6, 7])^(-1) ((-1)^Rational[3, 14] 2^Rational[5, 7] - 
     2 $CellContext`t)^(-1) ((-1)^Rational[11, 14] 2^Rational[5, 7] - 
     2 $CellContext`t)^(-1) (2^Rational[5, 7] + 
     Complex[0, 2] $CellContext`t)^(-1) ((-1)^Rational[1, 14] 
      2^Rational[5, 7] + 
     2 $CellContext`t)^(-1) ((-1)^Rational[5, 14] 2^Rational[5, 7] + 
     2 $CellContext`t)^(-1) ((-1)^Rational[9, 14] 2^Rational[5, 7] + 
     2 $CellContext`t)^(-1) ((-1)^Rational[13, 14] 2^Rational[5, 7] + 
     2 $CellContext`t)^(-1) (
    2^Rational[2, 7] (Complex[0, 49179] - 49178 (-1)^Rational[1, 14] + 
      49162 (-1)^Rational[3, 14] - 49167 (-1)^Rational[5, 14] - 
      49170 (-1)^Rational[9, 14] + 49161 (-1)^Rational[11, 14] - 
      49173 (-1)^Rational[13, 14]) - 295020 
    2^Rational[4, 7] (1 - (-1)^Rational[1, 7] + (-1)^Rational[2, 7] - (-1)^
     Rational[3, 7] + (-1)^Rational[4, 7] - (-1)^
     Rational[5, 7] + (-1)^Rational[6, 7]) $CellContext`t + 
    737550 2^Rational[6, 7] (Complex[0, -1] + (-1)^Rational[1, 14] - (-1)^
      Rational[3, 14] + (-1)^Rational[5, 14] + (-1)^Rational[9, 14] - (-1)^
      Rational[11, 14] + (-1)^Rational[13, 14]) $CellContext`t^2 + 
    1966800 
     2^Rational[1, 7] (1 - (-1)^Rational[1, 7] + (-1)^Rational[2, 7] - (-1)^
      Rational[3, 7] + (-1)^Rational[4, 7] - (-1)^
      Rational[5, 7] + (-1)^Rational[6, 7]) $CellContext`t^3 - 1475100 
    2^Rational[3, 7] (Complex[0, -1] + (-1)^Rational[1, 14] - (-1)^
     Rational[3, 14] + (-1)^Rational[5, 14] + (-1)^Rational[9, 14] - (-1)^
     Rational[11, 14] + (-1)^Rational[13, 14]) $CellContext`t^4 - 590040 
    2^Rational[5, 7] (1 - (-1)^Rational[1, 7] + (-1)^Rational[2, 7] - (-1)^
     Rational[3, 7] + (-1)^Rational[4, 7] - (-1)^
     Rational[5, 7] + (-1)^Rational[6, 7]) $CellContext`t^5 + 
    196680 (Complex[0, -1] + (-1)^Rational[1, 14] - (-1)^
      Rational[3, 14] + (-1)^Rational[5, 14] + (-1)^Rational[9, 14] - (-1)^
      Rational[11, 14] + (-1)^Rational[13, 14]) $CellContext`t^6)],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.849905352133359*^9, {3.849905946696056*^9, 3.8499059764536753`*^9}, 
   3.8499060320579977`*^9, {3.849906123949737*^9, 3.849906149563455*^9}, 
   3.849934740678877*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.849906306913105*^9, 3.849906309331121*^9}}],

Cell[TextData[StyleBox["Example B", "Text",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Input",
 CellChangeTimes->{{3.8490956743654633`*^9, 3.8490956743684587`*^9}, {
  3.849095798234562*^9, 3.849095829816025*^9}, {3.8490958762490063`*^9, 
  3.8490958800398993`*^9}, {3.849095940110881*^9, 3.8490960433681784`*^9}, {
  3.849100592496808*^9, 3.84910060107707*^9}, {3.849100963941261*^9, 
  3.849100974372068*^9}, {3.8491011664033337`*^9, 3.849101180062392*^9}, {
  3.8491014733460264`*^9, 3.8491014740904746`*^9}, {3.8491015091954823`*^9, 
  3.849101529548568*^9}, {3.8491017272615504`*^9, 3.84910187694384*^9}, {
  3.8491019680490255`*^9, 3.849102005560727*^9}, {3.8491020526516275`*^9, 
  3.8491020806662817`*^9}, {3.8491021602073884`*^9, 3.8491021795852985`*^9}, {
  3.849102558280779*^9, 3.8491025966364975`*^9}, {3.8491026836079807`*^9, 
  3.84910268389948*^9}},
 FormatType->
  "TextForm",ExpressionUUID->"05449e22-fcf3-4fdd-888e-f36702f66835"],

Cell[BoxData[
 RowBox[{
  RowBox[{"r", 
   RowBox[{"(", "t", ")"}]}], "=", 
  FractionBox["1", 
   RowBox[{
    SuperscriptBox["t", "6"], "+", 
    RowBox[{"5", 
     SuperscriptBox["t", "4"]}], "-", 
    RowBox[{"6", "t"}], "+", "1"}]]}]], "Input",
 CellChangeTimes->{{3.849905089380625*^9, 3.849905089382535*^9}, {
  3.849906324519289*^9, 3.849906358987198*^9}, {3.849906400565593*^9, 
  3.849906428627611*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "\"\<ASPPlusPMinus.m\>\""}]}], "Input",
 CellChangeTimes->{
  3.8422960679074907`*^9, {3.8422964033208666`*^9, 3.842296473492343*^9}, 
   3.8484136871089506`*^9, {3.8499063676097193`*^9, 3.84990636837149*^9}},
 ExpressionUUID -> "60800ca0-047a-4c73-ac38-98fcf0f0b1d1"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*\\nStyleBox[\\\"r\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"(\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"t\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\")\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"=\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \\\"Section\\\"]\\)\"\>", 
   "\[InvisibleSpace]", 
   FractionBox["1", 
    RowBox[{"1", "-", 
     RowBox[{"6", " ", "t"}], "+", 
     RowBox[{"5", " ", 
      SuperscriptBox["t", "4"]}], "+", 
     SuperscriptBox["t", "6"]}]]}],
  SequenceForm[
  "\!\(\*\nStyleBox[\"r\", \"Section\"]\)\!\(\*\nStyleBox[\"(\", \"Section\"]\
\)\!\(\*\nStyleBox[\"t\", \"Section\"]\)\!\(\*\nStyleBox[\")\", \
\"Section\"]\)\!\(\*\nStyleBox[\" \", \"Section\"]\)\!\(\*\nStyleBox[\"=\", \
\"Section\"]\)\!\(\*\nStyleBox[\" \", \"Section\"]\)", (1 - 6 $CellContext`t + 
    5 $CellContext`t^4 + $CellContext`t^6)^(-1)],
  Editable->False]], "Print",
 CellChangeTimes->{3.849906379409133*^9, 3.849906443509503*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*\\nStyleBox[SubscriptBox[\\\"S\\\", \\\"\
\[DoubleStruckCapitalT]\\\"], \\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"r\\\
\", \\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"(\\\", \\\"Section\\\"]\\)\\!\
\\(\\*\\nStyleBox[\\\"t\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\")\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"=\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \\\"Section\\\"]\\)\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{"1", "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"t", "-", 
              RowBox[{"Root", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"1", "-", 
                  RowBox[{"6", " ", "#1"}], "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["#1", "4"]}], "+", 
                  SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}]}], 
             ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Root", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"1", "-", 
                  RowBox[{"6", " ", "#1"}], "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["#1", "4"]}], "+", 
                  SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}], "-", 
              RowBox[{"Root", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"1", "-", 
                  RowBox[{"6", " ", "#1"}], "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["#1", "4"]}], "+", 
                  SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}], 
             ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Root", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"1", "-", 
                  RowBox[{"6", " ", "#1"}], "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["#1", "4"]}], "+", 
                  SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}], "-", 
              RowBox[{"Root", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"1", "-", 
                  RowBox[{"6", " ", "#1"}], "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["#1", "4"]}], "+", 
                  SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], 
             ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Root", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"1", "-", 
                  RowBox[{"6", " ", "#1"}], "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["#1", "4"]}], "+", 
                  SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}], "-", 
              RowBox[{"Root", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"1", "-", 
                  RowBox[{"6", " ", "#1"}], "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["#1", "4"]}], "+", 
                  SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], 
             ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Root", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"1", "-", 
                  RowBox[{"6", " ", "#1"}], "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["#1", "4"]}], "+", 
                  SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}], "-", 
              RowBox[{"Root", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"1", "-", 
                  RowBox[{"6", " ", "#1"}], "+", 
                  RowBox[{"5", " ", 
                   SuperscriptBox["#1", "4"]}], "+", 
                  SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], 
             ")"}]}], ")"}]}], ")"}]}], "+", 
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"t", "-", 
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}]}], 
           ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}], "-", 
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}], 
           ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}], "-", 
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], 
           ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}], "-", 
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], 
           ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}], "-", 
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], 
           ")"}]}], ")"}]}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Root", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "-", 
           RowBox[{"6", " ", "#1"}], "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["#1", "4"]}], "+", 
           SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}], "-", 
       RowBox[{"Root", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "-", 
           RowBox[{"6", " ", "#1"}], "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["#1", "4"]}], "+", 
           SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}]}], ")"}]}], 
    "+", 
    RowBox[{"1", "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"t", "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}], "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}], "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}], "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], ")"}]}],
       ")"}]}], "+", 
    RowBox[{"1", "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"t", "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}], "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}], "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], ")"}]}],
       ")"}]}], "+", 
    RowBox[{"1", "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"t", "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}], "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], ")"}]}],
       ")"}]}], "+", 
    RowBox[{"1", "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"t", "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], ")"}]}],
       ")"}]}]}]}],
  SequenceForm[
  "\!\(\*\nStyleBox[SubscriptBox[\"S\", \"\[DoubleStruckCapitalT]\"], \
\"Section\"]\)\!\(\*\nStyleBox[\"r\", \"Section\"]\)\!\(\*\nStyleBox[\"(\", \
\"Section\"]\)\!\(\*\nStyleBox[\"t\", \"Section\"]\)\!\(\*\nStyleBox[\")\", \
\"Section\"]\)\!\(\*\nStyleBox[\" \", \"Section\"]\)\!\(\*\nStyleBox[\"=\", \
\"Section\"]\)\!\(\*\nStyleBox[\" \", \"Section\"]\)", (
      Root[1 - 6 # + 5 #^4 + #^6& , 1, 0] - Root[
      1 - 6 # + 5 #^4 + #^6& , 2, 
       0])^(-1) (-($CellContext`t - Root[
        1 - 6 # + 5 #^4 + #^6& , 1, 0])^(-1) (
        Root[1 - 6 # + 5 #^4 + #^6& , 1, 0] - Root[
        1 - 6 # + 5 #^4 + #^6& , 3, 0])^(-1) (
        Root[1 - 6 # + 5 #^4 + #^6& , 1, 0] - Root[
        1 - 6 # + 5 #^4 + #^6& , 4, 0])^(-1) (
        Root[1 - 6 # + 5 #^4 + #^6& , 1, 0] - Root[
        1 - 6 # + 5 #^4 + #^6& , 5, 0])^(-1)/(
      Root[1 - 6 # + 5 #^4 + #^6& , 1, 0] - Root[
      1 - 6 # + 5 #^4 + #^6& , 6, 
       0]) + ($CellContext`t - Root[1 - 6 # + 5 #^4 + #^6& , 2, 0])^(-1) (
        Root[1 - 6 # + 5 #^4 + #^6& , 2, 0] - Root[
        1 - 6 # + 5 #^4 + #^6& , 3, 0])^(-1) (
        Root[1 - 6 # + 5 #^4 + #^6& , 2, 0] - Root[
        1 - 6 # + 5 #^4 + #^6& , 4, 0])^(-1) (
        Root[1 - 6 # + 5 #^4 + #^6& , 2, 0] - Root[
        1 - 6 # + 5 #^4 + #^6& , 5, 0])^(-1)/(
      Root[1 - 6 # + 5 #^4 + #^6& , 2, 0] - Root[
      1 - 6 # + 5 #^4 + #^6& , 6, 0])) + ($CellContext`t - Root[
      1 - 6 # + 5 #^4 + #^6& , 3, 0])^(-1) (-
       Root[1 - 6 # + 5 #^4 + #^6& , 1, 0] + 
      Root[1 - 6 # + 5 #^4 + #^6& , 3, 0])^(-1) (-
       Root[1 - 6 # + 5 #^4 + #^6& , 2, 0] + 
      Root[1 - 6 # + 5 #^4 + #^6& , 3, 0])^(-1) (
      Root[1 - 6 # + 5 #^4 + #^6& , 3, 0] - Root[
      1 - 6 # + 5 #^4 + #^6& , 4, 0])^(-1) (
      Root[1 - 6 # + 5 #^4 + #^6& , 3, 0] - Root[
      1 - 6 # + 5 #^4 + #^6& , 5, 0])^(-1)/(
    Root[1 - 6 # + 5 #^4 + #^6& , 3, 0] - Root[
    1 - 6 # + 5 #^4 + #^6& , 6, 
     0]) + ($CellContext`t - Root[
      1 - 6 # + 5 #^4 + #^6& , 4, 0])^(-1) (-
       Root[1 - 6 # + 5 #^4 + #^6& , 1, 0] + 
      Root[1 - 6 # + 5 #^4 + #^6& , 4, 0])^(-1) (-
       Root[1 - 6 # + 5 #^4 + #^6& , 2, 0] + 
      Root[1 - 6 # + 5 #^4 + #^6& , 4, 0])^(-1) (-
       Root[1 - 6 # + 5 #^4 + #^6& , 3, 0] + 
      Root[1 - 6 # + 5 #^4 + #^6& , 4, 0])^(-1) (
      Root[1 - 6 # + 5 #^4 + #^6& , 4, 0] - Root[
      1 - 6 # + 5 #^4 + #^6& , 5, 0])^(-1)/(
    Root[1 - 6 # + 5 #^4 + #^6& , 4, 0] - Root[
    1 - 6 # + 5 #^4 + #^6& , 6, 
     0]) + ($CellContext`t - Root[
      1 - 6 # + 5 #^4 + #^6& , 5, 0])^(-1) (-
       Root[1 - 6 # + 5 #^4 + #^6& , 1, 0] + 
      Root[1 - 6 # + 5 #^4 + #^6& , 5, 0])^(-1) (-
       Root[1 - 6 # + 5 #^4 + #^6& , 2, 0] + 
      Root[1 - 6 # + 5 #^4 + #^6& , 5, 0])^(-1) (-
       Root[1 - 6 # + 5 #^4 + #^6& , 3, 0] + 
      Root[1 - 6 # + 5 #^4 + #^6& , 5, 0])^(-1) (-
       Root[1 - 6 # + 5 #^4 + #^6& , 4, 0] + 
      Root[1 - 6 # + 5 #^4 + #^6& , 5, 0])^(-1)/(
    Root[1 - 6 # + 5 #^4 + #^6& , 5, 0] - Root[
    1 - 6 # + 5 #^4 + #^6& , 6, 
     0]) + ($CellContext`t - Root[
      1 - 6 # + 5 #^4 + #^6& , 6, 0])^(-1) (-
       Root[1 - 6 # + 5 #^4 + #^6& , 1, 0] + 
      Root[1 - 6 # + 5 #^4 + #^6& , 6, 0])^(-1) (-
       Root[1 - 6 # + 5 #^4 + #^6& , 2, 0] + 
      Root[1 - 6 # + 5 #^4 + #^6& , 6, 0])^(-1) (-
       Root[1 - 6 # + 5 #^4 + #^6& , 3, 0] + 
      Root[1 - 6 # + 5 #^4 + #^6& , 6, 0])^(-1) (-
       Root[1 - 6 # + 5 #^4 + #^6& , 4, 0] + 
      Root[1 - 6 # + 5 #^4 + #^6& , 6, 0])^(-1)/(-
     Root[1 - 6 # + 5 #^4 + #^6& , 5, 0] + 
    Root[1 - 6 # + 5 #^4 + #^6& , 6, 0])],
  Editable->False]], "Print",
 CellChangeTimes->{3.849906379409133*^9, 3.84990644355709*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*\\nStyleBox[SubscriptBox[\\\"P\\\", \\\"+\\\"], \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"r\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"(\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"t\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\")\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"=\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \\\"Section\\\"]\\)\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{"1", "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"t", "-", 
           RowBox[{"Root", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"6", " ", "#1"}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["#1", "4"]}], "+", 
               SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}], ")"}],
          " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Root", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"6", " ", "#1"}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["#1", "4"]}], "+", 
               SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}], "-", 
           RowBox[{"Root", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"6", " ", "#1"}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["#1", "4"]}], "+", 
               SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}], ")"}],
          " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}]}], "+", 
           RowBox[{"Root", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"6", " ", "#1"}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["#1", "4"]}], "+", 
               SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}], ")"}],
          " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Root", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"6", " ", "#1"}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["#1", "4"]}], "+", 
               SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}], "-", 
           RowBox[{"Root", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"6", " ", "#1"}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["#1", "4"]}], "+", 
               SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], ")"}],
          " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Root", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"6", " ", "#1"}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["#1", "4"]}], "+", 
               SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}], "-", 
           RowBox[{"Root", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"6", " ", "#1"}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["#1", "4"]}], "+", 
               SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], ")"}],
          " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Root", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"6", " ", "#1"}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["#1", "4"]}], "+", 
               SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}], "-", 
           RowBox[{"Root", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"6", " ", "#1"}], "+", 
               RowBox[{"5", " ", 
                SuperscriptBox["#1", "4"]}], "+", 
               SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], 
          ")"}]}], ")"}]}], ")"}]}], "-", 
    RowBox[{"1", "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"t", "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}], "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}], "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}], "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], ")"}]}],
       ")"}]}], "-", 
    RowBox[{"1", "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"t", "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}], "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}], "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], ")"}]}],
       ")"}]}], "-", 
    RowBox[{"1", "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"t", "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}], "-", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], ")"}], 
       " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"6", " ", "#1"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["#1", "4"]}], "+", 
              SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], "+", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"6", " ", "#1"}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox["#1", "4"]}], "+", 
             SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], ")"}]}],
       ")"}]}]}]}],
  SequenceForm[
  "\!\(\*\nStyleBox[SubscriptBox[\"P\", \"+\"], \"Section\"]\)\!\(\*\n\
StyleBox[\"r\", \"Section\"]\)\!\(\*\nStyleBox[\"(\", \"Section\"]\)\!\(\*\n\
StyleBox[\"t\", \"Section\"]\)\!\(\*\nStyleBox[\")\", \"Section\"]\)\!\(\*\n\
StyleBox[\" \", \"Section\"]\)\!\(\*\nStyleBox[\"=\", \"Section\"]\)\!\(\*\n\
StyleBox[\" \", \"Section\"]\)", -($CellContext`t - Root[
      1 - 6 # + 5 #^4 + #^6& , 3, 0])^(-1) (
      Root[1 - 6 # + 5 #^4 + #^6& , 1, 0] - Root[
      1 - 6 # + 5 #^4 + #^6& , 3, 0])^(-1) (-
       Root[1 - 6 # + 5 #^4 + #^6& , 2, 0] + 
      Root[1 - 6 # + 5 #^4 + #^6& , 3, 0])^(-1) (
      Root[1 - 6 # + 5 #^4 + #^6& , 3, 0] - Root[
      1 - 6 # + 5 #^4 + #^6& , 4, 0])^(-1) (
      Root[1 - 6 # + 5 #^4 + #^6& , 3, 0] - Root[
      1 - 6 # + 5 #^4 + #^6& , 5, 0])^(-1)/(
    Root[1 - 6 # + 5 #^4 + #^6& , 3, 0] - Root[
    1 - 6 # + 5 #^4 + #^6& , 6, 0]) - ($CellContext`t - Root[
     1 - 6 # + 5 #^4 + #^6& , 4, 0])^(-1) (
     Root[1 - 6 # + 5 #^4 + #^6& , 1, 0] - Root[
     1 - 6 # + 5 #^4 + #^6& , 4, 0])^(-1) (-
      Root[1 - 6 # + 5 #^4 + #^6& , 2, 0] + 
     Root[1 - 6 # + 5 #^4 + #^6& , 4, 0])^(-1) (-
      Root[1 - 6 # + 5 #^4 + #^6& , 3, 0] + 
     Root[1 - 6 # + 5 #^4 + #^6& , 4, 0])^(-1) (
     Root[1 - 6 # + 5 #^4 + #^6& , 4, 0] - Root[
     1 - 6 # + 5 #^4 + #^6& , 5, 0])^(-1)/(
   Root[1 - 6 # + 5 #^4 + #^6& , 4, 0] - Root[
   1 - 6 # + 5 #^4 + #^6& , 6, 
    0]) - ($CellContext`t - Root[1 - 6 # + 5 #^4 + #^6& , 5, 0])^(-1) (
     Root[1 - 6 # + 5 #^4 + #^6& , 1, 0] - Root[
     1 - 6 # + 5 #^4 + #^6& , 5, 0])^(-1) (-
      Root[1 - 6 # + 5 #^4 + #^6& , 2, 0] + 
     Root[1 - 6 # + 5 #^4 + #^6& , 5, 0])^(-1) (-
      Root[1 - 6 # + 5 #^4 + #^6& , 3, 0] + 
     Root[1 - 6 # + 5 #^4 + #^6& , 5, 0])^(-1) (-
      Root[1 - 6 # + 5 #^4 + #^6& , 4, 0] + 
     Root[1 - 6 # + 5 #^4 + #^6& , 5, 0])^(-1)/(
   Root[1 - 6 # + 5 #^4 + #^6& , 5, 0] - Root[
   1 - 6 # + 5 #^4 + #^6& , 6, 
    0]) - ($CellContext`t - Root[1 - 6 # + 5 #^4 + #^6& , 6, 0])^(-1) (
     Root[1 - 6 # + 5 #^4 + #^6& , 1, 0] - Root[
     1 - 6 # + 5 #^4 + #^6& , 6, 0])^(-1) (-
      Root[1 - 6 # + 5 #^4 + #^6& , 2, 0] + 
     Root[1 - 6 # + 5 #^4 + #^6& , 6, 0])^(-1) (-
      Root[1 - 6 # + 5 #^4 + #^6& , 3, 0] + 
     Root[1 - 6 # + 5 #^4 + #^6& , 6, 0])^(-1) (-
      Root[1 - 6 # + 5 #^4 + #^6& , 4, 0] + 
     Root[1 - 6 # + 5 #^4 + #^6& , 6, 0])^(-1)/(-
    Root[1 - 6 # + 5 #^4 + #^6& , 5, 0] + 
   Root[1 - 6 # + 5 #^4 + #^6& , 6, 0])],
  Editable->False]], "Print",
 CellChangeTimes->{3.849906379409133*^9, 3.8499064435766363`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*\\nStyleBox[SubscriptBox[\\\"P\\\", \\\"-\\\"], \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"r\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"(\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"t\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\")\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"=\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \\\"Section\\\"]\\)\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"t", "-", 
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}]}], 
           ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}], "-", 
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}], 
           ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}], "-", 
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], 
           ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}], "-", 
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], 
           ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}], "-", 
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], 
           ")"}]}], ")"}]}], "-", 
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"t", "-", 
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}]}], 
           ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}], "-", 
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}], 
           ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}], "-", 
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], 
           ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}], "-", 
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], 
           ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}], "-", 
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"6", " ", "#1"}], "+", 
                RowBox[{"5", " ", 
                 SuperscriptBox["#1", "4"]}], "+", 
                SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], 
           ")"}]}], ")"}]}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Root", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "-", 
           RowBox[{"6", " ", "#1"}], "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["#1", "4"]}], "+", 
           SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}], "-", 
       RowBox[{"Root", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "-", 
           RowBox[{"6", " ", "#1"}], "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["#1", "4"]}], "+", 
           SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}]}], ")"}]}], 
    ")"}]}],
  SequenceForm[
  "\!\(\*\nStyleBox[SubscriptBox[\"P\", \"-\"], \"Section\"]\)\!\(\*\n\
StyleBox[\"r\", \"Section\"]\)\!\(\*\nStyleBox[\"(\", \"Section\"]\)\!\(\*\n\
StyleBox[\"t\", \"Section\"]\)\!\(\*\nStyleBox[\")\", \"Section\"]\)\!\(\*\n\
StyleBox[\" \", \"Section\"]\)\!\(\*\nStyleBox[\"=\", \"Section\"]\)\!\(\*\n\
StyleBox[\" \", \"Section\"]\)", (Root[1 - 6 # + 5 #^4 + #^6& , 1, 0] - Root[
     1 - 6 # + 5 #^4 + #^6& , 2, 
      0])^(-1) (($CellContext`t - Root[1 - 6 # + 5 #^4 + #^6& , 1, 0])^(-1) (
       Root[1 - 6 # + 5 #^4 + #^6& , 1, 0] - Root[
       1 - 6 # + 5 #^4 + #^6& , 3, 0])^(-1) (
       Root[1 - 6 # + 5 #^4 + #^6& , 1, 0] - Root[
       1 - 6 # + 5 #^4 + #^6& , 4, 0])^(-1) (
       Root[1 - 6 # + 5 #^4 + #^6& , 1, 0] - Root[
       1 - 6 # + 5 #^4 + #^6& , 5, 0])^(-1)/(
     Root[1 - 6 # + 5 #^4 + #^6& , 1, 0] - Root[
     1 - 6 # + 5 #^4 + #^6& , 6, 0]) - ($CellContext`t - Root[
      1 - 6 # + 5 #^4 + #^6& , 2, 0])^(-1) (
      Root[1 - 6 # + 5 #^4 + #^6& , 2, 0] - Root[
      1 - 6 # + 5 #^4 + #^6& , 3, 0])^(-1) (
      Root[1 - 6 # + 5 #^4 + #^6& , 2, 0] - Root[
      1 - 6 # + 5 #^4 + #^6& , 4, 0])^(-1) (
      Root[1 - 6 # + 5 #^4 + #^6& , 2, 0] - Root[
      1 - 6 # + 5 #^4 + #^6& , 5, 0])^(-1)/(
    Root[1 - 6 # + 5 #^4 + #^6& , 2, 0] - Root[
    1 - 6 # + 5 #^4 + #^6& , 6, 0]))],
  Editable->False]], "Print",
 CellChangeTimes->{3.849906379409133*^9, 3.8499064436049347`*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{3.849906319019919*^9}],

Cell[TextData[StyleBox["Example C", "Text",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Input",
 CellChangeTimes->{{3.8490956743654633`*^9, 3.8490956743684587`*^9}, {
  3.849095798234562*^9, 3.849095829816025*^9}, {3.8490958762490063`*^9, 
  3.8490958800398993`*^9}, {3.849095940110881*^9, 3.8490960433681784`*^9}, {
  3.849100592496808*^9, 3.84910060107707*^9}, {3.849100963941261*^9, 
  3.849100974372068*^9}, {3.8491011664033337`*^9, 3.849101180062392*^9}, {
  3.8491014733460264`*^9, 3.8491014740904746`*^9}, {3.8491015091954823`*^9, 
  3.849101529548568*^9}, {3.8491017272615504`*^9, 3.84910187694384*^9}, {
  3.8491019680490255`*^9, 3.849102005560727*^9}, {3.8491020526516275`*^9, 
  3.8491020806662817`*^9}, {3.8491021602073884`*^9, 3.8491021795852985`*^9}, {
  3.849102558280779*^9, 3.8491025966364975`*^9}, {3.8491026836079807`*^9, 
  3.84910268389948*^9}, {3.8491027452557955`*^9, 3.8491027456208925`*^9}},
 FormatType->
  "TextForm",ExpressionUUID->"7a3a2a50-1bf0-427c-b9e5-92850aab5d7c"],

Cell[BoxData[
 StyleBox[
  RowBox[{" ", Cell[BoxData[{
    FormBox[
     RowBox[{
      RowBox[{"numerator", "[", 
       RowBox[{"r", "(", "t", ")"}], "]"}], "=", 
      RowBox[{"t", "+", "3"}]}], TraditionalForm], "\[IndentingNewLine]", 
    FormBox[
     RowBox[{"poles", "=", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], "}"}]}], TraditionalForm]}], "Text",
    ExpressionUUID -> "b6dd9905-0b30-4a9b-b5fd-c8d7d8543793"]}], 
  "Text"]], "Input",
 CellChangeTimes->{{3.849905109164076*^9, 3.849905109165876*^9}, {
  3.8499064847269163`*^9, 3.84990649084825*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "\"\<ASPPlusPMinus.m\>\""}]}], "Input",
 CellChangeTimes->{
  3.8422960679074907`*^9, {3.8422964033208666`*^9, 3.842296473492343*^9}, {
   3.8422967970931845`*^9, 3.8422968359332633`*^9}, {3.8491041052690735`*^9, 
   3.849104106216172*^9}, {3.84990649546504*^9, 3.8499065356151037`*^9}},
 ExpressionUUID -> "7e74ba55-2b9d-40cc-b5e3-c6a086fbb213"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*\\nStyleBox[\\\"r\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"(\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"t\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\")\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"=\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \\\"Section\\\"]\\)\"\>", 
   "\[InvisibleSpace]", 
   FractionBox[
    RowBox[{"3", "+", "t"}], "t"]}],
  SequenceForm[
  "\!\(\*\nStyleBox[\"r\", \"Section\"]\)\!\(\*\nStyleBox[\"(\", \"Section\"]\
\)\!\(\*\nStyleBox[\"t\", \"Section\"]\)\!\(\*\nStyleBox[\")\", \
\"Section\"]\)\!\(\*\nStyleBox[\" \", \"Section\"]\)\!\(\*\nStyleBox[\"=\", \
\"Section\"]\)\!\(\*\nStyleBox[\" \", \"Section\"]\)", $CellContext`t^(-1) (
    3 + $CellContext`t)],
  Editable->False]], "Print",
 CellChangeTimes->{3.84993378276125*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*\\nStyleBox[SubscriptBox[\\\"S\\\", \\\"\
\[DoubleStruckCapitalT]\\\"], \\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"r\\\
\", \\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"(\\\", \\\"Section\\\"]\\)\\!\
\\(\\*\\nStyleBox[\\\"t\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\")\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"=\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \\\"Section\\\"]\\)\"\>", 
   "\[InvisibleSpace]", 
   FractionBox[
    RowBox[{
     RowBox[{"-", "3"}], "+", "t"}], "t"]}],
  SequenceForm[
  "\!\(\*\nStyleBox[SubscriptBox[\"S\", \"\[DoubleStruckCapitalT]\"], \
\"Section\"]\)\!\(\*\nStyleBox[\"r\", \"Section\"]\)\!\(\*\nStyleBox[\"(\", \
\"Section\"]\)\!\(\*\nStyleBox[\"t\", \"Section\"]\)\!\(\*\nStyleBox[\")\", \
\"Section\"]\)\!\(\*\nStyleBox[\" \", \"Section\"]\)\!\(\*\nStyleBox[\"=\", \
\"Section\"]\)\!\(\*\nStyleBox[\" \", \"Section\"]\)", (-3 + \
$CellContext`t)/$CellContext`t],
  Editable->False]], "Print",
 CellChangeTimes->{3.849933782773736*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*\\nStyleBox[SubscriptBox[\\\"P\\\", \\\"+\\\"], \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"r\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"(\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"t\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\")\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"=\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \\\"Section\\\"]\\)\"\>", 
   "\[InvisibleSpace]", "1"}],
  SequenceForm[
  "\!\(\*\nStyleBox[SubscriptBox[\"P\", \"+\"], \"Section\"]\)\!\(\*\n\
StyleBox[\"r\", \"Section\"]\)\!\(\*\nStyleBox[\"(\", \"Section\"]\)\!\(\*\n\
StyleBox[\"t\", \"Section\"]\)\!\(\*\nStyleBox[\")\", \"Section\"]\)\!\(\*\n\
StyleBox[\" \", \"Section\"]\)\!\(\*\nStyleBox[\"=\", \"Section\"]\)\!\(\*\n\
StyleBox[\" \", \"Section\"]\)", 1],
  Editable->False]], "Print",
 CellChangeTimes->{3.849933782789321*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*\\nStyleBox[SubscriptBox[\\\"P\\\", \\\"-\\\"], \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"r\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"(\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"t\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\")\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"=\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \\\"Section\\\"]\\)\"\>", 
   "\[InvisibleSpace]", 
   FractionBox["3", "t"]}],
  SequenceForm[
  "\!\(\*\nStyleBox[SubscriptBox[\"P\", \"-\"], \"Section\"]\)\!\(\*\n\
StyleBox[\"r\", \"Section\"]\)\!\(\*\nStyleBox[\"(\", \"Section\"]\)\!\(\*\n\
StyleBox[\"t\", \"Section\"]\)\!\(\*\nStyleBox[\")\", \"Section\"]\)\!\(\*\n\
StyleBox[\" \", \"Section\"]\)\!\(\*\nStyleBox[\"=\", \"Section\"]\)\!\(\*\n\
StyleBox[\" \", \"Section\"]\)", 3/$CellContext`t],
  Editable->False]], "Print",
 CellChangeTimes->{3.849933782804688*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.849906895257866*^9, 3.8499068969736967`*^9}}],

Cell[TextData[StyleBox["Example D", "Text",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Input",
 CellChangeTimes->{{3.8490956743654633`*^9, 3.8490956743684587`*^9}, {
  3.849095798234562*^9, 3.849095829816025*^9}, {3.8490958762490063`*^9, 
  3.8490958800398993`*^9}, {3.849095940110881*^9, 3.8490960433681784`*^9}, {
  3.849100592496808*^9, 3.84910060107707*^9}, {3.849100963941261*^9, 
  3.849100974372068*^9}, {3.8491011664033337`*^9, 3.849101180062392*^9}, {
  3.8491014733460264`*^9, 3.8491014740904746`*^9}, {3.8491015091954823`*^9, 
  3.849101529548568*^9}, {3.8491017272615504`*^9, 3.84910187694384*^9}, {
  3.8491019680490255`*^9, 3.849102005560727*^9}, {3.8491020526516275`*^9, 
  3.8491020806662817`*^9}, {3.8491021602073884`*^9, 3.8491021795852985`*^9}, {
  3.849102558280779*^9, 3.8491025966364975`*^9}, {3.8491026836079807`*^9, 
  3.84910268389948*^9}, {3.8491027452557955`*^9, 3.8491027456208925`*^9}, {
  3.8491041508775735`*^9, 3.849104151869879*^9}},
 FormatType->
  "TextForm",ExpressionUUID->"253aac49-a837-4ca0-aa3e-678a6712345e"],

Cell[BoxData[
 StyleBox[Cell[BoxData[{
   FormBox[
    RowBox[{
     RowBox[{"zeros", "=", 
      RowBox[{"{", 
       RowBox[{"[", 
        RowBox[{"1", ",", "0"}]}], "}"}]}], "}"}], TraditionalForm], 
  "\[IndentingNewLine]", 
   FormBox[
    RowBox[{"poles", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"4", ",", "2"}], "}"}]}], "}"}]}], TraditionalForm]}], "Text",
   ExpressionUUID -> "b83fe767-f409-4d23-937c-0e7090350018"], 
  "Text"]], "Input",
 CellChangeTimes->{{3.849905124060894*^9, 3.849905124063519*^9}, {
  3.8499069000218353`*^9, 3.849906900765224*^9}, {3.8499069824966507`*^9, 
  3.849907005878281*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "\"\<ASPPlusPMinus.m\>\""}]}], "Input",
 CellChangeTimes->{
  3.8422960679074907`*^9, {3.8422964033208666`*^9, 3.842296473492343*^9}, {
   3.8422967970931845`*^9, 3.8422968359332633`*^9}, {3.8422969153385267`*^9, 
   3.8422969272568226`*^9}, {3.8491041120599627`*^9, 3.849104113935296*^9}, {
   3.8499069064069653`*^9, 3.849906911903932*^9}},
 ExpressionUUID -> "5e995680-ded1-4a15-ab43-4c23b1db074b"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*\\nStyleBox[\\\"r\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"(\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"t\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\")\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"=\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \\\"Section\\\"]\\)\"\>", 
   "\[InvisibleSpace]", 
   FractionBox["1", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "t"}], ")"}], "2"], " ", "t"}]]}],
  SequenceForm[
  "\!\(\*\nStyleBox[\"r\", \"Section\"]\)\!\(\*\nStyleBox[\"(\", \"Section\"]\
\)\!\(\*\nStyleBox[\"t\", \"Section\"]\)\!\(\*\nStyleBox[\")\", \
\"Section\"]\)\!\(\*\nStyleBox[\" \", \"Section\"]\)\!\(\*\nStyleBox[\"=\", \
\"Section\"]\)\!\(\*\nStyleBox[\" \", \"Section\"]\)", (-4 + \
$CellContext`t)^(-2)/$CellContext`t],
  Editable->False]], "Print",
 CellChangeTimes->{3.8422969461913843`*^9, 3.849906940108305*^9, 
  3.849906979685851*^9, 3.849907060513586*^9},
 ExpressionUUID -> "9e5eafb7-6135-44da-ae13-7cf9b23154f1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*\\nStyleBox[SubscriptBox[\\\"S\\\", \\\"\
\[DoubleStruckCapitalT]\\\"], \\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"r\\\
\", \\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"(\\\", \\\"Section\\\"]\\)\\!\
\\(\\*\\nStyleBox[\\\"t\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\")\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"=\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \\\"Section\\\"]\\)\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"8", "-", 
      RowBox[{"8", " ", "t"}], "+", 
      SuperscriptBox["t", "2"]}], 
     RowBox[{"8", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", "t"}], ")"}], "2"], " ", "t"}]]}]}],
  SequenceForm[
  "\!\(\*\nStyleBox[SubscriptBox[\"S\", \"\[DoubleStruckCapitalT]\"], \
\"Section\"]\)\!\(\*\nStyleBox[\"r\", \"Section\"]\)\!\(\*\nStyleBox[\"(\", \
\"Section\"]\)\!\(\*\nStyleBox[\"t\", \"Section\"]\)\!\(\*\nStyleBox[\")\", \
\"Section\"]\)\!\(\*\nStyleBox[\" \", \"Section\"]\)\!\(\*\nStyleBox[\"=\", \
\"Section\"]\)\!\(\*\nStyleBox[\" \", \"Section\"]\)", 
   Rational[-1, 8] (-4 + $CellContext`t)^(-2) $CellContext`t^(-1) (8 - 
    8 $CellContext`t + $CellContext`t^2)],
  Editable->False]], "Print",
 CellChangeTimes->{3.8422969461913843`*^9, 3.849906940108305*^9, 
  3.849906979685851*^9, 3.849907060530982*^9},
 ExpressionUUID -> "9e5eafb7-6135-44da-ae13-7cf9b23154f1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*\\nStyleBox[SubscriptBox[\\\"P\\\", \\\"+\\\"], \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"r\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"(\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"t\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\")\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"=\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \\\"Section\\\"]\\)\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"4", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "4"}], "+", "t"}], ")"}], "2"]}]], "-", 
    FractionBox["1", 
     RowBox[{"16", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "4"}], "+", "t"}], ")"}]}]]}]}],
  SequenceForm[
  "\!\(\*\nStyleBox[SubscriptBox[\"P\", \"+\"], \"Section\"]\)\!\(\*\n\
StyleBox[\"r\", \"Section\"]\)\!\(\*\nStyleBox[\"(\", \"Section\"]\)\!\(\*\n\
StyleBox[\"t\", \"Section\"]\)\!\(\*\nStyleBox[\")\", \"Section\"]\)\!\(\*\n\
StyleBox[\" \", \"Section\"]\)\!\(\*\nStyleBox[\"=\", \"Section\"]\)\!\(\*\n\
StyleBox[\" \", \"Section\"]\)", Rational[1, 4] (-4 + $CellContext`t)^(-2) + 
   Rational[-1, 16]/(-4 + $CellContext`t)],
  Editable->False]], "Print",
 CellChangeTimes->{3.8422969461913843`*^9, 3.849906940108305*^9, 
  3.849906979685851*^9, 3.8499070605475388`*^9},
 ExpressionUUID -> "9e5eafb7-6135-44da-ae13-7cf9b23154f1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*\\nStyleBox[SubscriptBox[\\\"P\\\", \\\"-\\\"], \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"r\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"(\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"t\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\")\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"=\\\", \
\\\"Section\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \\\"Section\\\"]\\)\"\>", 
   "\[InvisibleSpace]", 
   FractionBox["1", 
    RowBox[{"16", " ", "t"}]]}],
  SequenceForm[
  "\!\(\*\nStyleBox[SubscriptBox[\"P\", \"-\"], \"Section\"]\)\!\(\*\n\
StyleBox[\"r\", \"Section\"]\)\!\(\*\nStyleBox[\"(\", \"Section\"]\)\!\(\*\n\
StyleBox[\"t\", \"Section\"]\)\!\(\*\nStyleBox[\")\", \"Section\"]\)\!\(\*\n\
StyleBox[\" \", \"Section\"]\)\!\(\*\nStyleBox[\"=\", \"Section\"]\)\!\(\*\n\
StyleBox[\" \", \"Section\"]\)", Rational[1, 16]/$CellContext`t],
  Editable->False]], "Print",
 CellChangeTimes->{3.8422969461913843`*^9, 3.849906940108305*^9, 
  3.849906979685851*^9, 3.8499070605661697`*^9},
 ExpressionUUID -> "9e5eafb7-6135-44da-ae13-7cf9b23154f1"]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1025, 620},
WindowMargins->{{Automatic, 59}, {Automatic, 0}},
FrontEndVersion->"11.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (September \
21, 2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 65164, 1161, 242, "Input"],
Cell[65725, 1183, 72370, 1191, 753, "Input"],
Cell[138098, 2376, 87, 1, 54, "Input"],
Cell[138188, 2379, 273513, 4556, 1903, "Input"],
Cell[411704, 6937, 1191, 19, 50, "Input"],
Cell[412898, 6958, 921, 14, 31, "Input"],
Cell[413822, 6974, 289, 11, 58, "Input"],
Cell[CellGroupData[{
Cell[414136, 6989, 608, 15, 75, "Input"],
Cell[CellGroupData[{
Cell[414769, 7008, 1131, 24, 38, "Print"],
Cell[415903, 7034, 20109, 532, 278, "Print"],
Cell[436015, 7568, 1116, 21, 35, "Print"],
Cell[437134, 7591, 19580, 531, 277, "Print"]
}, Open  ]]
}, Open  ]],
Cell[456741, 8126, 92, 1, 32, "Input"],
Cell[456836, 8129, 971, 15, 31, "Input"],
Cell[457810, 8146, 413, 12, 51, "Input"],
Cell[CellGroupData[{
Cell[458248, 8162, 607, 15, 75, "Input"],
Cell[CellGroupData[{
Cell[458880, 8181, 1093, 23, 38, "Print"],
Cell[459976, 8206, 27153, 741, 454, "Print"],
Cell[487132, 8949, 18585, 511, 277, "Print"],
Cell[505720, 9462, 9326, 240, 167, "Print"]
}, Open  ]]
}, Open  ]],
Cell[515073, 9706, 87, 1, 54, "Input"],
Cell[515163, 9709, 1021, 15, 31, "Input"],
Cell[516187, 9726, 601, 16, 55, "Input"],
Cell[CellGroupData[{
Cell[516813, 9746, 685, 16, 75, "Input"],
Cell[CellGroupData[{
Cell[517523, 9766, 916, 19, 37, "Print"],
Cell[518442, 9787, 1114, 22, 39, "Print"],
Cell[519559, 9811, 965, 18, 35, "Print"],
Cell[520527, 9831, 1002, 19, 38, "Print"]
}, Open  ]]
}, Open  ]],
Cell[521556, 9854, 94, 1, 32, "Input"],
Cell[521653, 9857, 1072, 16, 31, "Input"],
Cell[522728, 9875, 720, 21, 55, "Input"],
Cell[CellGroupData[{
Cell[523473, 9900, 740, 17, 75, "Input"],
Cell[CellGroupData[{
Cell[524238, 9921, 1151, 25, 41, "Print"],
Cell[525392, 9948, 1530, 32, 43, "Print"],
Cell[526925, 9982, 1494, 33, 42, "Print"],
Cell[528422, 10017, 1174, 22, 38, "Print"]
}, Open  ]]
}, Open  ]]
}
]
*)

