(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    220621,       4404]
NotebookOptionsPosition[    217753,       4316]
NotebookOutlinePosition[    218112,       4332]
CellTagsIndexPosition[    218069,       4329]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[Cell[TextData[{
  StyleBox["            ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["Algorithm:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox["AZeros",
   FontFamily->"Optima",
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox["             \n               ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["Authors:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox[
  "Ana C. Concei\[CCedilla]\[ATilde]o (aconcei@ualg.pt) & J\[EAcute]ssica \
Pires (jessicaccpires@gmail.com) ",
   FontFamily->"Optima",
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontWeight->"Plain",
   Background->None],
  StyleBox["        \n                    ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["Year:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["2021",
   FontFamily->"Optima",
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox["\n           ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["Institution:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox[
  "Center for Functional Analysis, Linear Structures and Applications \
(CEAFEL), Universidade do Algarve",
   FontFamily->"Optima",
   FontWeight->"Plain",
   FontColor->GrayLevel[0.5],
   Background->None],
  StyleBox["          ",
   FontFamily->"Optima",
   FontWeight->"Plain",
   Background->None],
  "\n   ",
  StyleBox["Article/Journal:",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  " ",
  StyleBox["Symb",
   FontColor->GrayLevel[0.5]],
  StyleBox["olic comput",
   FontColor->GrayLevel[0.5],
   Background->GrayLevel[0.85]],
  StyleBox[
  "ation applied to Cauchy type singular integrals. \n                  Math. \
Comput. Appl. ",
   FontColor->GrayLevel[0.5]],
  "\n                  \n        ",
  StyleBox["  ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  StyleBox["License",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.35672541390096896`, 0.6326237888151369, 0.7690699626153964],
   Background->None],
  StyleBox[":",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.3799496452277409, 0.6257724879835203, 0.7690852216372931],
   Background->None],
  StyleBox[" ",
   FontFamily->"Optima",
   FontSize->18,
   FontWeight->"Plain",
   Background->None],
  Cell[BoxData[
   GraphicsBox[
    TagBox[RasterBox[CompressedData["
1:eJzs3QmUHMd54Pnqaq2GjzNaWbIlPy5FUGvrjQ9aegQlr+WZXR+AZnzKh6jD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      "], {{0, 270}, {1400, 0}}, {0, 255},
      ColorFunction->RGBColor],
     BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
     Selectable->False],
    DefaultBaseStyle->"ImageGraphics",
    ImageSize->{251.96484375, Automatic},
    ImageSizeRaw->{1400, 270},
    PlotRange->{{0, 1400}, {0, 270}}]]],
  "\n  "
 }], "Section",
  CellChangeTimes->{{3.560518296834669*^9, 3.5605183114080544`*^9}, {
   3.560518646082142*^9, 3.560518662165022*^9}, {3.560518702205791*^9, 
   3.560518800592577*^9}, {3.560518864590123*^9, 3.5605188705762587`*^9}},
  FontFamily->"Courier",
  FontSize->14,
  Background->GrayLevel[0.85],
  ExpressionUUID -> "8c5f323e-a33d-4a8f-a576-4cb80b2c81be"]], "Input",
 CellChangeTimes->{{3.8499020777175817`*^9, 3.849902078798779*^9}, {
  3.849903937087978*^9, 3.8499039376929407`*^9}}],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzs3QeYFAXe7/vhnnvv2Xvec57X59118V13Zc2LgKioCAhDFkRAAZGkIILk
HCUNCJJhyBlGchhyzgMMMAwwg+TsAAMMsIAwktR1/7eqY3V1mOmqnun0/TzP
bxe7q6srdvdvqqr7+ead6nz9f8XExHT7g/I/db7sVaFr1y+/qfuU8h+fduzW
plXHli2qd+zeslXLru81/x/KjenKsLeUf/zfyr8FAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAESspKUni4uKkadOm
EhsbK4UKFZKYmBgSBlHXlRp1vanrT426PgEAAAAA4SUhIcHS6YLdM0ne9Xc6
OwAAAACEPrW3cbw8uqKub/XvMgAAAACA0EE/J+r65/g6AAAAAARfTue3/+25
v0mjJg1kyoyJsmHLGjl+Jl3uP75NwiDqulKjrjd1/b1ftrQlvta3+l0EAAAA
AIDgUL9fzFtfa9C4vqzZtFxuP7hGIizpJ1OlZ59uXte9ul0AAAAAAPJPRkaG
145ev1FdOXgiWbKyM0iER13P6vr2dh68up0AAAAAAPKep47+7N/+IkvXzZcr
P50lUZb9R3da1r+nrg4AAAAAyFueOnrJMm/LxTvHSRRn95EtUqdBbc6BBwAA
AIB85Ok7494tXULO3kojRHamr5NPPvuI75YDAAAAgHyg/uaWvn+9XepNOZG1
nxBHthxcIbXrV3fbVvjNNgAAAAAILE/nux+5tosQt2w4sET++68FuVYdAAAA
APJIQkKCW0efunSUHLyylRCPWb1/vts2o25HAAAAAADz1GOh2r5VvW4l2Zex
nhCfUbcTjqkDAAAAQGB5Opa+dPdU2X1xBSE+o24nXKcOAAAAAIGl/473LzrU
le3nFhOSq6jbi3b7UbcnAAAAAIBx+nPev98xRjadmUtIrqJuL5z7DgAAAACB
4em32NaenEGIXyn6ziuc+w4AAAAAARAXF+fSr+q3+VBWHJtMiF8p8vbLnPsO
AAAAAAGgvza9zbcNZekPYwnxK+p2Q08HAAAAAPNiY2Nd+lXfGV/LgrThUZO5
+wfJ9O39ZXrSIJnrbZiD9n8PtQw7a/9Q9+Fs45myfaBy/zDvz5mL5wvHqNuN
djtStysAAAAAgP/03yE3am0XSTg0KIzTV1rVKajMS0H520uaKPP2tzqfyQzb
cLO2tpb61Z/XXZv/vDSd0sk5rgMdpKrtvlKtqssn5e3DvS6D99qG2d1BGjX8
h9s1/oXrVJehuzXTdaC7tGqmH66gNJ3ZPQSWmfmo2w3fJQcAAAAA5un75YwD
fcM8PeSzEgXc5suSElVlnDrM7pZS0tP9tnw2t5t1XDu/kjc8DlNavttnHU85
H+NxDHfgG+nctKDHYV5t3ywElpn5DFvVnp4OAAAAAAGg742T9/UI83STviOq
ScMe1aXZQNdz+p/94jOZqAzTo/NLjtte+aK2DE3qrDymjHPYDz6Sceq4kr6Q
d+2PfdE2fLXX5NkX3pMBST2kt2Y8MTGvSYspX0iPERXlWc1zVhzRSpmmTtKw
rP224tJjTScZteYradG2hHw05KsQWGaBiX5bAgAAAAD4T3/ee1zilzI+uVNE
JH5BNfmLY95elK4b1dvbSP2yzvlt9P3XMmydmsZS3j7sW2XkO3UcOxrJ25pl
U2V4M8349eNp57iv/4Bijttf7tRQua2V1H/LOWzpNjWkz7p2+bIM8ivqdsPx
dAAAAAAwT/89cm3G1ZLRu1qHf5SOrT0nvfLQJrb7msgHL/g6V13NX6TjJmXY
rfXkLdttBd4sLd+5jL+BZvx/l86bnPd9N6O0Y1z/Xa+a5baOHfTXwiv3VSkj
32xqFfxlFYCo2w3fIwcAAAAA5ul/l61ez7IydMdXYZ9WX/+3c77KlJWBO760
3D5sU13HuezW/JcUfOGPmsTIM5XLygBl+GGbajuvTy9T2jEO63g098U8J+3X
N3fcN3BaKWcXb1zVdvvn0qpLEfe/CSjjHaAZb7hG3W6088XvsgEAAACAMQkJ
CS796o2qL8i325qEdQbM0VxrHvO8fL1Ke/9n8klp+31PSbNEH+Pa8KEUtx9P
f6Ok9NvmOp5apZ3fV1dvbmPHfV0HOL/X/R9tP3QZ56DN9aXNt2/L85rpa7ch
+MvMbNTtxuX6ibi4YG/aAAAAABCW9D39P//8v6T/5k/DOLWkUnHXc9g/GVhK
Pun1rtTqV0F6ba4nn33yn877S70uzefUkM4La0iL0WWk0ieFpHS/atZxra0s
xezDFS+hPFb7PPWkkXY8z78sjSZVleYD35CCmuVZaXQtGbChhpQv/p9Ssk0Z
abOwtvRYWEnzffOFpMXa+iGw3MxF3W6021FSUlKwN20AAAAACEsZGRlu52I3
Hl5GvtlYOzyzopy84vW6879Lq3W1pdf3JX1en16weTnbuGKd43q9uHTTPVdO
44kpVVy62KapkLdhKpSQHsFeZiajbi981zsAAAAABI7+u+SKVHpWuq+rHp5Z
XVZKeO3OL8pXq63DtZ9aQooX8zDM3wtKjXGV3Mf1XjHp6OH5vI3ntcZvSlvH
cFWl/tfPuQ3zt2qFpcWKasFfZiajbi9cmw4AAAAAgaM/9/3//Pn/k2azykrH
tR9EfNourSgtvy8vLedXkDbLq3gYpoq0X15V2uc0nkUV5CtlPF+p41nlZbhV
VaTVfOtwrZZWDfq8ByLqdqL/+4O6PQEAAAAAjFPPfdcfU3+14l+k9ZqqhPiM
up1otxt+Nx0AAAAAAkN/TF1N9SElpPnqyoR4jLp96LcZvj8OAAAAAAJHf0z9
P57+g3w8rYx8vrISIW5Rtw+OpQMAAABA3lGPheqPjz5d9Cn5bEUFQlyibhcc
SwcAAACAvBcXF+fe1Ys8JR8vjyXEEnV70G8jfMc7AAAAAOQN9Tvl1M6l72F/
LPKfUnFKSamxvByJ4qjbgX7bUK+XAAAAAADkHbWrq9ca6/vYH57+n/J2XDGp
kliWRFnU9e7pN+np6AAAAACQP7x1dTUFY/8sJSeVkNhlpUmER13P6vr21tHV
7QQAAAAAkD+8nQOv5n/+6f+VP5d7Wor0LyKlF5ciEZa3Jrwlf6v7V4/rnuPo
AAAAABA8alf39N1y2vw/Smf/Y7k/yfOtX5BX+xWWYuPfkLcXlSRhEnV9qetN
XX9/qfusz3XNd8YBAAAAQGhQf3NL//vqJLqirn9+ew0AAAAAQktCQgJ9Pcqi
fk+But4BAAAAAKFJPReevh7ZUbu5en47/RwAAAAAwou9s6tRe53a3b19TzwJ
zajrS11v6vpTv4uAc9sBAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAMESFxcnMTExIRF1WgAAAAAA
iGb0dAAAAAAAQkewu7k+AAAAAABEs2D3cno6AAAAAABOnPcOAAAAAEDoaNq0
adD7OcfTAQAAAACwCnYvp6cDAAAAAOAU7F7Oee8AAAAAAFhlZGS49OTeSpbk
c7TPn5CQEOxFAgAAAABAUKnd2N6TCyrZFVMg39Kbc94BAAAAAHChP6Y+Lh+7
enHOeQcAAAAAwI32t9mK51NP15/zrv69AAAAAAAABOeYuvZYuvrbcAAAAAAA
wEn7O+rV8rincywdAAAAAADf8vOYejWOpQMAAAAAkKPY2Nh8Oaau/XtAUlJS
sGcbAAAAAICQpHZm7W+0LcmDrt5M09ELFSoU7FkGAAAAACCk5fUx9YKanq7+
djsAAAAAAPBO7c7aY+qB7Oi9dd8fBwAAAAAAcpZXx9SLcywdAAAAAAC/5cUx
dY6lAwAAAABgjPobbdpj6s0C0NW1x9Lj4uKCPYsAAAAAAISVQB5TX6I7lq7+
HQAAAAAAAOSe2qW13Xqcia5eTTOepk2bBnvWAAAAAAAIS4E6pq7t++pvtAMA
AAAAAP8F4ph6M83j1WveAQAAAACAcep3vtl7dnEDPZ1j6QAAAAAABI6ZY+ra
Y+mFChUK9qwAAAAAABAR1O9+s/ftan709IKanq5e6w4AAAAAAMzTHlMvmMtj
6r11v8UGAAAAAAACR/0OOH+OqRfXdHT1GncAAAAAABA46nfAaY+pL/HR1Zfo
jqWrx+MBAAAAAEBg5faYuvZYunptOwAAAAAACDz1u+C0x9Q5lg4AAAAAQHDl
dEy9GsfSAQAAAADINzkdU9ceS1evaQcAAAAAAHlHPY+9UKFCji7eW9PVm2k6
ujoMAAAAAADIe96OqRfU9HR1GAAAAAAAkPfUY+ra89vH2Y6ra28DAAAAAAD5
R39MnWPpAAAAAAAEj/6YOsfSAQAAAAAIrri4OLeOrt4GAAAAAADyn6dj6upt
AAAAAAAgOGJjYznnHQAAAACAEKE9pp6UlBTsyQEAAAAAIOqpx9TVAAAAAACA
4FOPo3MsHQAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAQLDExMYTkSQAAAAAA/gt2lyORGwAAAACA
/4Ld5UjkBgAAAADgv2B3ORK5AQAAAAD4T9+tbv/yOyGGQk8HAAAAAPP03Srr
ye+EGAo9HQAAAADM03erq49/J8RQ6OkAAAAAYJ6+W11+9C9CDIWeDgAAAADm
6bvVxYe/E2Io9HQAAAAAME/frc7+/C9CDIWeDgAAAADm6bvVyezfCDEUejoA
AAAAmKfvVsfu/0aIodDTAQAAAMA8fbdKv/cbIYZCTwcAAAAA8/Td6uBPvxFi
KPR0AAAAADBP36323/2VEEOhpwMAAACAefputefOr4QYCj0dAAAAAMzTd6uk
f/5KiKHQ0wEAAADAPH232nrrF0IMhZ4OAAAAAObpu9Wmm78QYij0dAAAAAAw
T9+t1t34hRBDoacDAAAAgHn6brU66wkhhkJPBwAAAADz9N1q+fUnhBgKPR0A
AAAAzNN3qyVXnxBiKPR0AAAAADBP360WZD4mxFDo6QAAAABgnr5bzb3ymBBD
oacDAAAAgHn6bjX78mNCDIWeDgAAAADm6bvV9EuPCDEUejoAAAAAmKfvVpMz
HhFiKPR0AAAAADBP363G//iIEEOhpwMAAACAefpuNfbCw6jJwBXTpMR7H0nR
ys2l6YZrhsfz3Z506bRkg7SZv0E6bTguw84Ef96CEXo6AAAAAJin71Yjzz+I
mnTq95Fjvt8cnm5gHJek/mdF3ZZhTIFy8vnmm0Gfv/wOPR0AAAAAzNN3q6Hn
HkZNOvYr55jvN5Se7t/j70uz1h46uiPNpePx4M9jfoaeDgAAAADm6bvVt2cf
RFFuSNdNqdJu02kZ4OdjBx3aKs87lltRqbnwmPTatkqKa5ZlxbnnQ2Ae8y/0
dAAAAAAwT9+tBp55EDXpMKW7o2fXXnvDclv/ozfkmzTv6Xv0nmW4rjO7O5ZZ
wVYbHONsN7q54/Z/9E0O+jzmZ+jpAAAAAGCevlv1Pf0gavLVQOf16VVXXFVu
uyEflvR2HrstlaZJD/WxfZyPLT3jtGOcvdZMcxs22POZX6GnAwAAAIB50dzT
Ww5s4NbTq76au56ufWz1NTcc4+yxZrxz2JLj6ekAAAAAAL/ou1WvUz9HTZrH
feaY78rLMy23ddqeJl+uT5MWnrL6gLTYken1sWp6bF8qf7bd/vQXS6VHCMxn
foWeDgAAAADm6btVtxM/R02aDnB27QrLMi23dUnLknb7M6VDapZbLLen/eT2
2Morsxzj7LBMczz93ZHSLgTmM79CTwcAAAAA8/TdqvPxn6MmTTRdu/zSTOW2
LKn0bk7nvU+VtspjG/V2Xp9ebES6Y5xtVzp7+l+7bgn6POZn6OkAAAAAYJ6+
W7U/9nPUpGF/Z08vq/T09seypOwrOfT0ClOllfLYplO7OW9rstQxzk+7OH+T
/dXBaUGfx/wMPR0AAAAAzNN3q9ZHs6Mm9TU9vcySK5bbvtp+Uhqt/8FrGm+/
bn180kr5k2a5Fe+/RGoM6+uyLD/YfDfo85ifoacDAAAAgHn6btXih+yoSZ1+
NRzzXWrxFT8ff0uqNPF+3P2/vlopzUNgHvMz9HQAAAAAME/frb48kh01qTeq
rWO+Sy+7bmAcZyW2eQ23ZfhSmyXSOATmL79DTwcAAAAA8/TdqknafeJnGu+/
LJ9uPiP1tl+UBvuDPz3BCj0dAAAAAMzTd6uGh+8TYij0dAAAAAAwT9+tPj10
nxBDoacDAAAAgHn6bvXxwXuEGAo9HQAAAADM03erWqn3CDEUejoAAAAAmKfv
VjX23yHEUOjpAAAAAGCevltVS75FiKHQ0wEAAADAPH23qrLrBiGGQk8HAAAA
APP03arizmuEGAo9HQAAAADM03er8luvEGIo9HQAAAAAME/frcpuziDEUOjp
AAAAAGCevluVWn+REEOhpwMAAACAefpu9e7ac4QYCj0dAAAAAMzTd6u3Vp0m
xFDo6QAAAABgnr5bvbniBCGGQk8HAAAAAPP03er1xGOEGAo9HQAAAADM03er
IouPEGIo9HQAAAAAME/frV5dcJgQQ6GnAwAAAIB5+m718txUQgyFng4AAAAA
5um71QsJKYQYCj0dAAAAAMzTd6vnZu8lxFDo6QAAAABgnr5b/XX6bkIMhZ4O
AAAAAObpu9UzU3YSYij0dAAAAAAwT9+t/jxpOyGGQk8HAAAAAPP03YqQQAUA
AAAA4L9gdzkSuQEAAAAA+C/YXY5EbgAAAAAA/gt2lyORGwAAAAAAAo3uCQAA
AABA6KCnAwAAAAAQOujpAAAAAACEDno6AAAAAAChg54OAAAAAEDooKcDAAAA
ABA66OkAAAAAAIQOejoAAAAAAKGDng4AAAAAQOigpwMAAAAAEDro6QAAAAAA
hA56OgAAAAAAoYOeDgAAAABA6KCnAwAAAAAQOujpAAAAAACEDno6AAAAAACh
g54OAAAAAEDooKcDAAAAABA66OkAAAAAAIQOejoAAAAAAKGDng4AAAAAQOig
pwMAAAAAEDro6QAAAAAAhA56OgAAAAAAoYOeDgAAAABA6KCnAwAAAAAQOujp
AAAAAACEDno6AAAAAAChg54OAAAAAEDooKcDAAAAABA66OkAAAAAAIQOejoA
AAAAAKGDng4AAAAAQOigpwMAAAAAEDro6QA80b82EBKoAAAAwDc+PwHwJNhd
jkRuAAAA4BufnwB4EuwuRyI3AAAA8I3PTwA8CXaXI5EbAAAA+MbnJwCe6F8b
7vz6OyGGwvsMAACAf/j8BMAT/WtD1pPfCTEU3mcAAAD8w+cnAJ7oXxsyH/9O
iKHwPgMAAOAfPj8B8ET/2vDjw98JMRTeZwAAAHKWkJAgcXFxEhsb6/b5qVCh
QtK0aVNLkpKSgj2pAIJE/9pw9ud/EWIo9HQAAADP1G6udm9/v5fX3tvp7EB0
0b8WnMj+jRBDoacDAAC4Uvu12rUD8Vs66njo60B00O//R+79Roih0NMBAACs
MjIyPJ7XHoio41XHDyBy6ff7gz/9Soih0NMBAACsx9Bzey679vi42r3VqOfI
q/HV89VxqMMAiEz6fX7fnV8JMRR6OgAAiHa+Orrazf09Dq4O7+26drWrq99H
ByDy6Pf3Xbd/JcRQ6OkAACCaeevogThP3dd59HR1IPLo9/Ott34hxFDo6QAA
IFp56+iBPjdd7eScAw9EPv1+vvHmL4QYCj0dAABEI/VYt6eOnlffze7pbwJq
V+e75YDIod/H12Q9IcRQ6OkAACAaeTofPa9/P81TV1enA0Bk0O/fy68/IcRQ
6OkAACDaeOrL+XUOuqdz4Pl9dSAy6PftRVcfE2Io9HQAABBt9MfS8/uYtv75
1fPfAYQ/fbeae+UxIYZCTwcAANFEPW4e7OPZnq6N55g6EP70+/Wsy48JMRR6
OgAAiCb63zVX/zuapwNA4Oi71dSMR5GT8xfli+YN5JUqNaVsl4Uy0s/HD181
Q94tVVOKV/lKWm66bmpaxh04IXHbj8igvZdkcrCXSx6Fng4AAKKJ/rNPsL5v
XX9MnXPfgfCnf32Z8OOjyMnx/VLMMW8NpPdp/x7fY0BNx3J5e+QRY9Nw7rJ8
3buBcxkXKCddj4fAssmD0NMBAEC00J/zHuxurL9OnXPfgfCm71ZjLjyMnJzY
Jy9penr3k/49vnv/co7lUmLEEb+ff/CGhVLU7bc0a0qXoyGwbPIg9HQAABAt
9Oeaq9+9Hkz6vxtw7jsQ3vTdavj5BxGVwalnpPP6g9L78B0Dj78pvTcflM6b
z8iQ8w91992R5p0ayDPKMis7Nt3jYz95r4Db8lV7eocf9OOKjNDTAQBAtND3
9Pz6LTZv6OlAZNF3q8FnH0ROTh6Tsq/aunKtOdLfcvs96Z+e5SO3ZaDt8V2m
drctl6JSZ90N3fhvSK2S1mVWuG+yh+e/LZ/WUu4v2U++XLZAntf09LbpIbBs
8iD0dAAAEC3U89xD4dp0O65RByKLvlsNOPMgcpK2V16xz1vJ8dJTua332vEe
jnG75sO1NyyPbznoI8dtH6y46jLuuDNKT69kve9Vpad7noafrP9/IlVznXxN
aZkWAssmD0JPBwAA0SLUezohJLLyzakHkZMje6WIfd7eHS/dlNu6LR+V4zKo
tvqG5fEt4ho6bquy/Kpy2z3pduCqdFHS7dAxKfuK9b5C3TZIlyM3LLd3OXBD
evmaDqWnf3koBJZNHiTY2y4hhAQzHLsCoov+NSAUBPt1kBCSd+l+8ufISXqy
vGafN6Wnd7LcliHNVx2Q5uvSPabpqjRpn259fNO4zxzLpWJipnQ/mCx/y2kZ
Fignnx/yMR1KT3e7P0IS7G2XEEJCJQAiX6gdT1cF+7WPEJJ36XT858jJ4WR5
1T5vSk9vY7n9J2mzL1Nap2ZJG7cot+/Lkva2xzce4OzpsUszpWPqzlz19M9S
fUyH0tMb6u+PkAR72yWEkFAJgMgXar+Dpj5/sF/7CCF5l7ZHsyMnB/c4r09/
Z5y0VG5ruWREjsug3PLrlsd/1t/Z08suuSJtjl6XRssPyGfLD0vj1Zsd57I/
+9Vsabj+sHL7fiU/SCtf0xFTQz5NCYFlkwcJ9rZLCCGhEgCRL9R7ujp9AMKX
/rNFyx+yIyepu52/n6709GbKbc0W59zT30+8bnl83X7Onl5q8RXd+G9JbAXr
d8k/1y/F93SkHdb8jvtnUictBJZNHoTPqQCiFa9/QPTR/y5bsH8HLdR+zx2A
OfrPFs3S70dOUvbIC/Z5e3ucNFZvO3RZ6q35Qep4zQlpcsj6+Np9nT295MLL
uvFfk1Llrfc912OPx+dvsHCFvD9wlpTr0dZlGb/aY7KUi5srtXfcCf4yCmD4
nAogWvH6B0Qf/e+VB/u7JPXXywf799wBmKP/bNE47X7kJHmP83pypafX9/Px
H/ap4VguJZSerr2vSdpNKfOh9b6/dt/j9tgmadfk3bd9H7d/e+G14C+jAIbP
qQCiFa9/QPTx9DtowTr33dO0AAhv+n26/qH7kZMDh5zXhcdOkTp+Pv7D4c7j
4CUWX/UwzB2pu/emfOrl8RU71PDZ0z2PM3zD+wOAaMXrHxCd9NeoB+vc91A7
Bx+AefrPFh8fvBdhuS0f77kdAtMR+eFzKoBoxesfEJ08nfue38fUPR1L55x3
IPzp9+taqfcIMRQ+pwKIVrz+AdFJ7cjBPqauf/5gXycPIDD0ny0+3HebEEPh
cyqAaMXrHxC99MfU1eTXd617eu5g/z4cgMDQ79tVd90gxFD4nAogWvH6B0Q3
T8e08/rcc/3vpavhN9OByKHfvyvuuEqIofA5FUC04vUPiG7q+e/630XLy67u
qaOrUacDQGTQ799lN18mxFD4nAogWvH6B8BTd1a7eqDPgfd0rjvnuwORR7+P
l1p/kRBD4XMqgGjF6x8AlbcOrX63nNkerT5ef349HR2IXPr9/J3VZwkxFD6n
AohWvP4BsPPW1dVj60b6unouu/730enoQOTT7+tvrjhJiKHwORVAtOL1D4CW
2p3116t76+xq7NeVq/+vRu366vnyvsZBRwcim35/L7bsKCGGwudUANGK1z8A
ep5+Wz1QUcfLd8YBkU2/3xdemEaIofA5FUC04vUPgDfqsfFA9XV1PBxDB6KD
fv9/eW4qIYbC51QA0YrXPwC+2M9lN9rX1XPk8/r32AGEFv3rwPMJ+wgxFD6n
AohWvP4ByC17Z1e7t9rbPXV39T66ORDd9K8Lf525hxBD4XMqgGjF6x8AM3gN
AaCnf114ZspOQgyF9xgA0YrXPwBm8BoCQC8vvoOSEDUAEC14/QNgBq8hAPSC
3eVI5AYAogWvfwDM4DUEgF6wuxyJ3ABAtOD1D4AZvIYA0At2lyORGwCIFrz+
ATCD1xAAAAAgsPiMDcAMXkMAAACAwOIzNgAzeA0BAAAAAovP2ADM4DUEAAAA
CCw+YwMwg9cQAAAAILD4jA3ADF5DAAAAgMDiMzYAM3gNAQAAAAKLz9gAzOA1
BAAAAAgsPmMDMIPXEAAAACCw+IwNwAxeQwAAAIDA4jM2ADN4DQEAAAACi8/Y
AMzgNQQAAAAILD5jAzCD1xAAAAAgsPiMDcAMXkMAAACAwOIzNgAzeA0BAAAA
AovP2ADM4DUEAAAACCw+YwMwg9cQAAAAILD4jA3ADF5DAAAAgMDiMzYAM3gN
AQAAAAKLz9gAzOA1BAAAAAgsPmMDMIPXEAAAACCw+IwNwAxeQxDp9Ns4IYQQ
/wLAf+xHAMzgNQSRLtifbwkhJNwDwH/sRwDM4DUEkS7Yn28JISTcA8B/7EcA
zOA1BJEu2J9vCSEk3APAf+xHAMzgNQSRTr+NP/7934QQQnyEzwaAeexHAMzg
NQSRTr+NP/zXvwkhhPgInw0A89iPAJjBawginX4bz/7t34QQQnyEzwaAeexH
AMzgNQSRTr+N3/v134QQQnyEzwaAeexHAMzgNQSRTr+N3/n1d0IIIT7CZwPA
PPYjAGbwGoJIp9/Gb/3yOyGEEB/hswFgHvsRADN4DUGk02/jWU9+J4QQ4iN8
NgDMYz8CYAavIYh0+m382uPfCSGE+AifDQDz2I8AmMFrCCKdfhvPfPQ7IYQQ
H+GzAWAe+xEAoxLX75U/vlhOCpX8Sp594zPLv1PSzgR7soCA0r9PXnr0L0II
IT5CvwDMYz8CkFuZ1/9p6eb1W4+0dHNvKV27p3QdPNvS2dXHAOFM/z7548Pf
CSGE+Aj9AjCP/QiAL2rPjp+1JsduntveDoQb/fvk+Qf/IoQQ4iP0C8A89iMA
emqfVru52q+NdnM6OyKF/n3y7M//IoQQ4iP0C8A89iMAKvV8drWb+9e5e0i3
gTMkcU2SpKQes/x//VbD6eyIKPr3yVPZ/yKEEOIj9AvAPPYjIDrl9lpzT908
ftpyybx8VeSXRx6j3pe4Wu3swwx1dq5pRyjRv08ez/6NEEKIj9AvAPPYj4Do
YfRa8y5x0yV+aqLIkwd+J/PSFUlctcOvzs6xdoQS/fvk0fu/EUII8RH6BWAe
+xEQ2Yxca166Vnelm09T+vU2kcfZAUtmxiXLOOt/PZTOjrChf59Mv/cbMZGU
qz/Jrks/ScrtnIc9dPW6bDh+WfbesD320mXlv69LSgjMRzCXS7hm74XL1vVp
mcfHsuP0j7Lh9HU5FJTpeSx7L92yLPPgPH9kh34BmMd+BEQeQ9eaq918wDRJ
2Z8m8uh+nifzxwzLcyWu3O5Xb6ezI7/p3ycP//RbwLMv47KsSz8jq9Mvyqbz
P+XJc4REsg5KrG05vj38oO9hrx+R6rZhu+97LIdPr7Ktg2LyfaZ++J9l27Hj
8v3GrTJ1zVaZue2grD59S1KDOa//vCxxbRrJ2x/WkjrfLJWdgVouAc6SyS0t
y/TlIs68XbaYvKROj+Xf5Z33lS2qDNtSFrgt/5yTenq9Yx+qPvOM7Euf5fjv
7rvyf5tfPrmR5vlv+b/OiM/QLwDz2I+A8Ge/1lztr/528/gpSyXz4kWRhz8F
Neo0JK7YSmdHyNG/T6b+9Gtgc/uUNIgpoHmOWJmdGeDnCJVkpUo123zGDk/1
MWy2jG5TzLY84mTzTzela1nb8qk/T/Zohl2zcZaU0K0jR4o0kmF7b5qY5key
+dhpWZp6XNacv+vfY6+kOrp3jus018sl8Fk41tlXY5t1lAbNylv+3WzyEunS
zLoOqnXtJdWK2OellqHtM2nXZMfzVJt8Wvakz3P8d+9d3pft/sxrskJZ/kvT
L0jSP/Nmvrvuuun/OgvUdhKhoV8A5rEfAeHJ8LXm/adKvPL5Sx7cDdlkXrB3
9u84Px5Bp3+fTLn7a0CzI2my23M0WHQh4M8TErmeKh/Y5rHcsFSvw23VLBN1
WaxK7Oj47y5JNx3DJX7f0W3ZeUq/lLvGpvdyqvNvAEXGylY/59X594NGsuC6
+eWSF1lg66sNvj9t+e+9ByZbuvgSdflOqiUx78+SvZZhL0nLItaePvOK/8+z
detYl3W6LrGX47977fW+fr4fFusYrp1m3Qdqvl22KX/WWaC2kwgN/QIwj/0I
CB9GrzXv2n+KJC7fLPLz7bBL5vnzlmmv35LOjuDQv0/uvfNrQDO+SzG354j5
cJZs9Tj8I5d/b714U9Yr2W16WGt2X7srm85ek00X73odbvdNzb8vK+NUht96
7ZHPcarDbLym/PeNE1LVNo9llT7q7TGzh9VyHrtVHh/3ob0DDZPV9uEuJslb
2mVWtpeM2XlcVh89LZMTxsqLmvsKvD/Zy/LMIddSHdMb86GXcfhYZjvPXpC5
yemy/GK2yeViW39nb/pc1kYy29KDW8hS23rdmjzZcix5rvLfC8co9xWZ5Jjv
9at6Wfrr3Gv+Pk+2DGlqXx8tZOG1S9K2iO0ckrJjZb2Px84d4+zTnXbe9Tqc
dflY10Nupsl1vDdzsc58rIPcbCe5iH/73yPLsB63B9t4rNPqa/vO+fmMhn4B
mMd+BIQ2o9eaq908JTlVJPufEZPM8+csnd3f3k5nhxn698ndt38NXDKPSC2X
c96d59zGn3EddlGC/dhxI/l22Typ8pp2+EbyXcpdQ8Oq2XkmVdp8Gus2Dd1W
nXYOl3VcPrXdVyVurvTv3chl+NpDk2Sny/xdk/6da7kMU6tzC8e/3x+a6mW5
/CS9qzvPsU64etfx32rf3mQbLmGi5vlf6yWLdOPZtNP1PIX+h7Itt8+f7pyG
3nucyyFhYgvH8pl56VdZs2Ws6NfLi5Zu2UKZJuUxNy65zZ96nXe39Zes47xx
WprYlnuBT+c5ptu/5fJIZiYMkzd10/Fm68my6GpgtsGdyvJdf+mRc7ntsfb0
hBvKsrL1dMe038iWTVcf+f0cSSdWOv5u0mbLTWXdOJftt0e8je+adKwe47Z8
1fHUmpjuGG7+sslS9jX9cLHScdlxn9OUoOnpHZWe7mudrdgyT97XbwtNJ8uK
GzltJ3elv+XaAWW6X9PE8vglss3g/vd+57HSvJr9daORdXtUh7l0XDq21m+T
yvbSdKzMv6SZ/5y23QCEfgGYx34EhBbj15p3k/hJiyTznNJF79+Kiqjzmpi4
SensQ+jsyDP690n1GtlAZe3mYY7x1pyTKhPinJ/Va0477TLs7NHun79d08hy
Pa2/wyZlpksVH8O223HTOlxGqpTxOc4Y+XLdNdv0PpIRnV/3OWyZ71K9Lpe5
c6znRL9QfZgsV8Y1pndty3+/1XmlbLEMc1e6ajpc4/kXPIznmrR6zX0+Zo9u
5D5vLrfXkikZyn9/V9vLtMcq93ufvzfj9rotL/XvC2sNLJfZExp5Hc45zsBm
425rT5+dpayH0daevtH0OGdb563Xeuv6nWD9u0S9aeneH5fpfXt7wbaM505r
4XNZ1vO4XejXt+dt3L58tx9f72X8sbnYTu5K+/e9TF/Zsdb1Z3b/K9BLFmZZ
x1PT49/8dMP52AYd224Aoh83AP+xHwHBZ/Rac7Wfxk9cKHIvK+qTefaUJC7b
4Fdnp7cjN/Tvk9v++UuA8lAGt7J/Xi4mg4/9Iht3jHE+V5kxskoz/KzRDV27
Sr046TG6p8ttDeef93vYid/VdH5O77xYlmbekZnz45zD1pur9LRfZHvmAans
siyKSYPvhkplTRd+Iy7ZMs7t53fKG5phS/eaJH2GuHaq0t8dMLzstv/zjvTQ
9PR2O+54XL7DOjuvKWi744bbsrHf5np7LZmq9K8tx5Olc1xHeUG7zEZPknaj
V8jSrDvS2fH8LWTi8Tuy6vgxGaAM33TOMes0apZXgfcnyTo/l8v288lSWtP5
+uy4JBtPp0lTTe/rsd/TfJvLut2TLM83M+sXmTO6vMS8NtEy7YF+npzX8X2Z
OGeS1K2uuS6kTE9lOx4jA3Zcle0Z2uUTI5XjFsvU3cnS7gvtcemestDL+D1t
B57W2bodkxzDfTQhWdZm3pA56+ZK3XpDZU7mLzlsJw+VfWmmdB49U/pMG+q6
T3beLFtM7X/K/lavkbzwWk/LdEz9Tvu3uYYyYN0BmTh/jMt01VX2eXXfyWnb
DUToF4B57EdAcBi61rxmN+nab5Klj8pP14mXZJ6xdfYWg+nsME3/Prn11i+B
yY+pzp5RfZKssdx+SupoevCgYw8dw08f5ewVxVsttg3/i0zQfM4vrnQ8/4a9
I500fbf77quy8pSaNOd0lBkqy9THXzkglTS9sf++O5Zxbjo4V9OjJslK5bY1
u53dJqb6TMfzL1ji7B+lbdNqLHeke3XNcjry0ONwY3tpvoNs+w23ZWO/zfX2
WjL5R/s40pzzrMzHJse4b0inMs7lVmPAYpl96r7r82uXVxnr+vVnubgMq3S1
ZT/ekGXn7sj02c7vzmux9qrH+V55MFn6z14hg+bbs1hG7r6Uq2W7xtbTp1//
RWaPsvb0Nbl4XF5l9gTn+uq+775uOu3LZ6astz/m2jGp4TiuXEsm/Oh5vB63
A0/rbLv2b2ctpP/a487ncsTbduLMpn1z5XnH/qNM17lfTOx/MdJg/imX/cF1
PM7l9L3mnAPrPp+LbTcAoV8A5rEfAfnH0LXmajfvO1FSdu0VuXuV+JnM0yck
cek6S/zp7dHe2f/973/Lw4cP5cmTJ16j3h8N9O+Tm27+EpAsWaE5ZhbTU0Zt
S5b4jevkc81n6Iqj0hzDT9X0ig677jhuX7nN2SNKDTng17Abb56Xz92u7dUn
VuIvKo+/fEAq2m+rpnRM+7xcTtPcrvR0y7w5jx2WGnXAOd/X0h3D2qfVWO5I
12rOaWy97U4uhrnhtmzst7neXksmXrTPm2aey1jnzT58/JCabsvq+XpjZM7F
X70+1p/lsmBxXA7rJUZeH5DscflMHKK/1lnJF4tztWxX7rL29KnX1C4ba+np
K3PxuLyKt/U1Z6rz7xWu29Id6eDYh4pJ37T7uR+vp/V9dqeUclv2xaT14lPO
8fnYTqzr95R8onn8Z/POW243vP+VGeP6HNeOacav2X51+/zzrVbkbtsNQOgX
gHnsR0DeMXytudLN4yfMVzrmcaVrZpIARl2mdPacjRw5MseOoGbt2rXBntQ8
p5/nDTd+CUDuS4+6OS/fmCJDZZHtMZNHOntF+6Q7jnEt3TjQcft7Sl/xa9hL
x6S6rn+8/loxed6eIgXk+bozZan6+EupUkHTRZbb58XD7bNmOTvUeyMPOOf7
appjWPu0GssNaa/5e8bHs065D3P1lHysmbdWW2/4XDbTxjl7+vgL3ufN+Rx3
lP3Ew+/CVZvkdXn5s1ymTXE9H/75MrHO9fKa9bvJ2tvmSZ/JI917WMznK3K1
bJcnWXv65KvKNIy09vTluXhcXkW7vlpp5ld7u+u2dEezbRSTAYcf5n68Xtb3
qsObpXaZGLdl2j6Hx9kzsr/m7ybVZmr2HYP7XzXdc2jv026/6vrc6uzpf++0
LnfbbgBCvwDMYz8CAsvezf2+1rzFt0o3nydy5zLJp2SeOiqJS9Zalr0/nT0a
ejs93cltnm88MZ+zO6RYLpavmu4H7lkeM0HTK0r23CyrbOMa1d/ZyV4fkuLn
sLelk+OYczEZeMLHNF9KkfKaLrLUx+1LkjTnJNedq3QK67CzFw9wTpdtWo1m
lMsxwQ4y4ZLu/pHaa/RbyJSr1tu1xxJrKf1evW2N0ukbOXpYLYm/4GHeqs1w
zIdLrmZJ/NwxmvXZ0DotJpeLy7AdN/u5fB7I0gu3Zfmle5ZY/n01d49dYuvp
E5Thp9h6+lK/njuw0W7LbZPuOW5funWi5m8Qix3b+NqsU5rfUKgloy7kPN6W
W7N8b+O2LDqcIi0/d3bu8uMO57idLE/WXBeibBvDz2rHGYD9zzaetppzR7od
eOC4b/asDt73OW/bbgDWG/0CMI/9CDDP2LXmXaVrnwlKT1wjcvsSCXIyT/5g
WRf+dPZIPtaenZ0tycnJcujQIUsXt79HPPXUU5bb1PvUqOe/Rzr9++SqrCem
M2Ou81hW0R5rZVHmPVmkdCk1SzOvSJe6zu9tfmdwiuUx40a6fjdc0a8nSc94
3XfDrc70c9gH0udrzfd0VRsqI1LOyewj52TM6hXyxdcNpO7Mo9bpztgvsZqe
sMg+Px5uX35ohctzVR08V3oOtvWFwq7zZTTLj6zQrZta8sW4xTJg7mJp+Lnr
ed/vjjzseNzsxAGa+2Kl4chJUrWw63jGXLA9z4UUeVcz7BdTFkvrfjNk6vlz
0rBMMak5eIVMPJIl84/s0XzXdkMZk/HY9HLRD9tw5h6ZcSRDZiTvlz7jhkr5
agNkYob5bVGfpTsnWZbBROXfU8fVtPT0RQF+Dn8yZrDz7ypFPx8jPaeMkdaJ
59yWT82Ra2Vc8h756nPt986NkQQv49XuI18pPd3btjxjkbK9lOkgfTYclfkX
smREvHPfdWxX3raTjEz5oozrttVT2T67TJkpHWbtVMYfgP3PkgcyQDuewh1k
wNbDMkLp4IU0y+gLdZ/PzMW2G4D1Rr8AzGM/Aowxdq252s3HS8rOJJF//khC
NJknjkji4tWW1P9qUNR3dpX9PaJ48eLBnpR8p3+fXHH9icnclvaac95bbbnt
NsycZdou2VOmKbeNHdHQbVpcowx3xfp4f4ZddlDfd11TqN8e63Sd13SR0pNk
gX16f3S9fa59Hqv5en5rHzW7LEeN8P67ZY7UmyQJ2scd3+zSXdxTS0adtw+f
Kc1L6+9vIROO7ZGi3h5fd64s9rq8/FkuD6R3S1/Dxsqw8+aWn1uuXJHuLa1/
42i+cId0tvxbPb8+I7DP40fmrh/qNu/lJh9V7ruXw/JR960sr+MdO8L5/ejN
7cN5WGejBpf3Ov72e+z7rvft5F2v06fcfyUA+9/13O3H6jntln3zfC623QBE
P24A/mM/AnLH+LXmXSV+XILS/dJEbl0gYRh13SUuXhm1nV39Tjn7e8Tf//73
YE9OvtO/Ty679sRkbkvbD5x9ecJlD8NcTJGymt444twTGT3c2b0LNekg72in
q3QH+Tb9gePx/gyrJmH3Cqns1jOUFK4pHTdnWoe7fNT5PdofzJB5tscm/njY
Oa115jpuX3buqNT/wHV8Hw6f4bjt7W9TArAsn8iEZTOkbOliHqe9/qQdzunR
Pmaha/cr8IGyv04a4LK87cPO27VYiriMu4PEX7wnA751/+3uok3GyISLT3wu
L/+WS5b07Ov5N8Lf6TBXZgVg+WkzeriH69ptfxP47pzrsPM0v1fmMUqXTAjI
dGVJ1w6u50fUmHHK5/IpULiRdLVvt962mxnO88Fb7rjtdZ0tOLhZKhd2Xx5f
Ljzlujw8bSdnNeNzi3PfN7P/5WY/Ltt9sWZbycW2G4DQLwDz2I8A7wxfa670
ObWby83zJMKSefyQJC7yv7OHc2+np7u+Ty65+sR8Lj2QhReV+BxOuV8d7pL1
v0dquneLXfeU2+7JjLQMmXH0tttj/RlWm3lns2zDZcr3F+95niaP022dVk/j
/P5kpkxVxjn74oMcxmEulmk/mmF5rhknfc+ndR3cts1rluM26/L2NB/3ZLay
TNRh57mMw3r71LRMmX3W0+O8z6tfy0XzPOq8zbsU2GVnJAuPHpYukxZLj+kr
pItblNuXHg3oOrauX3U5e9guleXjXPeetlt/4nk9OPeNLB/z5WU78WceDe1/
uvHYtq2p6ni8bSs5brvmQr8AzGM/AlwZudZcTddv4iVx4QqRG2dJlCTz2EHL
Oq//1cCIvqadnu76Prnw6uOgZLime3+xKStgwxJCSKBDvwDMYz8CDF5r/lEX
SzdP2bZNJOsMifJkHk1VOvtyiY+fLZ82z31vD4fOTk93fZ+cn/k4KBk8yHnu
b4O1WQEblhBCAh36BWAe+xGikeFrzZVuHj92tmT+cEDk+ilCvEbdRhIXJCqd
PS7sOzs93fV98vsrj4OSmYcOSfsJ30ubCctl2PGfAzYsIYQEOvQLwDz2I0QL
o9eaqz1L7eZy7SQhhpJ5JEUS5y/zu7OHSm+np7u+T865/JgQQoiP0C8A89iP
EMnUbm7oWvNeY5RetVTk6nFCApor6fss25Y/nT3Yx9rp6a7vkzMvPSaEEOIj
9AvAPPYjRBpj15p3Vrr5aEnZvEEp90cJyZdcSUuWxHlLJH7MTKn/5YCQ7ez0
dNf3yWmXHhFCCPER+gVgHvsRwp3xa807S/zo6UpX2iNy5YcwS5qcXjxMpo2Z
LLd+zIPxH18lC4f1k00bk0JgXjX5MVUen08L/nTkUdRtMXHe4pDr7NqeXrx4
8Tx7nlClf5+ckvGIEEKIj9AvAPPYjxCODP+u+Zf9lW4+TeRyephnr4wvpe6z
b8uBU4Eff/aGHpbXg4rfzA2BeVVzSI7N6yGvW16nyktaHsxzqCXz8G5JnLvI
ss3609nVfSIUrmkPpFu3bsnYsWPl0aNHQXl+/fvkxB8fEUII8RH6BWAe+xHC
heFrzXuOlMTvF4pcSougJEtCVVtnPRn48Wdv7mN5PagdtyB3w6dtlrsX8mZe
s3dPk29KFdC8TuXNPIdyMg/tsmzD/nT2YF/THkhXrlyxrPtnnnkmKH1d/z45
/uIjQsI+o4/dkmHpt2T02eBPC4m80C8A89iPEMoMXWteo7Olm6dsWCOScShC
s1sSqqjdNVbSTgR+/Nmb7D19Xq6mZfw/rMf2R4ybItfOBGg6zqyTxC7V3F6j
8mqewyWZB3cqnX2BZRuv38y/Y+3h2tntPd2e/O7r+m1w7MWHhORR7sjAPWek
z87j0n/PBRl2No+e5+Q+KWrbnl8asC8E5ptEWugXgHnsRwglhq81V7p5/Mgp
krJ+tciPB6Mgu5w9/bjuvtM75FLyWq+5diQ5x/Fnb+pt7ekD5uViWpJlTZsS
Lq8jrXp/K8dSdpmax2NDbOOs0lBGtKnu2tP18xzFyUzdIYkJ86X+l/0itrPr
e3p+93X9846+8JCQPEnfSc1dtrWX+u/Km+c6sU/esj1HUaWnB3u+SeSFfgGY
x36EYLN3c396ufVa835KN58scvFAFGantacXKCdpx1zvOzaknMdO48h7vSQ7
h/Fnb+xl6+lzcz1N2fsXysJeH7s8V4WG7WXH1vXG5vHYElk4eZo8Vv79r639
nOP1MM/EmswD25TOPs+vzu7Yn1qPDNne7q2n51df1z/fiPMPCMmDXJM6lfXb
d3f55vzDwD/X8X3ypu05ivTfGwLzTiIt9AvAPPYjBIPha827D5fEOUp3vJAS
5dkhCZVtPf2o9vZdsrC29Vruim36ydGdC2R4Yd21tUvW5Tj+7A32nv69/9N2
cqPsmdROarv8beBjWbhkiWQbnF/79Dh6+lFj44mmZKZstewr/nb2UDzWnlNP
z+u+rn+eoeceEhL47F0tz3jYrj9ed9Pj8ENOaf595Jr0PXBJ4o7f9zr+Icdv
Wobpf1z571Pp8oZt/IWVnh70eScRF/oFYB77EfKbv9/RriZ+xOSg957Qiree
vkq+KWA9Zv5Y+e9b81u67N+NB+eud5vq6Y7skgvLR8o3lV906dgjxk6Tayf3
+jUuerq5qJ1d/RuXfX/KTecN5wS6r+vHP+TsQ0ICnk5jmnvcngt22uA67Ml0
KW27r3iPBPm0YwOX4d/pu02+dRn3Jfm09Ueuw7RyPlfhvnuDPu8k8hLs94Fo
S6FChQLyfofQol/PQH4w8rtqpWt0snSNlHUrle6xP8qzXdPTXe/LTtsg2cr/
/7YzznX/bjDQcntuxp+9oaflMbUHJARkerP3z3c9J/69nrmeFu30WOJhnol7
7MfTtf08Wnq6PYHq6/rxDjz7gJCAZtDZDPmwpH0bayett62S5x3bXHPpcFIz
bPpeeTWHbb/iwgzb8Pfk81ZFfQ77j77JQZ9/EnkJ9ut/tEXt6UlJSZb/z8jI
CMhndQSffj0D+U3t7P5/b5za2YdZsn/tCpHz+6Is22w9vayk/eDh/hNzpInL
vv2FXDjtabh58rV6f+W2ck1ze/Z66++n1+43JyDTe3f3HFnYs7Zzet7rIdl+
PN4+PZZ4m2cimfu3SOLs76X+l3197j/B/jyRXylYsKCMGTMm8D39zANCApr+
Oxc4t7GmqyTuzA2pVtK5zVVbetUxbNzRvfK6yzZZVN7vO1hef1Xzmb17knXY
1K2avq908o7jpE4f1+P2lp4eAsuARFaC/fofbfnDH/7g+HfTpk0D8wEdQadf
z0AwGTnOru3t1s6eHAXZqunpuvsurJfpLt9F9KJs2rfX43ger7P13/f6KL3Z
OYyzp882MY075cLiIdLZ5bz3sjJ+4mS5dcLz9HiLe08P9vIPnWTu3yzxIyZa
9oHc7i/B/jyR1wlUP7fTj7/f6QeEBDRfD3Seu151xQ3LbR3Gt3Pc9melu/ex
D//DXinmeD0sJ3U3WIfvsyXBuZ2WHC/dldt6rhnvvK3SNOlpG0eHGc7v5ny1
T3LQ559EXoL9PhDtSUhICMj7H4JLv16BUKHt7P6fH6909jXLRc4lR2i2OHv6
kT0u9+3p8ZbLPj1i0Ubl9uWS0KmN7Ni1wzHcb0c2yrVdC+RA4nQ5vXeHyziy
13W3PNbS0/2dtiOrZMeYNlJB+9pSsr4kLlogjw3Or316rJ9L3ec52qJu2/HD
J4b998PlVm6/Ry7Q/dxO/zx9Tj0gJIA5L2VfKeDYvkqP2ypN5ydJo1Ga172Y
BtLiiG34I3sdv31u6d728RxJ1dyu9HTlts4Jgx3jeCVur/M5jzuHfaVPcggs
AxJpoV/kr9jYWJflzfXqkYH9COHC+DXtQ5Ves0zpN3siKJttPf19W2e15tJs
12OlncfMt9ye9u371s6euMEx7IUxVZ3DTUt0Gb+jp/efletpyt77vSR0quXy
/BUatJE9m9eant+7iR01431TdhwI9vLP32Tu3yiJs+dYtmV/u7n6uwrh2M21
Qu132Xqd+pmQgKXb5tm5+jvU+wkZ1sccSZYi9tvfHS9d7OPycHurcc5j8i/F
JTues+fxA45hX+6zJ+jLgERe6Bf5S70mXb/MOf89/LEfIRwZ6+wdpWu3oZak
rF4qcnZ3GGeTJFSy9fR0622/JQ3VXbMYI98M6i0jmr7v6Ld7DmnGcWym7bfT
XpQ1STtdxp+9rpvtePrMXEzLNlnT6k2X5/26xwA5nbLN3DyeXCN7pn4rCYOa
ux6bV/NqFRk/bICsmTtffgv6usibZO7bIImz5kj9Zn386ubqPqF2c3UfiRTe
enpe93M7/fN2P/kzIQFL424fedy+3VJ/vnRWH5OeLK9p+ngn+7g83N5xlea8
949mWx+v5OvpfZ39/Zs9QV8GJPJCv8h/cXFxbstd/W45hC/2I4Q749e0d9R0
9l1hFm1Pt96Wva6n7894JVvJLc04Hm+zX59YTy6cdB1/9rqu1p7eZ0aupmX8
q9a/A4wYM0GuHQvQPB7Tfxeep3nqKtlnk0JgfQQmmfvWS/zw8ZZt059tWT2f
Xd0HIpW+p+dXP7fTb3ddT/xMSIBySt61b1sFykmdbVnSMS1L2qcqSftJWq2c
qtn2akrD1J+lS1qyFNb08fa2cXm6vfO2pS7b7uu9Z0vN3rZj7K9Yb3uxd3II
LAcSaaFf5D/1mDrnv0cW9iNEEuPXtGs6+5ldYRBNT08zNo4Lo2ta9/vPBsnj
M0ku92Wv1fT0XIwre/9yuXsi2MskPKNuc/HDxkfNteZG2Ht6fvdzO/37ZKfj
PxMSkLRdq+nhFcdLG7dhzsl7rzi3vXemnZKOqcnyoqaPOx5z2PX21pbbs6RK
Rd9/71R7erCXA4m80C+CQz1+rl/26nF2hCf2I0Qy4+fHf6f0pyVKj0oK0Wy0
9fQySk838vgtsrCW9XuLWo1f6Ha/s6dPD4F5jbwkzpxl2cai8VpzI27duhWU
fm6nf59sf+xnQgKS1ismOLarNyYc9ThMo8GfOYZ5oVeydDiSJm/Yt8cKU6W1
bbgOhw7IK/bba8x23n4gTUpWcN2G3+g/1XGbOs5gLwcSeaFfBI/+/Hf7b6sj
/LAfIVoY6uwfWjt7/LBxkrJqscjpnSGSDc6eftjI49fINNtv834ztIs0iVHG
84Pz/uzVXaw9/ZvpITCv4Z/M5HWWbl6/6TdRf615ONK/T7Y9lk1IkHNXWh9S
4un2I3c9Pqbl3h+l6Y6z8tWhuzmMgxDzoV8Ej3r+u9rNtctfPR8e4Yf9CNHI
8DXtam/v+p2krFwkcmpHELNepr2r7rNvyIFDRh6/VfZ0K+PY77+dnOByv72n
v95tWpDnM3yTuWetxA8dZ9lm/L3WXO3mCB3698nWR7MJIYT4CP0iuNTfT+f8
9/DHfoRop+3s6rnF/nX2IbbOvj3f8/jQcrm2d5X8Zmoc6+Tx8W0e7tsot/Yu
l7tHtgRl3sI16rYQPzSea80jjP59suUP2YQQQnyEfhF86u+y6c9/V4+1I3yw
HwGuDJ8fr3b2FQtFTm4jUZTEGTMs655rzSOX/n3yqyPZhBBCfIR+EXz8pnr4
Yz8CvDPe2QdL/NCxSm9foHS5rSSCkrl7ldLNp0v9z3tzrXmU0L9PNkvPJoQQ
4iP0i9Dg6fx39TaEB/YjIHeMX9PewdLbU1bMFzmxhYRhMnetlPjvxlrWJdea
Rx/9++QX6fcJIYT4CP0iNPCb6uGN/Qjwn/Fr2rWdfTMJ4ajrKP67MVxrDrf3
ycZp9wkhhPgI/SJ0cP57+GI/Aswzdn680tm7fCspy+eJHN9EQiCJ06Za1gnX
mkNL/z7Z4PB9QgghPkK/CC3631RXw2+qhz72IyCwzHR2tSemLJ+rdMaNJB+S
mbTcsszrf96La83hlf59sv6h+4QQQnyEfhFaOP89PLEfAXnH1DXt6rH2xO9F
jm0gAUxmUqLEDxkt9Zv418251jx66d8n6x66RwghxEfoF6FHPX7Ob6qHF/Yj
IH+Y6+wDbZ19PTEQddnFDxll6FpzdZ0huunfJz8+eI8QQoiP0C9Ck6ffVOf8
99DFfgQEh+Hz4zsPkpRlCSJH1xEfSZw62bKsuNYcZunfJ2ul3iPEJTWSrkr1
7Velxv7gTwshoRD6RWhSz39Xu7l23ajnwyM0sR8BwWe8sw9U+ugkpbfPUbrp
2qhO5s7FlmVRv0nuv3+fa82RG/r3yY9S7pJc5MOtp6RSYppUSDwqlTZeCfr0
5Fl2Jckztm3jj12Sgj89hIRA6Behy9NvqnP+e2hiPwJCi/Hz49tbenvKstki
P6yJimTuWCLxg0f63c251hz+0L9PfrjvNskpew7J89rlVuB9KbUtBKYrL5K0
U561zWfBzjvz/fmrbzsjFRalSLllP0jVPSGwPCIyN6TyikNSTlnOFdZfCoHp
Cf3QL0Kbp/Pf1WPtCC3sR0DoMtzZq9s6+1Klsx9ZHVFR5yl+8AiuNUe+0b9P
Vku+RXJI5dmj3Jbb34enB3268iQ7tstfbPP4507b8/35S3cq41jGr84+F/zl
EYnZsl3+aN+WX/xOKgV7esIg9IvQxm+qhwf2IyB8GDo/3tLZ45R+O0vpuavC
MsunTLDMA9eaIxj075NVd90kOeTtJq+5LbeYsuOloqfhd19z+Xel9WelvJIq
Zoe1pcq2i1JhzUmpsP6i1+Gq7NT8e5MyTmX4Stuu+RynOkz5bepj98p/23t6
x60+l0uVbWel3LI0r4ldf9nvZV26Wz3HMv7HzIteh7MsK9tyCPT69msZK+ut
gpfl+4FtPOXXnlXu9/58H+Ti+XI7rlxl2zbHOo4pM8rzdkxcQr8IfZ7Of1dv
Q+hgPwLCk+HO3knp7EtmWSLpq0IymdsWSuLkCVxrjpCgf5+snJRFfGWL8zxw
lxQoI2+tch22zMCWtvvryusjpkjBF7SPqSvF514wNKyaSqu2ystVyrhNQ+Ex
Kc7htifLc7b7nmk1RYp+Wddl+L+0Wy2VXObvhBRtXM1lmGcbf+7499Ptt/pc
Nu91rea+XLR5c6RUzPWyPiGvltaPo7D8b3Waeu10DFdqxEh5+gX3dfHqiGQf
474gRWu+Zh3fC685ozz2/9Sc6ZhGf5fx042/lRfLONdZqS22YTYmy6v13JfN
f9UcLKU2aqZr+xG35a9O42sTjjiHyeW4SvVzrrcisy86b+/1uWP6SirDl5sy
2G1c/9uyPD93Tj9xC/0i9PGb6qGP/QgIf6bOj7f09plKP14Z1KjdPP7b4Vxr
jpCjf5+suPMa8ZFyk/s6O+zAzfLW16Wd/913n8uw73ap6ru3xtSRdzf7P2yF
zTsc3+3mKS9PP2Wdhg2b5c8+xxkjL4w/Zpvey/J6o8I+h326/WYfy+aiFPmo
gGW4pxqNlZILtstLuv780vj03C/rzd6n/X9/vc4yzHt9m/ic3r8NOehl/Ofk
5Te8PO6Nb6VcQJZxB3lvm3U8Hv+uoxvO1/J/yja/uR+Xuj3VcZ9Wl9s/kLc3
KP/d/gMv4yptuT/Y+1uohn4RHjj/PbSxHwGRxXRnXzxDJG1FvkR9LrWbq8/N
teYIVfr3yfLbM4nXZEixuvYuVViKLc2UclMHaTreIHlfM/w7neu4LNv/qNxN
/tG5vcttzw1O9XvYt9o5u9VTDadLqY1n5J3B3ZzDVp4o5dRp2LhRCrqs38Ly
XLs+Lsfqn2q51jq9q1bIU5ph/9R0mBRu19jl+f/UbqP3ZbMlyfpcbwyzPPf7
o7q5PLZgZx+P9ZgL8taAYfLX0pru+kZ7ZZkMkqJTf5Dy69bK09rxt5wuJWau
lZc+KqV53vZSyst6fGfwGHml8xgp3Ocb178BNFxichkrw1euI//rhfZScmOm
lGin7cF1pEj8Rnlr8ED5D+3fEyzr9Yy84jh/oLG8tfSMvL80SYq2bCHPD0iy
TFPux+W6Pb009YSHbfIDKbFOuW3pWnlFeQ7tOJ7rPExe6jxHSm0J9v4WuqFf
hA/1u97164vfVA8N7EdA5FI7u6nz4y2dfXlAkzh5vGXcRr4HjmvNEQz698nY
rZeJl5Rbs0H+ZF9WpYdKGfW2rXs0xzj/IUUWX3QMX6LTJ87uVmeqZXj19jfb
Oo+dP9V2g1/Dltt6Sl7WnA/+yvR0Kb1Mzf/P3plAR1Glbz+c853v//2dzRln
XMZxZJMtCzuI7OKCIOjMCAo6gsqigOz7FtawJgFC2EMSQkigScgKISskgRBI
AoQdggGaNUpQFFBR36+qeqmlqzvd1Uv18vzOeQ6k+tate997q/o+fW9V7efL
0XIGdWL3z8gUeMhO1CLqLJdn1+g1fJu3DKFXmG2dN4bw215ZaTx+x5CJxu1P
6csqp67ZF7lydJbmz6rvGmN+tqrdZD4u7HPkDNtF5e21kroY2mhfPn+vdb03
qHWq5fy7Rq3hPSqbPvmqHTFmfPL8Qr6/SPJpupEvf/vpgyXtWkkvteTTPjds
PbXbdVFRXtL+1Ciy0rRPMnVtk2rIez9fB6btu7rBuebugr/wHLD+3X3BeQSA
72CfZ9/Iico0Nkm7fxtp1obTwA+n4F5z4JFIvye7ZlVDZtRx6QRBrEZR0NoU
arUqhv4ZxMfv6bH7jOlbj31XNKdp2N5pLT+/89QX6Tal7ZJVTP9s4GfSbmJ1
opZ7qqlLWjrvvzqtoFf0eXZJ2yfYvpg6cXWbbtz/r1+mG4/fJZNPayirJYmO
qY9Tu0yZWK7U1evpLy3nKYxLw7UnjNvbTfvUJIY6nabGRr/bjJpuO2++rJkH
jM+y5zz2vGLddqUxbhnMxZLPP1eQ/+vUag//mbBdn/jXZm5byy9eNznOE72C
qd0e2/MyFzd+O5+HuA6LRXWA5AV/4Vmw8+fSNsM71dUH5xEAvol96+PnMp59
A+PDd8lKuz+WwueH2OzNca85cEek35Ov7L0MyeosNelZl3dj1HAatdfv02rM
O/yc5rpKY14dwsYbt/9lZJptaVOyJT64Gf2pQTN6okFzvRiv1nO5rgwpafy9
00GLqKOhLjLb28z8hPe9Y9L4eqfvNaY1lNW8jlKjTuKytYiTTxvwkW49+9+D
Cy3mKYxLgzUVstvF5aqkRkH88ZvFXDCbd8CnL/Nl7bRcEB+FMe4kiLH0M8YX
t0ziP+u4Zi7vrQdGG8seMOYTwXH5fDvYmJe5/tR6wjumeZjrJ5BZwV94HnLv
VMf6d3XBeQQAsMuzj2U8+471nFhvjnvNgbch/Z58Of0SJKfEBPpjXR7d4Is2
n+b2CRrNe6U/f7iNOurzCvjkNeP2P4xIsS1txglq1NFwrKbUPN5CmZNT+Hu4
gxZQOwvb20cs4OvQM4w66NO2njfOuP1JfVnNyf+TTqI4/HNZGXXKOEiNPpxN
gYnnjOnaxx+ioNW7KSA0g9qmWo67MC4N157m81gjKG/vCGO8OmXk8eve/V6j
AI18vh02hAnK+g75Jwo+d0SM9fk07MjHo/FmPgatZww1G9eOqWUUOGeWoL+9
Q0HJtuUVOILvN8/NyNOlTc2jfwTysQnUyNSh41Jj20PmBX/hebDr31lvLmw3
dj08UA+cRwAAIUrvace95sBbkX5Pdki9CMmo9Wx+nvMPg6Oo7Z5T1HbncU7t
9hyhRj34GP55+B5un4BR/UWx/UP/BdR43Oeibf9YesS2tGlnqUn/pvz2jlPI
f+MBahVzgFos3UAv9O9Pf5+epSv37j38/fSBCxhPfNHs9vZRG0THenp4KDUe
rvd/9cX1klMrgZ9n9ezELH29dH7xHyuO6dKmnaLGbxrSdST/nZbj7j+c95t/
enM2NZ40m+ovOmBS3mdGRVHAOg29+KYgNoGzqbVcvmml9EKgn2D/16jx7Ahq
NGkpNZy+g9o5Isbccc5SU2E+9YdS0/B0ajF7Nj0hKPsLTLu233OAng9sSs8O
30CBMceoTYxG8Lz5/hSw2/q8uPZYJGyPjvT8qAX0dH1xnY2x37mH/iJI+8Kk
CKo/dCm13K3+eeeugr/wTOTeqY717+qB8wgAYAlHeHbcaw48Gen3ZLs95yGp
Usqpfnc+Ri+GlpukaTV/rCCOIymI2RbwRX+T+IrFpEvS7W9L2rabIy2m/d8h
O3XlShA8wz1wPrU2lHeXzHa2jh0tHZ/xycOSZOPDlud/JWmf+yKE/tGvl9H7
Nd3Op2+zSv+M/MDJ1KqO2LdaPtmkHE9N2MuU9yQ17me5vC+GHpXPN2Gn6Nn2
Yr1P/kkOiPEe69rKr6N+H6ZMfzCTpl73ldTGlrxYxcaYtIlYvahFgqF/H6Z/
Bko/f58CdrnBueemgr/wXOTWv7Nz7cD14DwCAFiLnGc3GffhXnPgZUj7eOvk
s5BEbZKP0Ysd9DGqN4L8NTJpEnfTUwIP1Dz+LDX/vB/v6974WOwNAz6mJltO
Gfe3JS2rlhGR9NeAeqb+68Ve1GBlsa5Mmgz+Puv2i6mVsawpfFm7r+C3x2fQ
cx3E+T39+WLjtj99tls2Pq3CF1v2jwGTKEiQvvlnOv/+hw/irIj9EWr4nw6i
/J6ZkmX8rNHHA2Vi0I8a6mMgm6cwLlIJ2teeGFvTVn/5YJUxLm2Sj9NLn5nW
5Q9vzCT/RNvyMsh/jvjdeH4dRlCDCV+K+qixDSPCJb8TfEwtEi23jS8L/sJz
wTvV3QecRwAAJRg8u/QagnvNgbdh4tOTTkMyarXrJLXcwchCmpa7T1IQky5o
p+7vZiN47/3C6nJqtbucAjblU8DWUpN9bUkrVFDcYX26QgqKL5ctk1y5DWWV
zTOmkMszaMdJi3koiuPuw/SC3vc/E5xv9X5cPZk6BsaZ1rHVTiZWW/N1cYgx
/dxeKY2xubj6s/nsNBMfpi5BzOcBm9m6yrePtXnp8ivVlT36ML/vLvm2Z/sc
d2wmbZCDY+htgr/wbOTWv7PbgGvBeQQAsAdcQ4C3I+3jQZpKyEFqMqKvMa5/
X1bssLQerbid+uejtacGMW5QHghSIIwNPBu8U909wHkEALAHXEOAtyPt4wGJ
JyAHqdHQ9sa4Pruo0GFpPVqxhufm96Tnhn5Efu2XkL/aZYIgG4WxgeeD9e/q
g/MIAGAPuIYAb0fax1vsqIAcpObrdtHzYxYzCqdGW445LK1Ha3sq/w4wv/9Q
/Yhi9csEQTYKYwPvgH3Wu7Qt8U5114HzCABgD7iGAG9H2sebbi+DIKeqWXwp
NYk6pHo5IEipMDbwDrD+XV1wHgEA7AHXEODtSPt4k+3HIAiCIAvC2MB7YOfP
pe2Jd6q7BpxHAAB7sPca8uOPP9KDBw+4fw0y/A2AOyDt441jSyEIgiALgr/w
LuTeqY71784H5xEAwB7suYZcv37dZH+hfv31VyeVGgDrkfbLhtElEARBkAXB
X3gX7Pp31psL25RdDw+cC84jAIA9wKcDb0faL+tHHYIgCIIsCP7C+5B7pzrW
vzsXnEcAAHtwlE9/++23qbKykoqKiowCwB2Q9vEXtxRBEARBFgR/4Z3IrX9n
59qBc8B5BACwB0f59MjISCeVEAD7kPbxf2w8CEEQBFkQ/IV3gnequxacRwAA
e4BPB96OtI8/t7EAgiAIsiD4C+9Fbv07uw04HpxHAAB7cJRPr1+/Pk2aNIlG
jBjBafny5U4qMQC2Ie3jz67PgyAIgiwI/sJ7wTvVXQfOIwCAPTjrOXKsbwfA
HZD2zafX5kIQBEEWBH/h3WD9u2vAeQQAsAdH+nTWmz/55JOc2OfKAeAOSPv4
X9dkQxAEQRYEf+H9sM96l86p453qjgXnEQDAHhzl07HOHbgr5tZ8QBAEQdYJ
eB9Y/+58cB4BAOzBnmsIfDrwBNQe30IQBHm6gHfCzp9L2xrvVHccOI8AAPZg
zzUEPh14AmqPbyEIgjxdwHuRe6c61r87BpxHAAB7sOcaAp8OPAG1x7cQBEGe
LuC9sOvfWW8ubG92PTywH5xHAAB7sOcaUlNTY9wP708HAAAAAPA88E515wCf
DgCwB1xDAAAAAAB8G7n17+xcO1AOxtgAAHvANQQAAAAAwLfBO9UdD8bYAAB7
wDUEAAAAAABg/btjwRgbAGAPuIYAAAAAAAC8U92xYIwNALAHXEMAAAAAAAAL
1r87DoyxAQD2gGsIAAAAAAAwEBwcbDKnjneq2w7G2AAAe8A1BAAAAAAAGMD6
d8eAMTYAwB5wDQEAAAAAAELY+XPpGJGdZwfWgzE2AMAecA0BAAAAAABS5N6p
jvXv1oMxNgDAHnANAQAAAAAAUtj176w3F44T2fXwwDowxgYA2AOuIQAAAAAA
QA68U105GGMDAOwB1xAAAAAAAGAOufXv7Fw7sAzG2AAAe8A1BAAAAAAAmAPv
VFcGxtgAAHvANQQAAAAAAFgC699tB2NsAIA94BoCAAAAAAAsgXeq2w7G2AAA
e8A1BAAAAAAA1AXWv9sGxtgAAHvANQQAAAAAAFhDcHAw3qluJRhjAwDsAdcQ
AAAAAABgDXLvVMf6d3kwxgYA2AOuIQAAAAAAwFrY+XPp+JGdZwdiMMYGANgD
riEAAAAAAMAW5N6pjvXvYjDGBgDYA64hAAAAAADAFuTWv7PPgwc8GGMDAOwB
1xAAAAAAAGAreKe6ZTDGBgDYA64hAAAAAABACXLvVGfn2gHG2AAA+8A1BAAA
AAAAKAHvVDcPxtgAAHvANQQAAAAAACgF69/lwRgbAGAPuIYAAAAAAAClsHPq
cuvffR2MsQEA9oBrCAAAAAAAsAesfzcFY2wAgD3gGgIAAAAAAOwlODgY71QX
gDE2AMAecA0BAAAAAAD2IvdOdV9e/44xNgDAHnANAQAAAAAAjoCdP5eOLdl5
dl8EY2wAgD3gGgIAAAAAABwFe1861r8rG2P/9ttv9ODBA/rxxx/Niv0cAOD9
wKcDAAAAAABHIbf+nX0evK+hZIy9fPlyk/3klJaW5uTSAwDUBj4dAAAAAAA4
ErxTHT4dAGAf8OkAAAAAAMDRyL1TnZ1r9xWUjLHv379PRUVFdOzYMc6LG/Z9
8sknuW3sZ6zY9e8AAO8GPh0AAAAAADgaX3+nuiPG2IZ9W7Zs6eDSAQDcHfh0
AAAAAADgDHx5/bu9Y2z2mXKGfevXr++EEgIA3Bn4dODtWHOfFwRBEOQ6Ad+B
nVOXW//uC9jb7+HTAfBt8N0JvB21x6MQBEGQWMC38NX17/b2e/h0AHwbfHcC
b0ft8SgEQRAkFvA9goODRX3AF96pbm+/h08HwLfBdyfwdtQej0IQBEFiAd9D
7p3q3r7+3d5+D58OgG+D707g7Uj7+INffoMgCIJcKIw1AAs7fy7tC+w8u7cC
nw4AsAd8dwJvR9rH7z/+DYIgCHKhMNYABtj70qVz6t66/h0+HQBgD/juBN6O
tI/f+/k3CIIgyIXCWAMYkFv/zj4P3huBTwcA2AO+O4G3I+3j3/z0KwRBEORC
YawBhPjKO9Ud6dNbtmzphBICANwZfHcCb0fax2t+/BWCIAhyoTDWAFLk3qnO
zrV7E+j3AAB7wDUEeDvSPn6TGTNCEARBrhPGGkCKL7xTHf0eAGAPuIYAb0fa
x68/+hWCIAhyoTDWAHJ4+/p39HsAgD3gGgK8HWkfv/bwFwiCIMiFwlgDyMHO
qcutf/cW0O8BAPaAawjwdqR9vPrBLxAEQZALhbEGMIc3r39HvwcAKEWTUUxP
NepGL3b8jJ5v9T73/5Ly82oXCwCHIv2erPrhFwiCIMiFgl8BlggODjaZU/eG
d6qj3wMArEV782vOmw/8fDnnzc3plXem0sSFURS+JRW+HXg80u/JC8yYEYIg
CHKd4FeAJeTeqe7J69/Z8TY7hpb2e4ypAQBCDNcK1ntb8ubW+HZcX4AnIv2e
PPf9LxAEQZALBZ8O6oKdP5f2E3ae3VNgx8jseFs4fpbWB2NqAAA7Zy69VjhK
uL4AT0P6PXn6/mPIASq/eY8OX7tH5bV1pz158yblnLlKpTX6fa9dZf6+SeVu
UA/P0SMqvVbDxfyk6mVRrtKvrur6Qq2uToUXLlPOhZsq1ck7YuoJgk8H1sDe
l+4p698Na1TZMbG5MbOcT8eYGgDfwpprhbznnkKT5m0iTWoBaa9d5/4dOHKJ
Is/OlgEAd0T6PXnyu8dO1PeUe/oyZZw4T1mnr1LJXWceS0XdOUo99fFsv+xo
HWmPU1+/elzaaYcf0cnze/RtEUjbb+jSHL16lbLYmJ2voQqTPB5S0XldTHMv
31NU3ty8LdS36zvU8+3htPJQjd31r7hxk1IKiyk6q4C2Fx6nLGG57l6l+aMG
U/u+/em9mTupwEExT1k32NiHpxXaXwfr2/oUfeTvR038A3l17UFNAnRl4f5v
/Iz5P7PtvXXH5eN2PsNYh75bztPRE1sEdVLWto6OqaP7CqQTfDqwBrn17+zz
4N0FwxrVuu4fVToPBt8OgHeg9FrB+vDwDbtJe1VL9NMDWbGfaVLybfLs+F0Q
uCvS8WHFt4+dpszY4aJjtVta7NTjqabbR6mP3nv3WHrUQtrvKXxUoD4ewZT3
bQ1N6arbz29gHJVwae7RLH9DzHpQ7HXTY7UzxNQ/nA4oKG/80v7GNukTeUq/
/RHlnTpPyUdPUWbVPevy+uYyzZvY36RPsWo8dB3t/+YxHdcepR7G7YNp123H
xHxXOO8ppxyscVlbC+tTz78/fThxODXm2m8JLd+se/ZT44Fj6dNRfPnM9Yni
g+sE7XCeSo7HGf+eddB8Gxy7fpNSmXZKPn6Zir9xXN3kYirfV+qWs8roLYJP
B9bibu9UN6xnt/X+0UnzNlP4xmTSam+RJu0gM15fijE1AF6M0mvFhOCNpNmT
R/Tj9zZLe+Uqty88O/BUpN/3ZfceO0k1NLOPxL/Vm0bpTjueirp1lN4yzHUw
nsxcuvwDvC8btOMype8ea/x78oEafbp7FGyMW3/arjV/LL8+66hQQXkTl/Yw
Hvctxntx26+J/X9+Xfl8fZ4+9/cz6U9CcXW6JciX8emJtxwT88SwwTKxc2Vb
j6XdX7PbHlFwVz9qF8bG8Tx1Zz6beeh7Lu2+1GCLfSI/J1zUH/btnmb8e+ah
e2bLsF3Qfl86sO5yMZXtK1bIWWX0FsGnA1uQe6c6O9fuCuxbo7qZSo6eInr8
k6y0126SJpXx7COXcsKYGgDPRfG1ov9kxptvoJKSCqJH9x0mbfUVxrPncHkP
HBGC6wvwCKTjw9J7PztH5zJ084wSTT9UK5v+8NeC/9+qpdxLNyj31kO70+r0
kAqq71DWpTtUYE2e2hom7Q2zaQ3HzeKOy/z99SnqbfTppWb3iTXOTfanWGb/
BQY/7r+EMozpammOwKfHaiX53Co1Hqte10gqkNRT+H82LlnVtXTYpCy1lFpa
QfGlVYzP12+7Vsp5TEO+uXW0b+xS8Tx694lbKKr0FMXuTaQP9OUfc+AOl7bw
UhXFH6qglOr7ZmKuK6tcvLn2rTZtt3iBp5yoP47Jfmz7yNbfDjHxb8scs3fs
OWMspzM+ve3SCub/FdxnfHmu0FDm70ayfeI+LRmqX0vhN4x23rpCYwy/e3QN
oyxLsQ/rb7HuBun6vC4G1tRNPqYyfcWK88raMtYla9rRmn5kXSzqvk44SvDp
wBZc/U51a9+HJOfNwzckUUlpJdHPj2wWf8+p7Z4d42oAXI/iawXjzcPX7STt
V18RPfzWJWKPpUnOVeTZcX0BrkL6XX+49menKGHTMPn10DP2i9PWnKL39Z+9
GZJAi+cNFqXvNiOZcpWk5fSQomOWUBtJGdp8EUmam6Z5vjFvG82bIc7z3SUF
VCTK8wbNmyD2qO9O4OvabUmpmZjU0iyB/467yf9dr0ukoNzidNHXJPncLKU3
/Uz308QY5uYH07wdW4xpdL8DDKOIs98Z89DsMMzbBtKs4lrKzA4zbSv/QM4/
xt2UqcuNCnpXGHcmRuI031FCdimlsfvWnKOP9f6z3oBtuvIK23FGGA031new
8XiFZ4vp4z6BojI17hNM0V895j6PE3jK8QV3jMcuulhKowZ0l9SnO01NOeew
vl1wrZYKBO01tUs9arOkgvl/BdfXhOXh0taY5lF0Ntn4O9bo7DuUW8C3weIT
D80c+waNl65RYePC9sG1Ffy5p4mkbiZrHbrTeM0pi/WSi6m0rxjSpmVvo27S
cgyNpLSauspYS/OGBnL5NfYXiNs/0RhXq9rRin5kbSzM18c510f4dGArcuvf
HflMOXvWqLL3j5q7d1SpcM8pAO6J4mvF3PWMN08kelCrurSXL5MmKZvx7Itx
fQFuhfR7vvjuz07QDRrXxXCMsRRVlinwysMo/o4g7ZVS6irj54V6I6LC9rSM
YiMGm03Hetx9VuY5LPOGPs+HFDoh0GLaroxPNxeX+Gid52n01hJKYfJaPV3n
91tPSKY8Y7pawf0C/SnqqiSfG6X0hqAO2Ya6hsrfJ8777iWUoU8bJUg7Lv8O
xS4xt2932ig9PqPsokhBmv6yaeTat86Y15tGO9m+cbXYbJt0DS3V13ewqA66
2FQYYyMnYzqHqpam6H168V2dT7fmONlFumfGdZ2eoesbEbrfegZurDC/3w3z
fbXRvGJdPhvlfx8zaGB8ldn85WIq7SvstgNnMszkz/SXi3WVsVZwbZCoa5iu
f1jbjnX0I2tjYbE+lvq2HZIeC4C6YOfU5da/24OS9yG90n+K4P7RH1wi7ZVr
uOcUABVRdq2YTBPnrGP88H6iH+66rbRVVVwZ4dmBOyAdHx785meHK/9EIu+H
P89gtt2jsYKx+dj9d/j010vpdcM43p9dBxxIn0ZsoY96i8fdu2xNW1VMXQTj
7Tn5VyjnfAV9KijH9CO14jy5fwPpo5Al9HoLPl3r4GJdWasKqLUgdl2mR9Kc
ELEX6BJSamf87tH0t3gPvPmK5HNBeTnfq98ebfRYut8RGg2YRp+PF/5O0Z0i
qqRpmbZgPE/+6WKaNH2YKO3noZE0NjSZkm6blnFfocCnv8WXQVZy5TVpRybG
Az6kRi2mUdz1nyliunAsOpjm7CmgBSG69QJdIk7J1oHdti6E95StxydS0vVa
it4ezPfFAdsox+H9/R5NYvpU68UVzP8ruP5hKI/jdZ/WR0dSf0HfbDhkCU0K
DaMF+Tfo4BVhn/ej14MTaXNhMY0dIoin4fyQkVxM5bbty+fbv39EMe27fofi
MrbRgAFLmParo4zfPGTaZAvz9xaaszFEdO40HL+f8m1pR0v96IL1sbBcH2e0
I3w6UIa969/tWqO6fpfD7x+1975TJetX2fpjXA2AZey6VkQmUElxKdH3NR4p
7aWLpNmdRQOHW+/bhZ4d1xdgD9Lv+Pyvf3K4olYOMuY/Ou8uty1hK//MtIYj
0ynHkF57hF4T+MN5h3Xp86uLqLNxe3+KrP7ZprSZB9fy9XwvlpKrb1Pypbu0
RVCOEenXzeaZczSW9wVd1lIqs02U51ubKVNfh4SdvIfovPiInfGrpakCn76B
rbfwc0F52XJlysS89fgkyuK2P6B5H9cTtMVtmfa5rc+7ko8DU7csC2UUxkFY
BlnJlVcUcz8aHHdWVP8JxvoH0qJTD4yfZZ27QslauT52W7KfH009eJ1Sz7Eq
p/cMx+oSQsmy5bxNkTuTaFEcr3lxWaTRWtdeExif3mpROfP/cmoliqlzFLOG
r/uEg9/Jtovfe4I2vFlJb/vVM/apSGmfkj1vzfeVzLxQ/jhdhtG89EqT/mKu
jELlHI6lhsLz9pK0/etoRwv9yJZYWFMfRws+HSglODhY1Hfqeqe64X1Itq5R
ZT2wq+8fddU9p5gLA8AUxe9OG76IwtfuYPztBaL7d7xKbJ00u/dxdcT1BbgC
6fgwu+Ynhyqn5goNEcylDYrKpzX7iihkhXBudxBtuqZPf+0I9RJ6X2M+t2lU
Z34Mv+4r29ImJgab1FWqVnOLzOd5tVywfS2lMds0Sfz8X+cVR/g63+TTvrL4
iJ3xu0uT3+LjtO6a5HNheTvrysVu37yC90VjGV9kSL9J4JdG5942SWvYZi5f
OaWJfq+wnFYuX/G2UNH+OTcq6d9+5uufLVNftg45NZdE/U5e3WnNVzJl/KqI
89fS9HOPfme2XsL2GtdZ59NzavQ+XR9TZ0mu/VjFbuB/gxL2Q0MZDb99zK2Q
r5dcvrJ95WI+vWISr0AalXi2zjLy58xZQTsz14m4S/qyWt+OlvqRLbGwpj6O
Fnw6UIrcO9Wl69+VrlFl7x9l79mkB/c8Uvw9p/DsAFiD4V5zW84XVhNnR5JG
s5fou9s+I+3Fc1yd4dmBM5GOD/czY0ZHKl0wD21JHydd1+3DjLVfFfjkdH0+
WYz3HtZCMO/1lW1pt2wQr0dv0DmAGrQINIodh49l/IMoT8ZHphjqIrM9Ooof
+7M+3Vhvxqcb0rKewJ74ZTM+YqxgPnn+8QfiNEy5XpEp7waBL/qCrZeF7bJp
zcVBRim5gvlHxjOFXrRQJ7l8Re0oOdZXpQLPNIgir8nna1KHa5XGd9gbYids
7wb+9ajBe5spyUwZTX2aH81mfLpV7aX36fsZn95SEn9nyJq2FvZDQxnN9ilb
+wp7nldk0budTWM2to79DAqdK1h/zpzL/HlnQzta6Ee2xqKu+jha8OnAHtj5
c2H/+T//83v6cNhkRWtU2ftHSw4dVf0eUWfcc8rWy9b7TrF+FXgzit+d1m8S
483XUknhYaJvb/m8tBfOkmZXJidbfDs8u3J+/PFHevDgAfevnNjPHj9+rHYx
7UY6Ptx75yeHKmxuP6t8ut/HCZTC7nP1CPU0bu9PC8sf6PK6kE+dBNvDLtuW
NukAP+fbYFyW+TIL82R8ZJKF7cI82bX0Kfq0MQn83H2nRUfsjOF3NPU9Pk5B
c/NFn29cL/j9QVDedQJfMjLntjG93HbZtML69t5srJusLhcJ4s3Ed2QCHzdW
N65TyPoYCj35QD6+5mLO6TaNEfiomaUPjJ8llZfTxjPfmanDXZrQm99vyRnb
4p529TtKYpTC6S73f+v2vcuVN4jx6XvvlFOQJP7OkLDuYw7w5UzKEfRP5vxK
N+xz+6zg+fz6c6mOfC32FYF2lR+hkR/znrvn6nKLZWSVUiz8LW8QhV0Qx9Pq
drTQj5TGwlx9HC34dGAv7w8eQk/+ow0907yvjWtUF3P3j2ovXSL6/hufEVtf
W+85xbgaeAOK17MPW0jhEdtJe/4M0b0bkAWxMdLsyuBiZsu1BdcX6/jtt9+s
85ZeMJ6S1if99k8O1CUaYMy7O80vY/zOlbu0q4rRlQe0vWCz4Nj9aWUVs8+V
UuohKlN3Gr0lgQYInw3nH0Lbb9uWNqUsSVTPD7cU0dYTV2hrUQnNXRVCPXsH
0/orkjyZsf4uQ11ktkvz7L0olqYvGiva9jLj0+2N49bYcaI8A0eG0JyEJBo9
bZD4+FvOGveJWM5/NiL7tsXtsmkvH6GXBXEdui6BRs/dTBuvyJdxyVTJO7M6
D6IRqzbTqDlTKVC/bXzRXfn4mos5pwc0Z4TgmfothtHkhHSarI/zy6vKzdRB
sl/vEFp55BLFnrhEq1KTaOiID2jAlkoH93dW33HrqAOXs3lXcjEcUXDXCcfh
tWoR/1tYwH9Dafq6UBq9+5JJ/3x3eTpFFBXRiP8K4tI5VHcuycjavrKV/V2q
81ias7eSEqpu08pwvr++vLzcYhnTb1+noaJ56/40OTaBJq/bQuOiCpi+YEM7
WuhHtsTCmvo4Wt72vQJcg+I1qnMiuXss1b7X012Ee06Bt6P03WkTZ0VQ+Jo4
olotpFDac6dIszPdJs+O64tlfv31V5/16Sm3fnSYdhUJfHjvtZRgkqaaBjXn
j/3ejouUUn2EutcR836xF3X725L21g80c0Q9C2m70/IqJl1VCXUUjPWNZWaO
Jdy+ndv+DX3Z21KeftRxYYkDYnlRFCdZNQ+haME+q5fzvmhY9i3B9kEm2+XT
ammYybrfYbS22kwZq0/yz/Uyo2H538jH11zMDf2oxPy9E91XlZmtQ9KxJIvl
qT+70KH9nVVsfiw1YPP+71oK0azV/X9ELG01FzcHaHtmiGlc1p1kPvu2jj7v
R58L+oZUcjGV2xa6sIfZ/L8s+sZyGasK+bY3EdPftDa0o8V+ZH0srKmPoyU9
DgByKF6j2n8Sd/9oSWGJ6vd0ursM95yGr43H+lXg0Shbzz6R8eZrqKSgkOju
NcjB0p6tJE1iGuPZF3DC9UU5x44do6KiIqqsrKSWLVsax0/Lly8XfebpSMeH
yTd/dJji8/i1pv1izsqmCQ/nfWN7xtMmf1Ui8N7dqd9H4nXz/cILSWPY35a0
nG7SjNny71Du8GUsRbNprp2kfob7YXtvonjDvtVl/LH+E8tvv3SSPugtzqvf
sk30n1cEdXJEPL+6SBOmDJIpeyC9PjuBtlwTp1+3+Uvef+R9Ixvv0frt5tLG
FyZQgOhYX1LEVz+ZL+O1apoy+0t6UVrG5v3o48hCSjQXX3MxF2hL+ibqIMn3
xd5zaeWpHyzWYVthEr3xioznYso0Yb/Wof2d7Y/SMhoUMNtB/UBWN2nKl+L1
DP02nzV+Jtfn6zUfTFPqqL9cTOW2JR7NojdMfkfqTp/Fn627jMK2N9FUWnfN
hnassx9ZFwvr6uNYwacDcyhdo8rePxoeEc/dN6n2vZueLMN9p5hrB+6O4nen
Md48fHUs480PEn1zBXKhtGdOML49VZFnZ78XcH3RER0dbRw/Xb9+Xe3iOBTp
+FBz40d1dbmEuhrK8yYz1ma2xZ/V0qYKLcVdtiOtUFe/pZhKXbqos99Q/FVp
mh8o8TIjk32ZbVd/kM0zjjtuNcVc/qGOPOyUsezVFFV5S6bsjpbueNyxrN7n
B4o5y+6jpZiL38p+bhoba+LF5MuUI+biLTP5mlc8s08UFzO2b9i2r6eIq6O5
mDP9JqqyWtdvzjqn/nyMb5ltR4tldEg7WtGPrIyFNfVxlODTgRDFa1RnR3D3
j6p9b6a3Ssk9p/DswJkofs/iZws4b05fV0NuIu3p46RJSOHaBtcX24iMjDSO
n9h3oHgT0vEhOx5VVYz37mL03mtpq6PSQhAEuang030bu565PCuCSg4UqX4P
pq9JeM+prc+K8vUxNbAPRe9ZZNezz1zF+MA9RDWXITeX9nQF11YDP5sPz24F
vuTTd1x/pK4uHKAWxjWtK2mzo9JCEAS5qeDTfQ+71qiu2Yb7R91MwvtObRlT
s+3vi+NqYD3Kf8djvPmMVVSSm090pwryUGlPlXPS7Ei2ybcLPTvbh7wZX/Lp
cdpHKusehSTuoFERMTQh6QTFOCwtBEGQewo+3TdQvJ595hrdGlU3uJ8Scs49
p748FwZMUfzutM/mUXj4VtJWlhHdvgh5odi21cQncW2N64sOX/LpMdceQRAE
QS4UfLr3ongebOZq7l5Fte+ZhOwT7jkF1qL4d7wZ4Yxv20106zzkY9KeLOXa
fsCnvu3ZfcmnR119BEEQBLlQ8Oneg13r2VfFUElevur3RkLudd8pnu/snShe
z/72BJo4PYxKsrOJbp6DIE7aE0dIs13D9Q1bfLs3eHZf8umbrzyEIAiCXCj4
dM9G+TOX5zPePJroziXIB6U9dczme069ZVztqyj+HY/x5uFhUaQ9XkJ04wwE
1Sm2r2jidjGePdjma4unXV98yadvYMaMEARBkOsEn+55KHvm8gT9GtUk1e9x
hNxLuOfUe1G8nn1aKIWHbiG6fhqC7NK1isOMZ99pk2f3pOuLL/n0yOqHEARB
kAsFn+7+2DMPxnrzkpwc1e9lhDxD7D2nbH+x9b5T4Zja3cfV3o6i3/HYa8W0
laTZlshccCohyCm6Vl7M9bGBn8z1Gs++c+dOn/HpEV89hCCfUeipGlp2/GsK
u6h+WSDfFXy6e6L0mcust+LWqJ44ovo9i5Dny3Dfqa8/K8qdUf473ngKX7mZ
SvZlEl07CUEu17XyIpt9O34T5KmpqaGwsDB6+PChU/KXjg9XXX4IQapqRcVl
Cs4/TbPzz9P8ozXOO9aZwxSo7/eNgw+pXm/IdwWf7j4omQfj1qhOD+XuBVT7
nkTIu6XknlN4dueg+N1pjB8KX7mRtGUHia4e90hV7E2g//m//5fSo9c4Jf/B
77xFLZs3Ub2eIl0+Qo8ulqlfDieK7ZOa2B1eNdfubK5du8aN25599lmn+HXp
+DC06gEEqafzp6ibsE/W60ZjTzrpWKcPUVv9cQLmHlK/7pDPCj5dPex65vK0
UCrZv4/o+imv1qMzh6iWUyk9doPyQDpdqzjE3XNq632nvjymthfDveY2/443
dTlpYuKJrpR7hcrSt3PfVWlbwp2S/4C+r1Hzxg1Ur6dOR6kydjIFcd/PPaj8
jNrlcY20xw5wfXbgJ3Pg2S1g8OkGOdqvS8eHyy/9AEGqaWHKGpM+2XXDeacc
a8WpQ9RGfwz/OcWq1x3yXcGnuxa75sFCN3P396l9j6HrVEyrmxv6Zns6cl7t
8kDm5I33naqN4t/x+o7nvHlJZhpRdZnXqSwtTu/Tw5yS/4A+ep+ucj3vH1hP
MzrVE3w/d6fy0+rH39XSHi1gPPt2TgOHWu/bfeHaIvXpjvbr0nyXMmNGCFJL
wz8PMO3vvTbQ/EsPZNOHnOO3h5y4QXNKr9D809+ZzT/k9B0uTfBpZr9zFdRa
f4zmjE9Xu+6Q7wo+3fkof+bySm6NKl074Zs6l0DvGPvmZ1T1lQPz/qqQzuXv
o8dq19ELda28kPHsCfDsClD+O95sCl++jrSleUzfPurVKkvbpvPpm0Odkv+A
Pr0Yn15fvTqeSyPNhN4y/ovx6afUj7/aYvu4JjqO6/O2XFu88fpizqc7yq9L
81t88QEEqSPm2tderp/X60afHpGkPVtBnfWft5oSTQPHfyDap/3sHFooyv8K
DfzibXGazz81/p/16arXH/JZwac7HuXr2dl5sBVUsjed6GqFz+txYTiN/Fcf
GjG4Dw2fuJYeOSLfs/spb8046sn193FU6wb19GYZ7jll+7Uta1i9cUxtDsW/
401ZxnlzulzqUypLjdX59E0rxZ+dzaUrhalmdaOi0Kr8jT5dpfpVLmqr+z5+
/QNa9oXQrzM+vVL9+LuTtEdybfbs3nR9qcun2+vXpfksuPADBKmiGbsWGvth
uzXF9NmUbsa/24aeFKevKKamdZwTr8ZX69N/S/8dKTNPL1CzWUWq1x/yXcGn
Owa7nrm8YgPjzdNUvyfQnVR7KJXO5aVSVV4SVWYl0X0787tfupPiZ/xb1Nd7
jgqnR3Xue5Ru5MVToWYLleflGrc/Kk+lI8y2Qk0MXTlzVPV4eYqU3HfKjqnZ
88obxtUGlK1nH8d585L0PcQ+V8xXVZYaI/Dp/PbKRd0sjrX8Xp5G963In/fp
KtWxMpHiIzfQI+b/v2TPFs0blVeqH393lfZIDuPZt3Ge3Vbfbri2WON5PVm2
+nXp/vPO/wBBKuhb+mCIwUsH0AeFP9CspBV83+y4gqYJ0gefLNY/08OPntHv
02XWQgpqyvflFycX6NKWZlMDoScfu4r+PfNTUb9nfbr6MYB8VWp/b3iy/t8f
n6Mn/9GGnm/1vm1jgqnLGW++nqj6GCSn88L17jqNj9mrKK8bueto2eC2orxG
Tl9AlUcO1r3/iQRa0Elcjg3pe6ly1SBJX+hOhSfcIG4eJu3RfJvvOfXkuTBF
v+Mx3jx8WSTjzZOJqkogRmUp0dx5l7ZphWD7AYp/R3cv96tfzKaT+dtpaXPx
ubs6Md2q/Ae89So1b1TfirQHSPNBY5u+Mz5cGGNTXe9nTuP3Z336SfXj7ynS
lmSTZmusTZ5d7TGFq2StX5fuN+fcDxDkepUVUxNDP+y1mqZx2yupo7FvBtD7
B7/l058oNr5Tjb1uvpd5m9s+a3803587rqYpzLZpqav5bb026PP+gcZu4n8j
bTqzSP0YQD4rtb8vPE2/+1tjeqpRNxvH2uO5eTB2fZ7a9/Z5jI5vFXj1xpRa
VGLD/kV0bvtCGvGysO260+rITXTjnJV5XEymEfpjjxhkOk/37qeDRL8lrE72
/vuCnSnhPafs+aJkLszdUerTJ05eCp8ukLxP30Mz6vlxc+aPmL9r4oaLzldb
/LEtPj31i7bk16wt9Xy5bgU186MRy7bbVFf4dOVifTr7Gxd7DsGni/XMM89Q
aGiozT595tkfIMjlGh/Ne+Z6TWbTfxMLaEjiHgoQ9M2A4FJ+n+PF/GeM955q
3F4q2L6aJnN58+vpmwQX83mc4tM2YXy62jGAfFdqf194glhv/kzzvrbPgy2P
9Pk1qkr1OC9E0AYfUNUFK/Y5u48Kw8eI/HPQ60NIk7SbW0NqaxmuJK2gvPyD
dD9toqg/jA9P5D43zN+xWp2Wo3rMvEnCNay2zrO7O4rvkRF59sM+q7KUrdw5
l7ZpuWj7/fJMus/8+zg/WHwN/2Aet93a/Hmfrn5d72dO5evB+XT1y+TOYufP
w5etVbQ+hz0n1R5rOFvW+nMD0v2nnf0eglysr6lfPyv6d5OF9KVhn+NF5G/Y
3mE1TbCwfeSq0cY8GgcXGY879dQRY9qXZha6QRwgX5Xa3xueIKU+HfNgylUV
9i7fBh+EcHNklvfJow0v8755xJwQqjyc7ZCyFI4XrJt/Z76uLOcT9fPtOkVn
5qseM2+SkrkwVqz39SRYz67Et+uuL0vocFoSaQ/vJ7p0yGdUtkfv0zcuN/38
9Fb6SHT9/piqzsnkc3qb7vx9bRTdkHxm9OluUNf7GVP4utTrSuUn1C+TO4nt
+5qoGO5cUOLNPWEdjiWsfY6crf7cgDSfKWe+hyDXqmQ//dPKsfrb+77W7VNR
RC0EfnycIS+Z7eP2CNa9vx1FE/RpR26cxfv3GYXqxwHyWUn7OTAP5sFcpQLS
fCDw3GEJVuyTK/LpI6fNo8rC/Q4oSyatEuS7IDGT2/44f7HgvHmXKs+oHTPP
l71zYd6AfdcYnW+nS0VerbI9UXqfvkz8WVUGbXxN+H3WiPYdKpbN41G63v++
PJPuXxKn0fn0F60oSz6lDm1Nfk0bUZA1Yq9lS2NtqqupT1c//mpLeziLuU5E
0MBPZtn8Gx77XgX2HPMWXP1etomnv4cgl2pYBD/f/cLoPTTm5Nc0pvQWp7En
q6nP23z/bDS9iNtnQnkRNRf48TH6vOS2j8/ZKerjQdOjqN/00aJthnwhSA3B
pyvDEfNgujG1+nMSbqezu2i8cK46K8e6/U5nUGHEePG699feJ03CDnqktCwn
Ngnya0N5pbrtVWHvCObY5ynP34dlmAuzdbzNenN2vO3pc2F1YbdnT91NdLHI
61SWvEXn0zcsFW0vnNJG9F22bMdeZvtuih73BeUdyDOme3x8L904sJ2OaDbS
ueI8k/yNPr3OsuSR5oNGNq3N+mhBlE11vZ8+WezTjxeqHn81xPbl8KURNq+v
8abf8OQw59Pt9ecGpPmOO/U9BLlQt+h1gQ9/dectkzQjtswS9NFJ9CmzbWxp
ETUS+PEvDOnLxNs/NxzjVcvXbdanqx8LyFcFn+4YMA/mOD3KE9xfWu8Nqjwt
PydmXvl0LmEhjRc+R44Z4y4Li6QbNuZ1P2Ucn0fTYXSFm3vLFt2bPiIsXvWY
eYowF6YMw/WF9R22/y4YwvicXYzfKfQKlSVv1vv0JcZtV6LEzwAbHxrHbS9f
0EXn2TWZxrRVoW/w6TZoTPLnfbr6da3VjBXUqzXlHVG/TK6Q9vBe0kRt5fqu
kvU13v4bngGpT3eUPzcgHR+OqfweglyoW9SrJ+/B/3tcJs2xIv5Z8H796P0j
zLbj5dTKsK3nehppTHuET9s3it9+pJw69hT39VZz1lPb9rr/N5xW5AaxgHxV
8OmOB/Ng9um7PYI5pNdmUM2xKBrR9A3KKz5gc141WZG0bGhXUR8fMW4GlR/I
smr/ygX8mN5v6FJ6zG3fL1pfG52ezviB/vTOlEj955BQmqhobi7MlnPBF+bC
7EHZWp6xNHFSCKeSlJ1EFw56pMqSN+l8+vol3N+PC0KM78o1aMb86bRsSBej
vy08JsijcrN+jUwjSi3IN8l/QO+eOp+uVh3PpFLh+gUUPf9T6imd22n6Oq1e
MpdSY+PosRu0hSOlPZRJmi1baeDQmYrW1/jib3gGn+5of25AOj4cdfI+BHmI
aunzo4zktlfUyu4zvOgrGpJ7gT47WltHHhDkOsGnOxfDeFrZ+njvmgezVqK1
ngJpcnMV5/noyDaKn9JflF/Q0BB6ZHG/LIp+TTBvrp+jY7dv6CizPmrokjry
8w1hLsy1KP9dcKzAsx/wGPE+PYT7+376VNnrhVEdR1KNYP9HOYZ3/LxHVWdM
8+d9ukp1rJQ+C0+uThPp/oUC1dvCXrF9L3zpaq4v2vobHuvNfZ2amhqn+HMD
0n43khkzQhAEQa4TfLprccyYWv25D+fOJ+2gBUIf3PEjKizIcUzelalUGPq5
bp6q43RmrGupHLtoQRPBvPm+fcbPqtZ/JDhvGtH0JevpETf2dIP4qSB2Lix8
6Rqb58J8fT27o7Hv+rKYub4kEp0vcGuVJW3U+/TFivavWtlPd96+P48eyXxu
9OluUFdvlGbzFgpfslrRb3hYX+NapOPDYSfuQxAEQS4UfLp6+No8mG3Ko/vH
0qm2Its5+Z/ZRzUVeXbl8bhyH9UyZXwkMyfnCzLMhdnSdzEX5loUrY/vo/fs
exI40bl8t1LZ7g06n75usYL9syhe/y7ekau3y6YZ0Lu7zqe7QV29QdqidM6b
Dxwyw2Zv7gvPi3RnpOPDT4/fhyAIglwo+HT3QPlzojxnHgzybGmLdeNttr8p
mQvDeFtdFP8uaPTtOxjflae6ynav1/v0RQr2TzHeszIjZAJ95NeZyk+I0+h8
+j9Vr6cnS1uURuFLVtnszbG+xr2Qjg+HVHwHQRAEuVDw6e6J0nkwdlxkmAtT
ex4F8nzZOxeG8bZ7Ypdnn7iISpIZz342VxU9qMikMs06+rY0VcH++6lw0ivG
77sFkVEmaS7v30an07aoVj9PFdsnwkPCFa2vwXp290Q6Pvyo/DsIgiDIhYJP
d3+8ZR4M8gyx/YWdC2P7j63jbaxn9zwUP+vS6NnjGZ+W41F6dCyNHp1Svxye
LG1hCmk2beL6ANbXeCfS8eGgsu8gCIIgFwo+3bMQenZ2vONJ82CQ+8qe8Tbm
wrwLpWt5dNeYhVSStJ3oTDbkhdIe3EPhIWE08L/TbbpWYD27ZyIdH77PjBkh
CIIg1wk+3bNR/JwoxpN56lwY5Li5MDzbCVhC+VqeL/WePY7xd/shDxbbhqw3
Z9sU62t8C+n48L1j30IQBEEuFHy692DfPaeYB/N2se2rG2/btp7dMBcGfBvh
9cW23wUFnv10FuQB0mzcwLUZ1rP7NtLx4btHv4UgCIJcKPh07wTzYBArzaaN
nDdXMt7GenZgCWVreZjry4QFFL44lEp2byM6tQ9yA2kLdpNmw3qb17NjfY13
Ix0f9i/9FoIgCHKh4NO9H3Y8rXhMzXh2dm4Fc2GeIe2BJK69MN4GrsSu3wUZ
3w7Pro43Z38vsXU9O9bX+A7w6ZA16ltwnd7KvU59D6tfFkgd9Stk+8AV6lP4
jepl8TbBp/seGFN7lwzjbTzbCbgDdl9fNLFElXshJ4idMw9ftBLra4BVSMeH
b5fUQlbrJr225yT11JRTrz1nqXex2uVxkg4U0LP6/vHUhAL1ywNZVvFZavXB
AHqqWx96cXgMveGQPlBMzxuuE23DqLfadfQywaf7NvDsniluvM14c4y3gTtj
11oezrPHkLZAw3jMTEiB2NhpNqzjYqnkWoH1Nb6NdHzY59A3kJV6ddEQUeye
Gp+tepmcooJ8o0d7Zny+y4//Vs556rmjhLrtOkFvFLpBPNxdOfn0jLFfDqCu
BQ7Os2sovaF2Hb1M8OnAgPL3KPPzYOzcrtpzRt4ow/2jGG8DT8au3wXHz6eS
XTFEJzMgC9Lm76LwRSto4EfTsL4G2IV0fPhmUQ1klS5Si65+kviNo26ql8sJ
ysul5/R1fHpcrsuP32lcZ2OMX4q6qH483F1Mez1l7JPv0St5ju0Dfm1WUC+1
6+hlgk8H5rB//WqM6vNJnix2Loxdo4rxNvBG7Pfs0YwvTYcYsbFgvbmSd6dh
fQ0wh3R8+PqB25A1StpBv/eT+nQ/ah59WTb9awWC/+dUUY/U09Qj97rdaTkd
vE49My5Q97QL9KoVefbad4HL01xa4XG75zB/5xcZPdrfxmZbjkvOBeq6q8ys
umVcsTnWHSf1Nsa36eYLFo6tLzMbhxwHt7ctMWbSmo2vtWU0tHt6Fb1WR5nk
0vRKLaNO0QXUVRJva8rItX2GpJ452bxPb72cXlUQH8i84NOBNWAezDVi48SO
t22JsWG8jWc7AU/FcH1h+7HNa3nGz2POm61EJ9J8Rtq8RNq9bi1Xd6yvAc5C
Oj7slX8TskIvz/rIJHasfv/JLnHanEJ6Qf/Zc2M2U8CI/4jS/+2TGOqhJC2n
a9Rh3mz6i6QMT763jF7JMs3z2RGR5P+JOM/nR++hV0V5nib/wb1Faf4+mK/r
38ZkWYxLxwm9ZeNiVKtlkjpY0mlq8opMjNlyT83j02UWUpP3TI/7l7cX0suZ
5vN/NSZSl1/DFiL5+TWngJivlMX4k4XUsLMh3X+oY5aNZcw5bhJ/tjzNVx8X
tXu7WVMkvxM1p4bz9DHJOUz1G+q213stUhdvK8r4qiaD6nduIY71K1OoQyrz
edZ+4zMKxG1oRXygOgWfDmzFvjE15sGE0ubvJM36SC4uGG8DoEPZPe1jON+q
8+1RjJ9N9SoZvPnAj6bafK3A+hqgBOn4sGfudahOnaSXWhliNozabtsu8Ckf
Ucf9grTp++hvlnwru5Z8aq7taRm1n/JvC354KXW1Ms8G4Sf1eV6hoEHNLab9
6+h9FuJymVq8pkv350Fh1GFbLjVqKN7/pfBy6+O813zZfz88nUvTY28u/d1i
/caI20Ogbuvnm92vUcRpB8RYd2zry2g+/k/q68uq3fg3zeTzJrVLl5THyjL2
TE83G+u/jt/HtcUzgjy72dIHoToFnw7sYciQIfR//uf39Lu/NaZnmve1ybP7
8lxY+MLlGG8DYAWK1/K8pfPtJTsZz348xSPFlj184TKuLlhfA1yNdHzYPfsq
VIe6bl/Px+zf26hb9llq1FLg8dZU8ukzMo3+5ncN2H+bUf3JK+kF0TzxaOpo
Y9puySn0V+O2TtQs8ih12bWfXgzi0zaNOivO00+X5wujZtDTDfh0fxqWwpW1
W7KGnhT0haeGhFCzUYNF/eOpUZlm49It+7BuzrZlCHVh/u60fKL4N4bx5veV
jXP2RWo9J4SeE5T1d31n0Evj5pF/ZAWXps2oNwTHeJf8wzKp9fxgfV11en7e
Yfn8d2VS01Eh1GTyGmrUSxjjZhSYcFlZjPVlfbLXv+iJBqOpXYb1ZWT70UvG
th5MrRPO0isJ+dRiGHPNn5Ovi/GuBFEbPT1sDbVcvp7+EaTLu22GuB+xbdFZ
tm+Jy9hySCdRGZsu11CLUZ/pfPrkPNk8rY6PG5yz7i74dKCUgoICk/4zaeos
hevjx3jtPBgrtl6sN2frifE2AMqwy7OPC6aSxC1EFXvcWprINRS+YJmi9TW4
1xw4Eun3e9esaqgOtR77rjFeDdee5ra1n/2JcdsT/4qhzvq0XdLSBc/e7kTN
N+vSd96zR+BxXqeWe2xL22n9Yr7dXl1FL+85QR2TTlNrQTnqrywzn2fUKn7/
lovp5SxJnp1WUCd9HdovmsD79C/SLcam0+4ybj9R/qz6rDLmZ6vaTuTj3Xj9
OcFnp6lxJ/4YLwk+azeN/33hj3WUuWvWeWrap5mgjnt0dVEUYz96Yd4BRWXs
nHWCGgt+73n2s3XUdud5cXwFZfrd+zGiOnSIP2Ha55i27WTSDy2VsRm1iL9k
/KzzziPUMU0+T2vjo/b56gmCTwdK6d69u6jvvPjii6LPhWNqm9avesE8GKvd
6yJw/ygATkTR+nijZ9/MiSqSVZU2J57z5krX1+BaAZyFdHz4yt7LkAV12nuY
XhDM7/5jZiIFhiVRizHvCOL4DrVK0e+TkkZPG73vcnrZmFcFNTDOOzLeO8m2
tO0WjDdpO6n++GmS+TxT9gq2L6KOzLb2S6bxXnVMGl/vdD7tX0am1R0n4TE5
fUFt0pXHvJUgtg3WVAjKlS1YT66Pof6zjmvm8n723U0W828z8xNRWdvqtyuK
cdBcLpZKyxgw8nWTYzzx6lxqnWRa1r+M2Vt3/IN0bWt9Gd+hlinW5Wl1fNzg
vHV3wacDJQQHB5v0HXZ+3RL2jKk9YS4M420A1MPuufaETUTlSS6RNns7hS9Y
SgM/nGJTWfEuB+BKpN/xL6dfgiyow5awOr0J598Xl+r2SU7h7/vtuJQ6GPLK
KKN/1jekf40CNbalbTnlA7GXC2pKT9Tn5efXlBqsLhPnGbSA2hnylNneasZQ
Y35/Hp3C1zs1w5j2yREplmOUUUoNOwpj0ZSabjOTNjlDN0f78lTGx5vPM2g0
79Prs3WSq4MhhvrP2q+ezcdmYJT58iYm0B8FcWyw9oTxM0UxflkQYyVlzDhB
/qOHkrQ/GfINGv2aoI0yzMRVps0tlLGTJkXwfIV3KCDZujytjo8bnLfuLvh0
YCvV1abrMNj71G3B/vWr6s+DsWLLwY63bb1/1DDeBgA4Hsd49t0OFZtn+IIl
NpWHFdazA7WQfs93SLsAWVCLob2s8ul+b66htuw+u5MFa9Z7UdOoM1w+7XfE
C7xRL/LfaVvatmv4Z6A9MSDWfJmFeQbO15XJzHZhnvV6hBrTtgoey3vD4ckW
49N86MuiOLyw9BizvYAaDp5CzaIqRWnbGY4XuIQvl4wCRvXnffQaYR4VVF/w
m0CjjWeMn7WaPsSKMldQox78/n8esUv0ud0xtqeMe46R/+yZgt8Q+lPAbqZM
4bNEfay94DgB4Tmmfc5QHotlPEb1A/nfVYRlbBuVToFxlXX2F4vxgeoUfDqw
Fel6d3v7jSfNg7HSRK7mvLmtc+YYbwPgegzXF8Xr4xM2EpVpbJZ2/zbSrA3n
8lByrcD6GqA20u/5NnvOQWbUNiWPfzeVX0d6aXMZtd5VRq0SGO06TUGrQwSx
7EXNEpj9diXRU6IYd6R/Tl1NzwrnnOtPppZ7bEy7OVLUbs9NTaSgrQcpcG0S
NfpyMj3V8Uvy3yXJM3AetTLUR267JM+nhq2ghsOGiLb9aViS2fgEBn8pSvv0
hExue/MvdL9tPL+8lE+fUEpBmzOo2fJE8t96wmLcmw/jfxv5w5szqeHEmfTP
BXlMe5ymxv2aCmIzhF4KTaWmM2fQ/wrK8XzIIdl8W4ZMFpX3D0OY+k5cQfW/
DKEmG8rsjzHXZ6wvY9ukPPp7YFN6etg6Jial1GprouCe8v7UnD3W5tWiMv2Z
KXOTuSvo6YB6ut9wzJXHljI2GEgN5m6i+vq2f/LLVKv6i9n4uMG56+6CTwe2
IPfsuLrWu9uKPevjWQ/t6LkwbXYcl6+ta1Sxnh0A90Pp9UV3jZnLXF82MD58
l6y0+2MpfH4I1rMDr0D6Xd86+QxkRq0iBM/N6hBMLU3SFNBzL/KxfGZODrVK
1Ei8t6menpGjy9+GtK2TK6lhP0tpO1CTeCZdvOAZ7gF8mdljCbcHcduP0j87
WD7+Hz/TyMdmY4TId3L1/3wxPdfvVWN5XtrGp28x4W2ZOskraOkkk3L8ZUK6
8biWysu2U5CZfJt+9qrZ/f46YZ/dMRbGxqoyxidI3okuUPfl+nwrqMEb5vLq
R80SzZSnjjK2XLfcbPmeGr3HzP5WxscNzl13F3w6sAX2WXHC/sLOrTsT++fa
lc+Fhc9fong9O8bbALg/dl1fxjKefcd6Tqw3x7vTgLchHR+23H0KMqPAUP65
X3+btlc2TdNRvP/80yc7KSh+p2DNegf66+tib/i3UfEUpNHta0taLr3mEDX4
aICsR3ryX8vIn02bKHj+V7uFFGjYPz6ZP1bXZcbtQXFp9Gz7euLjjlhIzwTU
M9ZJPjYLLXrRev4TdeXZzddV5/uaUMN1JyzGna1n/Xc7iPJ7ehIf/4BVEfRU
gOkx//x+mOiYUjWb9F+z5TXkb1eMBbKmjEGaMmr0iemxfv/6dGoaL8gvMZ9e
6Cv9jaEJPTtup65/yJXHijK2CFkgeucbq//XfjQ1iTphdn+r4uMG5667Cz4d
WAt7D7q0vzh6Lt0S9nl2y/NgrNg1qux4W8kaVaxnB8CzUfp+CqxnB96K9Ps+
cNdJyIEKikvkvU+7BRTAbAvYWkDNNhRQQJzytCLtOEotNuvSNd9aQgE7JJ/v
rGD2r+DyM9m+o0I2T3/uuLnUIq7Cch4KFbBmib7PfURNpeU1t09sETVn6ukf
e1T+c32Zm7FprMzTaimNsZIyCo7lHyvfPlxecUXUgilLi61F8m0rLY81ZWTS
tNjC5MvE2iTOlvavKz6QRcGnA2uQW+/OPvNdLdgxNTveVbQ+XjAPpokI5/7G
eBsAIETp74LSawXufQGeivQ73z/hOORIbdsh8N6zqLmj0nq4Go/5t66evVZQ
CzcoDwSpKfh0YA11vStdbRwxpsZ6dgCAHHLXF+l3p/RaAYCnI+3jTXeUQw5U
s6gYesIQ3xcn00sOSuvJahZ/mP7eWb82elyq6uWBILUFnw7qIjo6WtX17rbi
KM+O9ewAACmG64v0mohrBfA2pH28yfZjkAP1UlwxvThjKT03aiH9fbaGXnJQ
Wk/WS3F59EwLXX97avgM+qNfd3pxq/rlgiC1BJ8O6kLaR2x9V7qaGMbU7PxW
Xb4d69kBANaC707g7Uj7eOPYUghysg7T8+/3MPa5v4zf6QZlgiD1hLEGsITc
u9Krq6vVLpZi5ObasZ4dAGAr+O4E3o60jzeMLoEgl6jB+jxqsEX9ckCQ2sJY
A5hD7tlx7Bp4AADwdfDdCbwdaR+vH1UMQRAEuVAYawBzuPpd6QAA4CnguxN4
O9I+/sKWQgiCIMiFwlgDyKH2u9IBAMCdwXcn8Hakffzvmw5AEARBLhTGGkAK
e/+5tF+o+a50AABwN5zx3fnbb7/RgwcP6McffxSJ3fbrr7865BgAWIu0jz+7
Lh+CIAhyoeDTgRS5Z8cBAADgccY1sn79+ib54rdSoBbSPvjM2lwIgiDIhYIf
A0I87V3pAACgBs747mzZsqVZn758+XKHHAMAa5H2wb+uyYYgCIJcKPh0IETa
H/DsOAAAMMXZPj0tLY2OHTtGRUVFnGprax1yDACsxdxvRhAEQZA6Ar6Lt70r
HQAAnIUzvjuFPh0AtVF7PApBEASJBXwTvCsdAACsxxnfnfDpwJ1QezwKQRAE
iQV8E+lcOvvudAAAAPI447tT6NMHDRpEI0aM4MT+H+vegatRezwKQRAEiQV8
D/Y5wtJ+gGfHAQCAeZzx3WnpOXK4BwkAAAAAwHeQe1f6kCFD1C4WAAC4Nc72
6U8++aRR7N/Xr193yDEAAAAAAID7g3elAwCA7Tjbp//6668OyRMAAAAAAHgW
eFc6AAAoAz4dAAAAAAA4A/ZZccJxJt6VDgAA1gGfDgAAAAAAHA17DzqeUwQA
AMqATwcAAAAAAI5E7l3p7DPfAQAAWIczfHq3bt3g0wEAAAAAfBS8Kx0AAOwD
z98EAAAAAACOAu9KBwAA+4FPBwAAAAAAjgLvSgcAAPuBTwcAAAAAAI4A70oH
AADHgGspAAAAAACwF7lnx7HvTwcAAGA78OkAAAAAAMBe8K50AABwHPDpAAAA
AADAHuTelY5nxwEAgHLg0wEAAAAAgFLwrnQAAHA88OkAAAAAAEApeFc6AAA4
Hvh0AAAAAACgBPY5cVjvDgAAjgc+HQAAAAAAKEE6jsSz4wAAwDHApwMAAAAA
AFuRe1d6dXW12sUCAACvAD4dAAAAAADYAt6VDgAAzgU+HQAAAAAA2ALelQ4A
AM4FPh0AAAAAAFgL+841PDsOAACcC3w6AAAAAACwBvb+c+nYcciQIWoXCwAA
vA74dAAAAAAAYA1yz44DAADgeHCtBQAAAAAAdYF3pQMAgOuATwcAAAAAAHWB
d6UDAIDrgE8HAAAAAACWYO9Bx7vSAQDAdcCnAwAAAAAAc8i9K5195jsAAADn
AZ8OAAAAAADMIX12HPvudAAAAM4FPh0AAAAAAMiBd6UDAIA6wKcDAAAAAAAp
eFc6AACoB3w6AAAAAACQgnelAwCAeuD6CwAAAAAAhMg9Ow7r3QEAwHXApwMA
AAAAACHss+LwrnQAAFAP+HQAAAAAAGBA7l3pmEsHAADXAp8OAAAAAABY8K50
AABwD+DTAQAAAAAAC96VDgAA7gF8OgAAAAAAiI6Oxnp3AABwE+DTAQAAAAAA
3pUOAADuA3w6AAAAAIBvI/eu9OrqarWLBQAAPgt8OgAAAACA7yL37Dh2DTwA
AAD1gE8HAAAAAPBd8K50AABwP+DTAQAAAAB8E7wrHQAA3BP4dAAAAAAA34O9
/xzvSgcAAPcEPh0AAAAAwPeQe3YcAAAA9wDXZwAAAAAA3wLvSgcAAPcGPh0A
AAAAwLeQjv/w7DgAAHAv4NOBtyLt2xAEQZC6Au4B3pUOAADuD75Dgbei9ngU
giAIEguoD96VDgAAngG+Q4G3ovZ4FIIgCBILqI90Lp19dzoAAAD3A9+hwFtR
ezwKQRAEiQXUhX3nmrRN8Ow4AABwT/AdCrwVad9+8MtvEARBkAuFMYb7IPeu
9CFDhqhdLAAAAGbAdyjwVqR9+/7j3yAIgiAXCmMM9wHvSgcAAM8C12zgrUj7
9r2ff4MgCIJcKIwx3AO8Kx0AADwPfIcCb0Xat7/56VcIgiDIhcIYwz1gnxUn
bAe8Kx0AANwffIcCb0Xat2t+/BWCIAhyoTDGUB/2HnRpO+Bd6QAA4P7gOxR4
K9K+fZMZM0IQBEGuE8YY6iL3rnT2me8AAADcH3yHAm9F2revP/oVgiAIcqEw
xlAXvCsdAAA8F3yHAm9F2revPfwFgiAIcqEwxlAPvCsdAAA8F01Gsck1vKT8
vNrFAsAhmNyP9+AXCIIgyIWCT1cPvCsdAAA8B+3NrzlvPvDz5fRix884/e6v
jUVit73yzlSauDCKwrekwrcDj0U6Rqn64RcIgiDIhYJPVwe8Kx0AANwf1puz
fpv13gZvbqsMvh2eHXgS0jHKBWbMCEEQBLlO8IquR+7Zcez70wEAAKgPO2fO
enOlvhyeHXgD0nHKue9/gSAIglwo+HTXg3elAwCA+2BYz876Z9s89xSaNG8T
aVILSHvtOvfvwJFLFHl2tgwAuBPS8eHp+48hB6r85j06fO0eldfWnfbkzZuU
c+Yqldbo9712lfn7JpW7QT3cT4+o9FoNF9uTqpfFAaqpofwzlyn/q3uCvnCZ
Cm8+UqU8J2vYflvD9EV1ju9rgk93LXLvSsez4wAAwLUY1rML7zW3RqwPD9+w
m7RXtUQ/PZAV+5kmJd8mz465duBuSMcqJ7977AJ9T7mnL1PGifOUdfoqldx1
xTFV0J2j1FMf1/bLjtaR9jj19avHpZ12+BGdPL9H3yaBtP2GLs3Rq1cpi43Z
+RqqMMnjIRWd18U09/I9ReXNzdtCfbu+Qz3fHk4rD9UoyqPiTg3lnr9KBZdv
cso9z/5bQyV3Hsnvc/cqzR81mNr37U/vzdxJRVYeJ2XdYGOfnVaorKx1afe6
4Vz8m/jzat+V+Zc9Lvf/HvxnXQOYtMMp8YaSYz2kdZMM5+Bgyrj7PS3oqv+7
RSSVuLzf8n2xXtd1uuMrbCfIOsGnuw68Kx0AANSD9b9K7jWfELyRNHvyiH78
3mZpr1zl9oVnB56GdLxS8e1jpyszdrjomO2WFrvkuC7X7aPUR+93eiw9aiHt
9xQ+KlAfj2DK+7aGpnTV7ec3MI5KuDT3aJa/IWY9KPa66bHaGWLqH04HFJQ3
fml/Y5v0iTyl3/6I8k6dp+Sjpyiz6l4dedyjeV39TPqUsZ0HjqXwg1dE+xzX
HqUefhbqZUa7wnmfPuVgjVPaT3iMHkPH0odDe3D//zRyJ00eqmuvPhOnUR9j
u/S3uvzSuM3qa8hjOCV/8z0tHuhn9Mnm29KWtrFeojbpu46K7WgnZ5XR2wSf
7jrwrnQAAHAditez95/MePMNVFJSQfTovsOkrb7CePYcLu+BI0Lg2YFbIx0f
lt177GTV0Mw+Eg9XbxqlO/24KujWUXrLcO8j49PNpcs/sM4Yi0E7LlP67rHG
vycfqNGnu0fBfXg/uF1r/lh+fdZRoYLyJi7tYTzuW4xP57ZfE/v/fIt5CMto
Xm+FHRWV25i/32BKvGVlWcMGy8TIsTIcY3Dsee7v0tJ1XOx3M/9PiexPfl23
UCmX9ip97q9rlxhpu1ilGpps+F3GbyylaS/TJ8a23GK+LW1qG2X9lv2doNCO
dnJaGb1M8OmugX1OHNa7AwCAc5F7d5q13jx83U7SfvUV0cNvXSL2WJrkXEWe
Hb4dOBvpmKX03s/O1bkMaizj3aYfqpVNf/hrwf9v1VLupRuUe+uh3Wl1ekgF
1Xco69IdKrAmT20Nk/aG2bSG42Zxx2X+/voU9Tb69FKz+8Qa57H7Uyyz/wKD
1/VfQhnGdLU0R+DTY7WSfG6VGo9Vr2skFUjqKfw/G5es6lo6bFKWWkotraD4
0irGm5nm69dHmq/p/nMEPn3M7qMUf6CYVm0Oo+6S9p4jaO/CS1UUf6iCUqrv
W90+8QKfPvHAHbNtZo9il7LzbsMoSZ9fwaFI5u/uFM/8vTOM+cx/rTEeWanT
OP8af8v24xRWbDPW5V+x5yhr7xI+hntvmN/X2rbRnwu6OFpRJjN9yXw78cfI
lfYrm/qPJdlyrur6uGw6a2Nhrj5OEny6a5DGGc+OAwAAx6B4Pfvc9Yw3TyR6
UKu6tJcvkyYpm/Hsi7E+HrgF0nHL4dqfnaqETcNk51gbz9gvTltzit7Xf/bG
vERaPG+wKH23GcmUqyQtp4cUHbOE2kjK0OaLSNLclMtzG82bIc7z3SUFVCTK
8wbNm9BfnGYCX9duS0rNxKSWZgn8d9xN/u96XSIF5Rani74myedmKb3pZ7qf
JsYwNz+Y5u3YYkyj+x1gGEWc/c6Yh2bHNP1ngTSruJYys8NM2ynAj/OucTfr
qstgcZqaczS8C59PvQHbqEC//WN/fpuh3GnZ26ib9NhDIymtRvd5nMCnjy+4
oy9/MB/vMHPxtl5FTFvsv/bQ+Hdusc6nb2PKkKD36XwfvE+5Nx8qOM5DCpug
v+fBP4z2196h8YY4fZEs6WO8rGqba6do/Bf9TdK1GRpGCdL+U1dfMtNOh2uu
mPR7tv9MybxSZxkLjuh+n2jsHygSu/+8I/cVnavdxofRcLk+aG0sLNTHmddF
+HTnI/eu9OrqarWLBQAAHouSd6exc+YT56xj/PB+oh/uuq20VVVcGeHZgZpI
xy3Fd392om7QOKNXG0tRZZmC8fcwir8jSHullLrK+Hmh3oiosD0to9iIwWbT
sb5kn5V5Dsu8oc/zIYUavJYZdWV8urm4xEfr/HGjt5ZQCpPX6uk6n9B6QjLl
GdPVCu4X6E9RVyX53CilNwR1yDbUNdTUm4jEztnr00YJ0o7Lv0OxS8zt2502
So9vRRmz8yP5PAKm0W5JnA2xP3Amo87jxoYK7k8vekjFZ/aI0g6Mr3J4/80u
0vn0WKafxofqfHq23fkyMRsQyMUr9CTz950KeoetQ9dpFCsbY33962qbG/p8
zKneNNp5x0z+cn1Jpp0s9fs284rrLGN2vqmPN+iL7Dv2n6uGOlodC8v1cea1
UXo84FjwrnQAALAfu9azRyZQSXEp0fc1HintpYuk2Z1FA4db79uFnh2+HShB
OnY5+M3PTlP+iUR+jP15BrPtHo0VzLGO3X+HT3+9lF4XlS2QPo3YQh/1Fo+v
d9matqqYugj8wpz8K5RzvoI+FZRj+pFa2Tw/CllCr7fgt7UOLtaVtaqAWgvS
dpkeSXNCxOsGuoSU2hm/ezT9Ld4Db74i+VxQXs6/6LdHh4p9TqMB0+jz8cJt
3SmiyjTtWMan558upknBY6mRYP+PQiNpbGgyJd1WVkY+9v1p/RX5cu8T+Pn+
EcW07/odisvYRgMGLKG466Zlnb6/mD4XtUuBU/rvvkKdT49m6h6n9+n7nHAc
q86lOtpmc8g7gjYeTAsySmn99jBR+gHbq+Tzl+tLsv3rHk0ytvcwWn+6ljJO
n6IFTLk+jT5VZxnzz5fS9JBImh6xjcYOqCcobyCtOP3QjnOV6QMDPqRGLaZx
/cX6WFiujzPbEz7dueBd6QAAoAzF704bvojC1+5g/O0Fovt3vEpsnTS793F1
xFw7cCbS8WH+1z85TVErBxmPMzrvLrctYSv/zLSGI9Mpx5Bee4ReE4zR5x3W
pc+vLqLOAq8XWf2zTWkzD67l6/teLCVX36bkS3dpi6AcI9Kvm80z52gs/1tD
l7WUymwT5fnWZsrU1yFhJ78Ou/P/b++846K68r+Pfz2v3+5mWzbGxDURLCjF
EqNYY4uxRLLZJJpojKagxoq9NyxEVBy7CNJEio4ggqBSFaKAAioi9lhGo+sv
uomJMXny7H6fe+/M3DZ3hmlMYT7v1+vzEs9877nnfM8ZOJ+5Z+5dU25j/h7T
PJEHjmL7LX5d1F62XTkKOe88I52OcuVPacXYJqKxeKAwPg90dVcJeWD6lm9L
Gy9li+ZaCCVolNudUxgpxPUOoRXZNbp2K88lsXwmpvJ9V9Kh06W0Ii6dVifp
lUqRJ26ZNQbace5Lu+//SgkbGJ/ut9XkuRpexsbmMc0cKuRk3okf+GP2Rgmf
H3UyNieV5pLi/HpAM0WeefjyVEq49IOZbRTrB1o8VriO3WtNqSjflr5XvWh0
Up1kTpqfC3P60zCCT2842GeuyfOLe8cBAIBx9N81t8SDspq1ZDup1blEPzzw
GGmuXuL6DM8OGgL5+iXv4a8NovyHt2ic6JrnqNgi2pJVSuuj5onOP4qi7+ji
75TTQLH35et5QJN7CV5wxzeWxaalGa7Z5Oq0rNR4nberROXbKIspU6eHCx5j
fbnQ52+F2J5rym3M3yOaM1TI0447stfF7e2lbRdbHrNe8LPTGY+ij4/eIvLk
BQ8MYvVlxuqtv43afBttI9sH+djp6s+/WkQ9DcYlkCan1fF1idsqVujJpybz
uH2N4XdUvcammjUGWTqfHv3trxS3vh/n003lo6FlbGzy79XQe17K45BVIHwG
4jMx3ex6jZ1ry5pgw89KPoikxG9Mt1GsxNjpouPnUbKu3Kr3aq9IyTkszUV9
/Wkowac3DOz3z+W5HTdunLObBQAALoXVz04Lns14821UVnKK6Pv7Hi/NlTpS
78/hZIlvh2e3nF9++YWePn3K/ask9rXffvvN2c20Gfka5hizZmwIZYuuQ5vS
2PS72mOYtfcAkU/O1tVzlPHeIX5N+HX39m8si90dJd2P7t2rL3n7BfJi/eB0
xqNK6mT8Raa+Lwrl8SKfwfp0vt+MT9fHsj7dlvzlMR54Ou+BAyns7FNpDNOu
ngrtjRL52Ulsv0yUK8Yay4ORNs4W+XRubESvp6SJPpNh6ko3UX929VF6t5d0
bnCfNSi0VSLGp+0z0cao9YY+zGtsulljkKnz6VGMT9+t8+mm8qHX/oJsmp1U
zs9Lu8mcOSobh0yxNw3NNr9eI+dixzxyw3TDnA41Pb68rhZRR/HnLCce8a9Z
9V4dKjuHhbmotz8NJPj0hkHp3nEAAABs2M8esopUW/eS5vJFon/fg0yIzZF6
/2EuZ5Z4dvh20/z3v/81y1M2hr/58v7k/uvXBtHGZQr+SEljUymTPeZ2OfUX
ra9XVT3V1nWliHqIyjfesCw2/bhoL23oUeNtFtfJekoT5ZI6P0jUtp9RQqpw
PbDH6nIbc/gDzftAyFOHZUWS13ftFHkaUXt3iPzsxPwHfLxSuWKsuL9DYvi+
KesRzeTvCTCKdtwTXkuvyBaNBeO5mNxnm8qzTvurymniWGGt3X9zlUFbp6am
C8+OZzR0Z42JNj6l9BuPKPP2D5y4n+/Vl3tdH45rfTrbr13rtfve5e1V0pbV
jKdsEkn77f2+Mjo2j2iq6N4Mcyue8sckiD5TMjonlcaknnHKvfeAtuyJpA5e
ovG/Xd/8eSSZ0z1Wlyrk24b3qi25MNYfe4+hTo3t74orgGelAwCAFGufnTZr
8VZSbUkieqyBrJTm0gVS78u2yLPjWrsy//nPfzzWp2c/+LUBdI1G8OfoS2GV
jyj91iPaf53Rrae0tzhG1IZ3aMN15phbFdRP0ra+NGV3Ko0Q3xvOP5z2PrAs
NrMyXdLfj3eXUty5WxRXWkbLNoVT/yHLaectWZ3M2n+/vi8K5fI6h6xOpAWr
dR5At9e/O+MDbM1jXGKo5DyBE8NpKeNRp8yXXlsesruOP2brOuG1CXkPTJYr
xt4op+6ivH66I5WmLIuhXbeU2viIQvmcB9KI1dtoyrpIGvGJ/DOavrT2ivF8
xrGfb/SaTktzayj1+gPaoBL63X1dlUFbp5T+QHsPzJPUv6bW/vM4vXgbNz93
Mj9HbwrmfPp+M47buq6v2bEWyejYPKWwCR2EfPhNp7C8KtqQGEneonH49NBd
5XqV5r5CWdbda/Rxr0D6x+p02nnuAaWeKxXdV30Ubbr1f03On72HwiXvkUD2
fbMjkUI3xdDaike2v1c5mZ8Ls/rTIL8f4dMbAnlOce84AIAnYt1+9lmMN99C
ZcUlRI/uQHaWpq6G1GlZjGdfyQme3XLOnDlDpaWlVFNTQ6NGCZ5g9uzZktfc
HflaJvP+L3bX/lKRDx+yjVINYm7SqPZCGz5IuUqZN8upbz2fkQQnXtUeb0ns
/Z9o0YQmJmL70rrrTNz1MgoSrf35NjPnEpfv5cq/o2lDTNXpRUGryuyQy6uS
PCmqfTjFi47ZvE7wyCF590XlowzKlWM1FGKw/zyEtt1Uat93NGlIPe1j/Pus
PI1wjEKeI1f1M3r8tNLvFNr6neG5349WmGc2SKOheRO01/VDUgpp1sS+XF+m
5d2s99jNOp9u1/bUMzbpZ9JNj8MQ/dxVkNLcVywroUBj9b+fSPvraWPkKuN7
bAbvqLP9vaqT2bkwqz8NI/h0+8J+B12eUzwrHQDgCVj97DTGm6s2JzLe/ATR
d7cgB0pz8Rzj2w9Z5dnZ/RGe7tvF++fu3r3r7ObYFflaJuPbX+yu5EJh/2pw
Qp1ijEol+MaujKfN+KZM5L0DKXiMdE0frCohtf54S2I5fUsLl4QY9J1Vt2mJ
FM/G3DlPwV46jzAkmpL1x96sFM7FrN358mvn6SOZRw2OiObLuD7ZI5/fXKWZ
c5W+mx1Ig5ak0u470vgdMdP4mC8Lv1PM9xRdubHY5JJUCpCcaxpt/eZXhfZ9
T/PGKzx/un0gdXs/hL5QZdGua7JjFPKcdvoovWXweURf+iK5znS/zmaJ2jmP
dt2xQ771+Yow/izwtfI+MfOxmylf6PWO4THWvrdMjM2eknR6q6fh+fvNTdXO
cWNSmvuK74fvKWy14fsoYEwkd7+2+tooHkO5gmP0Y23De1Uk83JhXn8aQvDp
9gPPSgcAeBr675pbup995BcrOW9O/3sTchFpas+SOjWTGxvsjzeP7duF5zk3
ts/k5esZ9b1fXEM3yqiPvl2DmbU3U5Zcp6Hoag0l3bAhVqzb31NCjTYutu47
Sr4tj/mJ0m4wMjiWKbv9k2KdSdx5b1LCjZ/qqcNG8W2/SbE19xXabm9pz8ed
y+51K+co+ep9itX1z+75a0jdvknLo1NpdnwqzY9Pp8/GBHJ+fgLz83y2PDqL
Yuw6XqbHJlk3J6OZmCSzz6s0Jkbmsuh9lHBV+X1h8/yx+r1qRS7M6o99BZ9u
P+T3jmOfnQ4AAI0N9pq5pc9O4/azL9rE+MCDRA9vQC4uTW01N1YjvwiDZzeB
J/l0dp3rEmK8d2/ee2+jOHvFQpCDtXFtMDXpGUN7XKAtkGsKPt0+4FnpAIDG
ivXPTmO8+cJNVFZQRPSv65CbSnOhipM6JcMi3y727Owcaox4kk9PufvMNXTl
OPnx+6Y3UIy9YiHIwYpYq/1+epwLtAVyTcGn2w6elQ4AaGxY/ey0L1aQShVH
mppKogdXoUYodmzVyencWHv6tXZP8ulJmmcuon9TeFoKTd6aQDPTz1GC3WIh
yLEK/6ofeTXZQFEu0BbINQWfbjt4VjoAoDFg9bPTFqoY33aA6P5lyMOkOV/B
jf2Izz3Ts3uST0+48wyCILvqR4q69m8XaAfkqoK/tA2le8dhvzsAwB2wej/7
8Jk0a8FGKsvLI/r2EgRx0pwrJ/VeNTc3LPHt7uzZPcmnx95+BkEQBDlQ8Om2
wd4rTpw/PCsdAODKWP3sNMabqzbGkuZsGdG9ixBUr9i5ok7az3j25RZ7dnfx
7Z7k02Nu/QxBEAQ5UPDp1qP0rHRcSwcAuBpW72efH0mqyN1Ed2shyCbdqT7F
ePZ9Fnl2d7jW7kk+PYpZM0IQBEGOE3y6dSjtd2fv+Q4AAK6AVc9OY/ezz99A
6j1pRJoaCGoQ3an6mptjIz9b5vaefd++fR7j07ff/BmCIAhyoODTrQPPSgcA
uBLW72efQaoNMVR2JIfoznkIcrjuVJVa7NvFnt2VfLsjefjwIW3cuJF+/vnn
Bqlfvj7c+s3PEOQxirzwkCLO/i9tvOr8tkCeK/h0y8Gz0gEAroDVz05j/JBq
wy7SVJ4gun3WLVWVk0JNmjShQ7GbGqT+kcPfIr82Pk7vp0Q3yunZDRdoRwOK
nZPqxJRGca29oblz5w63/mjWrFmD+HX5OmfTjZ8hyMl6TGEll2lJUS0tL7lB
EVca6DwXT1Ggbt63Xn7SBfoNearg0y0Hz0oHADgL/XfNLfEw3HfN560jdUIy
0a2qRqHK7L3c79+s3aoGqX/E229S+9beTu+nVqepJnEOdeD+5rxHl644uz2O
kebMcW7OjvxsKTy7Anqfrpe9/bp8rRN5/SkEOVVLtn0umZOtlx5vmHPVnqQu
unMELDvp9H5Dniv4dMtQelZ6Y/tOGgDAdbD62Wlvz+C8eVlOFtHNykanyqwk
nU/f2CD1jxim8+n2rvtaEV0qyKbfzIx/cnwnLezRRPQ3py+V1zo//46W5nQx
49n3chr5qfm+vTF7drlPt7dfl9e77tpPEORE3aP33pTP9zm08NpTu59r/YWT
9JruHP5Lv3aBvkOeKvh081G6d1x8fLyzmwUAaGRYv599CanW7SBNRSHRN6cb
tSqz9mh9ekxkg9Q/YthAxqe3tF+dF3KocNNU6s/97ZhGj+uLv5RF6plDFHxY
X6q64Pz8O1vsHFfHJ3Fz3hLP3ph8uzGfbi+/Lq9vLbNmhCCn6WQmNVOY5/88
/C/F+PBLT4Wfz92jpRW3KKz2B6P1h9f+i4tZXsscd6maOuvqb8/4dKf3HfJY
waebD56VDgBoKKx+dtrcCM6b040Kj1LloUStT4/eIH2troBulRwyqnvVJWbV
z/t0G9v55FQyJc//p+RvR/9JG+hZPcfVrO6ijR/0EUVMGiL16TXOz78rSVNe
YLFnbwzX2uvz6bb6dXk9a64+hSCnaUbk54rz+8UZOdLYumrqpXut09x4Gjnj
I0l81yX5tEpS9y0aOWm4NOZL4VysT3d23yHPFXy6eeBZ6QAAe2PdfvZQzpuX
ZR8k9r5inqrKQwkiny6U16x+w7Rv6T6fnphRv+DTrWvfvbytFDHqNcm5J84P
o5pThebVUZNGydujGD9fTv8vb4lQT5M3GJ/u/Py7qjTl+Yxn38N5dkt9uzme
151lqV+XH7/yyk8Q5CTdpGFB+rk4hb7MP0je/Nz8nEIvimKrvybfet4LA5Jv
6uK/p08mBpiMbbe41AX6D3mqnP13wx3UvHlzgzI8Kx0AYA1WPTuN8eaqdds9
3puLpezTT1DyKN06bNISOl+UTGvbS393b047bFb91vn0E3RpbxhN6C46J+Or
NzN++16d9X19kjtfUh98uvkS+3ZP9+l6mevX5cetuPwTBDlFS4v2CnNx3EFa
fvkBDQkS5uaQfXf52OXnv9bdc1OvAOq9eBV18BXKXp1TrI2tyBP5fcaTT99E
7y2SXrdnfbqz+w95rpz998Id9PzzzxuUAQCANVjr02fNWcv49Ayi62UQo8rM
eO53cVb0eqH8chqNYX9Hd59Pz5j/P0waL/m9/fGqBLPrHzF0ALVv1dKs2N8u
5lLJxin0D9G5OgwaR+oDaq4dtvb1SY7Mp593fv7dRZqyPFJFbOfeQ/DpWlnr
05de+gmCnKKJK4S964PTH3Bl0zdP4cuaMt59sT7+3Nf8M9XY35cf5GjjFx+L
F+Zz0Gaay5TNP7RZKBsYRfN1dUyPFvYw+S4qdXr/Ic+Vs/9euIPY76Wz93TX
3+sd+90BALaiv4+7bZ79lMeqMjOO+32cFb1OVF5Mjyty6Anz829Fy6W/yz9a
wZWbW7/g0+uLLaCo7sL92CcsDaeaU8fs2tcnOfOEfnA+3fn5d2Wp4xIZb77N
4u+qO3ut0dCydd/7orqfIMgJukZ92gq/Y3tuyqNxScU0ev0c0fz8iELO6uLP
fk0B+nLGe8/T13O2QlS+meYwZTPiV/F1tF3+tXDOC0JsW8anOz8HkKfK2X83
3EGsT9eD+7sDAOwN69mt8e1az/4VncpKJw3rDa+d9BhVHtT59F3rDF+vjdNe
V+c1lq5fUqindg9NYF9/czLdk73G+/R625Iv8ekT5y2nmhNH7drXJ4fnCn1p
0oeqzjk//64kdu6rYxO49wLuI2e7P9cjr2d+3Y8Q5HDNPhpr1jzvHX9Te8zZ
UvLXl3fbTDP1dSmUT9wkXJNvvbyUP+e8C+V8bJtFJU7PAeS5ks9zAAAAzsW2
a+1a307XShu1Kg/G6nx6hPS164dpl+QZu63oyMmvFet4lq3zv90X0ZNr0hit
T3/VvPbUHqaSraHSfe9vjiR1ajI9u6Z8bktk6NOdn39nS3PqKKkittLIzxZb
9B5h31PscxXY95i74+jnss29+CMEOVxjZg83Oc95jUyimewx1aXkJ/Ljofq6
FMpDD4r2vQ+P1R7PaOKuxYJ/X1ji9BxAniv4dAAAcF1s9uyHDhBdLW10qszY
rfXpUWsl5SVzpfdYj0jJZcoPUHxoKFWdKebjfjubS/eO76Vy9S66Xl5oUD/v
0y1qVyFdSllJM0T3N2J9dUTkdrp3wfq+PsmeI6mv6myJ0/PvDLFzWbV2q1nf
NReLvWbOvocaG8Z8uq3+XI+83lm1P0KQg1VH3fjffW/Qe/n3aXrVfZpawajq
3zQxY6dojgbTqIofaWZVKbUX+fGpurqUymfk75PM8Q4LYil4ge4ae1ttWasF
pS6QB8hTBZ8OAADugd6zs77D8v3x4YzP2c/4nZJGocqMGJ1P/4ovuxUrvRfY
jMgkrrxqZW+tZ1fn8LHXI98S4mLVBvULPt269j08upUiPu0tac+E0IVUdfyI
xXU9Vk8X1dOZCsudn39HSHMql9Sxcdzc9aT97OYi9+n28ud65OvD0As/QpBD
NTlL5MMHbKZJBjFXqXtbYY52jaqj6RWl1Erkx/ljKqXlX3Ll92nQANPX6Vmf
7uw8QJ4r+HQAAHBPrPtO+3SaNTucU1nmPqIrJ9xSlRnRWp++8yvu/78Vh8ue
xeNFC8MWUMS43ry/LTkjqqMmRrdPvRUdKi4yqH/EkP5an25jO5+VJVHy3Hek
12zGraFnV46bPvbiISrcGUbxYZ9Tf/na0XcQbf5qGR1KjKffXGAs7CnNyRxS
746jkZ8ustibN5b97Oai9+n29ud65OvDqTU/QpBDNTF9Cz//Om05rxgzatWH
fIzP/FKaeraKOunnbf+dNFEfe6ac2urL344VysurKKi/dK53WrqTL+PqdIFc
QJ4p+HQAAHB/rN8fP13k2Y+7jQSfHs79/0l2PffrDppID0XHP8vXP3fnA7p+
0bB+wafbqc01mVQSOVHruYPm05MrxabjLybTDFP9YTVwCeP366nHDcTOPdXa
zdxctHQ/O+vNPZWHDx82iD/XI59vk88/gSA30WP68jQjpfLqx4rHjC/9hsYV
XKEvTj+upw4Icpzg0wEAoHFhm2dfw/imNKLLxS6tyvRdOp++xqrjr28I1v7d
+3AFPVN4nffp9m57bS49rCpwev6cLXXMblJ9tdmq/eyN8bvmroh8fTiRWTNC
EARBjhN8OgAANG6s2h8/TOfZD6ZyoktFLqXKA1Fan75jjRXHH6XkYJ332LxX
MWbEkL5an+4CfW0M0pRmc9585LiFVu1nb+zfNXdF5OvDkHNPIAiCIAcKPh0A
ADwHq6+18749hfFdhU5X5YGdOp++2orjMylKd0/2heEzaYxXL6o6J43R+vRX
nN5Pd5amNItUX22y2Js3pmenuTPy9eHnZ59AEARBDhR8OgAAeCY2efZZq6ks
g/HsdQVO0c/VOVSTGUNPzmRZcfwxKpndk/+7t3J7rEHM7cIUupIb77T+uavY
OaEKV1k0n/TfNcd+dtdCvj4cV/0DBEEQ5EDBpwMAANB7dqv2x3OePZnxaflu
pWeMx392wfntcGdpSjJJHR3NzQFrvmuO/eyui3x9OKbqBwiCIMiBgk8HAAAg
x9rvtGt9+yoqS99LdDEPaoTSnDhIqvCNNPKTBdjP3oiRrw9HVf4AQRAEOVDw
6QAAAExh/f74aTrPnsT4u2OQG4sdQ9abs2Nq6X52T352mjsjXx9+yKwZIQiC
IMcJPh0AAIC5iD27ZdfaRZ699ijkBlLviuLGDPvZPRP5+vCDM99DEARBDhR8
OgAAAGuxbn8849lnriTVmkgqO7CH6MIRyAWkKT5A6qidFu9nx7PTGify9eG7
p7+HIAiCHCj4dAAAAPbApv3xjG+HZ3eON2c/L7F0P7v+u+ag8SJfH75T8T0E
QRDkQMGnAwAAsDc2e3Z1IlFNLtQAYq+Zq1ZvsGo/O56d5jnAp0O26O3iuzS0
4C69fcr5bYEUdOoBDSu4RcOKH9ihvu+4utjxDnZ2vxqZ4NMBAAA0JKxnt2V/
fJk6gTTFasZj5kBWiM2dOmoHl0t81xyYi3x9OLzsMWSjhuXV0UB1FfVXn6eB
uXec3p4G0/FiaqabN8/PLHZ+eyAD9Z0/TPfeHkY9C7Vlb+7eRs27DKNmb3xK
XfZ+Y3Zd/ZaM4H9PBCSYfxxUv+DTAQAAOBKbrrXPCKOy/QlE5w9DJqQp2k+q
1etp5Jj5Vu1nx7PTgHx9OOzkd5AtKjlD3uKcNulNPfJdoF0NoeIiaq7r54sz
ihx+/qH5l6l/Shm9sf8cvVXiAvlwQfWZq/fWQ6mXbh72mjGUn5/NF5dZUZcX
+cfdcHrfGpPg0wEAADgL2z17PONLsyFGbC5Yb27Ns9Ownx3Ika8PB5c+hGzQ
wNj1Bjltubba6e1qEBUW0Eu6PjYNLXD4+XuE9uJz3Cb2qvPz4YLqOecD3qf3
OKYrE+Xt5YUnrajLi9oh33YVfDoAAABXQO/ZWd9o8f74GSsYnxpHdC7LY6Qp
TKMDO7Zxfcd+dmBv5OvDQccfQDaoyxg/g5x69dlEA5TiT9yV/Nz/8BXqy+hN
W2N1ejP/OvU7VEv9sq8bjXuzWPh54JErXPyAgrv11tk3n/l/USnv01+Ynmc6
N/lXqM/+SqN64/Ati3PdY/b7fI59Y64bjWNzpc+Dvcfbohwz42Y0v/q8Zl2h
Afmm8ljP+ZhzDDhcy80N9v89F+hzNISCjuhjrlOfpGLqkVRpOC/1c4tth6yd
0nxfMTqPIMsFnw4AAMAVse477VM536r17bGMnz3UqKT35iPHzLPYm2M/O7AE
+fpwYNG3kLU6WsjvA5eqJ72WIY3tuWK87rX3KTBiO73oI45/nzomXLMqltWA
jGPU+s2eBm1oF3lKiMsvoRa615pN2E7+n70viW8+5SANkPSvlvxHD5HEvDx6
DP/zC1OPmsxN0MwhCnkRqVME9TM717XUtqe8jvb0B7bd8wr5uO4REfSCj+FY
tI0oMVH3NfIf3l5bn4+fIObY54bH8G20NMcvjF5FPr2EMQs6qovJKaG2Hxjm
5q/DV1H3HFG78s8a5J9tY/vNZ/mYPru2UVPx673GUwv+nIxP19XXc/U0/ni/
3df543tv3y49ntEfhkdQ73z9GApzpO2uS7q65vJlf5t5zPnvQTcVfDoAAABX
x+r98UO1vr1sH+PZz2a6pdi2q1ZFcH2xdD87np0GrEW+PuxfcBeyUn22Lubz
+NKyI/TaeMHHvbSoVBLbdcZg077V6z3qmmt5bL/cAnrRRGybnRe1bcg+Qi+Y
rNOLvFXnde29RR1GtTcZ+7cpR0zk5gb5DdfG/WXURuq2p4BayfxzG1WV+bnO
Nd72P4zP5mKCFo0x2d5XVlUYqf8Ktelk7LOEMOpjlxxPpaBj2npeNjkG2jhT
+f+zrr/99u3lPkswXtdgej1b28fXRfNJ31b2eOXjelKXbP08fI8v9425Rf33
xZuZU6g+wacDAABwJ2zy7KHLqSxtN1H1QZeWevsWUq2MsGo/O75rDuyBfH3Y
N+82ZJVukP977XR5bEf+qbep9/YVQm47rqCeovguof+U5P33A2eRb+gUSVmL
Facsju08+S2+7E8f7qTuh+uoS9gsIXbgFurNtuFwjsxrtqMWkxdSU2+h7E8h
mVydb2So6c+i2OfHhVO7yaMl539+co7R3LxxpEh7ro7h3Ll7rJslObbpDOPH
KqlP3lXqvDScmvcUedeOU5icrCD/7dX0xqFM+pu4/pCd9NquTGr9dg/ReadQ
kJFx7BK2gdqEbiDfBQsl7fzdR6nMuW3JMeOrB/6Tfuc9hV4/fJteE9Xj5fUu
+W/Moc5hy+n3ovjmzLi+kVdHbfj9A6Opc2od9UwtIr8Q5m/C0iKu3R1Dekjq
ar10A70kGkuvJm/Ra4cM516r7TVcWa/t4XzZS3MyqdfhGnp94xZ6eeBCrq3y
43y3ZJK3ZK6oXeA96L6CTwcAAODOWLU/nvfsMZyoOsOp0uQnc97c2v3s+K45
sDfy9WGfozchK9TrYLbgDXusoR5MWe+jx0XXS9uRX/I1Pr7z9HcFj/PPHVw8
W95x0iC+/I+Tsi2MraXWPcTXdSup+75K6rHviNCOjgsoiG1bVrbIQ/ag9jG1
2n7EbhJ53zXUnSnrsXONUNZjPX/+rqtnCj5d11ZlXda2Q14/q2Gb+PosVZdZ
Ql5ax1zmyyXtHbCeeurKe+cU8M+R8/IaRB0P1jOmMZtEnpmJP3DThhyzn6Uc
F9Uvr+cS/9rr80dLxrXX0XPUuqMQ2+yLHdRl32WjdbXeVqvr73F6pYPQ/k4H
Deeez7Zz2pxtWy4a99HUbkMBnzelOSv53Eg0JyHrBJ8OAACgsWDztfbUaKKq
dIdIk7eXVCvX0siP51rUVjw7DTgC+fqwZ+4NyAp1/WqGKI+TKGBLBgVujKcW
gUJuX5iay8d3mvoP4Zrmjhq+PGjLMr78rxOzLIwtoRbehj5Kqu4UkM4cn5kl
fBe5xzrqru9LZq6ofDUFcX2bL/jxqVlCv7OFWH1bTUp8Tl2eXstWyOX6Zbp8
ma5TnBfvLdV8+WvzPjPIoVY11Ir3re2obUKd8fqziyR70psvL9G9ZmWOOyzj
cinUnyeqfxB1TBdeE4/r79+N5soCJg4yOM/vBiyjzsxxPXJP0aveoroyhbo6
z/yHwTkU87Y/jZ436Ec78l5VpJhvsVrtuur095+7Cz4dAABAY8Q+nv2AXcXW
qVr5lUXt0X/XHPvZgSORrw+7Z1+DLNXhWmrdvz7vxqjlPOqiO6bDFJFX2naO
r+v1SMHv/3lCpmWxGUdl+6x96U8tfel3vBhv138tvc4en5EpfHe6w0ptmZHy
Tgs/5ev8y5RMod+HDvOx+rYaz1EF+QRJ2+a7RznW/2NfLualpSdM1inOS8vN
lYrlknYdPkfeHUTnj7tktG7/z0T7yIPWivJjZY67i3Isf83rTQpUC6913bxE
8OIjY/m2+0/5VHReUb2HjvL33WfrCsgQ6uo44x8G5zCWt25xe+ilwCYG5/DW
xYiPk6jDEn5eQ9YJPh0AAEBjR+/Zrd4fn7qLqFJtsTTH9pB6m4qrw5rvmmM/
O3AW8vVht6wrkIXqmpJMf6zPo+vks6uGOyZg8juC9x2dSF11dfl9OpAv/+P4
DAtjq0VemPGhSSbafSBD2KcfGEZdTJR32RLGn6dJv0g+ttPy6UK7dG01pvaf
dpfkocXaM0x5Mfl8vJj8Uy7ycV2SSilApSa/9dnU+aDpvIvz4r2lRqhDJbTX
a/AWPl/dsvJF+94Hkv8+5Xpf3xEpaus71C5F/Lodcqyrp6Xoc4tWu4QcdFow
znheD54h/yWLRPPtHQo4UC35DMRnhzYXXQ/mU/NAw/6K8/aq6oxBuzvHZtCr
g4P4mL+FZhsc13LFTsnnFU1nH3H6+9CdBZ8OAADA07D2O+1a376M8e1RjA/f
ryjNsURShYVjPztwa+Trw9cOXoIsVOAi4Trncx9FU+f0c9QptZJT5/Svybuv
kN8/haRzx/hNCpbk/Y/BK8hn2gRJWfPwkxbFdsmspdbBvqLrwHOoXVQhdYgr
pPbhO+jl4GBqNi9H2+796cI+58AV1EnfH6XymO2Scz0fsp58QnResqW0X4r5
WT5NcnzTmdo2tJ+k/Zyh+boK7v9dMs+Rz2B9XBC1SzWd9/YhwucUzw1eRD6z
FtErKwsN2tt0UjT5bUujFoNFuQlcRB0V6uySeVLkbbX+1mfRZvKeFU4t5+2l
TvbIMXceWT0tx1GbyEPku2gh/Y98XNML6eVAX2oasoP84yqoU1yayCO/Q+33
y+ryHknei9ZT05bSfvjp8imeT69EVghjFDiOfNblMPO2gnynCZ8V/HnSIcPj
tp2jjisniuoPoraJzn8vuqvg0wEAAHgyNu2Pn8549pSdnFhvjmengcaCfH3Y
OeMiZJFO0ysiH/73DacNYgJXTBXleDwFMGXtvhxukHupxpO/Wnu8JbGddm01
Gfu7sanadiWL7uEesJw66traKU1a3kHfx26mzu9Ff/xCrZgftj3/I4t98cs1
9FLwAN3/u1GbPUJ8x426+5kFzKbAenLfYe1sg3b8dWY281o1+QSbbu/fN5Qp
15ucKrm3vVQjqb3a9hyLc2NyXLvp8s+0yegz1/qu4+rtqFpjui6vAeSbrJ9P
A/hyfR58v+hm9NhXtp5WOO40Ny9aiOdF3zUGfYTME3w6AAAAoEXs2S317djP
DhoT8vVhxwMXIAvUQV1BLbrq8xdC7dIUYpL30V9Ffqlt0gXynSBcm/w/gz6R
ekP/T6hV9Dn+eEtiWQVs2krPByh4rlcH0CsRJ7RxaaJ7nL2+igLVuuOTM4S2
9ongyzskZVGzrtLvLr8wYRVf9qfP9inmJzBylUn/2MR/Fvmrhfi2n2m94HMf
JpqR+5PU8l2pv2w6O5d/zXvMCIUcDKeW+hwoKU1+rzuxhPG1KcdmjNVfPtzI
56WDupJafWbYlz8MWsB4b6GudvOlz+pj58Yrk0Mk846Lm/2J4LcjK7TjtGM3
Pf+qvB3dqPniXKF+heM6RkeJPkMIIT+F+Q/VL/h0AAAAQBlrr7XLvTmenQbc
Dfn6MHD/echCBaRUU0ASI1Nx+6q1cSna/7cZL1wjb77xNPP6afKLKqD2MWUG
x1oSK2lXYqkurpgC9pxWbpNSu3VtVarTP66Y2jF1+iVVm67DCnXYV0rNdZ95
vLi0wPz8M/1k++ifqNDHlNPMawVcm9vHKbxu69hbm2N5Pbq8tmP7kWIkjumL
Xwwbx/ZVeXwCU8q49vjuLuXPqZ13RuKN9Ud0PNTwgk8HAAAA6scSz67/rjkA
7op8feifehZygFp9MYzPebPwE3aLdWcFxKfQc1w/u9Kru53fHghylODTAQAA
AMuQe3b9fnY8Ow00FuTrQ9+UKsgBajn2dWGvdlix3WLdWe1ik3V7qPvRi2NH
k1eXNU5vEwQ5QvDpAAAAgPXg/uygMSJfH7bdewZygNpsSaWXJq9iFEkto8rt
FuvWSjgo3B/d6z36u+qE89sEQQ4QfDoAAAAAABAjXx+2TqyAICfqFPnsKnGB
dkCQ4wSfDgAAAAAAxMjXhz7xZRAEQZADBZ8OAAAAAADEyNeHLWO/hiAIghwo
+HQAAAAAACBGvj5ssbsEgiAIcqDg0wEAAAAAgBj5+vDl6OMQBEGQAwWfDgAA
AAAAxMjXh812FEEQBEEOFHw6AAAAAAAQI18fvritAIIgCHKg4NMBAAAAAIAY
+frwb1vyIAiCIAcKPh0AAAAAAIiRrw8hCIIg5woAAAAAAHg2zl6PQhAEQVIB
AAAAAADPxtnrUQiCIEgqAAAAAADg2Th7PQpBEARJBQAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAADiL/w9sdZC8
    "], {{0, 718}, {1002, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->{535.78125, Automatic},
  ImageSizeRaw->{1002, 718},
  PlotRange->{{0, 1002}, {0, 718}}]], "Input"],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{3.8499021590298357`*^9}],

Cell[BoxData[
 RowBox[{"Instructions", ":", "\[IndentingNewLine]", " ", 
  RowBox[{
   RowBox[{
    GraphicsBox[
     TagBox[RasterBox[CompressedData["
1:eJztve1bVEe+98t5eHGu8+r8C+fee3YmavTlvfeeiQpv7pmJCtd9rrNnVJLr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       "], {{0, 266}, {574, 0}}, {0, 255},
       ColorFunction->RGBColor],
      BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
      Selectable->False],
     DefaultBaseStyle->"ImageGraphics",
     ImageSize->{262.1640625, Automatic},
     ImageSizeRaw->{574, 266},
     PlotRange->{{0, 574}, {0, 266}}], "                    ", "Shift"}], "+",
    "Enter", "            "}]}]], "Input",
 CellChangeTimes->{{3.8499023464082947`*^9, 3.8499023467180357`*^9}, {
   3.849902541591395*^9, 3.849902550003584*^9}, 3.849934536854948*^9}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{3.849902213436543*^9, 3.849903157313298*^9}],

Cell[TextData[StyleBox["Example A",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 
  3.842293134812916*^9}},ExpressionUUID->"b20cbaa2-b41b-4afb-a5be-\
891607dab6b0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   FormBox[
    FractionBox[
     RowBox[{"t", "-", 
      FractionBox["1", "2"]}], 
     RowBox[{"t", "+", 
      RowBox[{"2", "\[ImaginaryI]"}]}]],
    TraditionalForm]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"zeros", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"Numerator", "[", 
     RowBox[{"r", "[", "t", "]"}], "]"}], "\[Equal]", "0"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<AZeros.m\>\""}], "\[IndentingNewLine]", "listzeros"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
   3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
   3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
   3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.8422932731737304`*^9, 
   3.842293278005754*^9}, {3.842293854831499*^9, 3.842293871386408*^9}, {
   3.8422939647467413`*^9, 3.842293967252646*^9}, 3.84990222468021*^9, {
   3.849902575374688*^9, 3.8499025806945343`*^9}, 3.8499032320763483`*^9},
 ExpressionUUID -> "71b0e96a-3d83-44ac-8e31-5426e50d8ed1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"t", "\[Rule]", 
    FractionBox["1", "2"]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.842291889733539*^9, 3.842291915071255*^9}, {
   3.8422920596256094`*^9, 3.842292075027014*^9}, 3.8422921995066347`*^9, {
   3.8422923904141936`*^9, 3.8422924107581663`*^9}, {3.842292529528334*^9, 
   3.8422925498418074`*^9}, 3.8422929688845806`*^9, 3.8422930542716303`*^9, 
   3.842293205200923*^9, 3.842293279255352*^9, 3.8422938752005663`*^9, {
   3.8422939541235437`*^9, 3.842293968901334*^9}, 3.849902373428577*^9, 
   3.849902531528109*^9, 3.849902612642743*^9},
 ExpressionUUID -> "e067008e-da83-4af7-85dd-0383e56268d7"],

Cell[BoxData[
 RowBox[{"{", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\
\\), \\(+\\)]\\)\"\>", "}"}]], "Output",
 CellChangeTimes->{{3.842291889733539*^9, 3.842291915071255*^9}, {
   3.8422920596256094`*^9, 3.842292075027014*^9}, 3.8422921995066347`*^9, {
   3.8422923904141936`*^9, 3.8422924107581663`*^9}, {3.842292529528334*^9, 
   3.8422925498418074`*^9}, 3.8422929688845806`*^9, 3.8422930542716303`*^9, 
   3.842293205200923*^9, 3.842293279255352*^9, 3.8422938752005663`*^9, {
   3.8422939541235437`*^9, 3.842293968901334*^9}, 3.849902373428577*^9, 
   3.849902531528109*^9, 3.849902612658325*^9},
 ExpressionUUID -> "e067008e-da83-4af7-85dd-0383e56268d7"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.849903164765332*^9, 3.849903167632615*^9}}],

Cell[TextData[StyleBox["Example B",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 3.842293134812916*^9}, {
  3.8422931687293143`*^9, 
  3.8422931693503757`*^9}},ExpressionUUID->"3ad2ef4f-d587-4f31-9e20-\
869c68776e19"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   FormBox[
    FormBox[
     RowBox[{
      RowBox[{"3", "t"}], "-", "\[ImaginaryI]"}],
     TraditionalForm],
    TraditionalForm]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"zeros", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"Numerator", "[", 
     RowBox[{"r", "[", "t", "]"}], "]"}], "\[Equal]", "0"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<AZeros.m\>\""}], "\[IndentingNewLine]", "listzeros"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
   3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
   3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
   3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.842293182622344*^9, 
   3.8422931839706736`*^9}, {3.8422932673200707`*^9, 
   3.8422932830463624`*^9}, {3.842293986868483*^9, 3.8422939963321633`*^9}, {
   3.8499022419347057`*^9, 3.849902245618848*^9}, {3.8499026026903257`*^9, 
   3.8499026071902847`*^9}, 3.849903224313816*^9},
 ExpressionUUID -> "9418e246-1596-449d-b914-06346efdf0d5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"t", "\[Rule]", 
    FractionBox["\[ImaginaryI]", "3"]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.8422931866157265`*^9, 3.84229328399513*^9, {3.8422939883443813`*^9, 
   3.84229400060588*^9}, 3.8499026161075573`*^9},
 ExpressionUUID -> "ce2ef127-4fac-4461-a248-6235e68248c5"],

Cell[BoxData[
 RowBox[{"{", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\
\\), \\(+\\)]\\)\"\>", "}"}]], "Output",
 CellChangeTimes->{
  3.8422931866157265`*^9, 3.84229328399513*^9, {3.8422939883443813`*^9, 
   3.84229400060588*^9}, 3.849902616124937*^9},
 ExpressionUUID -> "ce2ef127-4fac-4461-a248-6235e68248c5"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.849903170816228*^9, 3.849903172407393*^9}}],

Cell[TextData[StyleBox["Example C",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 3.842293134812916*^9}, {
  3.8422931687293143`*^9, 
  3.8422931973930235`*^9}},ExpressionUUID->"0b7ea639-e4cc-4aeb-b87c-\
28fb03f9d9de"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   FormBox[
    RowBox[{
     FractionBox["\[ImaginaryI]", "t"], "-", 
     FractionBox[
      RowBox[{"8", "\[ImaginaryI]"}], 
      SuperscriptBox["t", "4"]]}],
    TraditionalForm]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"r", "[", "t", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"zeros", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"Numerator", "[", 
     RowBox[{"r", "[", "t", "]"}], "]"}], "\[Equal]", "0"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<AZeros.m\>\""}], "\[IndentingNewLine]", "listzeros"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
   3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
   3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
   3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.842293182622344*^9, 
   3.8422931839706736`*^9}, {3.8422932188473063`*^9, 3.8422932240991*^9}, 
   3.8422932899103546`*^9, {3.8422933226096425`*^9, 3.8422933941372023`*^9}, 
   3.842294024102351*^9, {3.84990225133212*^9, 3.8499022555793962`*^9}, {
   3.8499024358098583`*^9, 3.8499024614872303`*^9}, {3.8499026325981216`*^9, 
   3.849902640850541*^9}, 3.849903179803619*^9},
 ExpressionUUID -> "61d1b991-989e-4954-8311-8caff36084a4"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"-", "1"}], ")"}], 
       RowBox[{"1", "/", "3"}]]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"2", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"-", "1"}], ")"}], 
       RowBox[{"2", "/", "3"}]]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.8422932251870394`*^9, 3.8422932922649355`*^9, {3.842293328823125*^9, 
   3.8422933977893114`*^9}, 3.8422940258364053`*^9, {3.8499024516887407`*^9, 
   3.849902465544483*^9}, 3.8499025137155848`*^9, 3.849902647462844*^9, 
   3.849903199625869*^9},
 ExpressionUUID -> "d2369300-41c8-4fe7-9e3e-5ba30cc2ef83"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>"}], "}"}]], "Output",
 CellChangeTimes->{
  3.8422932251870394`*^9, 3.8422932922649355`*^9, {3.842293328823125*^9, 
   3.8422933977893114`*^9}, 3.8422940258364053`*^9, {3.8499024516887407`*^9, 
   3.849902465544483*^9}, 3.8499025137155848`*^9, 3.849902647462844*^9, 
   3.84990319963795*^9},
 ExpressionUUID -> "d2369300-41c8-4fe7-9e3e-5ba30cc2ef83"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.849903203424407*^9, 3.849903206149095*^9}}],

Cell[TextData[StyleBox["Example D",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 3.842293134812916*^9}, {
  3.8422931687293143`*^9, 3.8422931973930235`*^9}, {3.842293425545861*^9, 
  3.84229342697521*^9}},ExpressionUUID->"742a7cca-ee68-4b59-9b74-\
17ac8e738243"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   FormBox[
    FormBox[
     FractionBox[
      RowBox[{"2", "\[ImaginaryI]"}], 
      RowBox[{"t", "-", "3"}]],
     TraditionalForm],
    TraditionalForm]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"zeros", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"Numerator", "[", 
     RowBox[{"r", "[", "t", "]"}], "]"}], "\[Equal]", "0"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<AZeros.m\>\""}], "\[IndentingNewLine]", "listzeros"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
   3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
   3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
   3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.842293182622344*^9, 
   3.8422931839706736`*^9}, {3.8422932188473063`*^9, 3.8422932240991*^9}, 
   3.8422932899103546`*^9, {3.8422933226096425`*^9, 3.8422933941372023`*^9}, {
   3.842293439816018*^9, 3.842293463705413*^9}, 3.8422940329007792`*^9, 
   3.849902274117015*^9, {3.849902665187276*^9, 3.849902669921616*^9}},
 ExpressionUUID -> "d7b43145-53bc-42c8-b233-5f397d6ca980"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{{3.8422934506454973`*^9, 3.8422934648044357`*^9}, 
   3.8422940342919054`*^9, 3.8499027299995193`*^9},
 ExpressionUUID -> "72165b6d-2801-494c-8cb2-74acf85d172e"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{{3.8422934506454973`*^9, 3.8422934648044357`*^9}, 
   3.8422940342919054`*^9, 3.849902730014944*^9},
 ExpressionUUID -> "72165b6d-2801-494c-8cb2-74acf85d172e"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.849903209551484*^9, 3.8499032122679873`*^9}}],

Cell[TextData[StyleBox["Example E",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 3.842293134812916*^9}, {
  3.8422931687293143`*^9, 3.8422931973930235`*^9}, {3.842293425545861*^9, 
  3.84229342697521*^9}, {3.84229347456431*^9, 
  3.842293475341224*^9}},ExpressionUUID->"17f8dba9-3aa9-42d8-b5d3-\
6e493c067c82"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   FormBox[
    FormBox[
     FormBox[
      FractionBox[
       RowBox[{"2", "t"}], 
       RowBox[{"t", "-", 
        RowBox[{"2", "\[ImaginaryI]"}], "+", "3"}]],
      TraditionalForm],
     TraditionalForm],
    TraditionalForm]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"zeros", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"Numerator", "[", 
     RowBox[{"r", "[", "t", "]"}], "]"}], "\[Equal]", "0"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<AZeros.m\>\""}], "\[IndentingNewLine]", "listzeros"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
   3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
   3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
   3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.842293182622344*^9, 
   3.8422931839706736`*^9}, {3.8422932188473063`*^9, 3.8422932240991*^9}, 
   3.8422932899103546`*^9, {3.8422933226096425`*^9, 3.8422933941372023`*^9}, {
   3.842293439816018*^9, 3.842293488858713*^9}, 3.84229404026731*^9, 
   3.849902279464581*^9, {3.849902673435223*^9, 3.849902677198738*^9}, 
   3.849903220298726*^9},
 ExpressionUUID -> "d9f9f600-65ea-4127-be30-183e1c7949f8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"t", "\[Rule]", "0"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.842293489981035*^9, 3.8422940413547907`*^9, 
  3.849902734530718*^9},
 ExpressionUUID -> "df5bb288-f1ae-4e63-85cd-85595addf24a"],

Cell[BoxData[
 RowBox[{"{", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\
\\), \\(+\\)]\\)\"\>", "}"}]], "Output",
 CellChangeTimes->{3.842293489981035*^9, 3.8422940413547907`*^9, 
  3.849902734547476*^9},
 ExpressionUUID -> "df5bb288-f1ae-4e63-85cd-85595addf24a"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.8499032666293507`*^9, 3.849903269881919*^9}}],

Cell[TextData[StyleBox["Example F",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 3.842293134812916*^9}, {
  3.8422931687293143`*^9, 3.8422931973930235`*^9}, {3.842293425545861*^9, 
  3.84229342697521*^9}, {3.84229347456431*^9, 3.8422935036720257`*^9}},
 ExpressionUUID -> "ba7c5262-0dda-4b88-a201-7c429b21ee26"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   FractionBox[
    RowBox[{
     RowBox[{"2", 
      SuperscriptBox["t", "4"]}], "-", 
     RowBox[{"2", "\[ImaginaryI]", " ", 
      SuperscriptBox["t", "3"]}], "-", 
     RowBox[{"5", 
      SuperscriptBox["t", "2"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"5", "\[ImaginaryI]"}], " ", "+", "1"}], ")"}], " ", "t"}], 
     "-", "\[ImaginaryI]"}], 
    RowBox[{
     SuperscriptBox["t", "6"], "+", "1"}]]}], " ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"zeros", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"Numerator", "[", 
     RowBox[{"r", "[", "t", "]"}], "]"}], "\[Equal]", "0"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<AZeros.m\>\""}], "\[IndentingNewLine]", "listzeros"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
   3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
   3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
   3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.842293182622344*^9, 
   3.8422931839706736`*^9}, {3.8422932188473063`*^9, 3.8422932240991*^9}, 
   3.8422932899103546`*^9, {3.8422933226096425`*^9, 3.8422933941372023`*^9}, {
   3.842293439816018*^9, 3.842293518178523*^9}, 3.8422940452897744`*^9, {
   3.849902745815884*^9, 3.8499027472122*^9}, 3.849902823396131*^9, 
   3.849903244740981*^9, {3.8499032872837753`*^9, 3.8499033342503843`*^9}, {
   3.84990439353581*^9, 3.849904400764337*^9}},
 ExpressionUUID -> "9d17b01e-c4aa-406d-beef-d19821b7a724"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", "\[ImaginaryI]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "9"}], "+", 
          RowBox[{"\[ImaginaryI]", " ", 
           SqrtBox["669"]}]}], ")"}], 
        RowBox[{"1", "/", "3"}]], 
       SuperscriptBox["6", 
        RowBox[{"2", "/", "3"}]]], "+", 
      FractionBox["5", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"6", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "9"}], "+", 
            RowBox[{"\[ImaginaryI]", " ", 
             SqrtBox["669"]}]}], ")"}]}], ")"}], 
        RowBox[{"1", "/", "3"}]]]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"\[ImaginaryI]", " ", 
            SqrtBox["3"]}]}], ")"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "9"}], "+", 
            RowBox[{"\[ImaginaryI]", " ", 
             SqrtBox["669"]}]}], ")"}], 
          RowBox[{"1", "/", "3"}]]}], 
        RowBox[{"2", " ", 
         SuperscriptBox["6", 
          RowBox[{"2", "/", "3"}]]}]]}], "-", 
      FractionBox[
       RowBox[{"5", " ", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"\[ImaginaryI]", " ", 
           SqrtBox["3"]}]}], ")"}]}], 
       RowBox[{"2", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"6", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "9"}], "+", 
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox["669"]}]}], ")"}]}], ")"}], 
         RowBox[{"1", "/", "3"}]]}]]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"\[ImaginaryI]", " ", 
            SqrtBox["3"]}]}], ")"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "9"}], "+", 
            RowBox[{"\[ImaginaryI]", " ", 
             SqrtBox["669"]}]}], ")"}], 
          RowBox[{"1", "/", "3"}]]}], 
        RowBox[{"2", " ", 
         SuperscriptBox["6", 
          RowBox[{"2", "/", "3"}]]}]]}], "-", 
      FractionBox[
       RowBox[{"5", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"\[ImaginaryI]", " ", 
           SqrtBox["3"]}]}], ")"}]}], 
       RowBox[{"2", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"6", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "9"}], "+", 
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox["669"]}]}], ")"}]}], ")"}], 
         RowBox[{"1", "/", "3"}]]}]]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.842293519423861*^9, 3.8422940465235195`*^9, {3.849902738494795*^9, 
   3.849902751600698*^9}, 3.849902826929854*^9, 3.849903338846883*^9, 
   3.849904406595252*^9},
 ExpressionUUID -> "a59aa2a4-436c-4fc1-9a63-38901275d780"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Unit Circle-\[DoubleStruckCapitalT]\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>"}], "}"}]], "Output",
 CellChangeTimes->{
  3.842293519423861*^9, 3.8422940465235195`*^9, {3.849902738494795*^9, 
   3.849902751600698*^9}, 3.849902826929854*^9, 3.849903338846883*^9, 
   3.849904406665156*^9},
 ExpressionUUID -> "a59aa2a4-436c-4fc1-9a63-38901275d780"]
}, Open  ]],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{3.849903249646511*^9}],

Cell[TextData[StyleBox["Example G",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 3.842293134812916*^9}, {
  3.8422931687293143`*^9, 3.8422931973930235`*^9}, {3.842293425545861*^9, 
  3.84229342697521*^9}, {3.84229347456431*^9, 3.8422935036720257`*^9}, {
  3.849903376295842*^9, 3.849903376854575*^9}},
 ExpressionUUID -> "ba7c5262-0dda-4b88-a201-7c429b21ee26"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   RowBox[{
    SuperscriptBox["t", "10"], "+", 
    RowBox[{"3", " ", "t"}], "-", "1"}]}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{"zeros", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"Numerator", "[", 
     RowBox[{"r", "[", "t", "]"}], "]"}], "\[Equal]", "0"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<AZeros.m\>\""}], "\[IndentingNewLine]", "listzeros"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
   3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
   3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
   3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.842293182622344*^9, 
   3.8422931839706736`*^9}, {3.8422932188473063`*^9, 3.8422932240991*^9}, 
   3.8422932899103546`*^9, {3.8422933226096425`*^9, 3.8422933941372023`*^9}, {
   3.842293439816018*^9, 3.842293518178523*^9}, 3.8422940452897744`*^9, {
   3.849902745815884*^9, 3.8499027472122*^9}, 3.849902823396131*^9, 
   3.849903244740981*^9, {3.8499032872837753`*^9, 3.8499033342503843`*^9}, {
   3.849903380836404*^9, 3.8499033955632353`*^9}},
 ExpressionUUID -> "9d17b01e-c4aa-406d-beef-d19821b7a724"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"3", " ", "#1"}], "+", 
         SuperscriptBox["#1", "10"]}], "&"}], ",", "1"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"3", " ", "#1"}], "+", 
         SuperscriptBox["#1", "10"]}], "&"}], ",", "2"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"3", " ", "#1"}], "+", 
         SuperscriptBox["#1", "10"]}], "&"}], ",", "3"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"3", " ", "#1"}], "+", 
         SuperscriptBox["#1", "10"]}], "&"}], ",", "4"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"3", " ", "#1"}], "+", 
         SuperscriptBox["#1", "10"]}], "&"}], ",", "5"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"3", " ", "#1"}], "+", 
         SuperscriptBox["#1", "10"]}], "&"}], ",", "6"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"3", " ", "#1"}], "+", 
         SuperscriptBox["#1", "10"]}], "&"}], ",", "7"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"3", " ", "#1"}], "+", 
         SuperscriptBox["#1", "10"]}], "&"}], ",", "8"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"3", " ", "#1"}], "+", 
         SuperscriptBox["#1", "10"]}], "&"}], ",", "9"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"3", " ", "#1"}], "+", 
         SuperscriptBox["#1", "10"]}], "&"}], ",", "10"}], "]"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.849903398305038*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.849903398316968*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.849903415663829*^9, 3.849903417782097*^9}}],

Cell[TextData[StyleBox["Example H",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 3.842293134812916*^9}, {
  3.8422931687293143`*^9, 3.8422931973930235`*^9}, {3.842293425545861*^9, 
  3.84229342697521*^9}, {3.84229347456431*^9, 3.842293529817839*^9}, {
  3.849903454013064*^9, 3.8499034548618937`*^9}},
 ExpressionUUID -> "d127db33-bfc1-46f9-bfc2-bdc614c1416d"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   RowBox[{
    SuperscriptBox["t", "7"], "+", 
    FractionBox["\[ImaginaryI]", "4"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"zeros", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"Numerator", "[", 
     RowBox[{"r", "[", "t", "]"}], "]"}], "\[Equal]", "0"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<AZeros.m\>\""}], "\[IndentingNewLine]", "listzeros", "\
\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
   3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
   3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
   3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.842293182622344*^9, 
   3.8422931839706736`*^9}, {3.8422932188473063`*^9, 3.8422932240991*^9}, 
   3.8422932899103546`*^9, {3.8422933226096425`*^9, 3.8422933941372023`*^9}, {
   3.842293439816018*^9, 3.842293538972356*^9}, 3.842294051032448*^9, {
   3.8499027057399054`*^9, 3.849902707566375*^9}, {3.849902758271036*^9, 
   3.8499027589069347`*^9}, 3.84990285246786*^9},
 ExpressionUUID -> "471506e3-2d57-43fc-b2c9-4a5049f34ac9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     FractionBox["\[ImaginaryI]", 
      SuperscriptBox["2", 
       RowBox[{"2", "/", "7"}]]]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"-", 
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], 
        RowBox[{"1", "/", "14"}]], 
       SuperscriptBox["2", 
        RowBox[{"2", "/", "7"}]]]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     FractionBox[
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"-", "1"}], ")"}], 
       RowBox[{"3", "/", "14"}]], 
      SuperscriptBox["2", 
       RowBox[{"2", "/", "7"}]]]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"-", 
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], 
        RowBox[{"5", "/", "14"}]], 
       SuperscriptBox["2", 
        RowBox[{"2", "/", "7"}]]]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"-", 
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], 
        RowBox[{"9", "/", "14"}]], 
       SuperscriptBox["2", 
        RowBox[{"2", "/", "7"}]]]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     FractionBox[
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"-", "1"}], ")"}], 
       RowBox[{"11", "/", "14"}]], 
      SuperscriptBox["2", 
       RowBox[{"2", "/", "7"}]]]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"-", 
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], 
        RowBox[{"13", "/", "14"}]], 
       SuperscriptBox["2", 
        RowBox[{"2", "/", "7"}]]]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.842293540212613*^9, 3.8422940521382513`*^9, 
  3.849902761617548*^9, 3.849902855041965*^9},
 ExpressionUUID -> "6cdc4996-7b53-418f-a668-eea175a60732"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.842293540212613*^9, 3.8422940521382513`*^9, 
  3.849902761617548*^9, 3.849902855058758*^9},
 ExpressionUUID -> "6cdc4996-7b53-418f-a668-eea175a60732"]
}, Open  ]],

Cell[TextData[StyleBox["Example I",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 3.842293134812916*^9}, {
  3.8422931687293143`*^9, 3.8422931973930235`*^9}, {3.842293425545861*^9, 
  3.84229342697521*^9}, {3.84229347456431*^9, 3.842293529817839*^9}, {
  3.842293587372309*^9, 3.842293588049423*^9}, {3.8499034578038597`*^9, 
  3.849903458684903*^9}},
 ExpressionUUID -> "b21b562d-65c1-4707-a085-9a7e22af40ad"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   RowBox[{
    SuperscriptBox["t", "6"], "+", 
    RowBox[{"5", 
     SuperscriptBox["t", "4"]}], "-", 
    RowBox[{"6", " ", "t"}], "+", "1"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"zeros", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"Numerator", "[", 
     RowBox[{"r", "[", "t", "]"}], "]"}], "\[Equal]", "0"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<AZeros.m\>\""}], "\[IndentingNewLine]", "listzeros"}], "Input",
 CellChangeTimes->{{3.8422918379411063`*^9, 3.8422919127494454`*^9}, {
   3.8422920691634903`*^9, 3.842292073375047*^9}, {3.8422924013585496`*^9, 
   3.842292568186633*^9}, {3.842292949397753*^9, 3.8422929978829517`*^9}, {
   3.8422931088532267`*^9, 3.8422931105274267`*^9}, {3.842293182622344*^9, 
   3.8422931839706736`*^9}, {3.8422932188473063`*^9, 3.8422932240991*^9}, 
   3.8422932899103546`*^9, {3.8422933226096425`*^9, 3.8422933941372023`*^9}, {
   3.842293439816018*^9, 3.842293538972356*^9}, {3.8422936038794794`*^9, 
   3.8422938174414673`*^9}, 3.842294058167542*^9, {3.849902766535668*^9, 
   3.849902767753935*^9}, 3.8499028681626167`*^9},
 ExpressionUUID -> "fb8c65f0-acc0-437c-90a8-fe7af46369da"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"6", " ", "#1"}], "+", 
         RowBox[{"5", " ", 
          SuperscriptBox["#1", "4"]}], "+", 
         SuperscriptBox["#1", "6"]}], "&"}], ",", "1"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"6", " ", "#1"}], "+", 
         RowBox[{"5", " ", 
          SuperscriptBox["#1", "4"]}], "+", 
         SuperscriptBox["#1", "6"]}], "&"}], ",", "2"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"6", " ", "#1"}], "+", 
         RowBox[{"5", " ", 
          SuperscriptBox["#1", "4"]}], "+", 
         SuperscriptBox["#1", "6"]}], "&"}], ",", "3"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"6", " ", "#1"}], "+", 
         RowBox[{"5", " ", 
          SuperscriptBox["#1", "4"]}], "+", 
         SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"6", " ", "#1"}], "+", 
         RowBox[{"5", " ", 
          SuperscriptBox["#1", "4"]}], "+", 
         SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"6", " ", "#1"}], "+", 
         RowBox[{"5", " ", 
          SuperscriptBox["#1", "4"]}], "+", 
         SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.8422936178650923`*^9, 3.8422936483407016`*^9}, {
   3.8422937046294975`*^9, 3.842293724102346*^9}, {3.8422937919897795`*^9, 
   3.8422938184674635`*^9}, 3.8422940595228157`*^9, 3.849902770060442*^9, 
   3.8499028709469*^9},
 ExpressionUUID -> "50ffe12e-3fa9-42e9-a467-9f10f2770167"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>"}], "}"}]], "Output",
 CellChangeTimes->{{3.8422936178650923`*^9, 3.8422936483407016`*^9}, {
   3.8422937046294975`*^9, 3.842293724102346*^9}, {3.8422937919897795`*^9, 
   3.8422938184674635`*^9}, 3.8422940595228157`*^9, 3.849902770060442*^9, 
   3.849902870963663*^9},
 ExpressionUUID -> "50ffe12e-3fa9-42e9-a467-9f10f2770167"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.8499034790735826`*^9, 3.849903481071268*^9}}],

Cell[TextData[StyleBox["Example J",
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0.5, 0],
 Background->GrayLevel[0.85]]], "Text",
 CellChangeTimes->{{3.8422931309121637`*^9, 3.842293134812916*^9}, {
  3.8422931687293143`*^9, 3.8422931973930235`*^9}, {3.842293425545861*^9, 
  3.84229342697521*^9}, {3.84229347456431*^9, 3.842293529817839*^9}, {
  3.842293587372309*^9, 3.842293588049423*^9}, {3.8499034578038597`*^9, 
  3.849903484174429*^9}},
 ExpressionUUID -> "b21b562d-65c1-4707-a085-9a7e22af40ad"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"Context", "[", "]"}], "<>", "\"\<*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r", "[", "t", "]"}], "=", 
   RowBox[{
    SuperscriptBox["t", "21"], "-", 
    RowBox[{"6", 
     SuperscriptBox["t", "5"]}], "+", 
    RowBox[{"4", "\[ImaginaryI]", " ", "t"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"zeros", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"Numerator", "[", 
     RowBox[{"r", "[", "t", "]"}], "]"}], "\[Equal]", "0"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"<<", 
  "\"\<AZeros.m\>\""}], "\[IndentingNewLine]", "listzeros"}], "Input",
 CellChangeTimes->{{3.8499023040731993`*^9, 3.8499023043727617`*^9}, {
  3.8499034616809397`*^9, 3.849903496399844*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "1"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "2"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "3"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "4"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "5"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "6"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "7"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "8"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "9"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "10"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "11"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "12"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "13"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "14"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "15"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "16"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "17"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "18"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "19"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", "\[Rule]", 
     RowBox[{"Root", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "+", 
           SuperscriptBox["#1", "2"]}], "&"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", "#1"}], "-", 
           RowBox[{"6", " ", 
            SuperscriptBox["#2", "4"]}], "+", 
           SuperscriptBox["#2", "20"]}], "&"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "20"}], "}"}]}], "]"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.849903492342493*^9, 3.849934551638212*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Unit disk-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(+\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>", 
   ",", "\<\"Outside-\\!\\(\\*SubscriptBox[\\(\[DoubleStruckCapitalT]\\), \
\\(-\\)]\\)\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.849903492342493*^9, 3.849934551656106*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.849902307914934*^9, 3.84990231123905*^9}, {
  3.849902720231812*^9, 3.849902723656274*^9}}],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{3.849902318534693*^9}]
},
WindowSize->{1280, 498},
WindowMargins->{{-9, Automatic}, {Automatic, 0}},
FrontEndVersion->"11.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (September \
21, 2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 65157, 1161, 242, "Input"],
Cell[65718, 1183, 71503, 1176, 399, "Input"],
Cell[137224, 2361, 89, 1, 54, "Input"],
Cell[137316, 2364, 28198, 467, 172, "Input"],
Cell[165517, 2833, 90, 1, 32, "Input"],
Cell[165610, 2836, 257, 6, 30, "Text"],
Cell[CellGroupData[{
Cell[165892, 2846, 1447, 36, 167, "Input"],
Cell[167342, 2884, 675, 12, 44, "Output"],
Cell[168020, 2898, 682, 10, 32, "Output"]
}, Open  ]],
Cell[168717, 2911, 92, 1, 32, "Input"],
Cell[168812, 2914, 310, 7, 30, "Text"],
Cell[CellGroupData[{
Cell[169147, 2925, 1444, 36, 138, "Input"],
Cell[170594, 2963, 340, 8, 45, "Output"],
Cell[170937, 2973, 333, 6, 32, "Output"]
}, Open  ]],
Cell[171285, 2982, 92, 1, 32, "Input"],
Cell[171380, 2985, 310, 7, 30, "Text"],
Cell[CellGroupData[{
Cell[171715, 2996, 1753, 43, 180, "Input"],
Cell[173471, 3041, 868, 25, 35, "Output"],
Cell[174342, 3068, 663, 13, 32, "Output"]
}, Open  ]],
Cell[175020, 3084, 92, 1, 32, "Input"],
Cell[175115, 3087, 355, 7, 30, "Text"],
Cell[CellGroupData[{
Cell[175495, 3098, 1509, 37, 157, "Input"],
Cell[177007, 3137, 226, 4, 32, "Output"],
Cell[177236, 3143, 224, 4, 32, "Output"]
}, Open  ]],
Cell[177475, 3150, 94, 1, 32, "Input"],
Cell[177572, 3153, 403, 8, 30, "Text"],
Cell[CellGroupData[{
Cell[178000, 3165, 1607, 41, 157, "Input"],
Cell[179610, 3208, 253, 6, 32, "Output"],
Cell[179866, 3216, 283, 5, 32, "Output"]
}, Open  ]],
Cell[180164, 3224, 94, 1, 32, "Input"],
Cell[180261, 3227, 404, 7, 30, "Text"],
Cell[CellGroupData[{
Cell[180690, 3238, 1923, 48, 163, "Input"],
Cell[182616, 3288, 3264, 104, 112, "Output"],
Cell[185883, 3394, 640, 13, 32, "Output"]
}, Open  ]],
Cell[186538, 3410, 87, 1, 54, "Input"],
Cell[186628, 3413, 453, 8, 30, "Text"],
Cell[CellGroupData[{
Cell[187106, 3425, 1571, 35, 138, "Input"],
Cell[188680, 3462, 2869, 94, 81, "Output"],
Cell[191552, 3558, 1043, 22, 32, "Output"]
}, Open  ]],
Cell[192610, 3583, 92, 1, 32, "Input"],
Cell[192705, 3586, 453, 8, 30, "Text"],
Cell[CellGroupData[{
Cell[193183, 3598, 1515, 35, 176, "Input"],
Cell[194701, 3635, 2020, 68, 48, "Output"],
Cell[196724, 3705, 900, 18, 32, "Output"]
}, Open  ]],
Cell[197639, 3726, 502, 9, 30, "Text"],
Cell[CellGroupData[{
Cell[198166, 3739, 1550, 36, 138, "Input"],
Cell[199719, 3777, 2305, 68, 58, "Output"],
Cell[202027, 3847, 930, 18, 32, "Output"]
}, Open  ]],
Cell[202972, 3868, 94, 1, 32, "Input"],
Cell[203069, 3871, 502, 9, 30, "Text"],
Cell[CellGroupData[{
Cell[203596, 3884, 971, 29, 138, "Input"],
Cell[204570, 3915, 10813, 345, 173, "Output"],
Cell[215386, 4262, 2118, 44, 54, "Output"]
}, Open  ]],
Cell[217519, 4309, 140, 2, 32, "Input"],
Cell[217662, 4313, 87, 1, 54, "Input"]
}
]
*)

